PROGRAM NAME: ppconv

FILES:
  ppconv10.c
  ppconv.h
  Makefile
  README

AUTHOR: Kazuki Mae

It is understood by the author that the Institute of Industrial Science (IIS), 
the University of Tokyo, distributes this program as "FSIS Free Software" with 
users' agreement with the terms and conditions written in the file, LICENSE or
LICENSE_J.pdf (Japanese).

"ppconv" has been developed in the national project "Frontier Simulation
Software for Industrial Science (FSIS)",  which is supported by
the IT program of the Ministry of Education, Culture, Sports,
Science and Technology (MEXT) of Japan.


FUNCTION:
"ppconv" converts input files in CIAO, GNCPP and PSV formats each other.
The CIAO format recognized by "ppconv" is different from that used by
CIAO program currently (Augut, 2003). Users can use "ppconv" only for
converting GNCPP and PSV formats each other.


INSTALL:
for compiling "ppconv", type

  make

One will find an executable file, "ppconv". 


CIAO package:
"ppconv" is attached to "CIAO" program package. Expansion of the compressed
file of "ppconv" package is not necessary in the "CIAO" environment. "ppconv"
files locate in "src_ppconv", though the manual says they are in "ppconv10"
directory. The executable file, "ppconv" is moved to "tools" directory by

  make install
  

Last modification of this file: August 22, 2003

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   Version history: 
!
!     4.0:  2013/03/01
!           codes for spin-polarized pseudopotential generation are added
!     4.1:  2013/11/22 - 
!           Info of core wfns and energy contributions can be added to gncpp2
!     4.2:  2014/07/23 - 
!           gncpp2 can be geregated even when nmesh /= 1501
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : calc_tmpp_us, check_rphi_tm, write_checked_rphi_tm
!                : write_coeff_tmpp_us, lhs_tmpp_us, set_amat_tm
!  Function(s)   : fn_p_tm, fn_dp_tm, fn_ddp_tm, fn_dddp_tm
!                : fn_ddddp_tm
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine calc_tmpp_us(ier,ifile,is_bound_state, &
              nmesh,rpos,wr,wt,chi,veff,chi_ps,veff_ps, &
              ll,ee,nrc,gcut0,gcut1,gcut2,gcut3,gcut4, &
              coeff_tm)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: ifile, is_bound_state, nmesh, ll, nrc
   real(8),intent(in)  :: rpos(nmesh), wr(nmesh), chi(nmesh), &
                          veff(nmesh), &
                          ee, gcut0, gcut1, gcut2, gcut3, gcut4
   integer,intent(out) :: ier
   real(8),intent(out) :: wt(nmesh), chi_ps(nmesh), veff_ps(nmesh), &
                          coeff_tm(0:12)
   integer :: ir, maxloop, loop, &
              isample, nsample, i, j, ierr_count
   real(8) :: rcut, sum, gg, r, rhs, lhs, lhsmin, lhsmid, lhsmax, &
              fn_p_tm, fn_dp_tm, fn_ddp_tm, p, dp, ddp, &
              c2min, c2mid, c2max, eps_conv, &
              c0, c2, c4, c6, c8, c10, c12, &
              c_sum(0:4),lhs_sum(0:2),acoeff(0:2), &
              lhs_bottom, c2_bottom, c2min_trial(3), c2max_trial(3), &
              c2_solved
   integer :: n_mat, n_vec
   real(8),allocatable :: mat_a(:,:), vec_x(:,:), vec_b(:,:)
   maxloop  = 100
   nsample  = 100
   eps_conv = 1.d-12
   if (is_bound_state == 1) then
      sum = 0.d0
      do ir = 1,nmesh
         sum = sum + chi(ir)**2*wr(ir)
      end do
      write(ifile,*) '%%% BOUND state %%% ll --->',ll
      write(ifile,*) '   check norm of < chi | chi > ...',sum
      if (abs(sum-1.d0) > 1.d-5) then
         write(ifile,*) '### ERROR ### < chi | chi > != 1'
         ier = 1 ; go to 99
      end if
   else
      call set_weight_exp(ier,1,nrc,rpos,wt)
      sum = 0.d0
      do ir = 1,nrc
         sum = sum + chi(ir)**2*wt(ir)
      end do
      write(ifile,*) '%%% UNBOUND state %%% ll --->',ll
      write(ifile,*) '   check norm of < chi | chi >R ...',sum
      write(ifile,*) '                            nrc ...',nrc
      if (abs(sum-1.d0) > 1.d-5) then
         write(ifile,*) '### ERROR ### < chi | chi >R != 1'
         ier = 1 ; go to 99
      end if
   end if
   rcut = rpos(nrc)
   call set_weight_exp(ier,1,nrc,rpos,wt)
   gg = 0.d0
   do ir = 1,nrc
      gg = gg + chi(ir)**2 * wt(ir)
   end do
   rhs = log(gg)
   write(ifile,*) 'RHS         ...',rhs
   write(ifile,*) '... finding c2 which gives minimum of lhs ...'
   c2min = (-30.d0-ee)/dble(2*ll+3)
   c2max = ( 10.d0-ee)/dble(2*ll+3)
   c_sum(:) = 0.d0 ; lhs_sum(:) = 0.d0
   do isample = 1,nsample
      c2 = c2min + (c2max-c2min)*dble(isample-1)/dble(nsample-1)
      call lhs_tmpp_us(ier,ifile,nmesh,ll,nrc, &
                  gcut0,gcut1,gcut2,gcut3,gcut4, &
                  rpos,wt,c0,c2,c4,c6,c8,c10,c12,lhs)
      if (ier /= 0) then
         write(ifile,*) '### ERROR ### in lhs_tmpp' ; go to 99
      end if
      do i = 0,4
         c_sum(i) = c_sum(i) + c2**i
      end do
      do i = 0,2
         lhs_sum(i) = lhs_sum(i) + lhs*c2**i
      end do
   end do
   c_sum  (:) = c_sum  (:)/dble(nsample)
   lhs_sum(:) = lhs_sum(:)/dble(nsample)
   n_mat = 3 ; n_vec = 1
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   allocate(mat_a(n_mat,n_mat),vec_x(n_mat,n_vec),vec_b(n_mat,n_vec))
      mat_a = 0.d0 ; vec_x = 0.d0 ; vec_b = 0.d0
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   do i = 1,n_mat
      do j = 1,n_mat
         mat_a(i,j) = c_sum(i+j-2)
      end do
      vec_b(i,1) = lhs_sum(i-1)
   end do
   call axb_real_matrix(ier,n_mat,n_vec,mat_a,vec_x,vec_b)
   do i = 1,n_mat
      acoeff(i-1) = vec_x(i,1)
   end do
  !++++++++++++++++++++++++++++++
   deallocate(mat_a,vec_x,vec_b)
  !++++++++++++++++++++++++++++++
   lhs_bottom =   acoeff(0) - acoeff(1)**2 / (4.d0*acoeff(2))
   c2_bottom  = - acoeff(1) / (2.d0*acoeff(2))
   write(ifile,*) '!!! c2 & bottom !!! ..............', &
                       c2_bottom,lhs_bottom
   if (lhs_bottom > rhs) then
      write(ifile,*) '### ERROR ### lhs_bottom > rhs'
      write(ifile,*) '   lhs_bottom ...',lhs_bottom
      write(ifile,*) '   rhs        ...',rhs
      ier = 1 ; go to 99
   end if
   c2min_trial(1) = (-100.d0-ee)/dble(2*ll+3)
   c2max_trial(1) = (  30.d0-ee)/dble(2*ll+3)
   if (c2_bottom > 0.d0) then
      c2min = c2min_trial(1)
      c2max = c2_bottom
   else
      c2min = c2_bottom
      c2max = c2max_trial(1)
   end if
   ierr_count = 0
   c2mid = 0.5d0*(c2min + c2max)
   write(ifile,'(1x,a21,3f20.10)') &
      'c2min,c2mid,c2max ...',c2min,c2mid,c2max
SRCH_C2:do loop = 1,maxloop
   call lhs_tmpp_us(ier,ifile,nmesh,ll,nrc, &
                    gcut0,gcut1,gcut2,gcut3,gcut4, &
                    rpos,wt,c0,c2min,c4,c6,c8,c10,c12,lhsmin)
      if (ier /= 0) then
         write(ifile,*) '### ERROR ### in lhs_tmpp'
         write(ifile,*) '   c2min  ...',c2min
         write(ifile,*) '   lhsmin ...',lhsmin
         go to 99
      end if
   call lhs_tmpp_us(ier,ifile,nmesh,ll,nrc, &
                    gcut0,gcut1,gcut2,gcut3,gcut4, &
                    rpos,wt,c0,c2mid,c4,c6,c8,c10,c12,lhsmid)
      if (ier /= 0) then
         write(ifile,*) '### ERROR ### in lhs_tmpp'
         write(ifile,*) '   c2mid  ...',c2mid
         write(ifile,*) '   lhsmid ...',lhsmid
         go to 99
      end if
   call lhs_tmpp_us(ier,ifile,nmesh,ll,nrc, &
                    gcut0,gcut1,gcut2,gcut3,gcut4, &
                    rpos,wt,c0,c2max,c4,c6,c8,c10,c12,lhsmax)
      if (ier /= 0) then
         write(ifile,*) '### ERROR ### in lhs_tmpp'
         write(ifile,*) '   c2max  ...',c2max
         write(ifile,*) '   lhsmax ...',lhsmax
         go to 99
      end if
   
   if ((lhsmin-rhs)*(lhsmax-rhs) > 0.d0) then
      if (ierr_count == 0) then
         write(ifile,*) '### CAUTION ### rhs is out of range'
         write(ifile,*) '   rhs    ...',rhs
         write(ifile,*) '   lhsmin ...',lhsmin
         write(ifile,*) '   lhsmid ...',lhsmid
         write(ifile,*) '   lhsmax ...',lhsmax
         ierr_count = ierr_count+1   
         if (c2_bottom < 0.d0) then  
            c2min = c2min_trial(1)   
            c2max = c2_bottom        
         else                        
            c2min = c2_bottom        
            c2max = c2max_trial(1)   
         end if
         c2mid = 0.5d0*(c2min + c2max)
      else
         write(ifile,*) '### ERROR ### rhs is out of range'
         write(ifile,*) '   rhs    ...',rhs
         write(ifile,*) '   lhsmin ...',lhsmin
         write(ifile,*) '   lhsmid ...',lhsmid
         write(ifile,*) '   lhsmax ...',lhsmax
         write(ifile,*) 'Error count exceeds the limit !!!'
         ier = 1 ; go to 99
      end if
   else if (lhsmid == rhs) then
      c2max = rhs
      c2min = rhs
   else if ((lhsmin-rhs)*(lhsmid-rhs) < 0.d0) then
      c2max = c2mid
      c2mid = 0.5d0*(c2min + c2max)
   else if ((lhsmid-rhs)*(lhsmax-rhs) < 0.d0) then
      c2min = c2mid
      c2mid = 0.5d0*(c2min + c2max)
   else
      write(ifile,*) '### ERROR ### rhs is an accidental value'
      write(ifile,*) '   rhs    ...',rhs
      write(ifile,*) '   lhsmin ...',lhsmin
      write(ifile,*) '   lhsmid ...',lhsmid
      write(ifile,*) '   lhsmax ...',lhsmax
      ier = 1 ; go to 99
   end if
   write(ifile,'(1x,a21,3f20.10)') &
      'c2min,c2mid,c2max ...',c2min,c2mid,c2max
   if (abs(c2max-c2min) < eps_conv) then 
      exit SRCH_C2                       
   end if                                
   if (loop > maxloop) then
      write(ifile,*) '### ERROR ### c2 was not found !'
      ier = 1 ; go to 99
   end if
end do SRCH_C2
   c2_solved = c2mid
   c2 = c2_solved
   write(ifile,*) '%%% CHECK : ll,c2_solved ...',ll,c2_solved
   write(ifile,*) & 
      'Troullier-Martins norm-conserving p(r) was solved for ll =',ll
   write(ifile,10) '   c0  ...',c0
   write(ifile,10) '   c2  ...',c2
   write(ifile,10) '   c4  ...',c4
   write(ifile,10) '   c6  ...',c6
   write(ifile,10) '   c8  ...',c8
   write(ifile,10) '   c10 ...',c10
   write(ifile,10) '   c12 ...',c12
10 format(1x,a10,f20.10)
   coeff_tm(0) = c0 ; coeff_tm(2) = c2 ; coeff_tm(4) = c4
   coeff_tm(6) = c6 ; coeff_tm(8) = c8 ; coeff_tm(10)= c10
   coeff_tm(12)= c12
   do ir = 1,nrc
      r   = rpos(ir)
      dp  = fn_dp_tm (r,c0,c2,c4,c6,c8,c10,c12)
      ddp = fn_ddp_tm(r,c0,c2,c4,c6,c8,c10,c12)
      veff_ps(ir) = ee + dble(ll+1)/r*dp + 0.5d0*(ddp+dp*dp)
   end do
   do ir = nrc,nmesh
      veff_ps(ir) = veff(ir)
   end do
   do ir = 1,nrc
      r = rpos(ir)
      p = fn_p_tm(r,c0,c2,c4,c6,c8,c10,c12)
      chi_ps(ir) = r**(ll+1) * exp(p)
   end do
   do ir = nrc,nmesh
      chi_ps(ir) = chi(ir)
   end do
   if (is_bound_state == 1) then
      sum = 0.d0
      do ir = 1,nmesh
         sum = sum + chi_ps(ir)**2*wr(ir)
      end do
      write(ifile,*) '%%% check norm of chi_ps for ll --->',ll
      write(ifile,*) '   < chi_ps | chi_ps > ...',sum
   else if (is_bound_state == 0) then
      call set_weight_exp(ier,1,nrc,rpos,wt)
      sum = 0.d0
      do ir = 1,nrc
         sum = sum + chi_ps(ir)**2*wt(ir)
      end do
      write(ifile,*) '%%% check norm of chi_ps for ll --->',ll
      write(ifile,*) '   < chi_ps | chi_ps >R ...',sum
   else
      write(ifile,*) '### ERROR ### is_bound_state is out of range'
      write(ifile,*) '   is_bound_state ...',is_bound_state
      ier = 1 ; go to 99
   end if
   sum = sqrt(sum)
   chi_ps(:) = chi_ps(:) / sum
99 continue
   end subroutine calc_tmpp_us

!=====================================================================
   subroutine check_rphi_tm(ier,ips,nn,ll,tt,eref,deref,nrc,nk_tm, &
                            drpsi_tmp,rphi_tmp, &
                            sumpsi_exact,sumphi_num)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer,intent(in)  :: ips, nn, ll, tt, nrc, nk_tm
   real(8),intent(in)  :: drpsi_tmp(0:nk_tm), rphi_tmp(nmesh), &
                          eref, deref, sumpsi_exact, sumphi_num
   integer :: n1, n2, isdiff, ik
   real(8) :: f0_exact(0:4), f0_anal(0:4), f0_num(0:4), rcut, &
              c0, c2, c4, c6, c8, c10, c12, &
              p0, dp0, ddp0, dddp0, ddddp0, &
                  dq0, ddq0, dddq0, ddddq0, &
              fn_p_tm, fn_dp_tm, fn_ddp_tm, fn_dddp_tm, fn_ddddp_tm
   ier = 0
   do ik = 0,nk_tm
      f0_exact(ik) = drpsi_tmp(ik)
   end do
   f0_anal(:) = 0.d0
   rcut = rpos(nrc)
   c0  = coeff_phi_tm(0,ips,1) ; c2  = coeff_phi_tm(1,ips,1)
   c4  = coeff_phi_tm(2,ips,1) ; c6  = coeff_phi_tm(3,ips,1)
   c8  = coeff_phi_tm(4,ips,1) ; c10 = coeff_phi_tm(5,ips,1)
   c12 = coeff_phi_tm(6,ips,1)
   p0     = fn_p_tm    (rcut,c0,c2,c4,c6,c8,c10,c12)
   dp0    = fn_dp_tm   (rcut,c0,c2,c4,c6,c8,c10,c12)
   ddp0   = fn_ddp_tm  (rcut,c0,c2,c4,c6,c8,c10,c12)
   dddp0  = fn_dddp_tm (rcut,c0,c2,c4,c6,c8,c10,c12)
   ddddp0 = fn_ddddp_tm(rcut,c0,c2,c4,c6,c8,c10,c12)
   dq0    =       dble(ll+1)/rcut + dp0
   ddq0   =      -dble(ll+1)/rcut/rcut + ddp0
   dddq0  =  2.d0*dble(ll+1)/rcut/rcut/rcut + dddp0
   ddddq0 = -6.d0*dble(ll+1)/rcut/rcut/rcut/rcut + ddddp0
   f0_anal(0) = rcut**(ll+1) * exp(p0)
   f0_anal(1) = f0_anal(0)*dq0
   f0_anal(2) = f0_anal(1)*dq0 + f0_anal(0)*ddq0
   f0_anal(3) = f0_anal(2)*dq0 + 2.d0*f0_anal(1)*ddq0 &
              + f0_anal(0)*dddq0
   f0_anal(4) = f0_anal(3)*dq0 + 3.d0*f0_anal(2)*ddq0 &
              + 3.d0*f0_anal(1)*dddq0 + f0_anal(0)*ddddq0
   f0_num(:)  = 0.d0
   isdiff = nk_tm  
   n1 = nrc - 10
   n2 = nrc + 10
   rcut = rpos(nrc)
   call diff4_exp(ier,isdiff,n1,n2,rpos,rphi_tmp,rcut, &
                  f0_num(0),f0_num(1),f0_num(2),f0_num(3),f0_num(4))
   f0_num(0) = rphi_tmp(nrc)
   call write_checked_rphi_tm(IFLOG,nn,ll,tt, &
           nrc,rcut,eref,deref,ncoeff_phi_tm,coeff_phi_tm(0,ips,1), &
           nk_tm,f0_exact,f0_anal,f0_num,sumpsi_exact,sumphi_num)
   call write_checked_rphi_tm(IFSUM,nn,ll,tt, &
           nrc,rcut,eref,deref,ncoeff_phi_tm,coeff_phi_tm(0,ips,1), &
           nk_tm,f0_exact,f0_anal,f0_num,sumpsi_exact,sumphi_num)
99 continue
   end subroutine check_rphi_tm

!=====================================================================
   subroutine write_checked_rphi_tm(ifile,nn,ll,tt, &
      nrc,rcut,eref,deref,ncoeff,coeff,nk,f0_exact,f0_anal,f0_num, &
      sumpsi_exact,sumphi_num)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in) :: ifile, nn, ll, tt, nrc, ncoeff, nk
   real(8),intent(in) :: rcut, eref, deref, coeff(0:6), &
                         f0_exact(0:4), f0_anal(0:4), f0_num(0:4), &
                         sumpsi_exact, sumphi_num
   integer :: icoeff, ik             
   write(ifile,*)
   write(ifile,*)  &
      'Troullier-Martins norm-conserving phi[n](r) was solved.'
   write(ifile,15) ' (n,l,t) :', nn,ll,tt,'NC'
   write(ifile,10) ' rc, nrc :', rcut, nrc
   write(ifile,14) 'eref, de :', eref, deref
   write(ifile,11) 'ncoeff,nk:', ncoeff, nk
   write(ifile,14) 'c0,c2,c4 :',(coeff(icoeff),icoeff=0,2)
   write(ifile,14) 'c6,c8,c10:',(coeff(icoeff),icoeff=3,5)
   write(ifile,14) 'c12      :',(coeff(icoeff),icoeff=6,6)
   write(ifile,13) 'rphi(rc)','rphi''(rc)','rphi"(rc)'
   write(ifile,14) 'Exact    :',(f0_exact(ik),ik=0,2)
   write(ifile,14) 'Analytic :',(f0_anal (ik),ik=0,2)
   write(ifile,14) 'Numerical:',(f0_num  (ik),ik=0,2)
   write(ifile,16) 'rphi"''(rc)','rphi""(rc)','<phi|phi>rc'
   write(ifile,14) 'Exact    :',(f0_exact(ik),ik=3,nk),sumpsi_exact
   write(ifile,14) 'Analytic :',(f0_anal (ik),ik=3,nk)
   write(ifile,14) 'Numerical:',(f0_num  (ik),ik=3,nk),sumphi_num
10 format(1x,a10,f20.10,i20)
11 format(1x,a10,2(i20))
12 format(1x,(a6,i2,a2),f20.10)
13 format(1x,10x,(8x,a8,4x),(8x,a9,3x),(8x,a9,3x))
14 format(1x,a10,5(f20.10))
15 format(1x,a10,(10x,(i2,2x,i2,2x,i2)),(18x,a2))
16 format(1x,10x,2(8x,a10,2x),(8x,a11,1x))
   end subroutine write_checked_rphi_tm

!=====================================================================
   subroutine write_coeff_tmpp_us(ier,ifile,ips,tt)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer,intent(in)  :: ifile, ips, tt
   integer :: ishell, nn, ll, nrc, lt
   real(8) :: eref, rcut
   ier = 0
   ishell = ishell_ps(ips,1)
   nn = n_qnum(ishell)
   ll = l_qnum(ishell)
   lt = lt_n_us(ll,tt)  
   nrc  = nrcut_phi_us(lt)
   rcut = rpos(nrc)
   eref = eref_us(lt)
   write(ifile,*)
   write(ifile,*)  &
      'Troullier-Martins normconserving p(r) was solved.'
   write(ifile,12) ' (n,l,t) :',nn,ll,tt
   write(ifile,11) ' rc, nrc :',rcut, nrc
   write(ifile,10) '  eref   :',eref
   write(ifile,10) '  c0,  c2:',coeff_tm(0,ips,1),coeff_tm(2,ips,1)
   write(ifile,10) '  c4,  c6:',coeff_tm(4,ips,1),coeff_tm(6,ips,1)
   write(ifile,10) '  c8, c10:',coeff_tm(8,ips,1),coeff_tm(10,ips,1)
   write(ifile,10) ' c12     :',coeff_tm(12,ips,1)
10 format(1x,a10,2f20.10)
11 format(1x,a10,f20.10,i20)
12 format(1x,a10,10x,(i2,2x,i2,2x,i2))
   end subroutine write_coeff_tmpp_us

!=====================================================================
   subroutine lhs_tmpp_us(ier,ifile,nmesh,ll,nrc, &
                          gcut0,gcut1,gcut2,gcut3,gcut4, &
                          rpos,wt,c0,c2,c4,c6,c8,c10,c12,lhs)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: ifile, nmesh, ll, nrc
   real(8),intent(in)  :: rpos(nmesh), &
                          gcut0, gcut1, gcut2, gcut3, gcut4, c2
   integer,intent(out) :: ier
   real(8),intent(out) :: wt(nmesh), c0, c4, c6, c8, c10, c12, lhs
   integer :: ir
   real(8) :: rcut, sum, fn_p_tm, r, arg
   ier = 0
   rcut = rpos(nrc)
   call gtmpp_us(ier,ifile,ll, &
                 rcut,gcut0,gcut1,gcut2,gcut3,gcut4, &
                 c0,c2,c4,c6,c8,c10,c12)
   if (ier /= 0) then
      write(ifile,*) '### ERROR ### in gtmpp_us' ; go to 99
   end if
   call set_weight_exp(ier,1,nrc,rpos,wt)
   sum = 0.d0
   do ir = 1,nrc
      r  = rpos(ir)
      arg = 2.d0 * (fn_p_tm(r,c0,c2,c4,c6,c8,c10,c12) - c0)
      sum = sum + r**(2*ll+2)*exp(arg)*wt(ir)
   end do
   lhs = 2.d0*c0 + log(sum)
99 continue
   end subroutine lhs_tmpp_us

!=====================================================================
   subroutine gtmpp_us(ier,ifile,ll, &
                       rcut,gcut0,gcut1,gcut2,gcut3,gcut4, &
                       c0,c2,c4,c6,c8,c10,c12)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: ifile, ll
   real(8),intent(in)  :: rcut, gcut0, gcut1, gcut2, gcut3, gcut4, c2
   integer,intent(out) :: ier
   real(8),intent(out) :: c0, c4, c6, c8, c10, c12
   real(8) :: rcut2, rcut3, rcut4, &
              pcut0, pcut1, pcut2, pcut3, pcut4, &
              k1, k2, k3, k4
   integer :: n_mat, n_vec
   real(8),allocatable :: mat_a(:,:), vec_x(:,:), vec_b(:,:)
   ier = 0
   n_mat = 5 ; n_vec = 1
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   allocate(mat_a(n_mat,n_mat),vec_x(n_mat,n_vec),vec_b(n_mat,n_vec))
      mat_a = 0.d0 ; vec_x = 0.d0 ; vec_b = 0.d0
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   call set_amat_tm(rcut,mat_a)
   k1 = gcut1/gcut0 ; k2 = gcut2/gcut0
   k3 = gcut3/gcut0 ; k4 = gcut4/gcut0
   rcut2 = rcut * rcut
   rcut3 = rcut * rcut2
   rcut4 = rcut * rcut3
   pcut0 = log(gcut0) - dble(ll+1) * log(rcut)
   pcut1 = k1 - dble(ll+1)/rcut
   pcut2 = k2 - k1*k1 + dble(ll+1)/rcut2
   pcut3 = k3 - 3.d0*k2*k1 + 2.d0*k1*k1*k1 - 2.d0*dble(ll+1)/rcut3
   pcut4 = k4 - 4.d0*k3*k1 - 3.d0*k2*k2 + 12.d0*k2*k1*k1 &
         - 6.d0*k1*k1*k1*k1 + 6.d0*dble(ll+1)/rcut4
   c4 = - c2*c2/dble(2*ll+5)
   vec_b(1,1) = pcut0 -      c2*rcut2 -       c4*rcut2*rcut2
   vec_b(2,1) = pcut1 - 2.d0*c2*rcut  -  4.d0*c4*rcut2*rcut
   vec_b(3,1) = pcut2 - 2.d0*c2       - 12.d0*c4*rcut2
   vec_b(4,1) = pcut3                 - 24.d0*c4*rcut
   vec_b(5,1) = pcut4                 - 24.d0*c4
   call axb_real_matrix(ier,n_mat,n_vec,mat_a,vec_x,vec_b)
   if (ier /= 0) then
      write(ifile,*) '### ERROR ### ier != 0 : ier =',ier ; go to 99
   end if
   c0  = vec_x(1,1) ; c6  = vec_x(2,1) ; c8 = vec_x(3,1)
   c10 = vec_x(4,1) ; c12 = vec_x(5,1)
  !++++++++++++++++++++++++++++++
   deallocate(mat_a,vec_x,vec_b)
  !++++++++++++++++++++++++++++++
99 continue
   end subroutine gtmpp_us

!=====================================================================
   function fn_p_tm(r,c0,c2,c4,c6,c8,c10,c12)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   real(8),intent(in) :: r, c0, c2, c4, c6, c8, c10, c12
   real(8) :: fn_p_tm, r2, r4, r6, r8, r10, r12
   r2  = r   * r  ; r4  = r2  * r2 ; r6  = r4  * r2 
   r8  = r6  * r2 ; r10 = r8  * r2 ; r12 = r10 * r2
   fn_p_tm = c0 + c2*r2 + c4*r4 + c6*r6 + c8*r8 + c10*r10 + c12*r12
   end function fn_p_tm

!=====================================================================
   function fn_dp_tm(r,c0,c2,c4,c6,c8,c10,c12)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   real(8),intent(in) :: r, c0, c2, c4, c6, c8, c10, c12
   real(8) :: fn_dp_tm, r2, r3, r5, r7, r9, r11
   r2  = r  * r  ; r3  = r  * r2 ; r5  = r3 * r2
   r7  = r5 * r2 ; r9  = r7 * r2 ; r11 = r9 * r2
   fn_dp_tm = 2.d0*c2*r + 4.d0*c4*r3 + 6.d0*c6*r5 + 8.d0*c8*r7 &
            + 10.d0*c10*r9 + 12.d0*c12*r11
   end function fn_dp_tm

!=====================================================================
   function fn_ddp_tm(r,c0,c2,c4,c6,c8,c10,c12)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   real(8),intent(in) :: r, c0, c2, c4, c6, c8, c10, c12
   real(8) :: fn_ddp_tm, r2, r4, r6, r8, r10
   r2  = r  * r  ; r4  = r2 * r2 ; r6  = r4 * r2
   r8  = r6 * r2 ; r10 = r8 * r2
   fn_ddp_tm = 2.d0*c2 + 12.d0*c4*r2 + 30.d0*c6*r4 + 56.d0*c8*r6 &
            + 90.d0*c10*r8 + 132.d0*c12*r10
   end function fn_ddp_tm

!=====================================================================
   function fn_dddp_tm(r,c0,c2,c4,c6,c8,c10,c12)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   real(8),intent(in) :: r, c0, c2, c4, c6, c8, c10, c12
   real(8) :: fn_dddp_tm, r2, r3, r5, r7, r9

   r2  = r  * r  ; r3  = r  * r2 ; r5  = r3 * r2
   r7  = r5 * r2 ; r9  = r7 * r2
   fn_dddp_tm = 24.d0*c4*r + 120.d0*c6*r3 + 336.d0*c8*r5 &
            + 720.d0*c10*r7 + 1320.d0*c12*r9

   end function fn_dddp_tm

!=====================================================================
   function fn_ddddp_tm(r,c0,c2,c4,c6,c8,c10,c12)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   real(8),intent(in) :: r, c0, c2, c4, c6, c8, c10, c12
   real(8) :: fn_ddddp_tm, r2, r4, r6, r8, r10
   r2  = r  * r  ; r4  = r2 * r2 ; r6  = r4 * r2
   r8  = r6 * r2 ; r10 = r8 * r2
   fn_ddddp_tm = 24.d0*c4 + 360.d0*c6*r2 + 1680.d0*c8*r4 &
            + 5040.d0*c10*r6 + 11880.d0*c12*r8
   end function fn_ddddp_tm

!=====================================================================
   subroutine set_amat_tm(r,amat)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   real(8),intent(in)  :: r
   real(8),intent(out) :: amat(5,5)
   real(8) :: r2, r3, r4, r5, r6, r7, r8, r9, r10, r11, r12
   r2 =r  *r ; r3 =r2 *r ; r4 =r3 *r ; r5 =r4 *r ; r6 =r5 *r
   r7 =r6 *r ; r8 =r7 *r ; r9 =r8 *r ; r10=r9 *r ; r11=r10*r
   r12=r11*r
   amat(1,1) =     1.d0      ; amat(1,2) =     1.d0*r6
   amat(1,3) =     1.d0*r8   ; amat(1,4) =     1.d0*r10
   amat(1,5) =     1.d0*r12  
   amat(2,1) =     0.d0      ; amat(2,2) =     6.d0*r5
   amat(2,3) =     8.d0*r7   ; amat(2,4) =    10.d0*r9
   amat(2,5) =    12.d0*r11
   amat(3,1) =     0.d0      ; amat(3,2) =    30.d0*r4
   amat(3,3) =    56.d0*r6   ; amat(3,4) =    90.d0*r8
   amat(3,5) =   132.d0*r10
   amat(4,1) =     0.d0      ; amat(4,2) =   120.d0*r3
   amat(4,3) =   336.d0*r5   ; amat(4,4) =   720.d0*r7
   amat(4,5) =  1320.d0*r9
   amat(5,1) =     0.d0      ; amat(5,2) =   360.d0*r2
   amat(5,3) =  1680.d0*r4   ; amat(5,4) =  5040.d0*r6
   amat(5,5) = 11880.d0*r8
   end subroutine set_amat_tm

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   Version history: 
!
!     4.0:  2013/03/01
!           codes for spin-polarized pseudopotential generation are added
!     4.1:  2013/11/22 - 
!           Info of core wfns and energy contributions can be added to gncpp2
!     4.2:  2014/07/23 - 
!           gncpp2 can be geregated even when nmesh /= 1501
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Function(s)   : fn_number_of_words, fn_is_alphabet, fn_yes_no
!                : fn_label_orbital, fn_label_orbital_capital
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   function fn_number_of_words(string)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer :: fn_number_of_words
   character(*),intent(in) :: string
   integer        :: ipos, lpos
   character(256) :: tmp_string
   tmp_string = trim(adjustl(string))
   lpos       = len(tmp_string)
   fn_number_of_words = 0
   if (lpos == 0) then
      go to 99
   end if
   if (index(tmp_string,' ') == 1) then
      go to 99
   end if
   do while (index(tmp_string,' ') > 1)
      fn_number_of_words = fn_number_of_words + 1
      ipos               = index(tmp_string,' ')
      if (ipos == 0) then
         go to 99
      end if
      tmp_string = adjustl(tmp_string(ipos:lpos))
      tmp_string = adjustl(tmp_string)
   end do
99 continue
   end function fn_number_of_words

!=====================================================================
   function fn_is_alphabet(c)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   logical :: fn_is_alphabet
   character,intent(in) :: c

   if ((lge(c,'a').and.lle(c,'z')).or. &
       (lge(c,'A').and.lle(c,'Z'))) then
      fn_is_alphabet = .true.
   else
      fn_is_alphabet = .false.
   end if
   end function fn_is_alphabet

!=====================================================================
   function fn_yes_no(n)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in) :: n
   character(3) :: fn_yes_no
   select case (n)
   case (0)
      fn_yes_no = ' no'
   case default
      fn_yes_no = 'yes'
   end select
   end function fn_yes_no

!=====================================================================
   function fn_label_orbital(ll)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in) :: ll
   character(1) :: fn_label_orbital

   select case (ll)
   case (0)
      fn_label_orbital = 's'
   case (1)
      fn_label_orbital = 'p'
   case (2)
      fn_label_orbital = 'd'
   case (3)
      fn_label_orbital = 'f'
   case (4)
      fn_label_orbital = 'g'
   case (5)
      fn_label_orbital = 'h'
   case (6)
      fn_label_orbital = 'i'
   case (7)
      fn_label_orbital = 'j'
   case (8)
      fn_label_orbital = 'k'
   case (9)
      fn_label_orbital = 'l'
   case default
      fn_label_orbital = '?'
   end select
   end function fn_label_orbital

!=====================================================================
   function fn_label_orbital_capital(ll)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in) :: ll
   character(1) :: fn_label_orbital, fn_label_orbital_capital

   select case (ll)
   case (0)
      fn_label_orbital = 'S'
   case (1)
      fn_label_orbital = 'P'
   case (2)
      fn_label_orbital = 'D'
   case (3)
      fn_label_orbital = 'F'
   case (4)
      fn_label_orbital = 'G'
   case (5)
      fn_label_orbital = 'H'
   case (6)
      fn_label_orbital = 'I'
   case (7)
      fn_label_orbital = 'J'
   case (8)
      fn_label_orbital = 'K'
   case (9)
      fn_label_orbital = 'L'
   case default
      fn_label_orbital = '?'
   end select
   fn_label_orbital_capital(1:1) = fn_label_orbital(1:1)
   end function fn_label_orbital_capital

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   Version history: 
!
!     4.0:  2013/03/01
!           codes for spin-polarized pseudopotential generation are added
!     4.1:  2013/11/22 - 
!           Info of core wfns and energy contributions can be added to gncpp2
!     4.2:  2014/07/23 - 
!           gncpp2 can be geregated even when nmesh /= 1501
!
! ************************************************************* 
module dion_analysis
    use parameters
    implicit none
    private
    
    public:: write_dion
    
contains

    subroutine write_dion
        integer:: ln,tn,lm,tm
        integer:: lt,ltt,ltlt
        integer:: ll,ll_core,nn
        integer:: ir,mnrcl,ier
        integer,pointer:: nrcl(:,:)
        real(8):: r,tmp,dion_ae,dion_ps,dion_qps
        real(8),pointer:: vion_qps(:),vh_qps(:),vxc_qps(:)
        real(8),pointer:: vion_wps(:),vh_wps(:),vxc_wps(:),vloc_wps(:)
        real(8),pointer:: vion_wae(:),vh_wae(:),vxc_wae(:),vloc_wae(:),vcor_wae(:)
        real(8),pointer:: ekin_wps(:),ekin_wps2(:)
        real(8),pointer:: ekin_wae(:),ekin_wae2(:)
        real(8),pointer:: drphin(:),drphim(:),ddrphim(:)
        real(8),pointer:: drpsin(:),drpsim(:),ddrpsim(:)
        real(8),pointer:: wght(:),wght2(:)
        real(8),pointer:: emphnphm(:)
        real(8),pointer:: empsnpsm(:)
        real(8),pointer:: dh_ae(:),dh_ps(:),dh_qps(:)
        real(8):: bmat_tmp
        
        allocate(vion_qps(num_lttx_us))
        allocate(vh_qps(num_lttx_us))
        allocate(vxc_qps(num_lttx_us))
        allocate(vion_wps(num_lttx_us))
        allocate(vh_wps(num_lttx_us))
        allocate(vxc_wps(num_lttx_us))
        allocate(vloc_wps(num_lttx_us))
        allocate(vion_wae(num_lttx_us))
        allocate(vh_wae(num_lttx_us))
        allocate(vxc_wae(num_lttx_us))
        allocate(vloc_wae(num_lttx_us))
        allocate(vcor_wae(num_lttx_us))
        allocate(ekin_wps(num_lttx_us))
        allocate(ekin_wae(num_lttx_us))
        allocate(ekin_wps2(num_lttx_us))
        allocate(ekin_wae2(num_lttx_us))
        allocate(emphnphm(num_lttx_us))
        allocate(empsnpsm(num_lttx_us))
        allocate(dh_ae(num_lttx_us))
        allocate(dh_ps(num_lttx_us))
        allocate(dh_qps(num_lttx_us))
        allocate(drphin(nmesh))
        allocate(drphim(nmesh))
        allocate(ddrphim(nmesh))
        allocate(drpsin(nmesh))
        allocate(drpsim(nmesh))
        allocate(ddrpsim(nmesh))
        allocate(wght(nmesh))
        allocate(wght2(nmesh))
    
        vion_qps=0.d0
        vh_qps=0.d0
        vxc_qps=0.d0
        vion_wps=0.d0
        vh_wps=0.d0
        vxc_wps=0.d0
        vloc_wps=0.d0
        vion_wae=0.d0
        vh_wae=0.d0
        vxc_wae=0.d0
        vloc_wae=0.d0
        vcor_wae=0.d0
        wght=0.d0
        ekin_wps=0.d0
        ekin_wae=0.d0
        ekin_wps2=0.d0
        ekin_wae2=0.d0
        emphnphm=0.d0
        empsnpsm=0.d0
        drphin=0.d0
        drphim=0.d0
        drpsin=0.d0
        drpsim=0.d0
        dh_ae=0.d0
        dh_ps=0.d0
        dh_qps=0.d0
        
        allocate(nrcl(lmax+1,nref_max_us))
        do ln=0,lmax
            do tn=1,nref_us(ln)
                lt=lt_n_us(ln,tn)
                nrcl(ln+1,tn)=nrcut_phi_us(lt)
            end do
        end do

        if(is_core == PATOM) then
            ll_core=0
        else
            ll_core=lmax_core
        end if
        
        mnrcl=maxval(nrcl)
        call set_weight_exp(ier,1,mnrcl,rpos,wght)
        call set_weight_exp(ier,1,nmesh,rpos,wght2)
        do ltt=1,num_lttx_us
            ll=l_ltt_us(ltt)
            tn=tn_ltt_us(ltt)
            tm=tm_ltt_us(ltt)
            ltlt=ltlt_nm_us(ll,tn,ll,tm)
            ln=lt_n_us(ll,tn)
            lm=lt_n_us(ll,tm)
            call calc_diff_exp(ier,5,mnrcl,rpos,rphi_us(1,ln),drphin)
            call calc_diff_exp(ier,5,mnrcl,rpos,rphi_us(1,lm),drphim)
            call calc_diff_exp(ier,5,mnrcl,rpos,rpsi_us(1,ln),drpsin)
            call calc_diff_exp(ier,5,mnrcl,rpos,rpsi_us(1,lm),drpsim)
!            call calc_ddiff_exp(ier,5,mnrcl,rpos,rphi_us(1,lm),drphim,ddrphim)
!            call calc_ddiff_exp(ier,5,mnrcl,rpos,rpsi_us(1,lm),drpsim,ddrpsim)
            if(ltlt/=0) then
                do ir=1,mnrcl
                    r=rpos(ir)
                    tmp=r*r*wght(ir)*qps_us(ir,ltlt,0)

! ================================================ modified by K. T. ========= 4.0
!                    vion_qps(ltt)   =vion_qps(ltt)  +tmp*vloc_ion_sol(ir)
!                    vh_qps(ltt)     =vh_qps(ltt)    +tmp*vh_sol(ir)
!                    vxc_qps(ltt)    =vxc_qps(ltt)   +tmp*(vx_sol(ir)+vc_sol(ir))
!
                    vion_qps(ltt)   =vion_qps(ltt)  +tmp*vloc_ion_sol(ir,1)
                    vh_qps(ltt)     =vh_qps(ltt)    +tmp*vh_sol(ir)
                    vxc_qps(ltt)    =vxc_qps(ltt)   +tmp*(vx_sol(ir,1)+vc_sol(ir,1))
! ============================================================================== 4.0
                end do
            else
                vion_qps(ltt)=0.d0
                vh_qps(ltt)=0.d0
                vxc_qps(ltt)=0.d0
            end if
            bmat_tmp=0.d0
            do ir=1,mnrcl
                r=rpos(ir)
                tmp=wght(ir)*rphi_us(ir,ln)*rphi_us(ir,lm)

! ======================================== modified by K. T. ============= 4.0
!                vion_wps(ltt)   =vion_wps(ltt)  +tmp*vloc_ion_sol(ir)
!                vh_wps(ltt)     =vh_wps(ltt)    +tmp*vh_sol(ir)
!                vxc_wps(ltt)    =vxc_wps(ltt)   +tmp*(vx_sol(ir)+vc_sol(ir))
!                vloc_wps(ltt)   =vloc_wps(ltt)  +tmp*vloc_scr_sol(ir)
!
                vion_wps(ltt)   =vion_wps(ltt)  +tmp*vloc_ion_sol(ir,1)
                vh_wps(ltt)     =vh_wps(ltt)    +tmp*vh_sol(ir)
                vxc_wps(ltt)    =vxc_wps(ltt)   +tmp*(vx_sol(ir,1)+vc_sol(ir,1))
                vloc_wps(ltt)   =vloc_wps(ltt)  +tmp*vloc_scr_sol(ir,1)
! ============================================================================= 4.0

                tmp=wght(ir)*rpsi_us(ir,ln)*rpsi_us(ir,lm)
                vion_wae(ltt)   =vion_wae(ltt)  +tmp*vion(ir,ll_core)
                vh_wae(ltt)     =vh_wae(ltt)    +tmp*vh(ir)
                vxc_wae(ltt)    =vxc_wae(ltt)   +tmp*(vx(ir,1)+vc(ir,1))
                vloc_wae(ltt)   =vloc_wae(ltt)  +tmp*veff(ir,1,lmax_core)
                ekin_wps(ltt)   =ekin_wps(ltt)  + &
                                            0.5d0*(drphin(ir)*drphim(ir)+ &
                                                dble(ll*(ll+1))* &
                                                rphi_us(ir,ln)*rphi_us(ir,lm)/r/r)* &
                                                wght(ir)
                ekin_wae(ltt)   =ekin_wae(ltt)  + &
                                            0.5d0*(drpsin(ir)*drpsim(ir)+ &
                                                dble(ll*(ll+1))* &
                                                rpsi_us(ir,ln)*rpsi_us(ir,lm)/r/r)* &
                                                wght(ir)
!                ekin_wps(ltt)   =ekin_wps(ltt)  + &
!                                            0.5d0*(-drphin(ir)*ddrphim(ir)+ &
!                                                dble(ll*(ll+1))* &
!                                                rphi_us(ir,ln)*rphi_us(ir,lm)/r/r)* &
!                                                wght(ir)
!                ekin_wae(ltt)   =ekin_wae(ltt)  + &
!                                            0.5d0*(-drpsin(ir)*ddrpsim(ir)+ &
!                                                dble(ll*(ll+1))* &
!                                                rpsi_us(ir,ln)*rpsi_us(ir,lm)/r/r)* &
!                                                wght(ir)
                emphnphm(ltt)=emphnphm(ltt) + &
                            wght(ir)*eref_us(lm)*rphi_us(ir,ln)*rphi_us(ir,lm)
                empsnpsm(ltt)=empsnpsm(ltt) + &
                            wght(ir)*eref_us(lm)*rpsi_us(ir,ln)*rpsi_us(ir,lm)
            end do
            do ir=1,nmesh
                bmat_tmp=bmat_tmp+wght2(ir)*rphi_us(ir,ln)*rchi_us(ir,lm)
            end do
            
!            ekin_wps2(ltt)=emphnphm(ltt)-bmat_us(ltt)-vion_wps(ltt)-vh_wps(ltt)-vxc_wps(ltt)
!            ekin_wps2(ltt)=emphnphm(ltt)-bmat_us(ltt)-vloc_wps(ltt)
            ekin_wps2(ltt)=emphnphm(ltt)-bmat_tmp-vloc_wps(ltt)
!            ekin_wae2(ltt)=empsnpsm(ltt)-vion_wae(ltt)-vh_wae(ltt)-vxc_wae(ltt) 
            ekin_wae2(ltt)=empsnpsm(ltt)-vloc_wae(ltt)
            
            call make_vcor_wae(ln,lm,mnrcl,vcor_wae(ltt))  
            call make_dh_ae(ln,lm,mnrcl,dh_ae(ltt))
            call make_dh_ps(ln,lm,mnrcl,dh_ps(ltt))
            if(ltlt/=0) then
                call make_dh_qps(ltlt,mnrcl,dh_qps(ltt))
            else
                dh_qps(ltt)=0.d0
            end if
        end do
  
        write(IFLOG,*) 
        write(IFLOG,*) 'Dion analysis for PHASE PAW'
        write(IFLOG,'("    mnrcl = ",i5)') mnrcl
        do ltt=1,num_lttx_us
            ll=l_ltt_us(ltt)
            tn=tn_ltt_us(ltt)
            tm=tm_ltt_us(ltt)
            write(IFLOG,'(3i5)') ll,tn,tm
            write(IFLOG,'("ekin_ae                    : ",e19.10)') ekin_wae(ltt) 
            write(IFLOG,'("ekin_ae2                   : ",e19.10)') ekin_wae2(ltt) 
            write(IFLOG,'("vion_ae                    : ",e19.10)') vion_wae(ltt) 
            write(IFLOG,'("vh_ae                      : ",e19.10)') vh_wae(ltt) 
            write(IFLOG,'("vxc_ae                     : ",e19.10)') vxc_wae(ltt) 
            write(IFLOG,'("vcor_ae                    : ",e19.10)') vcor_wae(ltt) 
            write(IFLOG,'("kine_ps                    : ",e19.10)') ekin_wps(ltt) 
            write(IFLOG,'("kine_ps2                   : ",e19.10)') ekin_wps2(ltt) 
            write(IFLOG,'("vion_ps                    : ",e19.10)') vion_wps(ltt) 
            write(IFLOG,'("vh_ps                      : ",e19.10)') vh_wps(ltt) 
            write(IFLOG,'("vxc_ps                     : ",e19.10)') vxc_wps(ltt) 
            write(IFLOG,'("vion_qps                   : ",e19.10)') vion_qps(ltt) 
            write(IFLOG,'("vh_qps                     : ",e19.10)') vh_qps(ltt) 
            write(IFLOG,'("vxc_qps                    : ",e19.10)') vxc_qps(ltt) 
            write(IFLOG,'("ekin_ae -kine_ps           : ",e19.10)') ekin_wae(ltt)-ekin_wps(ltt) 
            write(IFLOG,'("ekin_ae2-kine_ps2          : ",e19.10)') ekin_wae2(ltt)-ekin_wps2(ltt)
            dion_ae=ekin_wae(ltt)+vion_wae(ltt)+vh_wae(ltt)+vxc_wae(ltt)
            write(IFLOG,'("dion_ae                    : ",e19.10)') dion_ae
            dion_ps=ekin_wps(ltt)+vion_wps(ltt)+vh_wps(ltt)+vxc_wps(ltt) 
            write(IFLOG,'("dion_ps                    : ",e19.10)') dion_ps
            dion_qps=vion_qps(ltt)+vh_qps(ltt)+vxc_qps(ltt)
            write(IFLOG,'("dion_ae -dion_ps           : ",e19.10)') dion_ae-dion_ps
            write(IFLOG,'("dion_ae2-dion_ps2          : ",e19.10)') dion_ae-dion_ps- &
                                                                    ekin_wae(ltt)+ekin_wae2(ltt)+ &
                                                                    ekin_wps(ltt)-ekin_wps2(ltt)
            write(IFLOG,'("dion_qps                   : ",e19.10)') dion_qps
            write(IFLOG,'("dion 1                     : ",e19.10)') dion_ae-dion_ps-dion_qps
            write(IFLOG,'("dion 2                     : ",e19.10)') dion_ae-dion_ps-dion_qps- &
                                                                    ekin_wae(ltt)+ekin_wae2(ltt)+ &
                                                                    ekin_wps(ltt)-ekin_wps2(ltt)
            write(IFLOG,'("em_phin_phim               : ",e19.10)') emphnphm(ltt)
            write(IFLOG,'("em_psin_psim               : ",e19.10)') empsnpsm(ltt)
            write(IFLOG,'("bmat_us                    : ",e19.10)') bmat_us(ltt)
            write(IFLOG,'("em_phin_phim-bmat_us       : ",e19.10)') emphnphm(ltt)-bmat_us(ltt)
            write(IFLOG,'("dmat_us                    : ",e19.10)') bmat_us(ltt)+ &
                                                                    empsnpsm(ltt)- &
                                                                    emphnphm(ltt)
            write(IFLOG,'("vlocqps_us                 : ",e19.10)') vlocqps_us(ltt)
            write(IFLOG,'("dion 3                     : ",e19.10)') bmat_us(ltt)+empsnpsm(ltt)- &
                                                                    emphnphm(ltt)-vlocqps_us(ltt)
            write(IFLOG,'("dion_kin_ion               : ",e19.10)') ekin_wae2(ltt)+ &
                                                                    vion_wae(ltt)+ &
                                                                    vcor_wae(ltt)- &
                                                                    ekin_wps2(ltt)- &
                                                                    vion_wps(ltt)- &
                                                                    vion_qps(ltt)
            write(IFLOG,'("dion_hartree               : ",e19.10)') vh_wae(ltt)- &
                                                                    vcor_wae(ltt)- &
                                                                    vh_wps(ltt)- &
                                                                    vh_qps(ltt)
            write(IFLOG,'("dion_vxc                   : ",e19.10)') vxc_wae(ltt)- &
                                                                    vxc_wps(ltt)- &
                                                                    vxc_qps(ltt) 
            write(IFLOG,'("dion_hartree_ae            : ",e19.10)') dh_ae(ltt)
            write(IFLOG,'("dion_hartree_ps            : ",e19.10)') dh_ps(ltt)
            write(IFLOG,'("dion_hartree_qps           : ",e19.10)') dh_qps(ltt)
            write(IFLOG,'("dion_hartree 2             : ",e19.10)') dh_ae(ltt)-dh_ps(ltt)-dh_qps(ltt)
                                                                    
        end do
        
        write(IFLOG,*) 
    
        deallocate(vion_qps,vh_qps,vxc_qps)
        deallocate(vion_wps,vh_wps,vxc_wps,vloc_wps)
        deallocate(vion_wae,vh_wae,vxc_wae,vloc_wae,vcor_wae)
        deallocate(nrcl)
        deallocate(wght,wght2)
        deallocate(ekin_wps,ekin_wae,drphin,drphim,drpsin,drpsim)
        deallocate(ddrphim,ddrpsim)
        deallocate(emphnphm,empsnpsm)
        deallocate(ekin_wps2,ekin_wae2)
        deallocate(dh_ae,dh_ps,dh_qps)
    
    end subroutine write_dion
    
   !========================================
    subroutine make_vcor_wae(ln,lm,nrc,vcor)
   !========================================
        integer,intent(in):: ln,lm,nrc
        real(8),intent(out):: vcor
        integer:: ier,i
        real(8),pointer,dimension(:):: pipj,dsum,wght,rhcor
        real(8):: rr,sum1,sum2,sum0
        integer:: ir,ii,i0,j,jr,is
            
        allocate(pipj(1:nrc))
        allocate(dsum(1:nrc))
        allocate(wght(1:nmesh))
        allocate(rhcor(1:nmesh))
        
        pipj(1:nrc)=rpsi_us(1:nrc,ln)*rpsi_us(1:nrc,lm)
        rhcor(1:nmesh)=4.d0*PI*rpos(1:nmesh)**2*rho_core(1:nmesh)
        
        dsum=0.d0
  !rhcorpw(i,it)      
        do ir=1,nrc
            sum1=0.d0
            sum2=0.d0
            if(ir==1) then
                sum1=0.d0
            else if((ir>=2).and.(ir<=5)) then
                do ii=2,ir
                    i0=ii-1
                    is=1
                    call set_open_weight_exp(ier,i0,is,rpos,wght)
                    do j=1,4
                        sum1=sum1+rhcor(i0+j*is)*wght(i0+j*is)
                    end do
                end do
            else
                call set_weight_exp(ier,1,ir,rpos,wght)
                do jr=1,ir
                    sum1=sum1+rhcor(jr)*wght(jr)
                end do
            end if
            sum1=sum1*pipj(ir)/rpos(ir)
            if(ir==nmesh) then
                sum2=0.d0
            else if((ir<=nmesh-1).and.(ir>=nmesh-4)) then
                do ii=ir,nmesh-1
                    i0=ii+1
                    is=-1
                    call set_open_weight_exp(ier,i0,is,rpos,wght)
                    do j=1,4
                        sum2=sum2+(1.d0/rpos(i0+j*is))* &
                                rhcor(i0+j*is)*wght(i0+j*is)
                    end do
                end do
            else
                call set_weight_exp(ier,ir,nmesh,rpos,wght)
                do jr=ir,nmesh
                    sum2=sum2+(1.d0/rpos(jr))* &
                                rhcor(jr)*wght(jr)
                end do
            end if
            sum2=sum2*pipj(ir)
            dsum(ir)=sum1+sum2
        end do
        
        call set_weight_exp(ier,1,nrc,rpos,wght)
        sum0=0.d0
        do ir=1,nrc
            sum0=sum0+dsum(ir)*wght(ir)
        end do
        
        vcor=sum0
        
        deallocate(pipj,dsum)
        deallocate(wght,rhcor)
        return
   end subroutine make_vcor_wae
   
! ***** For Debug *****

   !========================================
    subroutine make_dh_ae(ln,lm,nrc,dh_ae)
   !========================================
        integer,intent(in):: ln,lm,nrc
        real(8),intent(out):: dh_ae
        integer:: ier,i
        real(8),pointer,dimension(:):: pipj,dsum,wght,rhor
        real(8):: rr,sum1,sum2,sum0
        integer:: ir,ii,i0,j,jr,is
            
        allocate(pipj(1:nrc))
        allocate(dsum(1:nrc))
        allocate(wght(1:nrc))
        allocate(rhor(1:nrc))
        
        pipj(1:nrc)=rpsi_us(1:nrc,ln)*rpsi_us(1:nrc,lm)
        rhor=0.d0
        if(nspin.eq.1) then
            rhor(1:nrc)=rho(1:nrc,1)
        else
            rhor(1:nrc)=rho(1:nrc,1)+rho(1:nrc,2)
        end if
        do ir=1,nrc
            rhor(ir)=4.d0*PI*rpos(ir)**2*(rhor(ir)-rho_core(ir))
        end do
        
        dsum=0.d0
  !rhcorpw(i,it)      
        do ir=1,nrc
            sum1=0.d0
            sum2=0.d0
            if(ir==1) then
                sum1=0.d0
            else if((ir>=2).and.(ir<=5)) then
                do ii=2,ir
                    i0=ii-1
                    is=1
                    call set_open_weight_exp(ier,i0,is,rpos,wght)
                    do j=1,4
                        sum1=sum1+rhor(i0+j*is)*wght(i0+j*is)
                    end do
                end do
            else
                call set_weight_exp(ier,1,ir,rpos,wght)
                do jr=1,ir
                    sum1=sum1+rhor(jr)*wght(jr)
                end do
            end if
            sum1=sum1*pipj(ir)/rpos(ir)
            if(ir==nrc) then
                sum2=0.d0
            else if((ir<=nrc-1).and.(ir>=nrc-4)) then
                do ii=ir,nrc-1
                    i0=ii+1
                    is=-1
                    call set_open_weight_exp(ier,i0,is,rpos,wght)
                    do j=1,4
                        sum2=sum2+(1.d0/rpos(i0+j*is))* &
                                rhor(i0+j*is)*wght(i0+j*is)
                    end do
                end do
            else
                call set_weight_exp(ier,ir,nrc,rpos,wght)
                do jr=ir,nrc
                    sum2=sum2+(1.d0/rpos(jr))* &
                                rhor(jr)*wght(jr)
                end do
            end if
            sum2=sum2*pipj(ir)
            dsum(ir)=sum1+sum2
        end do
        
        call set_weight_exp(ier,1,nrc,rpos,wght)
        sum0=0.d0
        do ir=1,nrc
            sum0=sum0+dsum(ir)*wght(ir)
        end do
        
        dh_ae=sum0
        
        deallocate(pipj,dsum)
        deallocate(wght,rhor)
        return
   end subroutine make_dh_ae

   !========================================
    subroutine make_dh_ps(ln,lm,nrc,dh_ps)
   !========================================
        integer,intent(in):: ln,lm,nrc
        real(8),intent(out):: dh_ps
        integer:: ier,i
        real(8),pointer,dimension(:):: pipj,dsum,wght,rhor
        real(8):: rr,sum1,sum2,sum0
        integer:: ir,ii,i0,j,jr,is
            
        allocate(pipj(1:nrc))
        allocate(dsum(1:nrc))
        allocate(wght(1:nrc))
        allocate(rhor(1:nrc))
        
        pipj(1:nrc)=rphi_us(1:nrc,ln)*rphi_us(1:nrc,lm)
        rhor=0.d0
        do ir=1,nrc
! =============================================== modified by K. T. ======== 4.0
!            rhor(ir)=4.d0*PI*rpos(ir)**2*rho_sol(ir)
            rhor(ir)=4.d0*PI*rpos(ir)**2*rho_sol(ir,1)
! ========================================================================== 4.0
        end do
        
        dsum=0.d0
  !rhcorpw(i,it)      
        do ir=1,nrc
            sum1=0.d0
            sum2=0.d0
            if(ir==1) then
                sum1=0.d0
            else if((ir>=2).and.(ir<=5)) then
                do ii=2,ir
                    i0=ii-1
                    is=1
                    call set_open_weight_exp(ier,i0,is,rpos,wght)
                    do j=1,4
                        sum1=sum1+rhor(i0+j*is)*wght(i0+j*is)
                    end do
                end do
            else
                call set_weight_exp(ier,1,ir,rpos,wght)
                do jr=1,ir
                    sum1=sum1+rhor(jr)*wght(jr)
                end do
            end if
            sum1=sum1*pipj(ir)/rpos(ir)
            if(ir==nrc) then
                sum2=0.d0
            else if((ir<=nrc-1).and.(ir>=nrc-4)) then
                do ii=ir,nrc-1
                    i0=ii+1
                    is=-1
                    call set_open_weight_exp(ier,i0,is,rpos,wght)
                    do j=1,4
                        sum2=sum2+(1.d0/rpos(i0+j*is))* &
                                rhor(i0+j*is)*wght(i0+j*is)
                    end do
                end do
            else
                call set_weight_exp(ier,ir,nrc,rpos,wght)
                do jr=ir,nrc
                    sum2=sum2+(1.d0/rpos(jr))* &
                                rhor(jr)*wght(jr)
                end do
            end if
            sum2=sum2*pipj(ir)
            dsum(ir)=sum1+sum2
        end do
        
        call set_weight_exp(ier,1,nrc,rpos,wght)
        sum0=0.d0
        do ir=1,nrc
            sum0=sum0+dsum(ir)*wght(ir)
        end do
        
        dh_ps=sum0
        
        deallocate(pipj,dsum)
        deallocate(wght,rhor)
        return
   end subroutine make_dh_ps
   
   !=========================================
    subroutine make_dh_qps(ltlt,nrc,dh_qps)
   !=========================================
        integer,intent(in):: ltlt,nrc
        real(8),intent(out):: dh_qps
        integer:: ier,i
        real(8),pointer,dimension(:):: pipj,dsum,wght,rhor
        real(8):: rr,sum1,sum2,sum0
        integer:: ir,ii,i0,j,jr,is
            
        allocate(pipj(1:nrc))
        allocate(dsum(1:nrc))
        allocate(wght(1:nrc))
        allocate(rhor(1:nrc))
        
        pipj(1:nrc)=rpos(1:nrc)**2*qps_us(1:nrc,ltlt,0)
        rhor=0.d0
        do ir=1,nrc
! ============================================= modified by K. T. ======== 4.0
!            rhor(ir)=4.d0*PI*rpos(ir)**2*rho_sol(ir)
            rhor(ir)=4.d0*PI*rpos(ir)**2*rho_sol(ir,1)
! =========================================================================== 4.0
        end do
        
        dsum=0.d0
  !rhcorpw(i,it)      
        do ir=1,nrc
            sum1=0.d0
            sum2=0.d0
            if(ir==1) then
                sum1=0.d0
            else if((ir>=2).and.(ir<=5)) then
                do ii=2,ir
                    i0=ii-1
                    is=1
                    call set_open_weight_exp(ier,i0,is,rpos,wght)
                    do j=1,4
                        sum1=sum1+rhor(i0+j*is)*wght(i0+j*is)
                    end do
                end do
            else
                call set_weight_exp(ier,1,ir,rpos,wght)
                do jr=1,ir
                    sum1=sum1+rhor(jr)*wght(jr)
                end do
            end if
            sum1=sum1*pipj(ir)/rpos(ir)
            if(ir==nrc) then
                sum2=0.d0
            else if((ir<=nrc-1).and.(ir>=nrc-4)) then
                do ii=ir,nrc-1
                    i0=ii+1
                    is=-1
                    call set_open_weight_exp(ier,i0,is,rpos,wght)
                    do j=1,4
                        sum2=sum2+(1.d0/rpos(i0+j*is))* &
                                rhor(i0+j*is)*wght(i0+j*is)
                    end do
                end do
            else
                call set_weight_exp(ier,ir,nrc,rpos,wght)
                do jr=ir,nrc
                    sum2=sum2+(1.d0/rpos(jr))* &
                                rhor(jr)*wght(jr)
                end do
            end if
            sum2=sum2*pipj(ir)
            dsum(ir)=sum1+sum2
        end do
        
        call set_weight_exp(ier,1,nrc,rpos,wght)
        sum0=0.d0
        do ir=1,nrc
            sum0=sum0+dsum(ir)*wght(ir)
        end do
        
        dh_qps=sum0
        
        deallocate(pipj,dsum)
        deallocate(wght,rhor)
        return
   end subroutine make_dh_qps












end module dion_analysis

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   Version history: 
!
!     4.0:  2013/03/01
!           codes for spin-polarized pseudopotential generation are added
!     4.1:  2013/11/22 - 
!           Info of core wfns and energy contributions can be added to gncpp2
!     4.2:  2014/07/23 - 
!           gncpp2 can be geregated even when nmesh /= 1501
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : write_so_atom, read_input_so, calc_spin_orbit
!                : write_energy_level_so, write_etot_so
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine write_so_atom(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in) :: ifile
   write(ifile,*)
   write(ifile,*) 'oooooooooooooooooooooooooooooooooooooooooo'
   write(ifile,*) 'oooooo                              oooooo'
   write(ifile,*) 'oooooo          Spin-Orbit          oooooo'
   write(ifile,*) 'oooooo          Interaction         oooooo'
   write(ifile,*) 'oooooo                              oooooo'
   write(ifile,*) 'oooooooooooooooooooooooooooooooooooooooooo'
   end subroutine write_so_atom


!=====================================================================
   subroutine read_input_so(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: fn_number_of_words
   character(256) :: &
      buffer, keyword, sub_keyword
   character(50),allocatable :: &
      state_tmpj(:), state_tmpk(:)
   integer :: &
      loop, ishell, jshell, kshell, nn, ll, jj2, ss, &
      nocc_tmp, jjshell, jjspin
   integer,allocatable :: &
      spin_tmpj(:), n_qnum_tmpj(:), l_qnum_tmpj(:), &
      is_solve_tmpj(:), is_valence_tmpj(:), &
      spin_tmpk(:), n_qnum_tmpk(:), l_qnum_tmpk(:), k_qnum_tmpk(:), &
      j2_qnum_tmpk(:), is_solve_tmpk(:), is_valence_tmpk(:)
   real(8) :: &
      sum, res, fe1, fe2
   real(8),allocatable :: &
      focc_tmpj(:), focc_tmpk(:)
   ier = 0
   rewind(IFIN)
   loop = 0
INPUT: do while (loop < 1000)
   loop = loop + 1
      read(IFIN,'(a)',end=98) buffer
      if (buffer == '') cycle INPUT
      read(buffer,*) keyword
      select case (keyword(1:1))
      case ('#', '!')
         cycle INPUT
      end select
      select case (keyword)
      case ('#', '!')
         cycle INPUT
      case ('end', 'END', 'End')
         exit INPUT
      case ('jobname', 'JOBNAME', 'Jobname')
      case ('atom_number')
         read(buffer,*) keyword, fatom, felec
         zatom = max(nint(fatom),1)
      case ('electron_config')
         select case (fn_number_of_words(buffer))
         case (4)
            read(buffer,*) keyword, nshell_in, calc_type, spin_type
            spin_state_type = 'automatic'
         case (5)
            read(buffer,*) keyword, nshell_in, calc_type, spin_type, &
                           spin_state_type
         end select
         calc_type_explained = 'Relativistic'
         is_calc = REL
         select case (spin_type)
         case ('restricted', 'RESTRICTED', 'Restricted')
            spin_type_explained = 'Restricted'
            is_spin = RESTRICTED
         case ('polarized', 'POLARIZED', 'Polarized')
            write(IFLOG,*) '### CAUTION ### spin_type'
            write(IFLOG,*) '   spin_type ... ',spin_type
            write(IFLOG,*) &
            'spin_type must be RESTRICTED for spin-orbit calculation.'
            ier = -1 ; go to 99
         case default
            write(IFLOG,*) '### ERROR ### spin_type'
            write(IFLOG,*) '   spin_type ... ',spin_type
            ier = 1 ; go to 99
         end select
         is_spin_state = AUTOMATIC
         spin_state_type_explained = 'Automatic'
         felec1 = felec ; felec2 = 0.d0
         nspin = 1
        !++++++++++++++++++++++++++++++++++++++++++++++++++++++
         allocate(state_in(nshell_in),focc_in(nshell_in,2),  &
            is_valence_in(nshell_in),is_solve_in(nshell_in), &
            n_qnum_in(nshell_in),l_qnum_in(nshell_in))
            focc_in    = 0.d0
            is_valence_in = 0 ; is_solve_in = 0
            n_qnum_in     = 0 ; l_qnum_in   = 0
        !++++++++++++++++++++++++++++++++++++++++++++++++++++++
         focc_in(:,:) = 0.d0
         foccnl(:,:,:) = 0.d0
         do ishell = 1,nshell_in
            read(IFIN,*) state_in(ishell), focc_in(ishell,1), &
                         is_solve_in(ishell)
            is_valence_in(ishell) = 0
            read(state_in(ishell)(1:1),*) n_qnum_in(ishell)
            select case (state_in(ishell)(2:2))
            case ('s', 'S')
               l_qnum_in(ishell) = 0
            case ('p', 'P')
               l_qnum_in(ishell) = 1
            case ('d', 'D')
               l_qnum_in(ishell) = 2
            case ('f', 'F')
               l_qnum_in(ishell) = 3
            case default
               write(IFLOG,*) '### ERROR ### state_in(ishell)(2:2)'
               write(IFLOG,*) '   ishell                ...',ishell
               write(IFLOG,*) '   state_in(ishell)(2:2) ...', &
                                  state_in(ishell)(2:2)
               ier = 1 ; go to 99
            end select
            ll = l_qnum_in(ishell)
            nn = n_qnum_in(ishell)
            foccnl(nn,ll,1) = focc_in(ishell,1)
            foccnl(nn,ll,2) = focc_in(ishell,2)
         end do
        !+++++++++++++++++++++++++++++++++++++++++++
         allocate( &
            spin_tmpj      (nshell_in*nspin), &
            state_tmpj     (nshell_in*nspin), &
            n_qnum_tmpj    (nshell_in*nspin), &
            l_qnum_tmpj    (nshell_in*nspin), &
            is_solve_tmpj  (nshell_in*nspin), &
            is_valence_tmpj(nshell_in*nspin), &
            focc_tmpj      (nshell_in*nspin))
            spin_tmpj     = 0
            n_qnum_tmpj   = 0 ; l_qnum_tmpj     = 0
            is_solve_tmpj = 0 ; is_valence_tmpj = 0
            focc_tmpj  = 0.d0
        !+++++++++++++++++++++++++++++++++++++++++++
         fe1 = felec1 ; fe2 = felec2
         jshell = 0
         do ishell = 1,nshell_in
            jshell = jshell + 1
            spin_tmpj      (jshell) = +1
            state_tmpj     (jshell) = state_in     (ishell)
            n_qnum_tmpj    (jshell) = n_qnum_in    (ishell)
            l_qnum_tmpj    (jshell) = l_qnum_in    (ishell)
            is_solve_tmpj  (jshell) = is_solve_in  (ishell)
            is_valence_tmpj(jshell) = is_valence_in(ishell)
            focc_tmpj      (jshell) = focc_in      (ishell,1)
            if (is_spin == POLARIZED) then
               jshell = jshell + 1
               spin_tmpj      (jshell) = -1
               state_tmpj     (jshell) = state_in     (ishell)
               n_qnum_tmpj    (jshell) = n_qnum_in    (ishell)
               l_qnum_tmpj    (jshell) = l_qnum_in    (ishell)
               is_solve_tmpj  (jshell) = is_solve_in  (ishell)
               is_valence_tmpj(jshell) = is_valence_in(ishell)
               nocc_tmp = 2*l_qnum_in(ishell) + 1
               if (focc_in(ishell,1) > dble(nocc_tmp)) then
                  focc_tmpj(jshell-1) = dble(nocc_tmp)
                  focc_tmpj(jshell)   = focc_in(ishell,1) &
                                      - dble(nocc_tmp)
               else
                  focc_tmpj(jshell)   = 0.d0
               end if
                  if ((n_qnum_tmpj(jshell) == 1).and. &
                      (l_qnum_tmpj(jshell) == 0).and. &
                      (focc_tmpj  (jshell) <  1.d-10)) then
                     is_solve_tmpj(jshell) = 0
                  end if
            end if
         end do
         do jjshell = 1,jshell
            nn = n_qnum_tmpj(jjshell)
            ll = l_qnum_tmpj(jjshell)
            ss = spin_tmpj  (jjshell)
            jjspin = 2 - (ss+1)/2
            foccnls(nn,ll,jjspin) = focc_tmpj(jjshell)
         end do
        !+++++++++++++++++++++++++++++++++++++++++++
         allocate( &
            spin_tmpk      (jshell*2), &
            state_tmpk     (jshell*2), &
            n_qnum_tmpk    (jshell*2), &
            l_qnum_tmpk    (jshell*2), &
            k_qnum_tmpk    (jshell*2), &
            j2_qnum_tmpk   (jshell*2), &
            is_solve_tmpk  (jshell*2), &
            is_valence_tmpk(jshell*2), &
            focc_tmpk      (jshell*2))
            spin_tmpk     = 0 ; n_qnum_tmpk     = 0
            l_qnum_tmpk   = 0 ; k_qnum_tmpk     = 0
            j2_qnum_tmpk  = 0
            is_solve_tmpk = 0 ; is_valence_tmpk = 0
            focc_tmpk  = 0.d0
        !+++++++++++++++++++++++++++++++++++++++++++
         kshell = 0
         do ishell = 1,jshell
            nn = n_qnum_tmpj(ishell)
            ll = l_qnum_tmpj(ishell)
            ss = spin_tmpj  (ishell)
            if (ll > 0) then
               kshell = kshell + 1
               spin_tmpk      (kshell) = ss
               state_tmpk     (kshell) = state_tmpj(ishell)
               n_qnum_tmpk    (kshell) = nn
               l_qnum_tmpk    (kshell) = ll
               k_qnum_tmpk    (kshell) = ll
               j2_qnum_tmpk   (kshell) = 2*ll-1
               is_solve_tmpk  (kshell) = is_solve_tmpj  (ishell)
               is_valence_tmpk(kshell) = is_valence_tmpj(ishell)
               jj2 = j2_qnum_tmpk(kshell)
               if (focc_tmpj(ishell) > dble(jj2+1)) then
                  focc_tmpk(kshell) = dble(jj2+1)
                  res = focc_tmpj(ishell) - dble(jj2+1)
               else
                  focc_tmpk(kshell) = focc_tmpj(ishell)
                  res = 0.d0
               end if
            end if
               kshell = kshell + 1
               spin_tmpk      (kshell) = ss
               state_tmpk     (kshell) = state_tmpj(ishell)
               n_qnum_tmpk    (kshell) = nn
               l_qnum_tmpk    (kshell) = ll
               k_qnum_tmpk    (kshell) = -ll-1
               j2_qnum_tmpk   (kshell) = 2*ll+1
               is_solve_tmpk  (kshell) = is_solve_tmpj  (ishell)
               is_valence_tmpk(kshell) = is_valence_tmpj(ishell)
               if (ll == 0) then
                  focc_tmpk(kshell) = focc_tmpj(ishell)
               else
                  focc_tmpk(kshell) = res
               end if
         end do
         nshell = kshell
        !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         allocate(state(nshell),spin_label(nshell),spin(nshell), &
            focc(nshell),is_valence(nshell),is_solve(nshell),    &
            n_qnum(nshell),l_qnum(nshell),k_qnum(nshell),        &
            j2_qnum(nshell),list_shell(nshell),nocc(nshell),     &
            nrm_pos(nshell),nrt_pos(nshell),nmm_pos(nshell))
            spin       = 0 ; focc  = 0.d0
            is_valence = 0 ; is_solve = 0
            n_qnum     = 0 ; l_qnum   = 0
            k_qnum     = 0 ; j2_qnum  = 0
            list_shell = 0 ; nocc     = 0
            nrm_pos    = 0 ; nrt_pos  = 0
            nmm_pos    = 0
        !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         do ishell = 1,nshell
            spin      (ishell) = spin_tmpk      (ishell)
            if (spin(ishell) == 1) then
               spin_label(ishell) = '+'
            else
               spin_label(ishell) = '-'
            end if
            state     (ishell) = state_tmpk     (ishell)
            n_qnum    (ishell) = n_qnum_tmpk    (ishell)
            l_qnum    (ishell) = l_qnum_tmpk    (ishell)
            k_qnum    (ishell) = k_qnum_tmpk    (ishell)
            j2_qnum   (ishell) = j2_qnum_tmpk   (ishell)
            is_solve  (ishell) = is_solve_tmpk  (ishell)
            is_valence(ishell) = is_valence_tmpk(ishell)
            focc      (ishell) = focc_tmpk      (ishell)
            nocc(ishell) = (j2_qnum(ishell) + 1)/nspin
         end do
        !+++++++++++++++++++++++++++++++++++++++++++++++++++
         deallocate( &
            spin_tmpj,state_tmpj,n_qnum_tmpj,l_qnum_tmpj, &
            is_solve_tmpj,is_valence_tmpj,focc_tmpj,      &
            spin_tmpk,state_tmpk,n_qnum_tmpk,l_qnum_tmpk, &
            k_qnum_tmpk,j2_qnum_tmpk,                     &
            is_solve_tmpk,is_valence_tmpk,focc_tmpk)
        !+++++++++++++++++++++++++++++++++++++++++++++++++++
         fe1 = 0.d0 ; fe2 = 0.d0
         do ishell = 1,nshell
            fe1 = fe1 + focc(ishell)
         end do
         if (abs(fe1 - felec) > 1.d-8) then
            write(IFLOG,*) '### ERROR ### fe1 != felec'
            write(IFLOG,*) '   fe1   ...',fe1
            write(IFLOG,*) '   felec ...',felec
            ier = 3 ; go to 99
         end if
      case ('core_potential')
         read(buffer,*) keyword, core_type
         select case (core_type)
         case ('normal', 'NORMAL', 'Normal')
            core_type_explained = '-Z/r'
            is_core = NORMAL
            lmax_core = 0
         case ('patom', 'PATOM', 'Patom')
            core_type_explained = 'Pseudo-atom (Poly-12)'
            is_core = PATOM
            read(IFIN,*) keyword, sub_keyword
            select case (sub_keyword)
            case ('s', 'S')
               lmax_core = 0
            case ('p', 'P')
               lmax_core = 1
            case ('d', 'D')
               lmax_core = 2
            case ('f', 'F')
               lmax_core = 3
            case default
               write(IFLOG,*) '### ERROR ### lmax_core'
               ier = 1 ; go to 99
            end select
           !+++++++++++++++++++++++++++++++++++++++
            allocate(rcut_core(0:lmax_core), &
                     vcut_core(0:lmax_core))
               rcut_core = 0.d0 ; vcut_core = 0.d0
           !+++++++++++++++++++++++++++++++++++++++
            rcut_core(:) = 0.d0 ; vcut_core(:) = 0.d0
            do ll = 0,lmax_core
              read(IFIN,*) keyword, rcut_core(ll), vcut_core(ll)
            end do
         case default
            write(IFLOG,*) '### ERROR ### core_type'
            write(IFLOG,*) '   core_type ... ',core_type
            ier = 1 ; go to 99
         end select
      case ('xc_potential')
         select case (fn_number_of_words(buffer))
         case (2)
            read(buffer,*) keyword, xc_type
            xc_approx = 'momo'
         case (3)
            read(buffer,*) keyword, xc_type, xc_approx
         end select
         select case (xc_type)
         case ('pz81', 'ldapz81', 'ldapz', &
               'PZ81', 'LDAPZ81', 'LDAPZ')
            is_xc_class = LDA
            xc_type_explained = 'LDA (PZ81)'
            is_xc = LDAPZ81
         case ('pw92', 'ldapw92', 'pw91', 'ldapw91', &
               'PW92', 'LDAPW92', 'PW91', 'LDAPW91')
            is_xc_class = LDA
            select case (xc_approx)
            case ('none')
               xc_type_explained = 'LDA (PW92-MOMO)'
               is_xc = LDAPW92_MOMO
            case ('momo', 'MOMO')
               xc_type_explained = 'LDA (PW92-MOMO)'
               is_xc = LDAPW92_MOMO
            case ('momo2', 'MOMO2')
               xc_type_explained = 'LDA (PW92-MOMO2)'
               is_xc = LDAPW92_MOMO2
            case ('jrcat', 'JRCAT', 'gncpp', 'GNCPP')
               xc_type_explained = 'LDA (PW92-GNCPP)'
               is_xc = LDAPW92_GNCPP
            case default
               write(IFLOG,*) '### ERROR ### xc_approx'
               write(IFLOG,*) '   xc_type   ... ',xc_type
               write(IFLOG,*) '   xc_approx ... ',xc_approx
               ier = 1 ; go to 99
            end select
         case ('pbe96', 'ggapbe96', 'ggapbe', &
               'PBE96', 'GGAPBE96', 'GGAPBE')
            is_xc_class = GGA
            select case (xc_approx)
            case ('none')
               xc_type_explained = 'GGA (PBE96-MOMO)'
               is_xc = GGAPBE96_MOMO
            case ('momo', 'MOMO')
               xc_type_explained = 'GGA (PBE96-MOMO)'
               is_xc = GGAPBE96_MOMO
            case ('momo2', 'MOMO2')
               xc_type_explained = 'GGA (PBE96-MOMO2)'
               is_xc = GGAPBE96_MOMO2
            case ('jrcat', 'JRCAT', 'gncpp', 'GNCPP')
               xc_type_explained = 'GGA (PBE96-GNCPP)'
               is_xc = GGAPBE96_GNCPP
            case ('kato', 'Kato', 'KATO')
               xc_type_explained = 'GGA (PBE96-KATO)'
               is_xc = GGAPBE96_KATO
            case default
               write(IFLOG,*) '### ERROR ### xc_approx'
               write(IFLOG,*) '   xc_type   ... ',xc_type
               write(IFLOG,*) '   xc_approx ... ',xc_approx
               ier = 1 ; go to 99
            end select
         case ('revpbe', 'ggarevpbe', &
               'revPBE', 'ggarevPBE', &
               'REVPBE', 'GGAREVPBE')
            is_xc_class = GGA
            xc_type_explained = 'GGA (revPBE)'
            is_xc = REVPBE
         case ('xlda', 'XLDA')
            is_xc_class = LDA
            xc_type_explained = 'LDA (Exchange only)'
            is_xc = XLDA
         case ('xgga', 'XGGA')
            is_xc_class = GGA
            xc_type_explained = 'GGA (Exchange only)'
            is_xc = XGGA
         case ('none', 'NONE')
            is_xc_class = LDA
            xc_type_explained = 'None'
            is_xc = NONE
         case default
            write(IFLOG,*) '### ERROR ### xc_type'
            write(IFLOG,*) '   xc_type ... ',xc_type
            ier = 1 ; go to 99
         end select
      case ('rmesh', 'mesh')
         read(buffer,*) keyword, mesh_type
         select case (mesh_type)
         case ('manual', 'MANUAL', 'Manual')
            mesh_type_explained   = 'Logarithmic (Manual)'
            weight_type_explained = 'Extended rule'
            is_mesh   = MANUAL
            is_weight = EXTENDED
            read(IFIN,*) keyword, nmesh
            read(IFIN,*) keyword, rmin, rmax
            dx = log(rmax/rmin) / dble(nmesh-1)
         case ('standard', 'STANDARD', 'Standard', &
               'jrcat', 'JRCAT')
            mesh_type_explained   = 'Logarithmic (Standard)'
            weight_type_explained = 'Extended rule'
            is_mesh   = JRCAT
            is_weight = EXTENDED
            nmesh = 1501  ;  xh = 96.d0  ;  rmax = 60.d0
            rmin = rmax * exp(dble(1-nmesh)/xh)
            dx   = 1.d0/xh
         case default
            write(IFLOG,*) '### ERROR ### mesh_type'
            write(IFLOG,*) '   mesh_type ... ',mesh_type
            ier = 1 ; go to 99
         end select
      case ('mixing')
         read(buffer,*) keyword, mix1, mix2
      case ('anderson')
         read(buffer,*) keyword, n_anderson
      case ('conv')
         read(buffer,*) keyword
            read(IFIN,*) keyword, loop_conv
            read(IFIN,*) keyword, dee_conv
      case ('order_pc')
         read(buffer,*) keyword, iord_pc
      case ('order_diff')
         read(buffer,*) keyword, iord_diff
      case ('order_nec')
         read(buffer,*) keyword, iord_nec
      case ('order_coeff')
         read(buffer,*) keyword, iord_coeff
      case ('eps_check')
         read(buffer,*) keyword, eps_check
      case ('eps_de')
         read(buffer,*) keyword, eps_de
      case default
         cycle INPUT
      end select
end do INPUT
   sum = 0.d0
   do ishell = 1,nshell
      sum = sum + focc(ishell)
   end do
   if (abs(sum-felec) > 1.d-15) then
      write(IFLOG,*) '### ERROR ### sum of focc != felec'
      write(IFLOG,*) '   sum of focc ...',sum
      write(IFLOG,*) '   felec       ...',felec
      ier = 1 ; go to 99
   end if
   go to 99
98 continue
   ier = 100
99 continue
   end subroutine read_input_so

!=====================================================================
   subroutine calc_spin_orbit(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   rewind(IFIN)
   call read_input_so(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in read_input_so' ; go to 99
   end if
  !+++++++++++++++++++++++++++++++++++++++++++++
   allocate(atom_label(NATOM),atom_name(NATOM))
  !+++++++++++++++++++++++++++++++++++++++++++++
   call set_atom_label_name(NATOM,is_core,zatom,atom_label,atom_name)
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++
   allocate(rpos(nmesh),xpos(nmesh),wr(nmesh),wt(nmesh))
      rpos = 0.d0 ; xpos = 0.d0 ; wr = 0.d0 ; wt = 0.d0
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++
   call generate_rmesh(ier,nmesh,rmin,rmax,xmin,xmax,dx,xpos,rpos,wr)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in generate_rmesh' ; go to 99
   end if
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   allocate(chi_gl(nmesh),chi_gr(nmesh),chi_fl(nmesh),        &
      chi_fr(nmesh),dxchi_gl(nmesh),dxchi_gr(nmesh),          &
      dxchi_fl(nmesh),dxchi_fr(nmesh),                        &
      rho(nmesh,nspin),rho_old(nmesh,nspin),rho_zeta(nmesh),  &
      engy(nshell),engy_old(nshell),vh(nmesh),                &
      ex(nmesh),ec(nmesh),vx(nmesh,nspin),vc(nmesh,nspin),    &
      chi_g(nmesh,nshell),dxchi_g(nmesh,nshell),              &
      vcoeff(-1:iord_coeff,nspin,0:lmax_core),                &
      vion(nmesh,0:lmax_core),veff(nmesh,nspin,0:lmax_core),  &
      veff_old(nmesh,nspin,0:lmax_core),dee_save(nsave_dee))
      chi_gl   = 0.d0 ; chi_gr   = 0.d0
      chi_fl   = 0.d0 ; chi_fr   = 0.d0
      dxchi_gl = 0.d0 ; dxchi_gr = 0.d0
      dxchi_fl = 0.d0 ; dxchi_fr = 0.d0
      rho      = 0.d0 ; rho_old  = 0.d0 ; rho_zeta = 0.d0
      engy     = 0.d0 ; engy_old = 0.d0 ; vh       = 0.d0
      ex       = 0.d0 ; ec       = 0.d0
      vx       = 0.d0 ; vc       = 0.d0
      chi_g    = 0.d0 ; dxchi_g  = 0.d0 ; vcoeff   = 0.d0
      vion     = 0.d0 ; veff     = 0.d0 ; veff_old = 0.d0
      dee_save = 0.d0
   if (is_calc == REL) then
      allocate(chi_f(nmesh,nshell))   ; chi_f = 0.d0
      allocate(dxchi_f(nmesh,nshell)) ; dxchi_f = 0.d0
   end if
   if (is_xc_class == GGA) then
      allocate(drho(nmesh,nspin))  ; drho = 0.d0
      allocate(ddrho(nmesh,nspin)) ; ddrho = 0.d0
   end if
   if (is_xc == GGAPBE96_MOMO2) then
      allocate( &
         rho1_rad(nmesh),rho2_rad(nmesh),                      &
         drho1_rad(nmesh),drho2_rad(nmesh),drho_rad(nmesh),    &
         fx_rad(nmesh),fc_rad(nmesh),dfx_rad(nmesh,2),         &
         dfc_rad(nmesh,2),dfxda_rad(nmesh,2),dfcda_rad(nmesh), &
         vx_rad(nmesh,2),vc_rad(nmesh,2))
      rho1_rad = 0.d0 ; rho2_rad = 0.d0 ; drho1_rad = 0.d0
      drho2_rad = 0.d0 ; drho_rad = 0.d0
      fx_rad = 0.d0 ; fc_rad = 0.d0
      dfx_rad = 0.d0 ; dfc_rad = 0.d0
      dfxda_rad = 0.d0 ; dfcda_rad = 0.d0
      vx_rad = 0.d0 ; vc_rad = 0.d0
   end if
   if (n_anderson > 0) then
      allocate(rho_p(nmesh,nspin,0:n_anderson),                   &
         rho_old_p(nmesh,nspin,0:n_anderson),coeff_p(n_anderson), & 
         mat_p(n_anderson,n_anderson),vec_p(n_anderson,1))
         rho_p = 0.d0 ; rho_old_p = 0.d0 ; coeff_p = 0.d0
         mat_p = 0.d0 ; vec_p = 0.d0
   end if
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   call set_vion(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in set_vion' ; go to 99
   end if
   call set_init_state(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in set_init_state' ; go to 99
   end if
   call calc_scf(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_scf' ; go to 99
   end if
   nshell_so = nshell
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   allocate(state_so(nshell_so),spin_label_so(nshell_so), &
      spin_so(nshell_so),focc_so(nshell_so),              &
      is_valence_so(nshell_so),is_solve_so(nshell_so),    &
      n_qnum_so(nshell_so),l_qnum_so(nshell_so),          &
      k_qnum_so(nshell_so),j2_qnum_so(nshell_so),         &
      list_shell_so(nshell_so),nocc_so(nshell_so),        &
      nrm_pos_so(nshell_so),nrt_pos_so(nshell_so),        &
      nmm_pos_so(nshell_so),engy_so(nshell_so))
      spin_so       = 0 ; focc_so  = 0.d0
      is_valence_so = 0 ; is_solve_so = 0
      n_qnum_so     = 0 ; l_qnum_so   = 0
      k_qnum_so     = 0 ; j2_qnum_so  = 0
      list_shell_so = 0 ; nocc_so     = 0
      nrm_pos_so    = 0 ; nrt_pos_so  = 0
      nmm_pos_so    = 0 ; engy_so  = 0.d0
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   state_so(:)      = state(:)      ; spin_label_so(:) = spin_label(:)
   spin_so(:)       = spin(:)       ; focc_so(:)       = focc(:)
   is_valence_so(:) = is_valence(:) ; is_solve_so(:)   = is_solve(:)
   n_qnum_so(:)     = n_qnum(:)     ; l_qnum_so(:)     = l_qnum(:)
   k_qnum_so(:)     = k_qnum(:)     ; j2_qnum_so(:)    = j2_qnum(:)
   list_shell_so(:) = list_shell(:) ; nocc_so(:)       = nocc(:)
   nrm_pos_so(:)    = nrm_pos(:)    ; nrt_pos_so(:)    = nrt_pos(:)
   nmm_pos_so(:)    = nmm_pos(:)    ; engy_so(:)       = engy(:)
   felec_so         = felec         ; ekin_sum_so      = ekin_sum
   eion_sum_so      = eion_sum      ; eh_sum_so        = eh_sum
   exc_sum_so       = exc_sum       ; vxc_sum_so       = vxc_sum
   ex_sum_so        = ex_sum        ; ec_sum_so        = ec_sum
   vx_sum_so        = vx_sum        ; vc_sum_so        = vc_sum
   eband_sum_so     = eband_sum     ; etot_sum_so      = etot_sum
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   deallocate(atom_label,atom_name)
   deallocate(rpos,xpos,wr,wt)
   deallocate(chi_gl,chi_gr,chi_fl,chi_fr,dxchi_gl,dxchi_gr,   &
      dxchi_fl,dxchi_fr,rho,rho_old,rho_zeta,engy,engy_old,vh, &
      ex,ec,vx,vc,chi_g,dxchi_g,vcoeff,vion,veff,              &
      veff_old,dee_save)
   if (allocated(chi_f)) then
      deallocate(chi_f,dxchi_f)
   end if
   if (allocated(drho)) then
      deallocate(drho,ddrho)
   end if
   if (allocated(rho1_rad)) then
      deallocate(rho1_rad,rho2_rad,drho1_rad, &
         drho2_rad,drho_rad,fx_rad,fc_rad,    &
         dfx_rad,dfc_rad,dfxda_rad,dfcda_rad, &
         vx_rad,vc_rad)
   end if   
   if (allocated(rho_p)) then
      deallocate(rho_p,rho_old_p,coeff_p,mat_p,vec_p)
   end if
   deallocate(state_in,focc_in,is_valence_in,is_solve_in, &
      n_qnum_in,l_qnum_in)
   deallocate(state,spin_label,spin,focc,is_valence,is_solve, &
      n_qnum,l_qnum,k_qnum,j2_qnum,list_shell,nocc, &
      nrm_pos,nrt_pos,nmm_pos)
   if (allocated(rcut_core)) then
      deallocate(rcut_core,vcut_core)
   end if
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99 continue
   end subroutine calc_spin_orbit

!=====================================================================
   subroutine write_energy_level_so(ifile)
!=====================================================================  
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer        :: i, nn, ll, ishell, lshell
   character(100) :: line
   do i = 1,100
      line(i:i)='-'
   end do
   write(ifile,*)
   write(ifile,*) 'eng  Energy levels [All-electron]'
   write(ifile,10) line(1:100)
   write(ifile,11) 'symm','j', &
                   'Energy (Ha)','Energy (eV)','nocc','focc'
   write(ifile,10) line(1:100)
   do ishell = 1,nshell_so
      lshell = list_shell_so(ishell)
      if (is_solve_so(lshell) == 0) then
         cycle
      end if
      nn = n_qnum_so(lshell)
      ll = l_qnum_so(lshell)
      write(ifile,12) state_so(lshell)(1:2),j2_qnum_so(lshell), &
         engy_so(lshell),engy_so(lshell)*HARTREE, &
         nocc_so(lshell),focc_so(lshell)
   end do
   write(ifile,10) line(1:100)
   write(ifile,13) 'Total number of electrons',felec_so
   write(ifile,10) line(1:100)
10 format(1x,'eng',a71)
11 format(1x,'eng',(3x,a4),(4x,a1,1x),2(9x,a11),(2x,a4),(6x,a4))
12 format(1x,'eng',(4x,a2,1x),(3x,i1,'/2'),2(f20.10),i6,f10.5)
13 format(1x,'eng',2x,a25,32x,f10.5)
   end subroutine write_energy_level_so

!=====================================================================
   subroutine write_etot_so(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer        :: i
   character(100) :: line
   do i = 1,100
      line(i:i) = '-'
   end do
   write(ifile,*)
   write(ifile,*)  'etot  Total energy [All-electron]'
   write(ifile,10) line(1:100)
   write(ifile,11) 'Energy (Ha)','Energy (eV)'
   write(ifile,10) line(1:100)
   write(ifile,20) 'Ekin  ',ekin_sum_so ,ekin_sum_so *HARTREE
   write(ifile,20) 'Eion  ',eion_sum_so ,eion_sum_so *HARTREE
   write(ifile,20) 'Eh    ',eh_sum_so   ,eh_sum_so   *HARTREE
   write(ifile,20) 'Exc   ',exc_sum_so  ,exc_sum_so  *HARTREE
   write(ifile,10) line(1:100)
   write(ifile,20) 'Ex    ',ex_sum_so   ,ex_sum_so   *HARTREE
   write(ifile,20) 'Ec    ',ec_sum_so   ,ec_sum_so   *HARTREE
   write(ifile,20) 'Vx    ',vx_sum_so   ,vx_sum_so   *HARTREE
   write(ifile,20) 'Vc    ',vc_sum_so   ,vc_sum_so   *HARTREE
   write(ifile,20) 'Vxc   ',vxc_sum_so  ,vxc_sum_so  *HARTREE
   write(ifile,20) 'Eband ',eband_sum_so,eband_sum_so*HARTREE
   write(ifile,10) line(1:100)
   write(ifile,20) 'Etot  ',etot_sum_so ,etot_sum_so *HARTREE
   write(ifile,10) line(1:100)
   write(ifile,*)  'etot  Ekin = Eband - Veff = Eband - Eion - 2Eh - Vxc'
   write(ifile,*)  'etot  Etot = Eband - Eh + (Exc - Vxc)'
10 format(1x,'etot',a50)
11 format(1x,'etot',2x,6x,2(9x,a11))
20 format(1x,'etot',2x,a6,2(f20.10))
   end subroutine write_etot_so

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   Version history: 
!
!     4.0:  2013/03/01
!           codes for spin-polarized pseudopotential generation are added
!     4.1:  2013/11/22 - 
!           Info of core wfns and energy contributions can be added to gncpp2
!     4.2:  2014/07/23 - 
!           gncpp2 can be geregated even when nmesh /= 1501
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : calc_bound_state, calc_vcoeff, set_initpoints_left
!                : int_from_left, set_initpoints_right, int_from_right
!                : guess_de, write_orbital, analysis_orbital
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine calc_bound_state(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ishell, ll, ll_core, nn, ispin, kk, id,  &
              node, node_sum, nrt, nrm, nmesh_max
   real(8) :: r, rr, ee, vv, ss, mass, de, gg_norm, g_norm, &
              sign_gr, ee_upper_limit, ee_lower_limit,      &
              ee_upper_limit_in, engy_minimum,              &
              sum, tmp, etest
   integer :: num_eslides, max_eslides, loop, max_loop, jr
   ier    =  0
   max_eslides  =  25
   if (natom >= 104) then
      max_loop = 1000
   else
      max_loop = 600
   end if
   engy_minimum = 1.d-4
   call calc_vcoeff(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_vcoeff' ; go to 99
   end if
MAIN:do ishell = 1,nshell
      if (is_solve(ishell) == 0) then
         engy(ishell) = 0.d0 ; cycle MAIN
      end if
      ispin = (1-spin(ishell))/2 + 1
      ll = l_qnum(ishell)
      if (is_core == PATOM) then
         ll_core = ll
      else
         ll_core = lmax_core
      end if
      nn = n_qnum(ishell)
      kk = k_qnum(ishell)
      node = nn - ll - 1
      num_eslides = 0
      if (is_core == OZAKI_KINO) then
         nmesh_max = nrcut_ok + 20
      else
         nmesh_max = nmm_pos(ishell)
      end if
         write(IFLOG,'(1x,a31,5i5)') &
            '??? ishell,ispin,nn,ll,node ...',ishell,ispin,nn,ll,node
      if (mod(node,2) == 0) then
         sign_gr = +1.d0
      else
         sign_gr = -1.d0
      end if
      ee = engy(ishell)
      if (is_core == OZAKI_KINO) then
         ee_upper_limit = 100.d0
      else
         ee_upper_limit = veff(nmesh_max,ispin,ll_core) - engy_minimum
         if (ee_upper_limit > -engy_minimum) then
            ee_upper_limit = -engy_minimum
         end if
      end if
      ee_upper_limit_in = ee_upper_limit
      ee_lower_limit = -fatom**2 / dble(nn)**2
      if ((ee > ee_upper_limit).or.(ee < ee_lower_limit)) then
         ee = 0.5d0*(ee_upper_limit + ee_lower_limit)
      end if
      de = ee
      loop = 0
SRCH_EE:do while (abs(de) > eps_de)
      loop = loop + 1
      if (loop > max_loop) then
         if (node_sum < node) then
            write(IFLOG,*) '### CAUTION ### node_sum < node'
            write(IFLOG,*) '   node_sum,node ...',node_sum,node
            write(IFLOG,*) &
               '   Following state may be an unbound state.'
            write(IFLOG,*) '      ishell          ...',ishell
            write(IFLOG,*) '      (nn,ll,kk,spin) ...',nn,ll,kk, &
                            '     ('//spin_label(ishell)(1:1)//')'
            if (abs(focc(ishell)) > eps_check) then
               write(IFLOG,*) '   Since focc of the state is non-zero,'
               write(IFLOG,*) '      calculation continues.'
               exit SRCH_EE
            else
               write(IFLOG,*) &
                  '   The state is removed in the later calc.'
               is_solve(ishell) = 0 ; ee = 0.d0 ; exit SRCH_EE
            end if
         else
            write(IFLOG,*) '### ERROR ### loop > max_loop'
            write(IFLOG,*) '   loop, max_loop    ...',loop,max_loop
            write(IFLOG,*) '   ishell,nn,ll,node ...',ishell,nn,ll,node
            write(IFLOG,*) '   node_sum,node     ...',node_sum,node
            write(IFLOG,*) '   ee_upper_limit    ...',ee_upper_limit
            write(IFLOG,*) '   ee_lower_limit    ...',ee_lower_limit
            write(IFLOG,*) '   ee                ...',ee
            ier=1 ; go to 99
         end if
      end if
      if (num_eslides > max_eslides) then
         write(IFLOG,*) '### CAUTION ### Eigenvalue was not converged !'
         write(IFLOG,*) '      num_eslides     ...',num_eslides
         write(IFLOG,*) '      max_eslides     ...',max_eslides
         write(IFLOG,*) '   Following state may be an unbound state.'
         write(IFLOG,*) '      ishell          ...',ishell
         write(IFLOG,*) '      (nn,ll,kk,spin) ...',nn,ll,kk, &
                            '     ('//spin_label(ishell)(1:1)//')'
         if (abs(focc(ishell)) > eps_check) then
            write(IFLOG,*) '   Since focc of the state is non-zero,'
            write(IFLOG,*) '      calculation continues.'
            exit SRCH_EE
         else
            write(IFLOG,*) '   The state is removed in the later calc.'
            is_solve(ishell) = 0 ; ee = 0.d0 ; exit SRCH_EE
         end if
      end if
SRCH_RT:do ir = nmesh_max,10,-1
         r = rpos(ir)
         tmp = veff(ir,ispin,ll_core)-ee
         if (tmp < 0.d0) then
            nrt = ir ; exit SRCH_RT
         end if
      end do SRCH_RT
      nrt_pos(ishell) = nrt
      id = +1
      call set_initpoints_left(ier,ll,kk,ispin,ee)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in set_initpoints_left'
         go to 99
      end if
      call int_from_left(ier,node_sum,nrt,id,ll,kk,ee,ispin)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in int_from_left' ; go to 99
      end if
      if (node_sum > node) then
         if (ee < ee_upper_limit) then
            ee_upper_limit = ee
         end if
         if (ee_upper_limit > ee_upper_limit_in) then
            ee_upper_limit = ee_upper_limit_in
         end if
         ee = 0.5d0*(ee + ee_lower_limit)
         ee_lower_limit = ee_lower_limit * 1.2d0
         cycle SRCH_EE
      else if (node_sum < node) then
         if (ee > ee_lower_limit) then
            ee_lower_limit = ee
         end if
         ee = 0.5d0*(ee_upper_limit + ee)
         ee_upper_limit = ee_upper_limit_in
         ee = 0.5d0*(ee_upper_limit + ee)
         cycle SRCH_EE
      end if
      nrm = nrt
SRCH_RM:do ir = nrt,10,-1
         if (sign_gr*(chi_gl(ir-1)-chi_gl(ir)) < 0.d0) then
            nrm = ir ; exit SRCH_RM
         end if
         if (ir <= 10) then
            write(IFLOG,*) '### ERROR ### nrm was not found (SRCH_RM)'
            write(IFLOG,*) '   ir  ...',ir
            write(IFLOG,*) '   nrt ...',nrt
            write(IFLOG,*) '   ee      ...',ee
            write(IFLOG,*) '   ispin   ...',ispin
            write(IFLOG,*) '   ll_core ...',ll_core
         if (is_xc_class == GGA) then
            write(IFLOG,*) 'DEBUG:'
            write(IFLOG,*) &
               'DEBUG: jr, rpos, chi_gl, veff, vion, vh, vxc, rho, drho, ddrho'
            do jr = 1,nrt
               write(IFLOG,80) & 
                  jr,rpos(jr),chi_gl(jr),veff(jr,ispin,ll_core), &
                  vion(jr,ll_core),vh(jr),vx(jr,ispin)+vc(jr,ispin), &
                  rho(jr,ispin),drho(jr,ispin),ddrho(jr,ispin)
            end do
            write(IFLOG,*)
               80 format(1x,'DEBUG:',i5,10(1pe15.5))
         end if
            ier = 1 ; go to 99
         end if
      end do SRCH_RM
      nrm_pos(ishell) = nrm
      nmesh_max = nmesh
      do ir = nmesh,10,-1
         r  = rpos(ir)
         vv = veff(ir,ispin,ll_core)
         select case (is_calc)
         case (NONREL)
            ss = sqrt(2.d0*abs(ee-vv))
         case (SREL,REL)
            mass = 1.d0 + 0.5d0 * ALPHA * ALPHA * (ee-vv)
            ss   = sqrt(2.d0*mass*abs(ee-vv))
         end select
         if (ss*r < ARGMAX) then
            nmesh_max = ir ; exit
         end if
      end do
      if (nmesh_max < nmesh) then
         r  = rpos(nmesh_max)
         vv = veff(nmesh_max,ispin,ll_core)
         select case (is_calc)
         case (NONREL)
            ss = sqrt(2.d0*abs(ee-vv))
         case (SREL,REL)
            mass = 1.d0 + 0.5d0 * ALPHA * ALPHA * (ee-vv)
            ss   = sqrt(2.d0*mass*abs(ee-vv))
         end select
      do ir = nmesh_max+1,nmesh
         r  = rpos(ir)
         vv = veff(ir,ispin,ll_core)
         select case (is_calc)
         case (NONREL)
            ss = sqrt(2.d0*abs(ee-vv))
         case (SREL,REL)
            mass = 1.d0 + 0.5d0 * ALPHA * ALPHA * (ee-vv)
            ss   = sqrt(2.d0*mass*abs(ee-vv))
         end select
         select case (is_calc)
         case (NONREL)
            chi_gr(ir) = exp(-ss*r) * sign_gr
            chi_fr(ir) = -ss * chi_gr(ir) 
         case (SREL)
            chi_gr(ir) = exp(-ss*r) * sign_gr
            chi_fr(ir) = -ss/(2.d0*mass) * chi_gr(ir) 
         case (REL)
            chi_gr(ir) = exp(-ss*r) * sign_gr
            chi_fr(ir) = -ss*ALPHA/(2.d0*mass) * chi_gr(ir) 
         end select        
         dxchi_gr(ir) = 0.d0
         dxchi_fr(ir) = 0.d0
      end do
      end if
      id = -1
      call set_initpoints_right(ier,nmesh_max,sign_gr,ispin,ll,ee)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in set_initpoints_right'
         go to 99
      end if
      nrt = nrm-1-max(iord_pc,iord_diff)
      call int_from_right(ier,nmesh_max,nrt,id,ll,kk,ee,ispin)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in int_from_right' ; go to 99
      end if
      rr = chi_gl(nrm) / chi_gr(nrm)
      do ir = nmesh,nrm-1,-1
           chi_gr(ir) =   chi_gr(ir) * rr
           chi_fr(ir) =   chi_fr(ir) * rr
         dxchi_gr(ir) = dxchi_gr(ir) * rr
         dxchi_fr(ir) = dxchi_fr(ir) * rr
      end do
      call guess_de(ier,nrm,ispin,ll_core,ee,de,gg_norm)
      if (ier /= 0) then

! ================================ modified by K. T. ============================ 4.0
!         write(IFLOG,*) '### ERROR ### in guess_de' ; go to 99

#ifdef mode_v300
         write(IFLOG,*) '### ERROR ### in guess_de' ; go to 99
#else
         write(IFLOG,*) '### ERROR ### in guess_de'
         write(IFLOG,*) '# is_solve( ', ishell, ' ) is forced to be 0 '
         is_solve(ishell) = 0
#endif
! ============================================================================== 4.0

      end if
      if (de > 0.d0) then
         ee_lower_limit = ee
      else if (de < 0.d0) then
         ee_upper_limit = ee
         if (ee_upper_limit > ee_upper_limit_in) then
            ee_upper_limit = ee_upper_limit_in
         end if
      end if
      etest = ee + de
      if ((etest-ee_upper_limit)*(etest-ee_lower_limit) < 0.d0) then
         ee = etest
      else
         ee = 0.5d0*(ee_upper_limit + ee_lower_limit)
         num_eslides = num_eslides + 1
      end if
         write(IFLOG,'(1x,a20,i5,f25.15,1pe20.10)') &
           '??? ishell,ee,de ...',ishell,ee,de
end do SRCH_EE
      engy(ishell) = ee
      if (is_solve(ishell) == 0) then
         cycle MAIN
      end if
      g_norm = sqrt(gg_norm)
      select case (is_calc)
      case (NONREL,SREL)
         do ir = 1,nrm
              chi_g(ir,ishell) =   chi_gl(ir)/g_norm
            dxchi_g(ir,ishell) = dxchi_gl(ir)/g_norm
         end do
         do ir = nrm,nmesh
              chi_g(ir,ishell) =   chi_gr(ir)/g_norm
            dxchi_g(ir,ishell) = dxchi_gr(ir)/g_norm
         end do
      case (REL)
         do ir = 1,nrm
              chi_g(ir,ishell) =   chi_gl(ir)/g_norm
            dxchi_g(ir,ishell) = dxchi_gl(ir)/g_norm
              chi_f(ir,ishell) =   chi_fl(ir)/g_norm
            dxchi_f(ir,ishell) = dxchi_fl(ir)/g_norm
         end do
         do ir = nrm,nmesh
              chi_g(ir,ishell) =   chi_gr(ir)/g_norm
            dxchi_g(ir,ishell) = dxchi_gr(ir)/g_norm
              chi_f(ir,ishell) =   chi_fr(ir)/g_norm
            dxchi_f(ir,ishell) = dxchi_fr(ir)/g_norm
         end do
      end select
      sum = 0.d0
      select case (is_calc)
      case (NONREL,SREL)
         do ir = 1,nmesh
            sum = sum + wr(ir)*chi_g(ir,ishell)**2
         end do
      case (REL)
         do ir = 1,nmesh
            sum = sum + wr(ir)*( chi_g(ir,ishell)**2 &
                               + chi_f(ir,ishell)**2 )
         end do
      end select
      sum = sqrt(sum)
      select case (is_calc)
      case (NONREL,SREL)
         do ir = 1,nmesh
              chi_g(ir,ishell) =   chi_g(ir,ishell) / sum * sign_gr
            dxchi_g(ir,ishell) = dxchi_g(ir,ishell) / sum * sign_gr
         end do
      case (REL)
         do ir = 1,nmesh
              chi_g(ir,ishell) =   chi_g(ir,ishell) / sum * sign_gr
            dxchi_g(ir,ishell) = dxchi_g(ir,ishell) / sum * sign_gr
              chi_f(ir,ishell) =   chi_f(ir,ishell) / sum * sign_gr
            dxchi_f(ir,ishell) = dxchi_f(ir,ishell) / sum * sign_gr
         end do
      end select
      nmm_pos(ishell) = nmesh_max
end do MAIN
99 continue
   end subroutine calc_bound_state

!=====================================================================
   subroutine calc_vcoeff(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ncoeff, ispin, ll, ir, i, j
   real(8) :: r
   real(8),allocatable :: rveff(:), rave(:)
   integer :: n_mat, n_vec
   real(8),allocatable :: mat_a(:,:), vec_x(:,:), vec_b(:,:)
   ier = 0
   ncoeff =  iord_coeff
  !+++++++++++++++++++++++++++++++++++++++++
   allocate(rveff(ncoeff),rave(0:2*ncoeff))
      rveff = 0.d0 ; rave = 0.d0
  !+++++++++++++++++++++++++++++++++++++++++
   n_mat = ncoeff ; n_vec = 1
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   allocate(mat_a(n_mat,n_mat),vec_x(n_mat,n_vec),vec_b(n_mat,n_vec))
      mat_a = 0.d0 ; vec_x = 0.d0 ; vec_b = 0.d0
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   do ll = 0,lmax_core
   do ispin = 1,nspin
      rave(:) = 0.d0 ; rveff(:) = 0.d0
      do ir = 1,20
         r = rpos(ir)
         do i = 0,(n_mat-1)*2
            rave(i) = rave(i) + r**i
         end do
         do i = 1,n_mat
            rveff(i) = rveff(i) + veff(ir,ispin,ll) * r**i
         end do
      end do
      mat_a(:,:) = 0.d0 ; vec_b(:,:) = 0.d0
      do i = 1,n_mat
         vec_b(i,1) = rveff(i)
         do j = 1,n_mat
            mat_a(i,j) = rave(i+j-2)
         end do
      end do
      call axb_real_matrix(ier,n_mat,n_vec,mat_a,vec_x,vec_b)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in axb_real_matrix'
         go to 99
      end if
      do i = 1,n_mat
         vcoeff(i-2,ispin,ll) = vec_x(i,1)
      end do
   end do
   end do
  !++++++++++++++++++++++++++++++
   deallocate(mat_a,vec_x,vec_b)
   deallocate(rveff,rave)
  !++++++++++++++++++++++++++++++
99 continue
   end subroutine calc_vcoeff

!=====================================================================
   subroutine set_initpoints_left(ier,ll,kk,ispin,ee)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer,intent(in)  :: ll, kk, ispin
   real(8),intent(in)  :: ee
   integer :: ncoeff, icoeff, j, ir, ll_core
   real(8) :: sum, r, mass, power, sum1, sum2, det
   real(8),allocatable :: gcoeff(:), fcoeff(:)
   integer(2) :: n_mat, n_vec
   real(8), allocatable :: mat_a(:,:), vec_b(:,:)
   ier = 0
   ncoeff =  iord_coeff
  !++++++++++++++++++++++++++++++++++++++++++++
   allocate(gcoeff(0:ncoeff),fcoeff(0:ncoeff))
      gcoeff = 0.d0 ; fcoeff = 0.d0
  !++++++++++++++++++++++++++++++++++++++++++++
   if (is_core == PATOM) then
      ll_core = ll
   else
      ll_core = lmax_core
   end if
   select case (is_calc)
   case (NONREL)
      gcoeff(0) = 1.d0
      fcoeff(0) = vcoeff(-1,ispin,ll_core) / dble(ll+1) * gcoeff(0)
      if (ncoeff >= 2) then
         do icoeff = 1,ncoeff-1
            gcoeff(icoeff) =  fcoeff(icoeff-1) / dble(icoeff)
            sum = 0.d0
            do j = -1,icoeff-1
               sum = sum + vcoeff(j,ispin,ll_core)*gcoeff(icoeff-1-j)
            end do
            fcoeff(icoeff) = (-2.d0*ee*gcoeff(icoeff-1)+2.d0*sum) &
                           / dble(icoeff+2*ll+2)
         end do
      end if
      do ir = 1,10
         r = rpos(ir)
         chi_gl(ir) = 0.d0
         chi_fl(ir) = 0.d0
         do icoeff = 0,ncoeff-1
            chi_gl(ir) = chi_gl(ir) &
              + gcoeff(icoeff) * r**(icoeff+ll+1)
            chi_fl(ir) = chi_fl(ir) &
              + fcoeff(icoeff) * r**(icoeff+ll+1)
         end do
         call dgdx_dfdx_nonrel(r,chi_gl(ir),chi_fl(ir), &
              dxchi_gl(ir),dxchi_fl(ir),ll,ee,veff(ir,ispin,ll_core))
      end do
   case (SREL)
      mass = 1.d0 + 0.5d0*ALPHA*ALPHA*(ee-veff(1,ispin,ll_core))
      select case (ll)
      case (0)
         gcoeff(0) = 1.d0 ; power = 1.d0
         do icoeff = 1,ncoeff
            sum = 0.d0
            do j = -1,icoeff-2
               sum = sum + vcoeff(j,ispin,ll_core)*gcoeff(icoeff-j-2)
            end do
            if (icoeff >= 2) then
               sum = sum - ee*gcoeff(icoeff-2)
            end if
            gcoeff(icoeff) = sum * 2.d0*mass &
                                 / dble(icoeff*(icoeff+1))
            fcoeff(icoeff-1) = dble(icoeff) / (2.d0*mass) &
                             * gcoeff(icoeff)
         end do
      case (1:)
         gcoeff(0) = 0.d0 ; gcoeff(1) = 1.d0 ; power = dble(ll)
         fcoeff(0) = dble(ll)/(2.d0*mass) * gcoeff(1)
         if (ncoeff >= 2) then
            do icoeff = 2,ncoeff
               sum = 0.d0
               do j = -1,icoeff-2
                  sum = sum + vcoeff(j,ispin,ll_core) &
                              * gcoeff(icoeff-j-2)
               end do
               sum = sum - ee*gcoeff(icoeff-2)
               gcoeff(icoeff) = sum * 2.d0*mass &
                              / dble((icoeff-1)*(icoeff+2*ll))
               fcoeff(icoeff-1) = dble(icoeff+ll-1) &
                                / (2.d0*mass) * gcoeff(icoeff)
            end do
         end if
      end select
      do ir = 1,10
         r = rpos(ir)
         chi_gl(ir) = 0.d0
         chi_fl(ir) = 0.d0
         do icoeff = 0,ncoeff-1
            chi_gl(ir) = chi_gl(ir) &
              + gcoeff(icoeff) * r**(dble(icoeff)+power)
            chi_fl(ir) = chi_fl(ir) &
              + fcoeff(icoeff) * r**(dble(icoeff)+power)
         end do
         call dgdx_dfdx_srel(r,chi_gl(ir),chi_fl(ir), &
              dxchi_gl(ir),dxchi_fl(ir),ll,ee,veff(ir,ispin,ll_core))
      end do
   case (REL)
      power = sqrt(dble(kk*kk)-(ALPHA*vcoeff(-1,ispin,ll_core))**2)
      if (kk < 0) then
         gcoeff(0) = 1.d0
      else
         gcoeff(0) = ALPHA*ALPHA
      end if
      fcoeff(0) = ALPHA*vcoeff(-1,ispin,ll_core) &
                       / (power-dble(kk)) * gcoeff(0)
      n_mat = 2 ; n_vec = 1
     !++++++++++++++++++++++++++++++++++++++++++++++++
      allocate(mat_a(n_mat,n_mat),vec_b(n_mat,n_vec))
         mat_a = 0.d0 ; vec_b = 0.d0
     !++++++++++++++++++++++++++++++++++++++++++++++++
      if (ncoeff >= 2) then
         do icoeff = 0,ncoeff-2
            mat_a(1,1) = power + dble(icoeff+1+kk)
            mat_a(1,2) = ALPHA*vcoeff(-1,ispin,ll_core)
            mat_a(2,1) = -mat_a(1,2)
            mat_a(2,2) = power + dble(icoeff+1-kk)
            sum1 = 0.d0 ; sum2 = 0.d0
            if (icoeff >= 1) then
               do j = 1,icoeff
                  sum1 = sum1 + vcoeff(j,ispin,ll_core) &
                                * gcoeff(icoeff-j)
                  sum2 = sum2 + vcoeff(j,ispin,ll_core) &
                                * fcoeff(icoeff-j)
               end do
            end if
            vec_b(1,1) = + (2.d0/ALPHA &
                         + ALPHA*(ee-vcoeff(0,ispin,ll_core))) &
                           * fcoeff(icoeff) - ALPHA*sum2
            vec_b(2,1) = - ALPHA*(ee-vcoeff(0,ispin,ll_core)) &
                           * gcoeff(icoeff) + ALPHA*sum1
            det = mat_a(1,1)*mat_a(2,2) - mat_a(1,2)*mat_a(2,1)
            gcoeff(icoeff+1) = (+mat_a(2,2)*vec_b(1,1) &
                                -mat_a(1,2)*vec_b(2,1)) / det
            fcoeff(icoeff+1) = (-mat_a(2,1)*vec_b(1,1) &
                                +mat_a(1,1)*vec_b(2,1)) / det
         end do
      end if
     !++++++++++++++++++++++++
      deallocate(mat_a,vec_b)
     !++++++++++++++++++++++++
      do ir = 1,10
         r = rpos(ir)
         chi_gl(ir) = 0.d0
         chi_fl(ir) = 0.d0
         do icoeff = 0,ncoeff-1
            chi_gl(ir) = chi_gl(ir) &
              + gcoeff(icoeff) * r**(power+dble(icoeff))
            chi_fl(ir) = chi_fl(ir) &
              + fcoeff(icoeff) * r**(power+dble(icoeff))
         end do
         call dgdx_dfdx_rel(r,chi_gl(ir),chi_fl(ir), &
              dxchi_gl(ir),dxchi_fl(ir),kk,ee,veff(ir,ispin,ll_core))
      end do
   end select
99 continue
  !++++++++++++++++++++++++++
   deallocate(gcoeff,fcoeff)
  !++++++++++++++++++++++++++
   end subroutine set_initpoints_left

!=====================================================================
   subroutine int_from_left(ier,node_sum,nrt,id,ll,kk,ee,ispin)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier, node_sum
   integer,intent(in)  :: nrt, id, ll, kk, ispin
   real(8),intent(in)  :: ee
   integer :: nec, ir
   ier = 0
   nec = iord_nec
   node_sum = 0
   select case (iord_pc)
   case(4)
      do ir = 3,nrt+1
         call pc_adams_4(ier,ir,id,ll,kk,ee,nec,ispin)
         if (chi_gl(ir)*chi_gl(ir-1) < 0.d0) then
            node_sum = node_sum + 1
         end if
      end do
   case(5)
      do ir = 4,nrt+1
         call pc_adams_5(ier,ir,id,ll,kk,ee,nec,ispin)
         if (chi_gl(ir)*chi_gl(ir-1) < 0.d0) then
            node_sum = node_sum + 1
         end if
      end do
   case(6)
      do ir = 4,nrt+1
         call pc_adams_6(ier,ir,id,ll,kk,ee,nec,ispin)
         if (chi_gl(ir)*chi_gl(ir-1) < 0.d0) then
            node_sum = node_sum + 1
         end if
      end do
   case(7)
      do ir = 5,nrt+1
         call pc_adams_7(ier,ir,id,ll,kk,ee,nec,ispin)
         if (chi_gl(ir)*chi_gl(ir-1) < 0.d0) then
            node_sum = node_sum + 1
         end if
      end do
   case(8)
      do ir = 6,nrt+1
         call pc_adams_8(ier,ir,id,ll,kk,ee,nec,ispin)
         if (chi_gl(ir)*chi_gl(ir-1) < 0.d0) then
            node_sum = node_sum + 1
         end if
      end do
   case default
      write(IFLOG,*) '### ERROR ### iord_pc is invalid (inc)'
      write(IFLOG,*) '   iord_pc ...',iord_pc
      ier = 1 ; go to 99
   end select
99 continue
   end subroutine int_from_left

!=====================================================================
   subroutine set_initpoints_right(ier,nmesh_max,sign_gr,ispin,ll,ee)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer,intent(in)  :: nmesh_max, ispin, ll
   real(8),intent(in)  :: sign_gr, ee
   integer :: ir, ll_core
   real(8) :: vv, ss, r, mass
   ier = 0
   if (is_core == PATOM) then
      ll_core = ll
   else
      ll_core = lmax_core
   end if
   vv = veff(nmesh_max,ispin,ll_core)
   select case (is_calc)
   case (NONREL)
      ss = sqrt(2.d0*abs(ee-vv))
   case (SREL,REL)
      mass = 1.d0 + 0.5d0 * ALPHA * ALPHA * (ee-vv)
      ss   = sqrt(2.d0*mass*abs(ee-vv))
   end select
   do ir = nmesh_max-10,nmesh_max
      r  = rpos(ir)
      select case (is_calc)
      case (NONREL)
         chi_gr(ir) = exp(-ss*r) * sign_gr
         chi_fr(ir) = -ss * chi_gr(ir)
      case (SREL)
         chi_gr(ir) = exp(-ss*r) * sign_gr
         chi_fr(ir) = -ss/(2.d0*mass) * chi_gr(ir)
      case (REL)
         chi_gr(ir) = exp(-ss*r) * sign_gr
         chi_fr(ir) = -ss*ALPHA/(2.d0*mass) * chi_gr(ir)
      end select
      dxchi_gr(ir) = -ss*r * chi_gr(ir)
      dxchi_fr(ir) = -ss*r * chi_fr(ir)
   end do
99 continue
   end subroutine set_initpoints_right

!=====================================================================
   subroutine int_from_right(ier,nmesh_max,nrm,id,ll,kk,ee,ispin)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer,intent(in)  :: nmesh_max,nrm, id, ll, kk, ispin
   real(8),intent(in)  :: ee
   integer :: nec, ir
   ier = 0
   nec = iord_nec
   select case (iord_pc)
   case (4)
      do ir = nmesh_max-2,nrm-1,-1
         call pc_adams_4(ier,ir,id,ll,kk,ee,nec,ispin)
      end do
   case (5)
      do ir = nmesh_max-3,nrm-1,-1
         call pc_adams_5(ier,ir,id,ll,kk,ee,nec,ispin)
      end do
   case (6)
      do ir = nmesh_max-3,nrm-1,-1
         call pc_adams_6(ier,ir,id,ll,kk,ee,nec,ispin)
      end do
   case (7)
      do ir = nmesh_max-4,nrm-1,-1
         call pc_adams_7(ier,ir,id,ll,kk,ee,nec,ispin)
      end do
   case (8)
      do ir = nmesh_max-4,nrm-1,-1
         call pc_adams_8(ier,ir,id,ll,kk,ee,nec,ispin)
      end do
   case default
      write(IFLOG,*) '### ERROR ### iord_pc is invalid (dec)'
      write(IFLOG,*) '   iord_pc ...',iord_pc
      ier = 1 ; go to 99
   end select
99 continue
   end subroutine int_from_right

!=====================================================================
   subroutine guess_de(ier,nrm,ispin,ll_core,ee,de,gg_norm)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer,intent(in)  :: nrm, ispin, ll_core
   real(8),intent(in)  :: ee
   real(8),intent(out) :: de, gg_norm
   integer :: ir
   real(8) :: sum1, sum2, mass
   ier = 0
   call set_weight_exp(ier,1,nrm,rpos,wt)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in set_weight_exp(1)' ; go to 99
   end if
   sum1 = 0.d0
   select case (is_calc)
   case (NONREL,SREL)
      do ir = 1,nrm
         sum1 = sum1 + chi_gl(ir)**2*wt(ir)
      end do
   case (REL)
      do ir = 1,nrm
         sum1 = sum1 + (chi_gl(ir)**2 + chi_fl(ir)**2)*wt(ir)
      end do
   end select
   call set_weight_exp(ier,nrm,nmesh,rpos,wt)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in set_weight_exp(2)' ; go to 99
   end if
   sum2 = 0.d0
   select case (is_calc)
   case (NONREL,SREL)
      do ir = nrm,nmesh
         sum2 = sum2 + chi_gr(ir)**2*wt(ir)
      end do
   case (REL)
      do ir = nrm,nmesh
         sum2 = sum2 + (chi_gr(ir)**2 + chi_fr(ir)**2)*wt(ir)
      end do
   end select
   gg_norm = sum1 + sum2
   mass = 1.d0 + 0.5d0*ALPHA*ALPHA*(ee-veff(nrm,ispin,ll_core))
   select case (is_calc)
   case (NONREL)
      de = 0.5d0 * chi_gl(nrm) &
                 * (chi_fl(nrm) - chi_fr(nrm)) / gg_norm
   case (SREL)
      de = 0.5d0 * 2.d0*mass * chi_gl(nrm) &
                 * (chi_fl(nrm) - chi_fr(nrm)) / gg_norm
   case (REL)
      de = 0.5d0 * 2.d0*mass/ALPHA * chi_gl(nrm) &
                 * (chi_fl(nrm) - chi_fr(nrm)) / gg_norm
   end select
99 continue
   end subroutine guess_de

!=====================================================================
   subroutine write_orbital(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, nn, ll, j2, ishell, ispin, lshell
   character(10) :: xc_name
   real(8),allocatable :: array_tmp(:)
   ier = 0
  !++++++++++++++++++++++++++++++++++++++++++++++
   allocate(array_tmp(nmesh)) ; array_tmp = 0.d0
  !++++++++++++++++++++++++++++++++++++++++++++++
   open(IFORB,file=trim(orbfile),status='unknown')
   rewind(IFORB)
   write(IFLOG,*) '   Writing ORBITAL -->',IFORB
   call date_time(day_now)
   call write_title(IFORB,day_now)
   write(IFORB,*)
   write(IFORB,'(a16)') '### Atomic label'
   write(IFORB,'((a12,8x),a2,7x,a20)') &
      'atomic_label', atom_label(zatom), atom_name(zatom)
   write(IFORB,*)
   write(IFORB,'(a47)') '### Atomic charge : Z, Za, Zc, Zv, (Ne, Nc, Nv)'
   write(IFORB,'((a13,6x),(i3,4x),3f11.5)') &
      'atomic_charge', zatom, fatom, fcore, fval
   write(IFORB,'((13x,6x),(3x,4x),3f11.5)') &
      felec, felec_core, felec_val
   write(IFORB,*)
   write(IFORB,'(a34)') '### Exchange-correlation potential'
   select case (is_xc)
   case (LDAPZ81)
      xc_name = 'ldapz81'
   case (LDAPW92_MOMO, LDAPW92_MOMO2, LDAPW92_GNCPP)
      xc_name = 'ldapw92'
   case (GGAPW91_MOMO, GGAPW91_MOMO2, GGAPW91_F90, GGAPW91_F77)
      xc_name = 'ggapw91'
   case (GGAPBE96_MOMO, GGAPBE96_MOMO2, GGAPBE96_GNCPP, GGAPBE96_KATO)
      xc_name = 'ggapbe'
   case default
      write(IFLOG,*) '### ERROR ### xc_type'
      write(IFLOG,*) '   is_xc ...', is_xc
      ier = 1 ; go to 99
   end select
   write(IFORB,'((a12,8x),a7,5x,a5)') &
      'xc_potential', xc_name, xc_approx
   write(IFORB,*)
   write(IFORB,'(a30)') '### r-Mesh : Nmesh, rmin, rmax'
   write(IFORB,'(a5,5x,a11)') 'rmesh','logarithmic'
   write(IFORB,'(i10,2(1pe25.15))') nmesh, rmin, rmax
   write(IFORB,*)
   write(IFORB,'(a34)') '### All-electron SCF energy levels'
   select case (is_calc)
   case (NONREL)
      write(IFORB,'(a3,5x,a16)') '#AE','non_relativistic'
   case (SREL)
      write(IFORB,'(a3,5x,a19)') '#AE','scalar_relativistic'
   case (REL)
      write(IFORB,'(a3,5x,a17)') '#AE','full_relativistic'
   end select
   select case (is_spin)
   case (RESTRICTED)
      write(IFORB,'(a3,5x,a15)') '#AE','spin_restricted'
   case (POLARIZED)
      write(IFORB,'(a3,5x,a14)') '#AE','spin_polarized'
   end select
   select case (is_spin)
   case (RESTRICTED)
      select case (is_calc)
      case (NONREL,SREL)
         write(IFORB,21) &
            'symm','Energy (Ha)','Energy (eV)','nocc','focc'
         do ishell = 1,nshell
            lshell = list_shell(ishell)
            if (is_solve(lshell) == NO) then
               cycle
            end if
            write(IFORB,22) state(lshell)(1:2), &
               engy(lshell),engy(lshell)*HARTREE,nocc(lshell),focc(lshell)
         end do
      case (REL)
         write(IFORB,31) &
            'symm','j','Energy (Ha)','Energy (eV)','nocc','focc'
         do ishell = 1,nshell
            lshell = list_shell(ishell)
            if (is_solve(lshell) == NO) then
               cycle
            end if
            write(IFORB,32) state(lshell)(1:2),j2_qnum(lshell), &
               engy(lshell),engy(lshell)*HARTREE,nocc(lshell),focc(lshell)
         end do
      end select
   case (POLARIZED)
      select case (is_calc)
      case (NONREL,SREL)
         write(IFORB,23) &
            'symm','s','Energy (Ha)','Energy (eV)','nocc','focc'
         do ishell = 1,nshell
            lshell = list_shell(ishell)
            if (is_solve(lshell) == NO) then
               cycle
            end if
            write(IFORB,24) state(lshell)(1:2),spin_label(lshell)(1:1), &
               engy(lshell),engy(lshell)*HARTREE,nocc(lshell),focc(lshell)
         end do
      case (REL)
         write(IFORB,33) &
            'symm','j','s','Energy (Ha)','Energy (eV)','nocc','focc'
         do ishell = 1,nshell
            lshell = list_shell(ishell)
            if (is_solve(lshell) == NO) then
               cycle
            end if
            write(IFORB,34) state(lshell)(1:2),j2_qnum(lshell), &
               spin_label(lshell)(1:1), &
               engy(lshell),engy(lshell)*HARTREE,nocc(lshell),focc(lshell)
         end do
      end select
   end select
   select case (is_spin)
   case(RESTRICTED)
      select case (is_calc)
      case (NONREL,SREL)
         write(IFORB,41) 'Total number of electrons',felec
      case (REL)
         write(IFORB,42) 'Total number of electrons',felec
      end select
   case(POLARIZED)
      select case (is_calc)
      case (NONREL,SREL)
         write(IFORB,43) 'Number of electrons (+)',felec1
         write(IFORB,43) '                    (-)',felec2
      case (REL)
         write(IFORB,44) 'Number of electrons (+)',felec1
         write(IFORB,44) '                    (-)',felec2
      end select
   end select
21 format('#AE',(3x,a4),2(9x,a11),(2x,a4),(6x,a4))
22 format('#AE',(4x,a2,1x),2(f20.10),i6,f10.5)
23 format('#AE',(3x,a4),(4x,a1),2(9x,a11),(2x,a4),(6x,a4))
24 format('#AE',(4x,a2,1x),(4x,a1),2(f20.10),i6,f10.5)
31 format('#AE',(3x,a4),(4x,a1,1x),2(9x,a11),(2x,a4),(6x,a4))
32 format('#AE',(4x,a2,1x),(3x,i1,'/2'),2(f20.10),i6,f10.5)
33 format('#AE',(3x,a4),(4x,a1,1x),(4x,a1),2(9x,a11),(2x,a4),(6x,a4))
34 format('#AE',(4x,a2,1x),(3x,i1,'/2'),(4x,a1),2(f20.10),i6,f10.5)
41 format('#AE',2x,a25,26x,f10.5)
42 format('#AE',2x,a25,32x,f10.5)
43 format('#AE',2x,a23,31x,f10.5)
44 format('#AE',2x,a23,37x,f10.5)

   write(IFORB,*)
   write(IFORB,'(a29)') '### All-electron total energy'
   write(IFORB,54) 'Energy (Ha)','Energy (eV)'
   if (is_calc == NONREL) then
   write(IFORB,55) 'Ekin  ',ekin_sum1,ekin_sum1*HARTREE
   else
   write(IFORB,55) 'Ekin  ',ekin_sum ,ekin_sum*HARTREE
   end if
   write(IFORB,55) 'Eion  ',eion_sum ,eion_sum *HARTREE
   write(IFORB,55) 'Eh    ',eh_sum   ,eh_sum   *HARTREE
   write(IFORB,55) 'Exc   ',exc_sum  ,exc_sum  *HARTREE
   if (is_calc == NONREL) then
   write(IFORB,55) 'Etot  ',etot_sum1,etot_sum1*HARTREE
   else
   write(IFORB,55) 'Etot  ',etot_sum ,etot_sum *HARTREE
   end if
54 format('#AE',2x,6x,2(9x,a11))
55 format('#AE',2x,a6,2(f20.10))

   write(IFORB,*)
   write(IFORB,'(a48)') '### All-electron SCF wavefunctions : r*psi[n](r)'
   write(IFORB,'(a21)') 'ae_wave_function_rpsi'
MAIN:do ishell = 1,nshell
      lshell = list_shell(ishell)
      if (is_solve(lshell) == NO) then
         cycle
      end if
      ispin = (1-spin(lshell))/2 + 1
      ll = l_qnum(lshell)
      nn = n_qnum(lshell)
      j2 = j2_qnum(lshell)
      write(IFORB,*)
      write(IFORB,'(1x,a31,4i3)') &
         'r*psi[n](r): n = (n,l,2j,s) -->',nn,ll,j2,ispin
      do ir = 1,nmesh
         if (abs(chi_g(ir,lshell)) < 1.d-99) then
            array_tmp(ir) = 0.d0
         else
            array_tmp(ir) = chi_g(ir,lshell)
         end if
      end do
      write(IFORB,10) (array_tmp(ir),ir=1,nmesh)
      if (is_calc == REL) then
         do ir = 1,nmesh
            if (abs(chi_f(ir,lshell)) < 1.d-99) then
               array_tmp(ir) = 0.d0
            else
               array_tmp(ir) = chi_f(ir,lshell)
            end if
         end do
         write(IFORB,10) (array_tmp(ir),ir=1,nmesh)
      end if
   end do MAIN
   write(IFORB,*)
   write(IFORB,'(a18)') '### End of ORBITAL'
   write(IFORB,'(a3)') 'end'
10 format(3(1pe25.17))
99 continue
   close(IFORB)
  !++++++++++++++++++++++
   deallocate(array_tmp)
  !++++++++++++++++++++++
   end subroutine write_orbital

!=====================================================================
   subroutine analysis_orbital(ier,ifile)
!=====================================================================
!     
!  M. Okamoto
!  
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in)  :: ifile
   integer,intent(out) :: ier
   integer :: nn, ll, j2, ishell, ispin, lshell, l3, i
   real(8) :: ave_rl_tmp(0:3)
   character(100) :: line
   ier = 0
   do i = 1,100
      line(i:i)='-'
   end do
   write(ifile,*)
   write(ifile,*) 'ave  Averaged radius (in a.u.) : < r^L > = < psi[n] | r^L | psi[n] >'
   select case (is_calc)
   case (NONREL,SREL)
      select case (is_spin)
      case (RESTRICTED)
         write(ifile,10) line(1:100)
         write(ifile,11) 'symm','L=0','L=2','L=4','L=6'
         write(ifile,10) line(1:100)
      case (POLARIZED)
         write(ifile,20) line(1:100)
         write(ifile,21) 'symm','s','L=0','L=2','L=4','L=6'
         write(ifile,20) line(1:100)
      end select
   case (REL)
      select case (is_spin)
      case (RESTRICTED)
         write(ifile,30) line(1:100)
         write(ifile,31) 'symm','j','L=0','L=2','L=4','L=6'
         write(ifile,30) line(1:100)
      case (POLARIZED)
         write(ifile,40) line(1:100)
         write(ifile,41) 'symm','j','s','L=0','L=2','L=4','L=6'
         write(ifile,40) line(1:100)
      end select
   end select
MAIN:do ishell = 1,nshell
      lshell = list_shell(ishell)
      if (is_solve(lshell) == NO) then
         cycle
      end if
      ispin = (1-spin(lshell))/2 + 1
      ll = l_qnum(lshell)
      nn = n_qnum(lshell)
      j2 = j2_qnum(lshell)
      ave_rl_tmp(:) = 0.d0
      do l3 = 0,ll
         ave_rl_tmp(l3) = sum(chi_g(:,lshell)**2*wr(:)*rpos(:)**(2*l3))
         if (is_calc == REL) then
            ave_rl_tmp(l3) = ave_rl_tmp(l3) &
               + sum(chi_f(:,lshell)**2*wr(:)*rpos(:)**(2*l3))
         end if
      end do
      select case (is_calc)
      case (NONREL,SREL)
         select case (is_spin)
         case (RESTRICTED)
            write(ifile,12) state(lshell)(1:2),(ave_rl_tmp(l3),l3=0,ll)
         case (POLARIZED)
            write(ifile,22) state(lshell)(1:2),spin_label(lshell)(1:1), &
               (ave_rl_tmp(l3),l3=0,ll)
         end select
      case (REL)
         select case (is_spin)
         case (RESTRICTED)
            write(ifile,32) state(lshell)(1:2),j2_qnum(lshell), &
               (ave_rl_tmp(l3),l3=0,ll)
         case (POLARIZED)
            write(ifile,42) state(lshell)(1:2),j2_qnum(lshell), &
               spin_label(lshell)(1:1), &
               (ave_rl_tmp(l3),l3=0,ll)
         end select
      end select
   end do MAIN
   select case (is_calc)
   case (NONREL,SREL)
      select case (is_spin)
      case (RESTRICTED)
         write(ifile,10) line(1:100)
      case (POLARIZED)
         write(ifile,20) line(1:100)
      end select
   case (REL)
      select case (is_spin)
      case (RESTRICTED)
         write(ifile,30) line(1:100)
      case (POLARIZED)
         write(ifile,40) line(1:100)
      end select
   end select
10 format(1x,'ave',a68)
11 format(1x,'ave',(3x,a4),4(9x,a3,3x))
12 format(1x,'ave',(4x,a2,1x),4(f15.6))
20 format(1x,'ave',a73)
21 format(1x,'ave',(3x,a4),(4x,a1),4(9x,a3,3x))
22 format(1x,'ave',(4x,a2,1x),(4x,a1),4(f15.6))
30 format(1x,'ave',a74)
31 format(1x,'ave',(3x,a4),(4x,a1,1x),4(9x,a3,3x))
32 format(1x,'ave',(4x,a2,1x),(3x,i1,'/2'),4(f15.6))
40 format(1x,'ave',a79)
41 format(1x,'ave',(3x,a4),(4x,a1,1x),(4x,a1),4(9x,a3,3x))
42 format(1x,'ave',(4x,a2,1x),(3x,i1,'/2'),(4x,a1),4(f15.6))
99 continue
   end subroutine analysis_orbital

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   Version history: 
!
!     4.0:  2013/03/01
!           codes for spin-polarized pseudopotential generation are added
!     4.1:  2013/11/22 - 
!           Info of core wfns and energy contributions can be added to gncpp2
!     4.2:  2014/07/23 - 
!           gncpp2 can be geregated even when nmesh /= 1501
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : calc_etot_sol, calc_etot_ss, write_etot_sol
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine calc_etot_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ishell, ips, ll, t1, t2, ltt, &
              iord_tmp, lt1, lt2, nref
   real(8) :: r, pi4, pi2
   real(8),allocatable :: drphi_tmp(:)
   ier = 0
   pi4 = 4.d0*PI ; pi2 = 2.d0*PI
  !++++++++++++++++++++++++++++++++++++++++++++++
   allocate(drphi_tmp(nmesh)) ; drphi_tmp = 0.d0
  !++++++++++++++++++++++++++++++++++++++++++++++
   iord_tmp = 5
   ekin_sum1_sol = 0.d0
   do ips = 1,nps
      ishell = ishell_ps(ips,1)
      if (is_solve(ishell) == 0) then
         cycle
      end if
      ll = l_qnum(ishell)
      call calc_diff_exp(ier,iord_tmp,nmesh,rpos, &
                         rphi_sol(1,ips),drphi_tmp)
      do ir = 1,nmesh
         r = rpos(ir)
         ekin_sum1_sol = ekin_sum1_sol + focc_sol(ips) &
         * 0.5d0*wr(ir) &
         *( drphi_tmp(ir)**2 &
            + dble(ll*(ll+1))*(rphi_sol(ir,ips)/r)**2 )
      end do
   end do
  !++++++++++++++++++++++
   deallocate(drphi_tmp)
  !++++++++++++++++++++++
   eband_sum_sol = 0.d0
   do ips = 1,nps
      ishell = ishell_ps(ips,1)
      if (is_solve(ishell) /= 0) then
         eband_sum_sol = eband_sum_sol + focc_sol(ips) * engy_sol(ips)
      end if
   end do
   eloc_ion_sum_sol = 0.d0
   do ir = 1,nmesh
      r = rpos(ir)
      eloc_ion_sum_sol = eloc_ion_sum_sol &
! =========================================== modified by K. T. ============ 4.0
!         + pi4*r*r*wr(ir)*rho_sol(ir)*vloc_ion_sol(ir)
         + pi4*r*r*wr(ir)*rho_sol(ir,1)*vloc_ion_sol(ir,1)
! =========================================================================== 4.0

   end do
   enl_ion_sum_sol = 0.d0
   do ips = 1,nps
      ishell = ishell_ps(ips,1)
      if (is_solve(ishell) == 0) then
         cycle
      end if
      ll = l_qnum(ishell)
      nref = nref_us(ll)
      do t1 = 1,nref
      do t2 = 1,nref
         lt1 = lt_n_us(ll,t1)
         lt2 = lt_n_us(ll,t2)
         ltt = ltt_nm_us(ll,t1,t2)
         enl_ion_sum_sol = enl_ion_sum_sol &
            + focc_sol(ips) * dion_us(ltt) &
               * beta_phi_sol(lt1,ips) &
               * beta_phi_sol(lt2,ips)
      end do
      end do
   end do
   vlocqps_sum_sol = 0.d0
   do ips = 1,nps
      ishell = ishell_ps(ips,1)
      if (is_solve(ishell) == 0) then
         cycle
      end if
      ll = l_qnum(ishell)
      nref = nref_us(ll)
      do t1 = 1,nref
      do t2 = 1,nref
         lt1 = lt_n_us(ll,t1)
         lt2 = lt_n_us(ll,t2)
         ltt = ltt_nm_us(ll,t1,t2)
         vlocqps_sum_sol = vlocqps_sum_sol &
            + focc_sol(ips) * vlocqps_us(ltt) &
               * beta_phi_sol(lt1,ips) &
               * beta_phi_sol(lt2,ips)
      end do
      end do
   end do
   eh_sum_sol = 0.d0
   do ir = 1,nmesh
      r = rpos(ir)
      eh_sum_sol = eh_sum_sol &
! ================================================== modified by K. T. ========= 4.0
!             + pi2*r*r*wr(ir)*rho_sol(ir)*vh_sol(ir)
             + pi2*r*r*wr(ir)*rho_sol(ir,1)*vh_sol(ir)
! ============================================================================== 4.0

   end do
   select case (is_xc)
   case (LDAPW92_GNCPP, GGAPW91_F90, GGAPW91_F77, &
         GGAPBE96_GNCPP, GGAPBE96_KATO, &
         GGAPBE96_MOMO2)
   case default
      ex_sum_sol   = 0.d0
      ec_sum_sol   = 0.d0
      expc_sum_sol = 0.d0
      ecpc_sum_sol = 0.d0
      select case (is_pcc)
      case (NONE)
         do ir = 1,nmesh
            r = rpos(ir)
            ex_sum_sol = ex_sum_sol &
! ============================================ modified by K. T. ============ 4.0
!               + pi4*r*r*wr(ir)*rho_sol(ir)*ex_sol(ir)
               + pi4*r*r*wr(ir)*rho_sol(ir,1)*ex_sol(ir)
! ============================================================================ 4.0

            ec_sum_sol = ec_sum_sol &
! ============================================ modified by K. T. ============ 4.0
!               + pi4*r*r*wr(ir)*rho_sol(ir)*ec_sol(ir)
               + pi4*r*r*wr(ir)*rho_sol(ir,1)*ec_sol(ir)
! ============================================================================ 4.0
         end do

      case (PCC,FCC)
         do ir = 1,nmesh
            r = rpos(ir)
! ============================================ modified by K. T. ============== 4.0
!            ex_sum_sol = ex_sum_sol &
!               + pi4*r*r*wr(ir)*(rho_sol(ir)+rho_pcore(ir))*ex_sol(ir)
!            ec_sum_sol = ec_sum_sol &
!               + pi4*r*r*wr(ir)*(rho_sol(ir)+rho_pcore(ir))*ec_sol(ir)
!
            ex_sum_sol = ex_sum_sol &
               + pi4*r*r*wr(ir)*(rho_sol(ir,1)+rho_pcore(ir))*ex_sol(ir)
            ec_sum_sol = ec_sum_sol &
               + pi4*r*r*wr(ir)*(rho_sol(ir,1)+rho_pcore(ir))*ec_sol(ir)
! =========================================================================== 4.0

            expc_sum_sol = expc_sum_sol &
               - pi4*r*r*wr(ir)*rho_pcore(ir)*expc_sol(ir)
            ecpc_sum_sol = ecpc_sum_sol &
               - pi4*r*r*wr(ir)*rho_pcore(ir)*ecpc_sol(ir)
         end do
      end select
   end select
   exc_sum_sol   = ex_sum_sol + ec_sum_sol
   excpc_sum_sol = expc_sum_sol + ecpc_sum_sol
   vx_sum_sol = 0.d0
   vc_sum_sol = 0.d0
   do ir = 1,nmesh
      r = rpos(ir)

! ========================================= modified by K. T. ============ 4.0
!      vx_sum_sol = vx_sum_sol &
!         + pi4*r*r*wr(ir)*rho_sol(ir)*vx_sol(ir)
!      vc_sum_sol = vc_sum_sol &
!         + pi4*r*r*wr(ir)*rho_sol(ir)*vc_sol(ir)
!
      vx_sum_sol = vx_sum_sol &
         + pi4*r*r*wr(ir)*rho_sol(ir,1)*vx_sol(ir,1)
      vc_sum_sol = vc_sum_sol &
         + pi4*r*r*wr(ir)*rho_sol(ir,1)*vc_sol(ir,1)
! ========================================================================= 4.0

   end do
   vxc_sum_sol = vx_sum_sol + vc_sum_sol
   eion_sum_sol  = eloc_ion_sum_sol + enl_ion_sum_sol
   etot_sum1_sol = ekin_sum1_sol + eion_sum_sol  &
                 + eh_sum_sol + exc_sum_sol + excpc_sum_sol
   etot_sum2_sol = eband_sum_sol - eh_sum_sol  &
                 + exc_sum_sol - vxc_sum_sol + excpc_sum_sol
   etot_sum_sol  = etot_sum2_sol
   etot_sol      = etot_sum_sol
   ekin_sum2_sol = eband_sum_sol - eion_sum_sol - 2.d0*eh_sum_sol &
                 - vxc_sum_sol
   ekin_sum_sol  = ekin_sum2_sol
   end subroutine calc_etot_sol

!================================================ added by K. T. ===============4.0
subroutine calc_etot_sol_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ir, ishell, ips, ll, t1, t2, ltt, &
              iord_tmp, lt1, lt2, nref
  real(8) :: r, pi4, pi2
  real(8),allocatable :: drphi_tmp(:)

  integer :: ispin, itmp1, itmp2
  real(8) :: rho_tmp

  ier = 0
  pi4 = 4.d0*PI ; pi2 = 2.d0*PI

  !++++++++++++++++++++++++++++++++++++++++++++++
  allocate(drphi_tmp(nmesh)) ; drphi_tmp = 0.d0
  !++++++++++++++++++++++++++++++++++++++++++++++

  iord_tmp = 5

! ---------------------------------- kinetic ---------------------------
  ekin_sum1_sol = 0.d0
  do ips = 1,nps
     ishell = ishell_ps(ips,1)
     if (is_solve(ishell) == 0) then
        cycle
     end if
     ll = l_qnum(ishell)
     call calc_diff_exp(ier,iord_tmp,nmesh,rpos, &
          rphi_sol(1,ips),drphi_tmp)
     do ir = 1,nmesh
        r = rpos(ir)
        ekin_sum1_sol = ekin_sum1_sol + focc_sol(ips) &
             * 0.5d0*wr(ir) &
             *( drphi_tmp(ir)**2 &
             + dble(ll*(ll+1))*(rphi_sol(ir,ips)/r)**2 )
     end do
  end do

  !++++++++++++++++++++++
  deallocate(drphi_tmp)
  !++++++++++++++++++++++

! ------------------------------------ band ----------------------------
  eband_sum_sol = 0.d0
  do ips = 1,nps
     ishell = ishell_ps(ips,1)
     if (is_solve(ishell) /= 0) then
        eband_sum_sol = eband_sum_sol + focc_sol(ips) * engy_sol(ips)
     end if
  end do

! -------------------------------------- local ion ----------------
  eloc_ion_sum_sol = 0.d0
  Do ispin=1, nspin
     do ir = 1,nmesh
        r = rpos(ir)
        eloc_ion_sum_sol = eloc_ion_sum_sol &
             + pi4*r*r*wr(ir)*rho_sol(ir,ispin)*vloc_ion_sol(ir,ispin)
     end do
  End do

! ------------------------------- nonlocal ion -----------------
  enl_ion_sum_sol = 0.d0
  do ips = 1,nps
     ishell = ishell_ps(ips,1)

     if (is_solve(ishell) == 0) then
        cycle
     end if

     ll = l_qnum(ishell)
     nref = nref_us(ll)

     ispin = (1-spin(ishell))/2 + 1

     do t1 = 1,nref
        do t2 = 1,nref
           itmp1 = t1 + nref_max_us *(ispin - 1)
           itmp2 = t2 + nref_max_us *(ispin - 1)

           lt1 = lt_n_us(ll,itmp1)
           lt2 = lt_n_us(ll,itmp2)
           ltt = ltt_nm_us(ll,itmp1,itmp2)

           enl_ion_sum_sol = enl_ion_sum_sol &
                + focc_sol(ips) * dion_us(ltt) &
                * beta_phi_sol(lt1,ips) &
                * beta_phi_sol(lt2,ips)

        end do
     end do
  end do

! -------------------------------------------------------
  vlocqps_sum_sol = 0.d0
  do ips = 1,nps
     ishell = ishell_ps(ips,1)

     if (is_solve(ishell) == 0) then
        cycle
     end if

     ll = l_qnum(ishell)
     nref = nref_us(ll)

     ispin = (1-spin(ishell))/2 + 1

     do t1 = 1,nref
        do t2 = 1,nref
           itmp1 = t1 + nref_max_us *(ispin - 1)
           itmp2 = t2 + nref_max_us *(ispin - 1)

           lt1 = lt_n_us(ll,itmp1)
           lt2 = lt_n_us(ll,itmp2)
           ltt = ltt_nm_us(ll,itmp1,itmp2)

           vlocqps_sum_sol = vlocqps_sum_sol &
                + focc_sol(ips) * vlocqps_us(ltt) &
                * beta_phi_sol(lt1,ips) &
                * beta_phi_sol(lt2,ips)
        end do
     end do
  end do

! ---------------------------------------- hartree ----------------
  eh_sum_sol = 0.d0
  Do ispin=1, nspin
     do ir = 1,nmesh
        r = rpos(ir)
        eh_sum_sol = eh_sum_sol &
             + pi2*r*r*wr(ir)*rho_sol(ir,ispin)*vh_sol(ir)
     end do
  End do

! ---------------------------------------------EXC ------------------
  select case (is_xc)

  case (LDAPW92_GNCPP, GGAPW91_F90, GGAPW91_F77, &
       GGAPBE96_GNCPP, GGAPBE96_KATO, &
       GGAPBE96_MOMO2)

  case default
     ex_sum_sol   = 0.d0
     ec_sum_sol   = 0.d0
     expc_sum_sol = 0.d0
     ecpc_sum_sol = 0.d0

     select case (is_pcc)

     case (NONE)

        Do ispin=1, nspin
           do ir = 1,nmesh
              r = rpos(ir)
              ex_sum_sol = ex_sum_sol &
                   + pi4*r*r*wr(ir)*rho_sol(ir,ispin)*ex_sol(ir)
              ec_sum_sol = ec_sum_sol &
                   + pi4*r*r*wr(ir)*rho_sol(ir,ispin)*ec_sol(ir)
           end do
        End do

     case (PCC,FCC)

        Do ispin=1, nspin
           do ir = 1,nmesh
              r = rpos(ir)

              rho_tmp = rho_sol(ir,ispin) + rho_pcore(ir) /dble(nspin)
              ex_sum_sol = ex_sum_sol &
                   + pi4*r*r*wr(ir) *rho_tmp *ex_sol(ir)
              ec_sum_sol = ec_sum_sol &
                   + pi4*r*r*wr(ir) *rho_tmp *ec_sol(ir)

              rho_tmp = rho_pcore(ir) /dble(nspin)
              expc_sum_sol = expc_sum_sol &
                   - pi4*r*r*wr(ir) *rho_tmp *expc_sol(ir)
              ecpc_sum_sol = ecpc_sum_sol &
                   - pi4*r*r*wr(ir) *rho_tmp *ecpc_sol(ir)
           end do
        End do

     end select
  end select

  exc_sum_sol   = ex_sum_sol + ec_sum_sol
  excpc_sum_sol = expc_sum_sol + ecpc_sum_sol

! ---------------------------------------------VXC ------------------
  vx_sum_sol = 0.d0
  vc_sum_sol = 0.d0

  Do ispin=1, nspin
     do ir = 1,nmesh
        r = rpos(ir)
        vx_sum_sol = vx_sum_sol &
             + pi4*r*r*wr(ir)*rho_sol(ir,ispin)*vx_sol(ir,ispin)
        vc_sum_sol = vc_sum_sol &
             + pi4*r*r*wr(ir)*rho_sol(ir,ispin)*vc_sol(ir,ispin)
     end do
  End Do

! ------------------------------------------------- summation ----
  vxc_sum_sol = vx_sum_sol + vc_sum_sol

  eion_sum_sol  = eloc_ion_sum_sol + enl_ion_sum_sol
  etot_sum1_sol = ekin_sum1_sol + eion_sum_sol  &
       + eh_sum_sol + exc_sum_sol + excpc_sum_sol
  etot_sum2_sol = eband_sum_sol - eh_sum_sol  &
       + exc_sum_sol - vxc_sum_sol + excpc_sum_sol
  etot_sum_sol  = etot_sum2_sol
  etot_sol      = etot_sum_sol
  ekin_sum2_sol = eband_sum_sol - eion_sum_sol - 2.d0*eh_sum_sol &
       - vxc_sum_sol
  ekin_sum_sol  = ekin_sum2_sol

end subroutine calc_etot_sol_kt
! ============================================================================= 4.0

!=====================================================================
   subroutine calc_etot_ss(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ishell, ll, t1, t2, ltt, &
              iord_tmp, lt1, lt2, nref, iss, ispin
   real(8) :: r, pi4, pi2, rho_tmp
   real(8),allocatable :: drphi_tmp(:)
   ier    =  0
   pi4 = 4.d0*PI ; pi2 = 2.d0*PI
  !++++++++++++++++++++++++++++++++++++++++++++++
   allocate(drphi_tmp(nmesh)) ; drphi_tmp = 0.d0
  !++++++++++++++++++++++++++++++++++++++++++++++
   iord_tmp = 5
   ekin_sum1_ss = 0.d0
   do iss = 1,nss
      ishell = ishell_ss(iss)
      if (is_solve_ss(iss) == 0) then
         cycle
      end if
      ll = l_qnum(ishell)
      call calc_diff_exp(ier,iord_tmp,nmesh,rpos, &
                         rphi_ss(1,iss),drphi_tmp)
      do ir = 1,nmesh
         r = rpos(ir)
         ekin_sum1_ss = ekin_sum1_ss + focc_ss(iss) &
         * 0.5d0*wr(ir) &
         *( drphi_tmp(ir)**2 &
            + dble(ll*(ll+1))*(rphi_ss(ir,iss)/r)**2 )
      end do
   end do
  !++++++++++++++++++++++
   deallocate(drphi_tmp)
  !++++++++++++++++++++++
   eband_sum_ss = 0.d0
   do iss = 1,nss
      if (is_solve_ss(iss) /= 0) then
         eband_sum_ss = eband_sum_ss + focc_ss(iss) * engy_ss(iss)
      end if
   end do
   eloc_ion_sum_ss = 0.d0
   do ispin = 1,nspin_ss
   do ir = 1,nmesh
      r = rpos(ir)
      eloc_ion_sum_ss = eloc_ion_sum_ss &
! ============================================== modified by K. T. ========= 4.0
!         + pi4*r*r*wr(ir)*rho_ss(ir,ispin)*vloc_ion_sol(ir)
         + pi4*r*r*wr(ir)*rho_ss(ir,ispin)*vloc_ion_sol(ir,1)
! ========================================================================== 4.0
   end do
   end do
   enl_ion_sum_ss = 0.d0
   do iss = 1,nss
      ishell = ishell_ss(iss)
      if (is_solve_ss(iss) == 0) then
         cycle
      end if
      ll = l_qnum(ishell)
      nref = nref_us(ll)
      do t1 = 1,nref
      do t2 = 1,nref
         lt1 = lt_n_us(ll,t1)
         lt2 = lt_n_us(ll,t2)
         ltt = ltt_nm_us(ll,t1,t2)
         enl_ion_sum_ss = enl_ion_sum_ss &
            + focc_ss(iss) * dion_us(ltt) &
               * beta_phi_ss(lt1,iss) &
               * beta_phi_ss(lt2,iss)
      end do
      end do
   end do
   vlocqps_sum_ss = 0.d0
   do iss = 1,nss
      ispin = (1-spin_ss(iss))/2 + 1
      ishell = ishell_ss(iss)
      if (is_solve_ss(iss) == 0) then
         cycle
      end if
      ll = l_qnum(ishell)
      nref = nref_us(ll)
      do t1 = 1,nref
      do t2 = 1,nref
         lt1 = lt_n_us(ll,t1)
         lt2 = lt_n_us(ll,t2)
         ltt = ltt_nm_us(ll,t1,t2)
         vlocqps_sum_ss = vlocqps_sum_ss &
            + focc_ss(iss) * vlocqps_ss(ltt,ispin) &
               * beta_phi_ss(lt1,iss) &
               * beta_phi_ss(lt2,iss)
      end do
      end do
   end do
   eh_sum_ss = 0.d0
   do ispin = 1,nspin_ss
   do ir = 1,nmesh
      r = rpos(ir)
      eh_sum_ss = eh_sum_ss &
             + pi2*r*r*wr(ir)*rho_ss(ir,ispin)*vh_ss(ir)
   end do
   end do
   select case (is_xc)
   case (LDAPW92_GNCPP, GGAPW91_F90, GGAPW91_F77, &
         GGAPBE96_GNCPP, GGAPBE96_KATO, &
         GGAPBE96_MOMO2)
   case default
      ex_sum_ss   = 0.d0
      ec_sum_ss   = 0.d0
      expc_sum_ss = 0.d0
      ecpc_sum_ss = 0.d0
      select case (is_pcc)
      case (NONE)
         do ispin = 1,nspin_ss
         do ir = 1,nmesh
            r = rpos(ir)
            ex_sum_ss = ex_sum_ss &
               + pi4*r*r*wr(ir)*rho_ss(ir,ispin)*ex_ss(ir)
            ec_sum_ss = ec_sum_ss &
               + pi4*r*r*wr(ir)*rho_ss(ir,ispin)*ec_ss(ir)
         end do
         end do
      case (PCC,FCC)
         do ispin = 1,nspin_ss
         do ir = 1,nmesh
            r = rpos(ir)
            rho_tmp = rho_ss(ir,ispin)+rho_pcore(ir)/dble(nspin_ss)
            ex_sum_ss = ex_sum_ss &
               + pi4*r*r*wr(ir)*rho_tmp*ex_ss(ir)
            ec_sum_ss = ec_sum_ss &
               + pi4*r*r*wr(ir)*rho_tmp*ec_ss(ir)
            rho_tmp = rho_pcore(ir)/dble(nspin_ss)
            expc_sum_ss = expc_sum_ss &
               - pi4*r*r*wr(ir)*rho_tmp*expc_ss(ir)
            ecpc_sum_ss = ecpc_sum_ss &
               - pi4*r*r*wr(ir)*rho_tmp*ecpc_ss(ir)
         end do
         end do
      end select
   end select
   exc_sum_ss   = ex_sum_ss + ec_sum_ss
   excpc_sum_ss = expc_sum_ss + ecpc_sum_ss
   vx_sum_ss = 0.d0
   vc_sum_ss = 0.d0
   do ispin = 1,nspin_ss
   do ir = 1,nmesh
      r = rpos(ir)
      vx_sum_ss = vx_sum_ss &
         + pi4*r*r*wr(ir)*rho_ss(ir,ispin)*vx_ss(ir,ispin)
      vc_sum_ss = vc_sum_ss &
         + pi4*r*r*wr(ir)*rho_ss(ir,ispin)*vc_ss(ir,ispin)
   end do
   end do
   vxc_sum_ss = vx_sum_ss + vc_sum_ss
   eion_sum_ss  = eloc_ion_sum_ss + enl_ion_sum_ss
   etot_sum1_ss = ekin_sum1_ss + eion_sum_ss  &
                + eh_sum_ss + exc_sum_ss + excpc_sum_ss
   etot_sum2_ss = eband_sum_ss - eh_sum_ss  &
                + exc_sum_ss - vxc_sum_ss + excpc_sum_ss
   etot_sum_ss  = etot_sum2_ss
   etot_ss      = etot_sum_ss
   ekin_sum2_ss = eband_sum_ss - eion_sum_ss - 2.d0*eh_sum_ss &
                - vxc_sum_ss
   ekin_sum_ss  = ekin_sum2_ss
   end subroutine calc_etot_ss

!================================================== added by K. T. =========== 4.0
subroutine calc_etot_ss_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ir, ishell, ll, t1, t2, ltt, &
       iord_tmp, lt1, lt2, nref, iss, ispin
  real(8) :: r, pi4, pi2, rho_tmp
  real(8),allocatable :: drphi_tmp(:)

  integer :: ispin_ps, itmp1, itmp2

  ier    =  0
  pi4 = 4.d0*PI ; pi2 = 2.d0*PI

  !++++++++++++++++++++++++++++++++++++++++++++++
  allocate(drphi_tmp(nmesh)) ; drphi_tmp = 0.d0
  !++++++++++++++++++++++++++++++++++++++++++++++
  iord_tmp = 5

! ----------------------------------- kinetic ------------------------
  ekin_sum1_ss = 0.d0
  do iss = 1,nss
     ishell = ishell_ss(iss)
     if (is_solve_ss(iss) == 0) then
        cycle
     end if
     ll = l_qnum(ishell)
     call calc_diff_exp(ier,iord_tmp,nmesh,rpos, &
          rphi_ss(1,iss),drphi_tmp)
     do ir = 1,nmesh
        r = rpos(ir)
        ekin_sum1_ss = ekin_sum1_ss + focc_ss(iss) &
             * 0.5d0*wr(ir) &
             *( drphi_tmp(ir)**2 &
             + dble(ll*(ll+1))*(rphi_ss(ir,iss)/r)**2 )
     end do
  end do
  !++++++++++++++++++++++
  deallocate(drphi_tmp)
  !++++++++++++++++++++++

! ---------------------------------------- band ------------------------
  eband_sum_ss = 0.d0
  do iss = 1,nss
     if (is_solve_ss(iss) /= 0) then
        eband_sum_ss = eband_sum_ss + focc_ss(iss) * engy_ss(iss)
     end if
  end do

! ---------------------------------------- local ion ------------------------
  eloc_ion_sum_ss = 0.d0

  if ( nspin == 1 ) then
     do ispin = 1,nspin_ss
        do ir = 1,nmesh
           r = rpos(ir)
           eloc_ion_sum_ss = eloc_ion_sum_ss &
                + pi4*r*r*wr(ir)*rho_ss(ir,ispin)*vloc_ion_sol(ir,1)
        end do
     end do
  else if ( nspin == 2 ) then
     do ispin = 1,nspin_ss

        ispin_ps = ispin

        do ir = 1,nmesh
           r = rpos(ir)
           eloc_ion_sum_ss = eloc_ion_sum_ss &
                + pi4*r*r*wr(ir)*rho_ss(ir,ispin)*vloc_ion_sol(ir,ispin_ps)
        end do
     end do
  endif

! ----------------------------------------- nonlcoal ion ---------
  enl_ion_sum_ss = 0.d0
  do iss = 1,nss

     ishell = ishell_ss(iss)
     if (is_solve_ss(iss) == 0) then
        cycle
     end if

     ll = l_qnum(ishell)
     nref = nref_us(ll)

     ispin = (1-spin_ss(iss))/2 + 1

!     write(*,*) 'ispin nspin =', ispin, nspin

     do t1 = 1,nref
        do t2 = 1,nref

           itmp1 = t1 + nref_max_us *(ispin - 1)
           itmp2 = t2 + nref_max_us *(ispin - 1)

           if ( nspin == 1 ) then
              itmp1 = t1;  itmp2 = t2
           endif

           lt1 = lt_n_us(ll,itmp1)
           lt2 = lt_n_us(ll,itmp2)
           ltt = ltt_nm_us(ll,itmp1,itmp2)

           enl_ion_sum_ss = enl_ion_sum_ss &
                + focc_ss(iss) * dion_us(ltt) &
                * beta_phi_ss(lt1,iss) &
                * beta_phi_ss(lt2,iss)
        end do
     end do
  end do

! ---------------------------------------------------------------------
  vlocqps_sum_ss = 0.d0

  do iss = 1,nss
     ispin = (1-spin_ss(iss))/2 + 1
     ishell = ishell_ss(iss)
     
     if (is_solve_ss(iss) == 0) then
        cycle
     end if
     
     ll = l_qnum(ishell)
     nref = nref_us(ll)
     
     do t1 = 1,nref
        do t2 = 1,nref
           itmp1 = t1 + nref_max_us *(ispin - 1)
           itmp2 = t2 + nref_max_us *(ispin - 1)
           
           if ( nspin == 1 ) then
              itmp1 = t1;  itmp2 = t2
           endif
           
           lt1 = lt_n_us(ll,itmp1)
           lt2 = lt_n_us(ll,itmp2)
           ltt = ltt_nm_us(ll,itmp1,itmp2)
           
           vlocqps_sum_ss = vlocqps_sum_ss &
                + focc_ss(iss) * vlocqps_ss(ltt,ispin) &
                * beta_phi_ss(lt1,iss) &
                * beta_phi_ss(lt2,iss)
        end do
     end do
  end do

! -------------------------------- Hartree ----------------------
  eh_sum_ss = 0.d0
  do ispin = 1,nspin_ss
     do ir = 1,nmesh
        r = rpos(ir)
        eh_sum_ss = eh_sum_ss &
             + pi2*r*r*wr(ir)*rho_ss(ir,ispin)*vh_ss(ir)
     end do
  end do

! ---------------------------------- EXC --------------------------
  select case (is_xc)

  case (LDAPW92_GNCPP, GGAPW91_F90, GGAPW91_F77, &
       GGAPBE96_GNCPP, GGAPBE96_KATO, &
       GGAPBE96_MOMO2)

  case default
     ex_sum_ss   = 0.d0
     ec_sum_ss   = 0.d0
     expc_sum_ss = 0.d0
     ecpc_sum_ss = 0.d0

     select case (is_pcc)

     case (NONE)
        do ispin = 1,nspin_ss
           do ir = 1,nmesh
              r = rpos(ir)
              ex_sum_ss = ex_sum_ss &
                   + pi4*r*r*wr(ir)*rho_ss(ir,ispin)*ex_ss(ir)
              ec_sum_ss = ec_sum_ss &
                   + pi4*r*r*wr(ir)*rho_ss(ir,ispin)*ec_ss(ir)
           end do
        end do

     case (PCC,FCC)
        do ispin = 1,nspin_ss
           do ir = 1,nmesh
              r = rpos(ir)
              rho_tmp = rho_ss(ir,ispin)+rho_pcore(ir)/dble(nspin_ss)
              ex_sum_ss = ex_sum_ss &
                   + pi4*r*r*wr(ir)*rho_tmp*ex_ss(ir)
              ec_sum_ss = ec_sum_ss &
                   + pi4*r*r*wr(ir)*rho_tmp*ec_ss(ir)
              rho_tmp = rho_pcore(ir)/dble(nspin_ss)
              expc_sum_ss = expc_sum_ss &
                   - pi4*r*r*wr(ir)*rho_tmp*expc_ss(ir)
              ecpc_sum_ss = ecpc_sum_ss &
                   - pi4*r*r*wr(ir)*rho_tmp*ecpc_ss(ir)
           end do
        end do
     end select
  end select

  exc_sum_ss   = ex_sum_ss + ec_sum_ss
  excpc_sum_ss = expc_sum_ss + ecpc_sum_ss

! --------------------------------------- VXC ---------------------------------
  vx_sum_ss = 0.d0
  vc_sum_ss = 0.d0

  do ispin = 1,nspin_ss
     do ir = 1,nmesh
        r = rpos(ir)
        vx_sum_ss = vx_sum_ss &
             + pi4*r*r*wr(ir)*rho_ss(ir,ispin)*vx_ss(ir,ispin)
        vc_sum_ss = vc_sum_ss &
             + pi4*r*r*wr(ir)*rho_ss(ir,ispin)*vc_ss(ir,ispin)
     end do
  end do

! -------------------------------------- summation ----------------------
  vxc_sum_ss = vx_sum_ss + vc_sum_ss
  eion_sum_ss  = eloc_ion_sum_ss + enl_ion_sum_ss
  etot_sum1_ss = ekin_sum1_ss + eion_sum_ss  &
       + eh_sum_ss + exc_sum_ss + excpc_sum_ss
  etot_sum2_ss = eband_sum_ss - eh_sum_ss  &
       + exc_sum_ss - vxc_sum_ss + excpc_sum_ss
  etot_sum_ss  = etot_sum2_ss
  etot_ss      = etot_sum_ss
  ekin_sum2_ss = eband_sum_ss - eion_sum_ss - 2.d0*eh_sum_ss &
       - vxc_sum_ss
  ekin_sum_ss  = ekin_sum2_ss

end subroutine calc_etot_ss_kt
! =========================================================================== 4.0

!=====================================================================
   subroutine write_etot_sol(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer        :: i
   character(100) :: line
   do i = 1,100
      line(i:i) = '-'
   end do
   write(ifile,*)
   write(ifile,*)  'etot  Total energy for the present PP [Solved]'
   write(ifile,10) line(1:100)
   write(ifile,11) 'Energy (Ha)','Energy (eV)'
   write(ifile,10) line(1:100)
   write(ifile,20) 'Ekin     ',ekin_sum1_sol   ,ekin_sum1_sol   *HARTREE
   write(ifile,20) 'Eion[NL] ',enl_ion_sum_sol ,enl_ion_sum_sol *HARTREE
   write(ifile,20) 'Eion[LOC]',eloc_ion_sum_sol,eloc_ion_sum_sol*HARTREE
   write(ifile,20) 'Eh       ',eh_sum_sol      ,eh_sum_sol      *HARTREE
   write(ifile,20) 'Exc      ',exc_sum_sol     ,exc_sum_sol     *HARTREE
   write(ifile,20) 'Epcc     ',excpc_sum_sol   ,excpc_sum_sol   *HARTREE
   write(ifile,10) line(1:100)
   write(ifile,20) 'Ekin*    ',ekin_sum2_sol   ,ekin_sum2_sol   *HARTREE
   write(ifile,20) 'Eion     ',eion_sum_sol    ,eion_sum_sol    *HARTREE
   write(ifile,20) 'VlocQps  ',vlocqps_sum_sol ,vlocqps_sum_sol *HARTREE
   write(ifile,20) 'Ex       ',ex_sum_sol      ,ex_sum_sol      *HARTREE
   write(ifile,20) 'Ec       ',ec_sum_sol      ,ec_sum_sol      *HARTREE
   write(ifile,20) 'Vx       ',vx_sum_sol      ,vx_sum_sol      *HARTREE
   write(ifile,20) 'Vc       ',vc_sum_sol      ,vc_sum_sol      *HARTREE
   write(ifile,20) 'Vxc      ',vxc_sum_sol     ,vxc_sum_sol     *HARTREE
   write(ifile,20) 'Eband    ',eband_sum_sol   ,eband_sum_sol   *HARTREE
   write(ifile,10) line(1:100)
   write(ifile,20) 'Etot     ',etot_sum1_sol   ,etot_sum1_sol   *HARTREE
   write(ifile,20) 'Etot*    ',etot_sum2_sol   ,etot_sum2_sol   *HARTREE
   write(ifile,10) line(1:100)
   write(ifile,*)  'etot  Ekin* = Eband - Eion - 2Eh - Vxc'
   write(ifile,*)  'etot  Eion  = Eion[NL] + Eion[LOC]'
   write(ifile,*)  'etot  Etot  = Ekin + Eion + Eh + Exc + Epcc'
   write(ifile,*)  'etot  Etot* = Eband - Eh + Exc - Vxc + Epcc'
10 format(1x,'etot',a53)
11 format(1x,'etot',2x,9x,2(9x,a11))
20 format(1x,'etot',2x,a9,2(f20.10))
   end subroutine write_etot_sol

!=====================================================================
   subroutine write_etot_ss(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer        :: i
   character(100) :: line
   do i = 1,100
      line(i:i) = '-'
   end do
   write(ifile,*)
   write(ifile,*)  'etot  Total energy for the present PP [Solved]'
   write(ifile,10) line(1:100)
   write(ifile,11) 'Energy (Ha)','Energy (eV)'
   write(ifile,10) line(1:100)
   write(ifile,20) 'Ekin     ',ekin_sum1_ss   ,ekin_sum1_ss   *HARTREE
   write(ifile,20) 'Eion[NL] ',enl_ion_sum_ss ,enl_ion_sum_ss *HARTREE
   write(ifile,20) 'Eion[LOC]',eloc_ion_sum_ss,eloc_ion_sum_ss*HARTREE
   write(ifile,20) 'Eh       ',eh_sum_ss      ,eh_sum_ss      *HARTREE
   write(ifile,20) 'Exc      ',exc_sum_ss     ,exc_sum_ss     *HARTREE
   write(ifile,20) 'Epcc     ',excpc_sum_ss   ,excpc_sum_ss   *HARTREE
   write(ifile,10) line(1:100)
   write(ifile,20) 'Ekin*    ',ekin_sum2_ss   ,ekin_sum2_ss   *HARTREE
   write(ifile,20) 'Eion     ',eion_sum_ss    ,eion_sum_ss    *HARTREE
   write(ifile,20) 'VlocQps  ',vlocqps_sum_ss ,vlocqps_sum_ss *HARTREE
   write(ifile,20) 'Ex       ',ex_sum_ss      ,ex_sum_ss      *HARTREE
   write(ifile,20) 'Ec       ',ec_sum_ss      ,ec_sum_ss      *HARTREE
   write(ifile,20) 'Vx       ',vx_sum_ss      ,vx_sum_ss      *HARTREE
   write(ifile,20) 'Vc       ',vc_sum_ss      ,vc_sum_ss      *HARTREE
   write(ifile,20) 'Vxc      ',vxc_sum_ss     ,vxc_sum_ss     *HARTREE
   write(ifile,20) 'Eband    ',eband_sum_ss   ,eband_sum_ss   *HARTREE
   write(ifile,10) line(1:100)
   write(ifile,20) 'Etot     ',etot_sum1_ss   ,etot_sum1_ss   *HARTREE
   write(ifile,20) 'Etot*    ',etot_sum2_ss   ,etot_sum2_ss   *HARTREE
   write(ifile,10) line(1:100)
   write(ifile,*)  'etot  Ekin* = Eband - Eion - 2Eh - Vxc'
   write(ifile,*)  'etot  Eion  = Eion[NL] + Eion[LOC]'
   write(ifile,*)  'etot  Etot  = Ekin + Eion + Eh + Exc + Epcc'
   write(ifile,*)  'etot  Etot* = Eband - Eh + Exc - Vxc + Epcc'
10 format(1x,'etot',a53)
11 format(1x,'etot',2x,9x,2(9x,a11))
20 format(1x,'etot',2x,a9,2(f20.10))
   end subroutine write_etot_ss

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   Version history: 
!
!     4.0:  2013/03/01
!           codes for spin-polarized pseudopotential generation are added
!     4.1:  2013/11/22 - 
!           Info of core wfns and energy contributions can be added to gncpp2
!     4.2:  2014/07/23 - 
!           gncpp2 can be geregated even when nmesh /= 1501
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : calc_rho_pcore_sol, check_rho_pcore_sol
!                  write_checked_pcc_sol, calc_pcc_fourier_sol
!                  write_pcc_sol
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================

subroutine calc_rho_pcore_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ir, isdiff, n1, n2

! ============================= added by K. T. =================== 4.0
  real(8) :: rho_tmp
! ================================================================ 4.0

  ier = 0

  select case (is_pcc_rad)

  case (PCC_RATIO)

     do ir = 1,nmesh

! ============================= added by K. T. ===================== 4.0
        if ( nspin == 1 ) then
           rho_tmp = rho_ps(ir,1)
        else if ( nspin == 2 ) then
           rho_tmp = rho_ps(ir,1) +rho_ps(ir,2)
        endif
! ================================================================== 4.0

! ========================================== modified by K. T. ================ 4.0
!         if (rho_core(ir) < r0_pcc*rho_ps(ir)) then
        if (rho_core(ir) < r0_pcc*rho_tmp ) then
! ============================================================================== 4.0
           nr0_pcc = ir-1 ; r0_pcc = rpos(ir)
           exit
        end if

        if (ir == nmesh) then
           write(IFLOG,*) '### ERROR ### r0_pcc cannot be found'
           ier = 1 ; go to 99
        end if

     end do

  case (PCC_RC)

     do ir = nmesh,1,-1
        if (rpos(ir) < r0_pcc) then
           nr0_pcc = ir ; r0_pcc = rpos(ir)
           exit
        end if

        if (ir == 1) then
           write(IFLOG,*) '### ERROR ### r0_pcc cannot be found'
           ier = 1 ; go to 99
        end if
     end do

  end select

  nk_pcc = 2

!  write(*,*) 'r0_pcc = ', r0_pcc
!  write(*,*) 'nr0_pcc = ', nr0_pcc
!  write(450,*) 'rho_core = ', rho_core

   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  allocate(rho_core0_pcc(0:nk_pcc)) ; rho_core0_pcc = 0.d0
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  isdiff = nk_pcc
  n1 = nr0_pcc - 10
  n2 = nr0_pcc + 10
  r0_pcc = rpos(nr0_pcc)
  
  call diff_exp(ier,isdiff,n1,n2,rpos,rho_core,r0_pcc, &
       rho_core0_pcc(0),rho_core0_pcc(1),rho_core0_pcc(2))
  rho_core0_pcc(0) = rho_core(nr0_pcc)
  
  select case (is_pcc_method)
     
  case (POLYNOMIAL)
     call opt_poly_fn(ier,IFLOG,0,0, &
          nmesh,rpos,rho_core,nk_pcc,nr0_pcc,rho_core0_pcc, &
          ng_pcc,gmin_pcc,gmax_pcc,ncoeff_pcc,coeff_pcc)

     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in opt_poly_fn'
        go to 99
     end if
     
     rho_pcore(:) = rho_core(:)
     call calc_poly_fn(1,nr0_pcc,rpos,0,ncoeff_pcc,coeff_pcc,rho_pcore)
     
  case (SBESSEL)
     call opt_sbessel_fn(ier,IFLOG, &
          nr0_pcc,r0_pcc,rho_core0_pcc(0),rho_core0_pcc(1), &
          a_pcc,b_pcc)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in opt_sbessel_fn'
        go to 99
     end if
     rho_pcore(:) = rho_core(:)
     call calc_sbessel_fn(1,nr0_pcc,rpos,a_pcc,b_pcc,rho_pcore)
     
  end select

99 continue

end subroutine calc_rho_pcore_sol

!=====================================================================
   subroutine check_rho_pcore_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir1, ir2, ll, n1, n2, isdiff
   real(8) :: f0_anal(0:2), f0_num(0:2), f_tmp(nmesh)
   ier = 0
   f0_anal(:) = 0.d0
   ir1 = nr0_pcc
   ir2 = nr0_pcc
   ll  = 0
   call calc_poly_fn( &
      ir1,ir2,rpos,ll,ncoeff_pcc,coeff_pcc,f_tmp)
   f0_anal(0) = f_tmp(nr0_pcc)
   call calc_dpoly_fn( &
      ir1,ir2,rpos,ll,ncoeff_pcc,coeff_pcc,f_tmp)
   f0_anal(1) = f_tmp(nr0_pcc)
   call calc_ddpoly_fn( &
      ir1,ir2,rpos,ll,ncoeff_pcc,coeff_pcc,f_tmp)
   f0_anal(2) = f_tmp(nr0_pcc)
   f0_num(:)  = 0.d0
   isdiff = nk_pcc
   n1 = nr0_pcc - 10
   n2 = nr0_pcc + 10
   r0_pcc = rpos(nr0_pcc)
   call diff_exp(ier,isdiff,n1,n2,rpos,rho_pcore,r0_pcc, &
           f0_num(0),f0_num(1),f0_num(2))
   f0_num(0) = rho_pcore(nr0_pcc)
   call write_checked_pcc_sol(IFLOG, &
           nr0_pcc,r0_pcc,ncoeff_pcc,coeff_pcc, &
           nk_pcc,rho_core0_pcc,f0_anal,f0_num)
   call write_checked_pcc_sol(IFSUM, &
           nr0_pcc,r0_pcc,ncoeff_pcc,coeff_pcc, &
           nk_pcc,rho_core0_pcc,f0_anal,f0_num)
99 continue
   end subroutine check_rho_pcore_sol

!=====================================================================
   subroutine write_checked_pcc_sol(ifile, &
      nr0,r0,ncoeff,coeff,nk,f0_exact,f0_anal,f0_num)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in) :: ifile, nr0, ncoeff, nk
   real(8),intent(in) :: f0_exact(0:*), f0_anal(0:*), f0_num(0:*), &
                         coeff(0:*), r0
   integer :: icoeff, ik
   write(ifile,*)
   write(ifile,*)  'PCC (polynomial) [Solved]'
   write(ifile,10) 'r0, nr0  :', r0, nr0
   write(ifile,11) 'ncoeff,nk:', ncoeff, nk
   do icoeff=0,ncoeff
   write(ifile,12) 'coeff(',2*icoeff,'):', coeff(icoeff)
   end do
   write(ifile,13) 'rho_pc(rc)','rho_pc''(rc)','rho_pc"(rc)'
   write(ifile,14) 'Exact    :',(f0_exact(ik),ik=0,nk)
   write(ifile,14) 'Analytic :',(f0_anal (ik),ik=0,nk)
   write(ifile,14) 'Numerical:',(f0_num  (ik),ik=0,nk)
10 format(1x,a10,f20.10,i20)
11 format(1x,a10,2(i20))
12 format(1x,(a6,i2,a2),f20.10)
13 format(1x,7x,1x,2x,(8x,a10,2x),(8x,a11,1x),(8x,a11,1x))
14 format(1x,a10,5(f20.10))
   end subroutine write_checked_pcc_sol

!=====================================================================
subroutine calc_pcc_fourier_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ir, ig
  real(8) :: r, g

  ier = 0

  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++
  allocate(gg_rho_core(ng_mesh),gg_rho_pcore(ng_mesh), &
       gg_rho_val(ng_mesh))
  gg_rho_core = 0.d0 ; gg_rho_pcore = 0.d0
  gg_rho_val  = 0.d0
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++
  gg_rho_core(:)  = 0.d0
  gg_rho_pcore(:) = 0.d0
  gg_rho_val(:)   = 0.d0
  g = gpos(1)

  do ir = 1,nmesh
     r = rpos(ir)
     gg_rho_core(1)  = gg_rho_core(1)  &
          + 4.d0*PI*r*r*wr(ir) * rho_core(ir) * g*g
     gg_rho_pcore(1) = gg_rho_pcore(1) &
          + 4.d0*PI*r*r*wr(ir) * rho_pcore(ir) * g*g
     
! ================================================== modified by K. T. ======= 4.0
!      gg_rho_val(1)   = gg_rho_val(1) &
!                      + 4.d0*PI*r*r*wr(ir) * rho_sol(ir) * g*g
!
     if ( nspin == 1 ) then
        gg_rho_val(1)   = gg_rho_val(1) &
             + 4.d0*PI*r*r*wr(ir) * rho_sol(ir,1) *g*g
     else if ( nspin == 2 ) then
        gg_rho_val(1)   = gg_rho_val(1) &
             + 4.d0*PI*r*r*wr(ir) * ( rho_sol(ir,1) +rho_sol(ir,2) ) *g*g
     endif
! ============================================================================ 4.0
  end do

  do ig = 2,ng_mesh
     g = gpos(ig)
     do ir = 1,nmesh
        r = rpos(ir)
        gg_rho_core(ig) = gg_rho_core(ig)  &
             + 4.d0*PI*r*wr(ir) * rho_core(ir) * sin(g*r)*g
        gg_rho_pcore(ig) = gg_rho_pcore(ig) &
             + 4.d0*PI*r*wr(ir) * rho_pcore(ir) * sin(g*r)*g
        
! ================================== modified by K. T. =============== 4.0
!         gg_rho_val(ig) = gg_rho_val(ig) &
!            + 4.d0*PI*r*wr(ir) * rho_sol(ir) * sin(g*r)*g
!
        if ( nspin == 1 ) then
           gg_rho_val(ig) = gg_rho_val(ig) &
                + 4.d0*PI*r*wr(ir) * rho_sol(ir,1) * sin(g*r)*g
        else if ( nspin ==2 ) then
           gg_rho_val(ig) = gg_rho_val(ig) &
                + 4.d0*PI*r*wr(ir) * ( rho_sol(ir,1)+rho_sol(ir,2) ) *sin(g*r)*g
        endif
! ============================================================================= 4.0
     end do
  end do

99 continue

end subroutine calc_pcc_fourier_sol

!=====================================================================
subroutine write_pcc_sol(ier)
!=====================================================================
!
!  M. Okamoto
!     
!---------------------------------------------------------------------
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ir, ig

  ier = 0
  open(IFPCC,file=trim(pccfile),status='unknown')
  write(IFPCC,*) 'PCC electron density and its fourier transform'
  call write_file_header(IFPCC)
  write(IFPCC,*)
  write(IFPCC,31) rpos(nr0_pcc), 'rcut  '
  write(IFPCC,31) gmin_pcc,      'gcut  '
  write(IFPCC,*)
  write(IFPCC,*) 'rpos, rho_core, rho_pcc, rho_val'

  do ir = 1,nmesh
! ============================================ modified y K. T, ================= 4.0
!      write(IFPCC,10) rpos(ir),rho_core(ir),rho_pcore(ir),rho_sol(ir)
!
     if ( nspin == 1 ) then
        write(IFPCC,10) rpos(ir),rho_core(ir),rho_pcore(ir),rho_sol(ir,1)
     else if ( nspin ==2 ) then
        write(IFPCC,10) rpos(ir),rho_core(ir),rho_pcore(ir),rho_sol(ir,1)+rho_sol(ir,2)
     endif
! =============================================================================== 4.0
  end do

  write(IFPCC,*)
  write(IFPCC,*) 'gpos, gg_rho_core, gg_rho_pcc, gg_rho_val'

  do ig = 1,ng_mesh
     write(IFPCC,10) gpos(ig),gg_rho_core(ig),gg_rho_pcore(ig), &
          gg_rho_val(ig)
  end do

10 format(10(1pe20.10))
31 format(1x,f20.10, 5x,':',1x,a6)

  close(IFPCC)

end subroutine write_pcc_sol

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   Version history: 
!
!     4.0:  2013/03/01
!           codes for spin-polarized pseudopotential generation are added
!     4.1:  2013/11/22 - 
!           Info of core wfns and energy contributions can be added to gncpp2
!     4.2:  2014/07/23 - 
!           gncpp2 can be geregated even when nmesh /= 1501
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : calc_fourier, write_fourier, write_fourier_patom
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine calc_fourier(ier)
!=====================================================================
!
!  Calculates Fourier transforms of ion potentials
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ig, ir, ips, ll, nmesh_cut
   real(8) :: r, g, dg, sum, &
              eps_g = 1.d-6
   ier = 0
   nmesh_cut = nmesh
   dg = (gmax_fourier - gmin_fourier) / dble(ng_fourier - 1)
   do ig = 1,ng_fourier
      gpos_ft(ig) = gmin_fourier + dble(ig-1) * dg
   end do
   !call set_open_weight_exp(ier,1,nmesh_cut,rpos,wt)
   call set_weight_exp(ier,1,nmesh_cut,rpos,wt)
   do ll = 0,lmax_core
   do ig = 1,ng_fourier
      g = gpos_ft(ig)
      if (abs(g) < eps_g) then
         gg_vion_ft(ig,ll) = - fatom
      else
         sum = 0.d0
         do ir = 1,nmesh_cut
            r = rpos(ir)
            sum = sum + sin(g*r) &
                      * (r*vion(ir,ll)+fatom) * wt(ir)
         end do
         gg_vion_ft(ig,ll) = g*sum - fatom
      end if
   end do
   end do
   if (is_pp_generated == YES) then
      do ig = 1,ng_fourier
         g = gpos_ft(ig)
         if (abs(g) < eps_g) then
! ================================================= modified by K. T. ========== 4.0
!            gg_vloc_ion_ft(ig) = - fval
            gg_vloc_ion_ft(ig,1) = - fval
! ============================================================================= 4.0
         else
            sum = 0.d0
            do ir = 1,nmesh_cut
               r = rpos(ir)
               sum = sum + sin(g*r) &
! ================================================= modified by K. T. ========== 4.0
!                         * (r*vloc_ion_us(ir)+fval) * wt(ir)
                         * (r*vloc_ion_us(ir,1)+fval) * wt(ir)
! ============================================================================== 4.0
            end do

! ================================================= modified by K. T. ========== 4.0
!            gg_vloc_ion_ft(ig) = g*sum - fval
            gg_vloc_ion_ft(ig,1) = g*sum - fval
! ============================================================================== 4.0
         end if
      end do
      do ips = 1,nps
      do ig = 1,ng_fourier
         g = gpos_ft(ig)
         if (abs(g) < eps_g) then
            gg_vion_ps_ft(ig,ips) = - fval
         else
            sum = 0.d0
            do ir = 1,nmesh_cut
               r = rpos(ir)
               sum = sum + sin(g*r) &
                         * (r*vion_ps(ir,ips,1)+fval) * wt(ir)
            end do
            gg_vion_ps_ft(ig,ips) = g*sum - fval
         end if
      end do
      end do
   end if
   end subroutine calc_fourier

!====================================== added by K. T. ================== 4.0
subroutine calc_fourier_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  
  integer :: ig, ir, ips, ll, nmesh_cut
  integer :: ispin
  real(8) :: r, g, dg, sum, &
       eps_g = 1.d-6

  ier = 0
  nmesh_cut = nmesh
  dg = (gmax_fourier - gmin_fourier) / dble(ng_fourier - 1)

  do ig = 1,ng_fourier
     gpos_ft(ig) = gmin_fourier + dble(ig-1) * dg
  end do
  !call set_open_weight_exp(ier,1,nmesh_cut,rpos,wt)
  
  call set_weight_exp(ier,1,nmesh_cut,rpos,wt)

  do ll = 0,lmax_core
     do ig = 1,ng_fourier
        g = gpos_ft(ig)
        if (abs(g) < eps_g) then
           gg_vion_ft(ig,ll) = - fatom
        else
           sum = 0.d0
           do ir = 1,nmesh_cut
              r = rpos(ir)
              sum = sum + sin(g*r) &
                   * (r*vion(ir,ll)+fatom) * wt(ir)
           end do
           gg_vion_ft(ig,ll) = g*sum - fatom
        end if
     end do
  end do

  if (is_pp_generated == YES) then
     
     do ig = 1,ng_fourier
        g = gpos_ft(ig)
        
        if (abs(g) < eps_g) then
           gg_vloc_ion_ft(ig,:) = - fval
           
        else
           
           Do ispin=1, nspin
              sum = 0.d0
              do ir = 1,nmesh_cut
                 r = rpos(ir)
                 sum = sum + sin(g*r) &
                      & * (r*vloc_ion_us(ir,ispin) +fval) * wt(ir)
              end do
              gg_vloc_ion_ft(ig,ispin) = g*sum - fval
           End Do
           
        end if
        
     end do
     
     do ips = 1,nps
        do ig = 1,ng_fourier
           g = gpos_ft(ig)
           if (abs(g) < eps_g) then
              gg_vion_ps_ft(ig,ips) = - fval
           else
              sum = 0.d0
              do ir = 1,nmesh_cut
                 r = rpos(ir)
                 sum = sum + sin(g*r) &
                      * (r*vion_ps(ir,ips,1)+fval) * wt(ir)
              end do
              gg_vion_ps_ft(ig,ips) = g*sum - fval
           end if
        end do
     end do

  end if

end subroutine calc_fourier_kt
! ============================================================================ 4.0

!=====================================================================
   subroutine write_fourier(ier)
!=====================================================================
!
!  Outputs Fourier transforms into file (IFFT)
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ips, ishell, nn, ll, kk, jj2, ispin, ig, ll_core
   real(8) :: g
   character(1) :: fn_label_orbital
   character(2) :: ch_del, ch2
   character(4) :: ch4
   ier = 0
   ch_del = ','//' '
   open(IFFT,file=trim(ftfile),status='unknown')
   write(IFFT,*) 'Fourier transforms of Vion(r,l,t) and Vion_ps(r,l,t)'
   call write_file_header(IFFT)
   write(IFFT,23) ng_fourier,'ng_fourier'
   ch4(1:4) = '_loc'
   write(IFFT,*)
   write(IFFT,*) 'local potential [ion]'
   write(IFFT,*) 'gpos'//ch4//ch_del//'gg_vionk'//ch4
   do ig = 1,ng_fourier
      g = gpos_ft(ig)
! ============================================= modified by K. T. ================ 4.0
!      write(IFFT,10) g, gg_vloc_ion_ft(ig)
      write(IFFT,10) g, gg_vloc_ion_ft(ig,1)
! ============================================================================= 4.0
   end do
   do ips = 1,nps
      ishell = ishell_ps(ips,1)
      nn = n_qnum(ishell)
      ll = l_qnum(ishell)
      if (is_core == PATOM) then
         ll_core = ll
      else
         ll_core = lmax_core
      end if
      kk = k_qnum(ishell)
      jj2 = j2_qnum(ishell)
      ispin = (1-spin(ishell))/2 + 1
      ch2(1:2) = '_'//fn_label_orbital(ll)
      write(IFFT,*)
      write(IFFT,30) nn,ll,jj2,ispin,'(n, l, 2*j, s)'
      write(IFFT,31) engy(ishell),'elevel'
      write(IFFT,31) rcut_tm(ll) ,'rcut  '
      write(IFFT,*)
      write(IFFT,*) 'gpos'//ch2//ch_del//'gg_vionk'//ch2//ch_del &
                    //'gg_vionk_ps'//ch2
      do ig = 1,ng_fourier
         g = gpos_ft(ig)
         write(IFFT,10) g, gg_vion_ft(ig,ll_core), &
                           gg_vion_ps_ft(ig,ips)
      end do
   end do
10 format(10(1pe20.10))
23 format(1x,i10,10x,5x,':',1x,a10)
30 format(1x,4i5,    5x,':',1x,a14)
31 format(1x,f20.10, 5x,':',1x,a6)
   close(IFFT)
   end subroutine write_fourier

!========================================== added by K. T. ================= 4.0
subroutine write_fourier_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier

  integer :: ips, ishell, nn, ll, kk, jj2, ispin, ig, ll_core

  real(8) :: g
  character(1) :: fn_label_orbital
  character(2) :: ch_del, ch2
  character(4) :: ch4

  ier = 0
  ch_del = ','//' '
  
  open(IFFT,file=trim(ftfile),status='unknown')

  if ( nspin == 1 ) then
     write(IFFT,*) 'Fourier transforms of Vion(r,l,t) and Vion_ps(r,l,t)'
  else if ( nspin == 2 ) then
     write(IFFT,*) 'Fourier transforms of Vion(r,l,t,s) and Vion_ps(r,l,t,s)'
  endif

  call write_file_header(IFFT)
  write(IFFT,23) ng_fourier,'ng_fourier'

  ch4(1:4) = '_loc'

  write(IFFT,*)
  write(IFFT,*) 'local potential [ion]'

  Do ispin=1, nspin

     if ( nspin == 2 ) then
        write(IFFT,*)
        if ( ispin == 1 ) then
           write(IFFT,'(a)') ' spin component : up'
        else if ( ispin == 2 ) then
           write(IFFT,'(a)') ' spin component : down'
        endif
        write(IFFT,*)
     endif

     write(IFFT,*) 'gpos'//ch4//ch_del//'gg_vionk'//ch4

     do ig = 1,ng_fourier
        g = gpos_ft(ig)
        write(IFFT,10) g, gg_vloc_ion_ft(ig,ispin)
     end do

  End do
  
  do ips = 1,nps
     ishell = ishell_ps(ips,1)
     nn = n_qnum(ishell)
     ll = l_qnum(ishell)

     if (is_core == PATOM) then
        ll_core = ll
     else
        ll_core = lmax_core
     end if

     kk = k_qnum(ishell)
     jj2 = j2_qnum(ishell)

     ispin = (1-spin(ishell))/2 + 1
     ch2(1:2) = '_'//fn_label_orbital(ll)

     write(IFFT,*)
     write(IFFT,30) nn,ll,jj2,ispin,'(n, l, 2*j, s)'
     write(IFFT,31) engy(ishell),'elevel'
     write(IFFT,31) rcut_tm(ll) ,'rcut  '

     write(IFFT,*)
     write(IFFT,*) 'gpos'//ch2//ch_del//'gg_vionk'//ch2//ch_del &
          //'gg_vionk_ps'//ch2

     do ig = 1,ng_fourier
        g = gpos_ft(ig)
        write(IFFT,10) g, gg_vion_ft(ig,ll_core), gg_vion_ps_ft(ig,ips)
     end do
  end do

10 format(10(1pe20.10))
23 format(1x,i10,10x,5x,':',1x,a10)
30 format(1x,4i5,    5x,':',1x,a14)
31 format(1x,f20.10, 5x,':',1x,a6)

  close(IFFT)

end subroutine write_fourier_kt
! ============================================================================ 4.0

!=====================================================================
   subroutine write_fourier_patom(ier)
!=====================================================================
!
!  Outputs Fourier transforms into file (IFFT)
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ishell, nn, ll, kk, jj2, ispin, ig, ll_core
   real(8) :: g
   character(1) :: fn_label_orbital
   character(2) :: ch_del, ch2
   character(4) :: ch4
   ier = 0
   ch_del = ','//' '
   open(IFFT,file=trim(ftfile),status='unknown')
   write(IFFT,*) 'Fourier transforms of pseudoatom ion-core potentials'
   call write_file_header(IFFT)   
   write(IFFT,23) ng_fourier,'ng_fourier'   
   ch4(1:4) = '_loc'
   write(IFFT,*)
   write(IFFT,*) 'local potential [ion]'
   write(IFFT,*) 'gpos'//ch4//ch_del//'gg_vionk'//ch4
   do ig = 1,ng_fourier
      g = gpos_ft(ig)
! ==================================================== modified by K. T. ========= 4.0
!      write(IFFT,10) g, gg_vloc_ion_ft(ig)
      write(IFFT,10) g, gg_vloc_ion_ft(ig,1)
! =============================================================================== 4.0
   end do
   do ishell = 1,nshell
      nn = n_qnum(ishell)
      ll = l_qnum(ishell)
      ll_core = ll
      kk = k_qnum(ishell)
      jj2 = j2_qnum(ishell)
      ispin = (1-spin(ishell))/2 + 1
      ch2(1:2) = '_'//fn_label_orbital(ll)
      write(IFFT,*)
      write(IFFT,30) nn,ll,jj2,ispin,'(n, l, 2*j, s)'
      write(IFFT,31) engy(ishell)  ,'elevel   '
      write(IFFT,31) rcut_core(ll) ,'rcut_core'
      write(IFFT,31) vcut_core(ll) ,'vcut_core'
      write(IFFT,*)
      write(IFFT,*) 'gpos'//ch2//ch_del//'gg_vionk'//ch2
      do ig = 1,ng_fourier
         g = gpos_ft(ig)
         write(IFFT,10) g, gg_vion_ft(ig,ll_core)
      end do
   end do
10 format(10(1pe20.10))
23 format(1x,i10,10x,5x,':',1x,a10)
30 format(1x,4i5,    5x,':',1x,a14)
31 format(1x,f20.10, 5x,':',1x,a9)
   close(IFFT)
   end subroutine write_fourier_patom

!=================================================== added by K. T. ========= 4.0
subroutine write_fourier_patom_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier

  integer :: ishell, nn, ll, kk, jj2, ispin, ig, ll_core
  real(8) :: g
  character(1) :: fn_label_orbital
  character(2) :: ch_del, ch2
  character(4) :: ch4

  ier = 0
  ch_del = ','//' '

  open(IFFT,file=trim(ftfile),status='unknown')
  write(IFFT,*) 'Fourier transforms of pseudoatom ion-core potentials'

  call write_file_header(IFFT)   

  write(IFFT,23) ng_fourier,'ng_fourier'   

  ch4(1:4) = '_loc'

  write(IFFT,*)
  write(IFFT,*) 'local potential [ion]'

  Do ispin=1, nspin

     if ( nspin == 2 ) then
        write(IFFT,*)
        if ( ispin == 1 ) then
           write(IFFT,'(a)') ' spin component : up'
        else if ( ispin == 2 ) then
           write(IFFT,'(a)') ' spin component : down'
        endif
        write(IFFT,*)
     endif

     write(IFFT,*) 'gpos'//ch4//ch_del//'gg_vionk'//ch4

     do ig = 1,ng_fourier
        g = gpos_ft(ig)
        write(IFFT,10) g, gg_vloc_ion_ft(ig,ispin)
     end do

  End Do

  do ishell = 1,nshell
     nn = n_qnum(ishell)
     ll = l_qnum(ishell)
     ll_core = ll

     kk = k_qnum(ishell)
     jj2 = j2_qnum(ishell)

     ispin = (1-spin(ishell))/2 + 1

     ch2(1:2) = '_'//fn_label_orbital(ll)

     write(IFFT,*)
     write(IFFT,30) nn,ll,jj2,ispin,'(n, l, 2*j, s)'
     write(IFFT,31) engy(ishell)  ,'elevel   '
     write(IFFT,31) rcut_core(ll) ,'rcut_core'
     write(IFFT,31) vcut_core(ll) ,'vcut_core'
     write(IFFT,*)
     write(IFFT,*) 'gpos'//ch2//ch_del//'gg_vionk'//ch2

     do ig = 1,ng_fourier
        g = gpos_ft(ig)
        write(IFFT,10) g, gg_vion_ft(ig,ll_core)
     end do

  end do

10 format(10(1pe20.10))
23 format(1x,i10,10x,5x,':',1x,a10)
30 format(1x,4i5,    5x,':',1x,a14)
31 format(1x,f20.10, 5x,':',1x,a9)

  close(IFFT)

end subroutine write_fourier_patom_kt
! ======================================================================= 4.0

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   Version history: 
!
!     4.0:  2013/03/01
!           codes for spin-polarized pseudopotential generation are added
!     4.1:  2013/11/22 - 
!           Info of core wfns and energy contributions can be added to gncpp2
!     4.2:  2014/07/23 - 
!           gncpp2 can be geregated even when nmesh /= 1501
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : set_hubbard_b, calc_hubbard_i, calc_hubbard_u
!                : write_hubbard_u
!  Function(s)   : fn_hubbard_g1, fn_hubbard_g2
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine set_hubbard_b(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ll, mm
   ier = 0
   hubbard_b(:,:,:) = 0.d0
   ll = 0 ; mm = 0
   hubbard_b(ll,mm,0) =  1.d0
   ll = 1 ; mm = -1
   hubbard_b(ll,mm,0) =  1.d0/6.d0
   hubbard_b(ll,mm,2) = -1.d0/6.d0
   ll = 1 ; mm =  0
   hubbard_b(ll,mm,0) =  1.d0/3.d0
   hubbard_b(ll,mm,2) =  2.d0/3.d0
   ll = 1 ; mm = +1
   hubbard_b(ll,mm,0) =  2.d0/3.d0
   hubbard_b(ll,mm,2) = -2.d0/3.d0
   ll = 2 ; mm = -2
   hubbard_b(ll,mm,0) =   1.d0/120.d0
   hubbard_b(ll,mm,2) =  -1.d0/ 84.d0
   hubbard_b(ll,mm,4) =   1.d0/280.d0
   ll = 2 ; mm = -1
   hubbard_b(ll,mm,0) =   1.d0/ 30.d0
   hubbard_b(ll,mm,2) =   1.d0/ 42.d0
   hubbard_b(ll,mm,4) =  -2.d0/ 35.d0
   ll = 2 ; mm =  0
   hubbard_b(ll,mm,0) =   1.d0/  5.d0
   hubbard_b(ll,mm,2) =   2.d0/  7.d0
   hubbard_b(ll,mm,4) =  18.d0/ 35.d0
   ll = 2 ; mm = +1
   hubbard_b(ll,mm,0) =   6.d0/  5.d0
   hubbard_b(ll,mm,2) =   6.d0/  7.d0
   hubbard_b(ll,mm,4) = -72.d0/ 35.d0
   ll = 2 ; mm = +2
   hubbard_b(ll,mm,0) =  24.d0/  5.d0
   hubbard_b(ll,mm,2) = -48.d0/  7.d0
   hubbard_b(ll,mm,4) =  72.d0/ 35.d0
   ll = 3 ; mm = -3
   hubbard_b(ll,mm,0) =     1.d0/ 5040.d0
   hubbard_b(ll,mm,2) =    -1.d0/ 3024.d0
   hubbard_b(ll,mm,4) =     1.d0/ 6160.d0
   hubbard_b(ll,mm,6) =    -1.d0/33264.d0
   ll = 3 ; mm = -2
   hubbard_b(ll,mm,0) =     1.d0/  840.d0
   hubbard_b(ll,mm,2) =     0.d0
   hubbard_b(ll,mm,4) =    -1.d0/  440.d0
   hubbard_b(ll,mm,6) =     1.d0/  924.d0
   ll = 3 ; mm = -1
   hubbard_b(ll,mm,0) =     1.d0/   84.d0
   hubbard_b(ll,mm,2) =     1.d0/   84.d0
   hubbard_b(ll,mm,4) =     1.d0/  308.d0
   hubbard_b(ll,mm,6) =   -25.d0/  924.d0
   ll = 3 ; mm =  0
   hubbard_b(ll,mm,0) =     1.d0/    7.d0
   hubbard_b(ll,mm,2) =     4.d0/   21.d0
   hubbard_b(ll,mm,4) =    18.d0/   77.d0
   hubbard_b(ll,mm,6) =   100.d0/  231.d0
   ll = 3 ; mm = +1
   hubbard_b(ll,mm,0) =    12.d0/    7.d0
   hubbard_b(ll,mm,2) =    12.d0/    7.d0
   hubbard_b(ll,mm,4) =    36.d0/   77.d0
   hubbard_b(ll,mm,6) =  -300.d0/   77.d0
   ll = 3 ; mm = +2
   hubbard_b(ll,mm,0) =   120.d0/    7.d0
   hubbard_b(ll,mm,2) =     0.d0
   hubbard_b(ll,mm,4) =  -360.d0/   11.d0
   hubbard_b(ll,mm,6) =  1200.d0/   77.d0
   ll = 3 ; mm = +3
   hubbard_b(ll,mm,0) =   720.d0/    7.d0
   hubbard_b(ll,mm,2) = -1200.d0/    7.d0
   hubbard_b(ll,mm,4) =  6480.d0/   77.d0
   hubbard_b(ll,mm,6) = -1200.d0/   77.d0
   end subroutine set_hubbard_b

!=====================================================================
   subroutine calc_hubbard_i(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ishell, jshell, ll, llp
   real(8) :: sum1, sum2, fn_hubbard_g1, fn_hubbard_g2
   ier = 0
   hubbard_i(:,:,:) = 0.d0
LI:do ishell = 1,nshell
LJ:do jshell = ishell,nshell
      if ((is_solve(ishell) == 0).or.(is_solve(jshell) == 0)) then
         cycle LJ
      end if
      ll = min(l_qnum(ishell),l_qnum(jshell))
      do llp = 0,2*ll
         sum1 = 0.d0
         do ir = 1,nmesh
            sum1 = sum1 + chi_g(ir,ishell)**2 / rpos(ir)**(llp+1) &
                        * fn_hubbard_g1(ier,ir,jshell,llp) * wr(ir)
         end do
         sum2 = 0.d0
         do ir = 1,nmesh
            sum2 = sum2 + chi_g(ir,ishell)**2 * rpos(ir)**(llp) &
                        * fn_hubbard_g2(ier,ir,jshell,llp) * wr(ir)
         end do
         hubbard_i(ishell,jshell,llp) = (sum1 + sum2) / 2.d0
         hubbard_i(jshell,ishell,llp) = hubbard_i(ishell,jshell,llp)
      end do
   end do LJ
   end do LI
   end subroutine calc_hubbard_i

!=====================================================================
   function fn_hubbard_g1(ier,ir,ishell,llp)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer,intent(in)  :: ir, ishell, llp
   integer :: nn, ll, jr, ii, i0, is, j
   real(8) :: fn_hubbard_g1, sum
   ier = 0
   nn = n_qnum(ishell)
   ll = l_qnum(ishell)
   sum = 0.d0
   if (ir == 1) then
      sum = 0.d0
   else if ((ir >= 2).and.(ir <= 5)) then
      do ii = 2,ir
         i0 = ii-1
         is = 1
         call set_open_weight_exp(ier,i0,is,rpos,wt)
         do j = 1,4
            sum = sum + chi_g(i0+j*is,ishell)**2 &
                      * rpos(i0+j*is)**(llp) * wt(i0+j*is)
         end do
      end do
   else
      call set_weight_exp(ier,1,ir,rpos,wt)
      do jr = 1,ir
         sum = sum + chi_g(jr,ishell)**2 * rpos(jr)**(llp) * wt(jr)
      end do
   end if
   fn_hubbard_g1 = sum
   end function fn_hubbard_g1

!=====================================================================
   function fn_hubbard_g2(ier,ir,ishell,llp)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer,intent(in)  :: ir, ishell, llp
   integer :: nn, ll, jr, ii, i0, is, j
   real(8) :: fn_hubbard_g2, sum
   ier = 0
   nn = n_qnum(ishell)
   ll = l_qnum(ishell)
   sum = 0.d0
   if (ir == nmesh) then
      sum = 0.d0
   else if ((ir <= nmesh-1).and.(ir >= nmesh-4)) then
      do ii = ir,nmesh-1
         i0 = ii+1
         is = -1
         call set_open_weight_exp(ier,i0,is,rpos,wt)
         do j = 1,4
            sum = sum + chi_g(i0+j*is,ishell)**2 &
                      / rpos(i0+j*is)**(llp+1) * wt(i0+j*is)
         end do
      end do
   else
      call set_weight_exp(ier,ir,nmesh,rpos,wt)
      do jr = ir,nmesh
         sum = sum + chi_g(jr,ishell)**2 / rpos(jr)**(llp+1) * wt(jr)
      end do
   end if
   fn_hubbard_g2 = sum
   end function fn_hubbard_g2

!=====================================================================
   subroutine calc_hubbard_u(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ishell, jshell, ill, jll, ll, llp, imm, jmm
   integer(8) :: fn_factorial
   real(8) :: sum
   ier = 0
   hubbard_u(:,:,:,:) = 0.d0
LI:do ishell = 1,nshell
LJ:do jshell = ishell,nshell
      if ((is_solve(ishell) == 0).or.(is_solve(jshell) == 0)) then
         cycle LJ
      end if
      ill = l_qnum(ishell) ; jll = l_qnum(jshell) ; ll = min(ill,jll)
      do imm = -ill,ill
      do jmm = -jll,jll
         sum = 0.d0
         do llp = 0,2*ll
            sum = sum &
             + dble((2*ill+1)*(2*jll+1)) / dble(2*llp+1)**2 &
               * dble(fn_factorial(ill-imm)) &
               / dble(fn_factorial(ill+imm)) &
               * dble(fn_factorial(jll-jmm)) &
               / dble(fn_factorial(jll+jmm)) &
               * hubbard_b(ill,imm,llp) * hubbard_b(jll,jmm,llp) &
               * hubbard_i(ishell,jshell,llp)
          end do  
          hubbard_u(ishell,imm,jshell,jmm) = sum
          hubbard_u(jshell,jmm,ishell,imm) = sum    
       end do      
       end do
   end do LJ
   end do LI   
   end subroutine calc_hubbard_u

!=====================================================================
   subroutine write_hubbard_u(ifile)
!=====================================================================  
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer        :: i, nn, ll, mm, ishell, lshell, mm1, mm2
   character(100) :: line
   do i = 1,100
      line(i:i)='-'
   end do
   write(ifile,*)
   write(ifile,*) &
      'hubbard  Hubbard U (On-Site Coulomb Energy) [Diagonal]'
   write(ifile,10) line(1:100)
   write(ifile,11) '   symm','m','s', &
                   'Energy (Ha)','Energy (eV)'
   write(ifile,10) line(1:100)
LSH1:do ishell = 1,nshell
      lshell = list_shell(ishell)
      if (is_solve(lshell) == 0) then
         cycle LSH1
      end if
      nn = n_qnum(lshell)
      ll = l_qnum(lshell)
      do mm = -ll,ll
         write(ifile,12) state(lshell)(1:2), &
            mm,spin_label(lshell)(1:1), &
            hubbard_u(lshell,mm,lshell,mm), &
            hubbard_u(lshell,mm,lshell,mm)*HARTREE
      end do
   end do LSH1
   write(ifile,10) line(1:100)
10 format(1x,'hubbard',a59)
11 format(1x,'hubbard',a7,2(4x,a1),2(9x,a11))
12 format(1x,'hubbard',(4x,a2,1x),(i5),(4x,a1),2(f20.10))
   write(ifile,*)
   write(ifile,*) &
      'hubbard  Hubbard U (On-Site Coulomb Energy) [Off-Diagonal]'
   write(ifile,20) line(1:100)
   write(ifile,21) '   symm','m1','s1','m2','s2', &
                   'Energy (Ha)','Energy (eV)'
   write(ifile,20) line(1:100)
LSH2:do ishell = 1,nshell
      lshell = list_shell(ishell)
      if (is_solve(lshell) == 0) then
         cycle LSH2
      end if
      nn = n_qnum(lshell)
      ll = l_qnum(lshell)
      if (ll == 0) then
         cycle LSH2
      end if
      do mm1 = -ll,ll-1
      do mm2 = mm1+1,ll
         write(ifile,22) state(lshell)(1:2), &
            mm1,spin_label(lshell)(1:1), &
            mm2,spin_label(lshell)(1:1), &
            hubbard_u(lshell,mm1,lshell,mm2), &
            hubbard_u(lshell,mm1,lshell,mm2)*HARTREE
      end do
      end do
   end do LSH2
   write(ifile,20) line(1:100)
20 format(1x,'hubbard',a69)
21 format(1x,'hubbard',a7,4(3x,a2),2(9x,a11))
22 format(1x,'hubbard',(4x,a2,1x),2(i5,(4x,a1)),2(f20.10))
   end subroutine write_hubbard_u

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   Version history: 
!
!     4.0:  2013/03/01
!           codes for spin-polarized pseudopotential generation are added
!     4.1:  2013/11/22 - 
!           Info of core wfns and energy contributions can be added to gncpp2
!     4.2:  2014/07/23 - 
!           gncpp2 can be geregated even when nmesh /= 1501
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : calc_etot, write_etot
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine calc_etot(ier)
!=====================================================================
!
!  Calculates total energy
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ishell, ispin, ll, ll_core
   real(8) :: r
   ier    =  0
   eband_sum = 0.d0
   do ishell = 1,nshell
      if (is_solve(ishell) == 0) then
         cycle
      end if
      eband_sum = eband_sum + focc(ishell) * engy(ishell)
   end do
   if (is_calc /= REL) then
   ekin_sum1 = 0.d0
   do ishell = 1,nshell
      if (is_solve(ishell) == 0) then
         cycle
      end if
      do ir = 1,nmesh
         ll = l_qnum(ishell)
         r  = rpos(ir)
         ekin_sum1 = ekin_sum1 + focc(ishell) &
            * 0.5d0*wr(ir) &
            *( (dxchi_g(ir,ishell)/r)**2 &
               + dble(ll*(ll+1))*(chi_g(ir,ishell)/r)**2 )
      end do
   end do
   else
   ekin_sum1 = 0.d0
   do ishell = 1,nshell
      if (is_solve(ishell) == 0) then
         cycle
      end if
      do ir = 1,nmesh
         ll = l_qnum(ishell)
         r  = rpos(ir)
         ekin_sum1 = ekin_sum1 + focc(ishell) &
            * 0.5d0*wr(ir) &
            *( (dxchi_g(ir,ishell)/r)**2 &
               + dble(ll*(ll+1))*(chi_g(ir,ishell)/r)**2 &
             + (dxchi_f(ir,ishell)/r)**2 &
               + dble(ll*(ll+1))*(chi_f(ir,ishell)/r)**2 )   
      end do
   end do
   end if
   eion_sum = 0.d0
   do ishell = 1,nshell
      ll = l_qnum(ishell)
      if (is_core == PATOM) then
         ll_core = ll
      else
         ll_core = lmax_core
      end if
      select case (is_calc)
      case (NONREL,SREL)
         do ir = 1,nmesh
            eion_sum = eion_sum &
               + wr(ir) * focc(ishell) &
               * chi_g(ir,ishell)**2 * vion(ir,ll_core)
         end do
      case (REL)
         do ir = 1,nmesh
            eion_sum = eion_sum &
               + wr(ir) * focc(ishell) * vion(ir,ll_core) &
               * (chi_g(ir,ishell)**2 + chi_f(ir,ishell)**2)
         end do
      end select
   end do
   eh_sum = 0.d0
   do ispin = 1,nspin
   do ir = 1,nmesh
      r = rpos(ir)
      eh_sum = eh_sum &
             + 2.d0*PI*r*r*wr(ir)*rho(ir,ispin)*vh(ir)
   end do
   end do
   select case (is_xc)
   case (LDAPW92_GNCPP, GGAPW91_F90, GGAPW91_F77, &
         GGAPBE96_GNCPP, GGAPBE96_KATO, &
         GGAPBE96_MOMO2)
   case default
   ex_sum = 0.d0
   ec_sum = 0.d0
   do ispin = 1,nspin
   do ir = 1,nmesh
      r = rpos(ir)
      ex_sum  = ex_sum &
              + 4.d0*PI*r*r*wr(ir)*rho(ir,ispin)*ex(ir)
      ec_sum  = ec_sum &
              + 4.d0*PI*r*r*wr(ir)*rho(ir,ispin)*ec(ir)
   end do
   end do
   end select
   exc_sum = ex_sum + ec_sum
   vx_sum  = 0.d0
   vc_sum  = 0.d0
   do ispin = 1,nspin
   do ir = 1,nmesh
      r = rpos(ir)
      vx_sum = vx_sum &
              + 4.d0*PI*r*r*wr(ir)*rho(ir,ispin)*vx(ir,ispin)
      vc_sum = vc_sum &
              + 4.d0*PI*r*r*wr(ir)*rho(ir,ispin)*vc(ir,ispin)
   end do
   end do
   vxc_sum  = vx_sum + vc_sum
   veff_sum = 0.d0
   do ishell = 1,nshell
      ispin = (1-spin(ishell))/2 + 1
      ll = l_qnum(ishell)
      if (is_core == PATOM) then
         ll_core = ll
      else
         ll_core = lmax_core
      end if
      select case (is_calc)
      case (NONREL,SREL)
         do ir = 1,nmesh
            veff_sum = veff_sum &
               + wr(ir) * focc(ishell) &
               * chi_g(ir,ishell)**2 * veff(ir,ispin,ll_core)
         end do
      case (REL)
         do ir = 1,nmesh
            veff_sum = veff_sum &
               + wr(ir) * focc(ishell) * veff(ir,ispin,ll_core) &
               * (chi_g(ir,ishell)**2 + chi_f(ir,ishell)**2)
         end do
      end select

   end do
   etot_sum1 = ekin_sum1 + eion_sum + eh_sum + ex_sum + ec_sum
   etot_sum2 = eband_sum - eh_sum &
             + (ex_sum + ec_sum - vx_sum - vc_sum)
   etot_sum  = etot_sum2
   ekin_sum2 = eband_sum - veff_sum
   ekin_sum  = ekin_sum2
   end subroutine calc_etot

!=====================================================================
   subroutine write_etot(ifile)
!=====================================================================
!
!  Writes total energy to ifile
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer        :: i
   character(100) :: line
   do i = 1,100
      line(i:i) = '-'
   end do
   write(ifile,*)
   write(ifile,*)  'etot  Total energy [All-electron]'
   write(ifile,10) line(1:100)
   write(ifile,11) 'Energy (Ha)','Energy (eV)'
   write(ifile,10) line(1:100)
   if (is_calc == NONREL) then
   write(ifile,20) 'Ekin  ',ekin_sum1,ekin_sum1*HARTREE
   else
   write(ifile,20) 'Ekin  ',ekin_sum ,ekin_sum*HARTREE
   end if
   write(ifile,20) 'Eion  ',eion_sum ,eion_sum *HARTREE
   write(ifile,20) 'Eh    ',eh_sum   ,eh_sum   *HARTREE
   write(ifile,20) 'Exc   ',exc_sum  ,exc_sum  *HARTREE
   write(ifile,10) line(1:100)
   if (is_calc == NONREL) then
   write(ifile,20) 'Ekin* ',ekin_sum2,ekin_sum2*HARTREE
   end if
   write(ifile,20) 'Ex    ',ex_sum   ,ex_sum   *HARTREE
   write(ifile,20) 'Ec    ',ec_sum   ,ec_sum   *HARTREE
   write(ifile,20) 'Vx    ',vx_sum   ,vx_sum   *HARTREE
   write(ifile,20) 'Vc    ',vc_sum   ,vc_sum   *HARTREE
   write(ifile,20) 'Vxc   ',vxc_sum  ,vxc_sum  *HARTREE
   write(ifile,20) 'Eband ',eband_sum,eband_sum*HARTREE
   write(ifile,10) line(1:100)
   if (is_calc == NONREL) then
   write(ifile,20) 'Etot  ',etot_sum1,etot_sum1*HARTREE
   write(ifile,20) 'Etot* ',etot_sum2,etot_sum2*HARTREE
   else
   write(ifile,20) 'Etot  ',etot_sum ,etot_sum *HARTREE
   end if
   write(ifile,10) line(1:100)
   if (is_calc == NONREL) then
   write(ifile,*)  'etot  Ekin* = Eband - Veff = Eband - Eion - 2Eh - Vxc'
   write(ifile,*)  'etot  Etot  = Ekin + Eion + Eh + Exc'
   write(ifile,*)  'etot  Etot* = Eband - Eh + (Exc - Vxc)'
   else
   write(ifile,*)  'etot  Ekin = Eband - Veff = Eband - Eion - 2Eh - Vxc'
   write(ifile,*)  'etot  Etot = Eband - Eh + (Exc - Vxc)'
   end if
10 format(1x,'etot',a50)
11 format(1x,'etot',2x,6x,2(9x,a11))
20 format(1x,'etot',2x,a6,2(f20.10))
   end subroutine write_etot

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   Version history: 
!
!     4.0:  2013/03/01
!           codes for spin-polarized pseudopotential generation are added
!     4.1:  2013/11/22 - 
!           Info of core wfns and energy contributions can be added to gncpp2
!     4.2:  2014/07/23 - 
!           gncpp2 can be geregated even when nmesh /= 1501
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : mix_rho
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine mix_rho(ier,loop_scf)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in)  :: loop_scf
   integer,intent(out) :: ier
   integer :: ir, ip, jp, ispin, n_mat, n_vec
   real(8) :: sum, r, g0, gi, gj
   ier = 0
   ispin = 1
   call adjust_rho(ier,IFLOG, &
        nmesh,rpos,wr,rho(1,ispin),felec1,eps_check)
   if (is_spin == POLARIZED) then
      ispin = 2
      call adjust_rho(ier,IFLOG, &
           nmesh,rpos,wr,rho(1,ispin),felec2,eps_check)
   end if
   if (abs(felec1-felec1_old) > eps_check) then
      write(IFLOG,*) '### CAUTION ### felec1 != felec1_old'
      write(IFLOG,*) '   felec1     ...',felec1
      write(IFLOG,*) '   felec1_old ...',felec1_old
      rho_old(:,:) = rho(:,:)
      istart_anderson = loop_scf
      write(IFLOG,*) 'rho_old was reset to rho.'
      write(IFLOG,*) 'istart_anderson was reset to loop_scf.'
      write(IFLOG,*) '   istart_anderson ...',istart_anderson
   end if
   if (n_anderson < 0) then
      write(IFLOG,*) '### ERROR ### n_anderson < 0'
      write(IFLOG,*) '   n_anderson ...',n_anderson
      ier = 1 ; go to 99
   else if (n_anderson == 0) then
      rho(:,:) = (1.d0-mix1)*rho_old(:,:) + mix1*rho(:,:)
   else if (loop_scf-istart_anderson <= n_anderson) then
      do ip = n_anderson,1,-1
         rho_old_p(:,:,ip) = rho_old_p(:,:,ip-1)
         rho_p(:,:,ip)     = rho_p(:,:,ip-1)
      end do
      rho_old_p(:,:,0) = rho_old(:,:)
      rho_p(:,:,0)     = rho(:,:)
      rho(:,:) = (1.d0-mix1)*rho_old(:,:) + mix1*rho(:,:)
   else
LP_SPIN:do ispin = 1,nspin
   do ip = n_anderson,1,-1
      rho_old_p(:,ispin,ip) = rho_old_p(:,ispin,ip-1)
      rho_p(:,ispin,ip)     = rho_p(:,ispin,ip-1)
   end do
   rho_old_p(:,ispin,0) = rho_old(:,ispin)
   rho_p(:,ispin,0)     = rho(:,ispin)
   do ip = 1,n_anderson
      sum = 0.d0
      do ir = 1,nmesh
         r  = rpos(ir)
         g0 = rho_p(ir,ispin, 0) - rho_old_p(ir,ispin, 0)
         gi = rho_p(ir,ispin,ip) - rho_old_p(ir,ispin,ip) - g0
         sum = sum + gi*g0 *r*r*r*r*wr(ir)
      end do
      vec_p(ip,1) = -sum
      do jp = ip,n_anderson
         sum = 0.d0
         do ir = 1,nmesh
            r  = rpos(ir)
            g0 = rho_p(ir,ispin, 0) - rho_old_p(ir,ispin, 0)
            gi = rho_p(ir,ispin,ip) - rho_old_p(ir,ispin,ip) - g0
            gj = rho_p(ir,ispin,jp) - rho_old_p(ir,ispin,jp) - g0
            sum = sum + gi*gj *r*r*r*r*wr(ir)
         end do
         mat_p(ip,jp) = sum ; mat_p(jp,ip) = sum
      end do
   end do
   n_mat = n_anderson ; n_vec = 1
   call axb_real_matrix(ier,n_mat,1,mat_p,coeff_p,vec_p(1,1))
   do ip = 1,n_anderson
      rho_old(:,ispin) = rho_old(:,ispin) &
        + coeff_p(ip) * (rho_old_p(:,ispin,ip) - rho_old_p(:,ispin,0))
      rho(:,ispin) = rho(:,ispin) &
        + coeff_p(ip) * (rho_p(:,ispin,ip) - rho_p(:,ispin,0))
   end do
   do ir = 1,nmesh
      if (rho_old(ir,ispin) < 0.d0) then
         rho_old(ir,ispin) = 0.d0
      end if
      if (rho(ir,ispin) < 0.d0) then
         rho(ir,ispin) = 0.d0
      end if
   end do
   rho(:,ispin) = (1.d0-mix2)*rho_old(:,ispin) + mix2*rho(:,ispin)
end do LP_SPIN
   end if
   ispin = 1
   call adjust_rho(ier,IFLOG, &
        nmesh,rpos,wr,rho(1,ispin),felec1,eps_check)
   if (is_spin == POLARIZED) then
      ispin = 2
      call adjust_rho(ier,IFLOG, &
           nmesh,rpos,wr,rho(1,ispin),felec2,eps_check)
   end if
99 continue
   end subroutine mix_rho

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   Version history: 
!
!     4.0:  2013/03/01
!           codes for spin-polarized pseudopotential generation are added
!     4.1:  2013/11/22 - 
!           Info of core wfns and energy contributions can be added to gncpp2
!     4.2:  2014/07/23 - 
!           gncpp2 can be geregated even when nmesh /= 1501
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : set_infile, open_infile, set_filename, open_logfile
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine set_infile
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   if (have_infile == 0) then
      infile = 'input'
   end if
   end subroutine set_infile

!=====================================================================
   subroutine open_infile
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   open(IFIN,file=infile,status='old',err=90) ; go to 10
90 write(*,*) '### ERROR ### infile was not found'
   write(*,*) '   infile ... ',infile
   stop
10 continue
   end subroutine open_infile

!=====================================================================
   subroutine set_filename
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   logfile    = trim(jobname)//'.log'
   sumfile    = trim(jobname)//'.sum'
   orbfile    = trim(jobname)//'.orb'
   rhofile    = trim(jobname)//'.rho'
   pccfile    = trim(jobname)//'.pcc'
   usfile     = trim(jobname)//'.us'
   qpsfile    = trim(jobname)//'.qps'
   solfile    = trim(jobname)//'.sol'
   ldrfile    = trim(jobname)//'.ldr'
   ftfile     = trim(jobname)//'.ft'
   ppfile     = trim(jobname)//'.pp'
   gncppfile  = trim(jobname)//'.gncpp'
   gncpp2file = trim(jobname)//'.gncpp2'
   psvppfile  = trim(jobname)//'.psvpp'
   ciaoppfile = trim(jobname)//'.ciaopp'
   infofile   = trim(jobname)//'.info'
   paofile    = trim(jobname)//'.pao'

! ================== KT_add ================== 4.1
!
   file_cor2val = trim(jobname) // '.cor2val'
!
! ============================================ 4.1

   end subroutine set_filename

!=====================================================================
   subroutine open_logfile
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   open(IFLOG,file=trim(logfile),status='unknown')
   open(IFSUM,file=trim(sumfile),status='unknown')
   rewind(IFLOG) ; rewind(IFSUM)
   end subroutine open_logfile

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   Version history: 
!
!     4.0:  2013/03/01
!           codes for spin-polarized pseudopotential generation are added
!     4.1:  2013/11/22 - 
!           Info of core wfns and energy contributions can be added to gncpp2
!     4.2:  2014/07/23 - 
!           gncpp2 can be geregated even when nmesh /= 1501
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : set_vion, calc_vh, calc_veff
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine set_vion(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ll
   real(8) :: r, fn_patom_poly12, b_ok(0:3)
   ier = 0
   select case (is_core)
   case (NORMAL)
      vion(:,lmax_core) = - fatom / rpos(:)
   case (PATOM)
      do ll = 0,lmax_core
      do ir = 1,nmesh
         r = rpos(ir)
         if (r < rcut_core(ll)) then
            vion(ir,ll) = &
               fn_patom_poly12(r,fatom,rcut_core(ll),vcut_core(ll))
         else
            vion(ir,ll) = - fatom / r
         end if
      end do
      end do
   case (OZAKI_KINO)
      ll = lmax_core
      call calc_coeff_ok_poly3(fatom,rcut_ok,drcl_ok,h_ok,b_ok)
      do ir = 1,nmesh
         r = rpos(ir)
         if (r < rcut_ok - drcl_ok) then
            vion(ir,ll) = - fatom / r
         else if (r < rcut_ok) then
            vion(ir,ll) = &
               b_ok(0) + r*(b_ok(1) + r*(b_ok(2) + r*b_ok(3)))
         else
            vion(ir,ll) = h_ok
         end if
      end do
      do ir = nmesh,1,-1
         r = rpos(ir)
         if (r < rcut_ok) then
            nrcut_ok = ir+1 ; exit
         end if
      end do
   end select
99 continue
   end subroutine set_vion

!=====================================================================
   subroutine calc_vh(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ii, i0, is, j, jr, ispin
   real(8) :: sum1, sum2
   ier = 0
   do ir = 1,nmesh
      sum1 = 0.d0
      sum2 = 0.d0
      if (ir == 1) then
         sum1 = 0.d0
      else if ((ir >= 2).and.(ir <= 5)) then
         do ii = 2,ir
            i0 = ii-1
            is = 1
            call set_open_weight_exp(ier,i0,is,rpos,wt)
            do ispin = 1,nspin
            do j = 1,4
               sum1 = sum1 &
                    + rpos(i0+j*is)**2*rho(i0+j*is,ispin)*wt(i0+j*is)
            end do
            end do
         end do
      else
         call set_weight_exp(ier,1,ir,rpos,wt)
         do ispin = 1,nspin
         do jr = 1,ir
            sum1 = sum1 + rpos(jr)**2*rho(jr,ispin)*wt(jr)
         end do
         end do
      end if
      sum1 = sum1*(4.d0*PI/rpos(ir))
      if (ir == nmesh) then
            sum2 = 0.d0
      else if ((ir <= nmesh-1).and.(ir >= nmesh-4)) then
         do ii = ir,nmesh-1
            i0 = ii+1
            is = -1
            call set_open_weight_exp(ier,i0,is,rpos,wt)
            do ispin = 1,nspin
            do j = 1,4
               sum2 = sum2 &
                    - rpos(i0+j*is)**2*rho(i0+j*is,ispin)*wt(i0+j*is)
            end do
            end do
         end do
      else
         call set_weight_exp(ier,ir,nmesh,rpos,wt)
         do ispin = 1,nspin
         do jr = ir,nmesh
            sum2 = sum2 + rpos(jr)*rho(jr,ispin)*wt(jr)
         end do
         end do
      end if
      sum2 = sum2*(4.d0*PI)
      vh(ir) = sum1 + sum2
   end do
99 continue
   end subroutine calc_vh

!=====================================================================
   subroutine calc_vxc(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: imode
   ier = 0
   select case (is_xc)
   case(LDAPZ81)
      call calc_xc_lda_pz81(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_lda_pz81'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   case(LDAPW92_MOMO, LDAPW92_MOMO2)
      call calc_xc_lda_pw92(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_lda_pw92'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   case(LDAPW92_GNCPP, GGAPBE96_GNCPP, GGAPBE96_KATO)
      ier = 1 ! call calc_xc_gga_gncpp(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_gga_gncpp'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   case(GGAPW91_F90, GGAPW91_F77)
      ier = 1 ! call calc_xc_gga_gncpp(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_gga_gncpp(gga)'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   case(GGAPBE96_MOMO)
      imode = 0
      call calc_xc_gga_pbe96(ier,imode)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_gga_pbe96'
         write(IFLOG,*) '   ier   ...',ier
         write(IFLOG,*) '   imode ...',imode
         go to 99
      end if
   case(GGAPBE96_MOMO2)
      imode = 0
      call calc_xc_gga_pbe96_rad(ier,imode)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_gga_pbe96_rad'
         write(IFLOG,*) '   ier   ...',ier
         write(IFLOG,*) '   imode ...',imode
         go to 99
      end if
   case(REVPBE)
      imode = 1
      call calc_xc_gga_pbe96(ier,imode)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_gga_pbe96'
         write(IFLOG,*) '   ier   ...',ier
         write(IFLOG,*) '   imode ...',imode
         go to 99
      end if
   case(GGAPW91_MOMO, GGAPW91_MOMO2)
      call calc_xc_gga_pw91_rad(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_gga_pw91_rad'
         write(IFLOG,*) '   ier   ...',ier
         go to 99
      end if
   case(XLDA)
      call calc_x_lda(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_x_lda'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   case(XGGA)
      call calc_x_gga(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_x_gga'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   case(NONE)
      call calc_xc_none(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_none'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   end select
99 continue
end subroutine calc_vxc

!=====================================================================
   subroutine calc_veff(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ispin, ll

   integer :: ir

   ier = 0
   call calc_vh(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_vh'
      write(IFLOG,*) '   ier ...',ier ; go to 99
   end if
   call calc_vxc(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_vxc'
      write(IFLOG,*) '   ier ...',ier ; go to 99
   end if
   do ll = 0,lmax_core
   do ispin = 1,nspin
      veff(:,ispin,ll) = vion(:,ll) + vh(:) &
                        + vx(:,ispin) + vc(:,ispin)
#if 0
      Do ir=1, nmesh
         write(900,*) rpos(ir), veff(ir,ispin,ll)
      End Do
#endif

   end do
   end do
99 continue
   end subroutine calc_veff


! ===== KT_add ==== 4.2
subroutine calc_veff_sol( veff_sol )
  use parameters
  implicit none
!
  real(8) :: veff_sol( nmesh, nspin )

  integer :: ispin

  do ispin = 1,nspin
     veff_sol(:,ispin) = vloc_ion_us(:,ispin) + vh_sol(:) &
          &            + vx_sol(:,ispin) + vc_sol(:,ispin)
  end do
end subroutine calc_veff_sol

subroutine calc_soc_valence_kt
  use parameters
  implicit none
  
  real(8), parameter :: InvHyperFineConst = 137.035999679D0
  real(8) :: HyperFineConst

! -------
  logical :: use_MassCorrection = .true.
!  logical :: use_MassCorrection = .false.
!
  logical :: use_rphi_Hsoc_rphi = .true.
! -------

  integer :: ispin, ir, ier, count
  integer :: lt1, lt2, n1, n2, l1, l2, t1, t2
  real(8) :: fac1, fac2, r
  real(8) :: c1, c2, c3, c4, sum1, sum2

  integer :: nrc1, nrc2, nrc
  real(8), allocatable :: d_veff(:,:), wght(:)
  real(8), allocatable :: d_veff_us(:,:), veff_sol(:,:)

! ---------
!!  if ( nspin == 2 ) stop "nspin = 2 is not supported"
  if ( lmax_core > 0 ) stop "lmax_core >0 is not supported"

  allocate( d_veff(nmesh,nspin) ); d_veff = 0.0d0
!
  if ( use_rphi_Hsoc_rphi ) then
     allocate( veff_sol(nmesh,nspin) ); veff_sol = 0.d0
     allocate( d_veff_us(nmesh,nspin) ); d_veff_us = 0.0d0
     call calc_veff_sol( veff_sol ) 
  endif

! ---------
  HyperFineConst = 1.0d0 / InvHyperFineConst
  fac1 = 0.5d0 * HyperFineConst**2

  write(IFGNCPP2,'(A)') 'SOC-VALENCE [ASMS extension]'

  Do ispin=1, nspin
     call calc_diff_exp( ier,iord_diff, nmesh, rpos(1), veff(1,ispin,lmax_core), &
          &              d_veff(1,ispin) )
     do ir = nmesh-iord_diff*2-1,nmesh
        d_veff(ir,ispin)    = d_veff(    nmesh-iord_diff*2-2,ispin )
     end do

     if ( use_massCorrection ) then
        Do ir=1, nmesh
           r = rpos(ir)
           fac2 = 1.0d0 - veff(ir,ispin,lmax_core) *HyperFineConst **2
           d_veff(ir,ispin)    = fac1 *d_veff(ir,ispin)    /r /fac2
        End do
     else
        Do ir=1, nmesh
           r = rpos(ir)
           d_veff(ir,ispin)    = fac1 *d_veff(ir,ispin) /r
        End do
     endif
  End do

  if ( use_rphi_Hsoc_rphi ) then
     Do ispin=1, nspin
        call calc_diff_exp( ier,iord_diff, nmesh, rpos(1), veff_sol(1,ispin), &
             &              d_veff_us(1,ispin) )
        do ir = nmesh-iord_diff*2-1,nmesh
           d_veff_us(ir,ispin) = d_veff_us( nmesh-iord_diff*2-2,ispin )
        end do

        if ( use_massCorrection ) then
           Do ir=1, nmesh
              r = rpos(ir)
              fac2 = 1.0d0 - veff(ir,ispin,lmax_core) *HyperFineConst **2
              d_veff_us(ir,ispin) = fac1 *d_veff_us(ir,ispin) /r /fac2
           End do
        else
           Do ir=1, nmesh
              r = rpos(ir)
              d_veff_us(ir,ispin) = fac1 *d_veff_us(ir,ispin) /r
           End do
        endif
     End do
  endif
! ---------

#if 0
  Do ir=1, nmesh
     c1 = 0.0d0;  c2 = 0.0d0;  c3 = 0.0d0;  c4 = 0.0d0
     Do ispin=1, nspin
        c1 = c1 +  veff(ir,ispin,lmax_core)
        c2 = c2 +d_veff(ir,ispin)

        c3 = c3 +  veff_sol(ir,ispin)
        c4 = c4 +d_veff_us(ir,ispin)
     End do
     c1 = c1 /dble(nspin);  c2 = c2 /dble(nspin)
     c3 = c3 /dble(nspin);  c4 = c4 /dble(nspin)

     write(900,*) rpos(ir), c1, c2
     write(901,*) rpos(ir), c3, c4
  End Do
#endif
  
  count = 0

  Do ispin=1, nspin
     do lt1 = 1,num_ltx_us
        do lt2 = 1,num_ltx_us
           n1 = n_lt_us(lt1) ; n2 = n_lt_us(lt2)
           l1 = l_lt_us(lt1) ; l2 = l_lt_us(lt2)
           t1 = t_lt_us(lt1) ; t2 = t_lt_us(lt2)

           if ( l1 /= l2 ) cycle
           if ( l1 == 0 ) cycle

           count = count +1
        End do
     end do
  end Do

  write(IFGNCPP2,*) count

  Do ispin=1, nspin
     MAIN1:do lt1 = 1,num_ltx_us
        MAIN2:do lt2 = 1,num_ltx_us
           n1 = n_lt_us(lt1) ; n2 = n_lt_us(lt2)
           l1 = l_lt_us(lt1) ; l2 = l_lt_us(lt2)
           t1 = t_lt_us(lt1) ; t2 = t_lt_us(lt2)

           if ( l1 /= l2 ) cycle
           if ( l1 == 0 ) cycle

#if 0
           sum1 = 0.0d0;       sum2 = 0.0d0
           Do ir=1, nmesh
              sum1 = sum1 +wr(ir) *rpsi_us(ir,lt1) *rpsi_us(ir,lt2) &
                   &              *d_veff(ir,ispin)
              sum2 = sum2 +wr(ir) *rpsi_us(ir,lt1) *rpsi_us(ir,lt2)
           End do
           write(IFGNCPP2,'(6I4,e18.10)') n1, l1, t1, n2, l2, t2, sum1
#else
           nrc1 = nrcut_phi_us(lt1);    nrc2 = nrcut_phi_us(lt2)
           nrc = max( nrc1, nrc2 )
!
           allocate( wght(nrc) ); wght = 0.0d0
           call set_weight_exp(ier,1,nrc,rpos,wght)

           if ( use_rphi_Hsoc_rphi ) then
              sum1 = 0.0d0; sum2 = 0.0d0
              Do ir=1, nrc
                 sum1 = sum1 +wght(ir) *rpsi_us(ir,lt1) *rpsi_us(ir,lt2) &
                      &                *d_veff(ir,ispin)
                 sum2 = sum2 +wght(ir) *rphi_us(ir,lt1) *rphi_us(ir,lt2) &
                      &                *d_veff_us(ir,ispin)
              End do
              write(IFGNCPP2,'(6I4,e18.10)') n1, l1, t1, n2, l2, t2, sum1-sum2
           else
              sum1 = 0.0d0
              Do ir=1, nrc
                 sum1 = sum1 +wght(ir) *rpsi_us(ir,lt1) *rpsi_us(ir,lt2) &
                      &                *d_veff(ir,ispin)
              End do
              write(IFGNCPP2,'(6I4,e18.10)') n1, l1, t1, n2, l2, t2, sum1
           endif

           deallocate( wght )
#endif
        End do MAIN2
     end do MAIN1
  end Do

  deallocate( d_veff )
  if ( use_rphi_Hsoc_rphi ) then
     deallocate( d_veff_us )
     deallocate( veff_sol )
  endif

end subroutine calc_soc_valence_kt

subroutine calc_soc_core_kt
  use parameters
  implicit none
  
  real(8), parameter :: InvHyperFineConst = 137.035999679D0
  real(8) :: HyperFineConst

  logical :: use_MassCorrection = .true.
!  logical :: use_MassCorrection = .false.

  integer :: ispin, ir, ier, ishell, count
  integer :: lt1, lt2, n1, n2, l1, l2, t1, t2
  real(8) :: fac1, fac2, sum1, r
  real(8) :: sum2, sum3, sum4

  real(8), allocatable :: d_veff(:,:)

! ---------
  if ( nspin == 2 ) stop "nspin = 2 is not supported"
  if ( lmax_core > 0 ) stop "lmax_core >0 is not supported"

  allocate( d_veff(nmesh,nspin) ); d_veff = 0.0d0

! ---------
  HyperFineConst = 1.0d0 / InvHyperFineConst
  fac1 = 0.5d0 * HyperFineConst**2

  write(IFGNCPP2,'(A)') 'SOC-CORE [ASMS extension]'

  Do ispin=1, nspin
     call calc_diff_exp( ier,iord_diff, nmesh, rpos(1), veff(1,ispin,lmax_core), &
          &              d_veff(1,ispin) )

     do ir = nmesh-iord_diff*2-1,nmesh
        d_veff(ir,ispin) = d_veff( nmesh-iord_diff*2-2,ispin )
     end do

     if ( use_massCorrection ) then
        Do ir=1, nmesh
           r = rpos(ir)
           fac2 = 1.0d0 - veff(ir,ispin,lmax_core) *HyperFineConst **2
           d_veff(ir,ispin) = fac1 *d_veff(ir,ispin) /r /fac2
        End do
     else
        Do ir=1, nmesh
           r = rpos(ir)
           d_veff(ir,ispin) = fac1 *d_veff(ir,ispin) /r
        End do
     endif
  End do
! ---------
  count = 0

  do ishell = 1,nshell
     if ( is_core_states(ishell) == 0 ) cycle

     n1 = n_qnum(ishell);  l1 = l_qnum(ishell)
     if ( l1 == 0 ) cycle
!
     count = count +1
  End do

  write(IFLOG,*) 
  write(IFLOG,*) '### Estimation of SO splitting of core states [asms]'

  write(IFGNCPP2,*) count

  do ishell = 1,nshell
     if ( is_core_states(ishell) == 0 ) cycle

     n1 = n_qnum(ishell);  l1 = l_qnum(ishell)
     if ( l1 == 0 ) cycle

     sum1 = 0.0d0;  
     do ir = 1,nmesh
        sum1 = sum1 + wr(ir) *chi_g(ir,ishell)**2 * d_veff(ir,1)
     end do
     sum3 = sum1 *( 2.d0*l1 +1.d0 )/2.d0

     write(IFGNCPP2,'(2I4,e18.10)') n1, l1, sum1 
     write(IFLOG,'(2I4,e18.10)') n1, l1, sum3 
  end Do

  write(IFLOG,*) 

  deallocate( d_veff )

end subroutine calc_soc_core_kt
! ================= 4.2

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   Version history: 
!
!     4.0:  2013/03/01
!           codes for spin-polarized pseudopotential generation are added
!     4.1:  2013/11/22 - 
!           Info of core wfns and energy contributions can be added to gncpp2
!     4.2:  2014/07/23 - 
!           gncpp2 can be geregated even when nmesh /= 1501
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : calc_logderi_nc, write_logderi_nc, calc_vcoeff_ps
!                : set_initpoints_left_ps, int_from_left_ps
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine calc_logderi_nc(ier)
!=====================================================================
!
!  M. Okamoto
!
!  ### CAUTION ### 2006.08.23 M.O.
!  Temporarily, tt = 1
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ishell, ll, nn, tt, kk, jj2, ispin, ips, id, &
              node_sum, nrc, nrt, isdiff, ie_logderi
   real(8) :: ee, de, rcut, gcut0, gcut1, dummy2
   ier = 0
   call calc_vcoeff(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_vcoeff' ; go to 99
   end if
   call calc_vcoeff_ps(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_vcoeff_ps' ; go to 99
   end if
   de = (emax_logderi - emin_logderi) / dble(ne_logderi-1)
   do ie_logderi = 1,ne_logderi
      ee_logderi(ie_logderi) = emin_logderi &
                             + dble(ie_logderi-1) * de
   end do
   if (rcut_logderi < 1.d-12) then
      nrcut_logderi = 0
   else if (rcut_logderi >= rmax) then
      write(IFLOG,*) '### ERROR ### rcut_logderi >= rmax'
      write(IFLOG,*) '   rcut_logderi ...',rcut_logderi
      write(IFLOG,*) '   rmax         ...',rmax
      ier = 1 ; go to 99
   else
      do ir = nmesh,5,-1
         if (rpos(ir) < rcut_logderi) then
            nrcut_logderi = ir ; exit
         end if
      end do
   end if
   if (nrcut_logderi == 0) then
      nrc = nrcut_max_us
   else
      nrc = nrcut_logderi
   end if
   nrt = nrc + 1 + iord_diff
   rcut = rpos(nrc)
MAIN:do ips = 1,nps
   ishell = ishell_ps(ips,1)
   ispin = (1-spin(ishell))/2 + 1
   ll = l_qnum(ishell)
   nn = n_qnum(ishell)
   tt = 1
   kk = k_qnum(ishell)
   jj2 = j2_qnum(ishell)
L_EE:do ie_logderi = 1,ne_logderi
      ee = ee_logderi(ie_logderi)
      id = +1
      call set_initpoints_left(ier,ll,kk,ispin,ee)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in set_initpoints_left'
         go to 99
      end if
      call int_from_left(ier,node_sum,nrt,id,ll,kk,ee,ispin)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in int_from_left' ; go to 99
      end if
      isdiff = 1
      call diff_exp(ier,isdiff,nrc-iord_diff,nrc+iord_diff, &
                    rpos,chi_gl,rcut,gcut0,gcut1,dummy2)
      logderi(ie_logderi,ips) = gcut1 / gcut0
      call set_initpoints_left_ps(ier,ll,ips,ee)
      call int_from_left_ps(ier,node_sum,nrt,id,ll,tt,kk,ee,ips)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in int_from_left_ps' ; go to 99
      end if
      isdiff = 1
      call diff_exp(ier,isdiff,nrc-iord_diff,nrc+iord_diff, &
                    rpos,chi_gl,rcut,gcut0,gcut1,dummy2)
      logderi_ps(ie_logderi,ips) = gcut1 / gcut0
end do L_EE
end do MAIN
99 continue
   end subroutine calc_logderi_nc

!=====================================================================
   subroutine write_logderi_nc(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ips, ishell, nn, ll, kk, jj2, ispin, ie_logderi
   real(8) :: ee
   character(1) :: fn_label_orbital
   character(2) :: ch_del, ch2
   ier = 0
   ch_del = ','//' '
   open(IFLDR,file=trim(ldrfile),status='unknown')
   write(IFLDR,*) 'Logarithmic derivatives [Semilocal]'
   call write_file_header(IFLDR)
   write(IFLDR,23) ne_logderi,'ne_mesh'
   do ips = 1,nps
      ishell = ishell_ps(ips,1)
      nn = n_qnum(ishell)
      ll = l_qnum(ishell)
      kk = k_qnum(ishell)
      jj2 = j2_qnum(ishell)
      ispin = (1-spin(ishell))/2 + 1
      ch2(1:2) = '_'//fn_label_orbital(ll)
      write(IFLDR,*)
      write(IFLDR,30) nn,ll,jj2,ispin,'(n, l, 2*j, s)'
      write(IFLDR,31) engy(ishell),'elevel'
      write(IFLDR,31) rcut_tm(ll) ,'rcut  '
      write(IFLDR,*)
      write(IFLDR,*) 'ee'//ch2//ch_del//'logderi'//ch2//ch_del &
                     //'logderi_ps'//ch2
      do ie_logderi = 1,ne_logderi
         ee = ee_logderi(ie_logderi)
         write(IFLDR,10) ee,logderi(ie_logderi,ips), &
                            logderi_ps(ie_logderi,ips)
      end do
   end do
10 format(3(1pe20.10))
23 format(1x,i10,10x,    5x,':',1x,a7)
30 format(1x,4i5,        5x,':',1x,a14)
31 format(1x,f20.10,     5x,':',1x,a6)
   close(IFLDR)
   end subroutine write_logderi_nc

!=====================================================================
   subroutine calc_vcoeff_ps(ier)
!=====================================================================
!
!  M. Okamoto
!
!  ### CAUTION ### 2006.08.23 M.O.
!  Temporarily, tt = 1 for veff_ps()
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ncoeff, ips, ir, i, j
   real(8) :: r
   real(8),allocatable :: rveff(:), rave(:)
   integer :: n_mat, n_vec
   real(8),allocatable :: mat_a(:,:), vec_b(:,:)
   ier = 0
   ncoeff =  iord_coeff
  !+++++++++++++++++++++++++++++++++++++++++
   allocate(rveff(ncoeff),rave(0:2*ncoeff))
      rveff = 0.d0 ; rave = 0.d0
  !+++++++++++++++++++++++++++++++++++++++++
   n_mat = ncoeff ; n_vec = 1
  !++++++++++++++++++++++++++++++++++++++++++++++++
   allocate(mat_a(n_mat,n_mat),vec_b(n_mat,n_vec))
      mat_a = 0.d0 ; vec_b = 0.d0
  !++++++++++++++++++++++++++++++++++++++++++++++++
   do ips = 1,nps
      rave(:) = 0.d0 ; rveff(:) = 0.d0
      do ir = 1,20
         r = rpos(ir)
         do i = 0,(n_mat-1)*2
            rave(i) = rave(i) + r**i
         end do
         do i = 1,n_mat
            rveff(i) = rveff(i) + veff_ps(ir,ips,1) * r**i
         end do
      end do
      mat_a(:,:) = 0.d0 ; vec_b(:,:) = 0.d0
      do i = 1,n_mat
         vec_b(i,1) = rveff(i)
         do j = 1,n_mat
            mat_a(i,j) = rave(i+j-2)
         end do
      end do
      call axb_real_matrix(ier,n_mat,1,mat_a,vec_b(1,1),vec_b(1,1))
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in axb_real_matrix'
         go to 99
      end if
      do i = 1,n_mat
         vcoeff_ps(i-2,ips,1) = vec_b(i,1)
      end do
   end do
  !++++++++++++++++++++++++
   deallocate(mat_a,vec_b)
   deallocate(rveff,rave)
  !++++++++++++++++++++++++
99 continue
   end subroutine calc_vcoeff_ps

!=====================================================================
   subroutine set_initpoints_left_ps(ier,ll,ips,ee)
!=====================================================================
!
!  M. Okamoto
!
!  ### CAUTION ### 2006.08.23 M.O.
!  Temporarily, tt = 1 for veff_ps()
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in)  :: ll, ips
   real(8),intent(in)  :: ee
   integer,intent(out) :: ier
   integer :: ncoeff, icoeff, ir, j
   real(8) :: sum, r
   real(8),allocatable :: gcoeff(:), fcoeff(:)
   ier = 0
   ncoeff =  iord_coeff
  !++++++++++++++++++++++++++++++++++++++++++++
   allocate(gcoeff(0:ncoeff),fcoeff(0:ncoeff))
      gcoeff = 0.d0 ; fcoeff = 0.d0
  !++++++++++++++++++++++++++++++++++++++++++++
   gcoeff(0) = 1.d0
   fcoeff(0) = vcoeff_ps(-1,ips,1) / dble(ll+1) * gcoeff(0)
   if (ncoeff >= 2) then
      do icoeff = 1,ncoeff-1
         gcoeff(icoeff) =  fcoeff(icoeff-1) / dble(icoeff)
         sum = 0.d0
         do j = -1,icoeff-1
            sum = sum + vcoeff_ps(j,ips,1)*gcoeff(icoeff-1-j)
         end do
         fcoeff(icoeff) = (-2.d0*ee*gcoeff(icoeff-1)+2.d0*sum) &
                        / dble(icoeff+2*ll+2)
      end do
   end if
   do ir = 1,10
      r = rpos(ir)
      chi_gl(ir) = 0.d0
      chi_fl(ir) = 0.d0
      do icoeff = 0,ncoeff-1
         chi_gl(ir) = chi_gl(ir) &
           + gcoeff(icoeff) * r**(icoeff+ll+1)
         chi_fl(ir) = chi_fl(ir) &
           + fcoeff(icoeff) * r**(icoeff+ll+1)
      end do
      call dgdx_dfdx_nonrel(r,chi_gl(ir),chi_fl(ir), &
             dxchi_gl(ir),dxchi_fl(ir),ll,ee,veff_ps(ir,ips,1))
   end do
  !++++++++++++++++++++++++++
   deallocate(gcoeff,fcoeff)
  !++++++++++++++++++++++++++
   end subroutine set_initpoints_left_ps

!=====================================================================
   subroutine int_from_left_ps(ier,node_sum,nrt,id,ll,tt,kk,ee,ips)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in)  :: nrt, id, ll, tt, kk, ips
   real(8),intent(out) :: ee
   integer,intent(out) :: ier, node_sum
   integer :: nec, ir
   ier = 0
   nec = iord_nec
   node_sum = 0
   select case (iord_pc)
   case(4)
      do ir = 3,nrt+1
         call pc_adams_4ps(ier,ir,id,ll,tt,kk,ee,nec,ips)
         if (chi_gl(ir)*chi_gl(ir-1) < 0.d0) then
            node_sum = node_sum + 1
         end if
      end do
   case(5)
      do ir = 4,nrt+1
         call pc_adams_5ps(ier,ir,id,ll,tt,kk,ee,nec,ips)
         if (chi_gl(ir)*chi_gl(ir-1) < 0.d0) then
            node_sum = node_sum + 1
         end if
      end do
   case(6)
      do ir = 4,nrt+1
         call pc_adams_6ps(ier,ir,id,ll,tt,kk,ee,nec,ips)
         if (chi_gl(ir)*chi_gl(ir-1) < 0.d0) then
            node_sum = node_sum + 1
         end if
      end do
   case(7)
      do ir = 5,nrt+1
         call pc_adams_7ps(ier,ir,id,ll,tt,kk,ee,nec,ips)
         if (chi_gl(ir)*chi_gl(ir-1) < 0.d0) then
            node_sum = node_sum + 1
         end if
      end do
   case(8)
      do ir = 6,nrt+1
         call pc_adams_8ps(ier,ir,id,ll,tt,kk,ee,nec,ips)
         if (chi_gl(ir)*chi_gl(ir-1) < 0.d0) then
            node_sum = node_sum + 1
         end if
      end do
   case default
      write(IFLOG,*) '### ERROR ### iord_pc is invalid (inc)'
      write(IFLOG,*) '   iord_pc ...',iord_pc
      ier = 1 ; go to 99
   end select
99 continue
   end subroutine int_from_left_ps

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   Version history: 
!
!     4.0:  2013/03/01
!           codes for spin-polarized pseudopotential generation are added
!     4.1:  2013/11/22 - 
!           Info of core wfns and energy contributions can be added to gncpp2
!     4.2:  2014/07/23 - 
!           gncpp2 can be geregated even when nmesh /= 1501
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : calc_general_pp_srel, sizeof_lt_us, set_lt_us
!                : sizeof_ltt_us, set_ltt_us, sizeof_ltlt_us
!                : set_ltlt_us, set_param_us, calc_rpsi_us
!                : calc_ncpp_us, calc_nodes_us, set_vloc_us
!                : calc_rphi_us, check_phi_us, write_checked_phi_us
!                : calc_norm_rcl_us, write_norm_rcl_us 
!                : calc_norm_rc_us, write_norm_rc_us
!                : write_eref_rcl_phi_us, calc_rchi_us, calc_bmat_us
!                : calc_rbeta_us, calc_qnm_us, calc_qnm_sum_us
!                : write_qnm_sum_us, calc_dmat_us
!                : write_qnm_bmat_dmat_us, set_rcut_qps_us
!                : write_rcut_qps_us, calc_qps_us, check_qps_us
!                : write_checked_qps_us, calc_qps_vlocqps_us
!                : write_qps_vlocqps_us, calc_dion_us
!                : write_bmat_dmat_dion_us, calc_us_fourier
!                : write_us, calc_qps_fourier, write_qps
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================

subroutine calc_general_pp_srel(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
  use parameters
  implicit none

  integer,intent(out) :: ier
  
  !+++++++++++++++++++++++++++++++++++++++++++++++++
  allocate(nref_us(0:lmax),is_val_type_us(0:lmax))
  nref_us = 0 ; is_val_type_us = 0
  !+++++++++++++++++++++++++++++++++++++++++++++++++
  
  call sizeof_lt_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in sizeof_lt_us' ; go to 99
  end if

   !+++++++++++++++++++++++++++++++++++++++++++++++++
  allocate( &
       lt_n_us(0:lmax,nref_max_us),                &
       ips_lt_us(num_ltx_us),                      &
       n_lt_us(num_ltx_us),                        &
       l_lt_us(num_ltx_us),                        &
       t_lt_us(num_ltx_us),                        &
       ln_lt_us(num_ltx_us),                       &
       tn_lt_us(num_ltx_us)                        &
       )
  lt_n_us  = 0 ; ips_lt_us = 0
  n_lt_us  = 0 ; l_lt_us   = 0 ; t_lt_us = 0
  ln_lt_us = 0 ; tn_lt_us  = 0
  allocate( &
       is_bound_us(num_ltx_us),                    &
       nrcut_phi_us(num_ltx_us),                   &
       nodes_phi_us(num_ltx_us),                   &

! =========================================== modifided by K. T. ======== 4.0
!       vloc_scr_us(nmesh),                         &
!       vloc_ion_us(nmesh),                         &
       vloc_scr_us(nmesh,1),                         &
       vloc_ion_us(nmesh,1),                         &
! ======================================================================== 4.0
       eref_us(num_ltx_us),                        &
       veff_us(nmesh,num_ltx_us),                  &
       rpsi_us(nmesh,num_ltx_us),                  &
       rphi_us(nmesh,num_ltx_us),                  &
       drpsi_us(nmesh,num_ltx_us),                 &
       drphi_us(nmesh,num_ltx_us),                 &
       ddrphi_us(nmesh,num_ltx_us),                &
       rchi_us(nmesh,num_ltx_us),                  &
       rbeta_us(nmesh,num_ltx_us),                 &
       coeff_phi_us(0:ncoeff_phi_us,num_ltx_us),   &
       is_bound_ps(nps),                           &
       norm_psi_ps(nps),                           &
       norm_psi_us(num_ltx_us),                    &
       norm_phi_us(num_ltx_us)                     &
       )
  is_bound_us    = 0 ; nrcut_phi_us    = 0
  nodes_phi_us   = 0
  vloc_scr_us = 0.d0 ; vloc_ion_us  = 0.d0
  eref_us     = 0.d0 ; veff_us      = 0.d0
  rpsi_us     = 0.d0 ; rphi_us      = 0.d0
  drpsi_us    = 0.d0 ; drphi_us     = 0.d0
  ddrphi_us   = 0.d0 ; rchi_us      = 0.d0
  rbeta_us    = 0.d0 ; coeff_phi_us = 0.d0
  is_bound_ps =    0 ; norm_psi_ps  = 0.d0
  norm_psi_us = 0.d0 ; norm_phi_us  = 0.d0
  !+++++++++++++++++++++++++++++++++++++++++++++++++
  call set_lt_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in set_lt_us' ; go to 99
  end if
  call sizeof_ltt_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in sizeof_ltt_us' ; go to 99
  end if
  !++++++++++++++++++++++++++++++++++++++++++++++++
  allocate( &
       ltt_nm_us(0:lmax,nref_max_us,nref_max_us), &
       ips1_ltt_us(num_lttx_us),                  &
       ips2_ltt_us(num_lttx_us),                  &
       n1_ltt_us(num_lttx_us),                    &
       n2_ltt_us(num_lttx_us),                    &
       l_ltt_us(num_lttx_us),                     &
       t1_ltt_us(num_lttx_us),                    &
       t2_ltt_us(num_lttx_us),                    &
       tn_ltt_us(num_lttx_us),                    &
       tm_ltt_us(num_lttx_us),                    &
       q_sum_us(num_lttx_us),                     &
       qps_sum_us(num_lttx_us),                   &
       vlocqps_us(num_lttx_us),                   &
       bmat_us(num_lttx_us),                      &
       dmat_us(num_lttx_us),                      &
       dion_us(num_lttx_us)                       &
       )
  ltt_nm_us   = 0
  ips1_ltt_us = 0 ; ips2_ltt_us = 0
  n1_ltt_us   = 0 ; n2_ltt_us   = 0
  l_ltt_us    = 0
  t1_ltt_us   = 0 ; t2_ltt_us   = 0
  tn_ltt_us   = 0 ; tm_ltt_us   = 0
  q_sum_us   = 0.d0 ; qps_sum_us = 0.d0
  vlocqps_us = 0.d0 ; bmat_us    = 0.d0
  dmat_us    = 0.d0 ; dion_us    = 0.d0
  !++++++++++++++++++++++++++++++++++++++++++++++++
  call set_ltt_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in set_ltt_us' ; go to 99
  end if
  call sizeof_ltlt_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in sizeof_ltlt_us' ; go to 99
  end if
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  allocate( &
       ltlt_nm_us(0:lmax,nref_max_us,0:lmax,nref_max_us),      &
       ips1_ltlt_us(num_ltltx_us),                             &
       n1_ltlt_us(num_ltltx_us),                               &
       l1_ltlt_us(num_ltltx_us),                               &
       t1_ltlt_us(num_ltltx_us),                               &
       ln_ltlt_us(num_ltltx_us),                               &
       tn_ltlt_us(num_ltltx_us),                               &
       ips2_ltlt_us(num_ltltx_us),                             &
       n2_ltlt_us(num_ltltx_us),                               &
       l2_ltlt_us(num_ltltx_us),                               &
       t2_ltlt_us(num_ltltx_us),                               &
       lm_ltlt_us(num_ltltx_us),                               &
       tm_ltlt_us(num_ltltx_us),                               &
       nrcut_qps_us(num_ltltx_us,0:l3_max_us),                 &
       q_us(nmesh,num_ltltx_us),                               &
       qps_us(nmesh,num_ltltx_us,0:l3_max_us),                 &
       coeff_qps_us(0:ncoeff_qps_us,num_ltltx_us,0:l3_max_us), &
       rcut_qps_us(num_ltltx_us,0:l3_max_us)                   &
       )
  ltlt_nm_us   = 0
  ips1_ltlt_us = 0 ; n1_ltlt_us = 0 ; l1_ltlt_us = 0
  t1_ltlt_us   = 0 ; ln_ltlt_us = 0 ; tn_ltlt_us = 0
  ips2_ltlt_us = 0 ; n2_ltlt_us = 0 ; l2_ltlt_us = 0
  t2_ltlt_us   = 0 ; lm_ltlt_us = 0 ; tm_ltlt_us = 0
  nrcut_qps_us = 0
  q_us         = 0.d0 ; qps_us      = 0.d0
  coeff_qps_us = 0.d0 ; rcut_qps_us = 0.d0
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  call set_ltlt_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in set_ltlt_us' ; go to 99
  end if
  call set_param_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in set_param_us' ; go to 99
  end if
  call write_title_wave_function(IFLOG)
  call write_title_wave_function(IFSUM)
  call calc_rpsi_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_rpsi_us' ; go to 99
  end if
  call calc_ncpp_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_ncpp_us' ; go to 99
  end if
  call set_vloc_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in set_vloc_us' ; go to 99
  end if
  call calc_rphi_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_rphi_us' ; go to 99
  end if
  call calc_norm_rcl_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_norm_rcl_us' ; go to 99
  end if
  call write_norm_rcl_us(IFLOG)
  call write_norm_rcl_us(IFSUM)
  call calc_norm_rc_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_norm_rc_us' ; go to 99
  end if
  call write_norm_rc_us(IFLOG)
  call write_norm_rc_us(IFSUM)
  call write_eref_rcl_phi_us(IFLOG)
  call write_eref_rcl_phi_us(IFSUM)
  call elapse_time(time,icount0)
  call write_etime(IFLOG,time)
  call write_etime(IFSUM,time)
  call write_title_separable(IFLOG)
  call write_title_separable(IFSUM)
  call calc_rchi_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_rchi_us' ; go to 99
  end if
  call calc_bmat_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_bmat_us' ; go to 99
  end if
  call calc_rbeta_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_rbeta_us' ; go to 99
  end if
  if (is_write_us /= 0) then
     !+++++++++++++++++++++++++++++++++++++++++
     allocate(psi_g_us(ng_mesh,num_ltx_us), &
          phi_g_us(ng_mesh,num_ltx_us), &
          chi_g_us(ng_mesh,num_ltx_us), &
          beta_g_us(ng_mesh,num_ltx_us))
     psi_g_us = 0.d0 ; phi_g_us  = 0.d0
     chi_g_us = 0.d0 ; beta_g_us = 0.d0
     !+++++++++++++++++++++++++++++++++++++++++
     call calc_us_fourier(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_us_fourier' ; go to 99
     end if
  end if
  call calc_qnm_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_qnm_us' ; go to 99
  end if
  call calc_qnm_sum_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_qnm_sum_us' ; go to 99
  end if
  call write_qnm_sum_us(IFLOG)
  call calc_dmat_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_dmat_us' ; go to 99
  end if
  if (is_pp_calc_class == NC) then
     write(IFLOG,*)
     write(IFLOG,*) &
          '*** Because this is NC-PP, bypass US-PP subroutines. ***'
     nrcut_qps_us(:,:) = 0
     rcut_qps_us(:,:)  = 0.d0
     qps_us(:,:,:)     = 0.d0
     qps_sum_us(:)     = 0.d0
     vlocqps_us(:)     = 0.d0
     dion_us(:)        = dmat_us(:)
     call write_qps_vlocqps_us(IFLOG)
     call write_qps_vlocqps_us(IFSUM)
     call write_bmat_dmat_dion_us(IFLOG)
     call write_bmat_dmat_dion_us(IFSUM)
     call elapse_time(time,icount0)
     call write_etime(IFLOG,time)
     call write_etime(IFSUM,time)
     call write_title_deliminator(IFLOG)
     call write_title_deliminator(IFSUM)
     ier = 0 ; go to 99
  end if
  call elapse_time(time,icount0)
  call write_etime(IFLOG,time)
  call write_etime(IFSUM,time)
  call write_title_deficit_charge(IFLOG)
  call write_title_deficit_charge(IFSUM)
  call set_rcut_qps_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in set_rcut_qps_us' ; go to 99
  end if
  call write_rcut_qps_us(IFLOG)
  call calc_qps_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_qps_us' ; go to 99
  end if
  call calc_qps_vlocqps_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_qps_vlocqps_us' ; go to 99
  end if
  call write_qps_vlocqps_us(IFLOG)
  call calc_dion_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_dion_us' ; go to 99
  end if
  call write_bmat_dmat_dion_us(IFLOG)
  if (is_write_qps /= 0) then
     !+++++++++++++++++++++++++++++++++++++++++++++++++++++++
     allocate(qps_g_us(ng_mesh,num_ltltx_us,0:l3_max_us), &
          q_g_us(ng_mesh,num_ltltx_us))
     qps_g_us = 0.d0 ; q_g_us = 0.d0
     !+++++++++++++++++++++++++++++++++++++++++++++++++++++++
     call calc_qps_fourier(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_qps_fourier' ; go to 99
     end if
  end if
  call write_rcut_qps_us(IFSUM)
  call write_qps_vlocqps_us(IFSUM)
  call write_bmat_dmat_dion_us(IFSUM)
  call elapse_time(time,icount0)
  call write_etime(IFLOG,time)
  call write_etime(IFSUM,time)
  call write_title_deliminator(IFLOG)
  call write_title_deliminator(IFSUM)
99 continue
end subroutine calc_general_pp_srel

! ============================ added by K. T. ======================== 4.0
subroutine calc_general_pp_srel_kt(ier)
  use parameters
  implicit none
  
  integer,intent(out) :: ier
  
  !+++++++++++++++++++++++++++++++++++++++++++++++++
  allocate(nref_us(0:lmax),is_val_type_us(0:lmax))
  nref_us = 0 ; is_val_type_us = 0
  !+++++++++++++++++++++++++++++++++++++++++++++++++
  
  call sizeof_lt_us_kt(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in sizeof_lt_us_kt' ; go to 99
  end if
!  write(*,*) ' nspin = ', nspin

   !+++++++++++++++++++++++++++++++++++++++++++++++++
  allocate( &
       lt_n_us(0:lmax,nref_max_us*nspin),                &
       ips_lt_us(num_ltx_us),                      &
       n_lt_us(num_ltx_us),                        &
       l_lt_us(num_ltx_us),                        &
       t_lt_us(num_ltx_us),                        &
       ln_lt_us(num_ltx_us),                       &
       tn_lt_us(num_ltx_us)                        &
       )
  lt_n_us  = 0 ; ips_lt_us = 0
  n_lt_us  = 0 ; l_lt_us   = 0 ; t_lt_us = 0
  ln_lt_us = 0 ; tn_lt_us  = 0

  allocate( spin_index_lt_us(num_ltx_us) )
  spin_index_lt_us = 0

  allocate( &
       is_bound_us(num_ltx_us),                    &
       nrcut_phi_us(num_ltx_us),                   &
       nodes_phi_us(num_ltx_us),                   &
       vloc_scr_us(nmesh,nspin),                         &
       vloc_ion_us(nmesh,nspin),                         &
       eref_us(num_ltx_us),                        &
       veff_us(nmesh,num_ltx_us),                  &
       rpsi_us(nmesh,num_ltx_us),                  &
       rphi_us(nmesh,num_ltx_us),                  &
       drpsi_us(nmesh,num_ltx_us),                 &
       drphi_us(nmesh,num_ltx_us),                 &
       ddrphi_us(nmesh,num_ltx_us),                &
       rchi_us(nmesh,num_ltx_us),                  &
       rbeta_us(nmesh,num_ltx_us),                 &
       coeff_phi_us(0:ncoeff_phi_us,num_ltx_us),   &
       is_bound_ps(nps),                           &
       norm_psi_ps(nps),                           &
       norm_psi_us(num_ltx_us),                    &
       norm_phi_us(num_ltx_us)                     &
       )
  is_bound_us    = 0 ; nrcut_phi_us    = 0
  nodes_phi_us   = 0
  vloc_scr_us = 0.d0 ; vloc_ion_us  = 0.d0
  eref_us     = 0.d0 ; veff_us      = 0.d0
  rpsi_us     = 0.d0 ; rphi_us      = 0.d0
  drpsi_us    = 0.d0 ; drphi_us     = 0.d0
  ddrphi_us   = 0.d0 ; rchi_us      = 0.d0
  rbeta_us    = 0.d0 ; coeff_phi_us = 0.d0
  is_bound_ps =    0 ; norm_psi_ps  = 0.d0
  norm_psi_us = 0.d0 ; norm_phi_us  = 0.d0
  !+++++++++++++++++++++++++++++++++++++++++++++++++
  call set_lt_us_kt(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in set_lt_us_kt' ; go to 99
  end if

  call sizeof_ltt_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in sizeof_ltt_us' ; go to 99
  end if
  !++++++++++++++++++++++++++++++++++++++++++++++++
  allocate( &
       ltt_nm_us(0:lmax,nref_max_us*nspin,nref_max_us*nspin), &
       ips1_ltt_us(num_lttx_us),                  &
       ips2_ltt_us(num_lttx_us),                  &
       n1_ltt_us(num_lttx_us),                    &
       n2_ltt_us(num_lttx_us),                    &
       l_ltt_us(num_lttx_us),                     &
       t1_ltt_us(num_lttx_us),                    &
       t2_ltt_us(num_lttx_us),                    &
       tn_ltt_us(num_lttx_us),                    &
       tm_ltt_us(num_lttx_us),                    &
       q_sum_us(num_lttx_us),                     &
       qps_sum_us(num_lttx_us),                   &
       vlocqps_us(num_lttx_us),                   &
       bmat_us(num_lttx_us),                      &
       dmat_us(num_lttx_us),                      &
       dion_us(num_lttx_us)                       &
       )
  ltt_nm_us   = 0
  ips1_ltt_us = 0 ; ips2_ltt_us = 0
  n1_ltt_us   = 0 ; n2_ltt_us   = 0
  l_ltt_us    = 0
  t1_ltt_us   = 0 ; t2_ltt_us   = 0
  tn_ltt_us   = 0 ; tm_ltt_us   = 0
  q_sum_us   = 0.d0 ; qps_sum_us = 0.d0
  vlocqps_us = 0.d0 ; bmat_us    = 0.d0
  dmat_us    = 0.d0 ; dion_us    = 0.d0

  allocate( spin1_index_ltt_us(num_lttx_us) )
  allocate( spin2_index_ltt_us(num_lttx_us) )
  spin1_index_ltt_us = 0
  spin2_index_ltt_us = 0

  !++++++++++++++++++++++++++++++++++++++++++++++++
  call set_ltt_us_kt(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in set_ltt_us' ; go to 99
  end if

  call sizeof_ltlt_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in sizeof_ltlt_us' ; go to 99
  end if
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  allocate( &
       ltlt_nm_us(0:lmax,nref_max_us*nspin,0:lmax,nref_max_us*nspin),      &
       ips1_ltlt_us(num_ltltx_us),                             &
       n1_ltlt_us(num_ltltx_us),                               &
       l1_ltlt_us(num_ltltx_us),                               &
       t1_ltlt_us(num_ltltx_us),                               &
       ln_ltlt_us(num_ltltx_us),                               &
       tn_ltlt_us(num_ltltx_us),                               &
       ips2_ltlt_us(num_ltltx_us),                             &
       n2_ltlt_us(num_ltltx_us),                               &
       l2_ltlt_us(num_ltltx_us),                               &
       t2_ltlt_us(num_ltltx_us),                               &
       lm_ltlt_us(num_ltltx_us),                               &
       tm_ltlt_us(num_ltltx_us),                               &
       nrcut_qps_us(num_ltltx_us,0:l3_max_us),                 &
       q_us(nmesh,num_ltltx_us),                               &
       qps_us(nmesh,num_ltltx_us,0:l3_max_us),                 &
       coeff_qps_us(0:ncoeff_qps_us,num_ltltx_us,0:l3_max_us), &
       rcut_qps_us(num_ltltx_us,0:l3_max_us)                   &
       )
  ltlt_nm_us   = 0
  ips1_ltlt_us = 0 ; n1_ltlt_us = 0 ; l1_ltlt_us = 0
  t1_ltlt_us   = 0 ; ln_ltlt_us = 0 ; tn_ltlt_us = 0
  ips2_ltlt_us = 0 ; n2_ltlt_us = 0 ; l2_ltlt_us = 0
  t2_ltlt_us   = 0 ; lm_ltlt_us = 0 ; tm_ltlt_us = 0
  nrcut_qps_us = 0
  q_us         = 0.d0 ; qps_us      = 0.d0
  coeff_qps_us = 0.d0 ; rcut_qps_us = 0.d0

  allocate( spin1_index_ltlt_us(num_ltltx_us) )
  allocate( spin2_index_ltlt_us(num_ltltx_us) )
  spin1_index_ltlt_us = 0
  spin2_index_ltlt_us = 0

   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  call set_ltlt_us_kt(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in set_ltlt_us_kt' ; go to 99
  end if

  call set_param_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in set_param_us' ; go to 99
  end if

  call write_title_wave_function(IFLOG)
  call write_title_wave_function(IFSUM)

  call calc_rpsi_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_rpsi_us' ; go to 99
  end if

  call calc_ncpp_us_kt(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_ncpp_us_kt' ; go to 99
  end if

  call set_vloc_us_kt(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in set_vloc_us' ; go to 99
  end if

  call calc_rphi_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_rphi_us' ; go to 99
  end if

  call calc_norm_rcl_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_norm_rcl_us' ; go to 99
  end if

  call write_norm_rcl_us_kt(IFLOG)
  call write_norm_rcl_us_kt(IFSUM)

  call calc_norm_rc_us(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_norm_rc_us' ; go to 99
  end if

  call write_norm_rc_us_kt(IFLOG)
  call write_norm_rc_us_kt(IFSUM)

  call write_eref_rcl_phi_us_kt(IFLOG)
  call write_eref_rcl_phi_us_kt(IFSUM)

  call elapse_time(time,icount0)
  call write_etime(IFLOG,time)
  call write_etime(IFSUM,time)
  call write_title_separable(IFLOG)
  call write_title_separable(IFSUM)

  call calc_rchi_us_kt(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_rchi_us_kt' ; go to 99
  end if

  call calc_bmat_us_kt(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_bmat_us_kt' ; go to 99
  end if

  call calc_rbeta_us_kt(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_rbeta_us_kt' ; go to 99
  end if

  if (is_write_us /= 0) then
     !+++++++++++++++++++++++++++++++++++++++++
     allocate(psi_g_us(ng_mesh,num_ltx_us), &
          phi_g_us(ng_mesh,num_ltx_us), &
          chi_g_us(ng_mesh,num_ltx_us), &
          beta_g_us(ng_mesh,num_ltx_us))
     psi_g_us = 0.d0 ; phi_g_us  = 0.d0
     chi_g_us = 0.d0 ; beta_g_us = 0.d0
     !+++++++++++++++++++++++++++++++++++++++++
     call calc_us_fourier(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_us_fourier' ; go to 99
     end if
  end if

  call calc_qnm_us_kt(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_qnm_us_kt' ; go to 99
  end if

  call calc_qnm_sum_us_kt(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_qnm_sum_us_kt' ; go to 99
  end if

  call write_qnm_sum_us_kt(IFLOG)

  call calc_dmat_us_kt(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_dmat_us_kt' ; go to 99
  end if

  if (is_pp_calc_class == NC) then

!     stop "Not supported "

     write(IFLOG,*)
     write(IFLOG,*) &
          '*** Because this is NC-PP, bypass US-PP subroutines. ***'
     nrcut_qps_us(:,:) = 0
     rcut_qps_us(:,:)  = 0.d0
     qps_us(:,:,:)     = 0.d0
     qps_sum_us(:)     = 0.d0
     vlocqps_us(:)     = 0.d0
     dion_us(:)        = dmat_us(:)

     call write_qps_vlocqps_us_kt(IFLOG)
     call write_qps_vlocqps_us_kt(IFSUM)
     call write_bmat_dmat_dion_us_kt(IFLOG)
     call write_bmat_dmat_dion_us_kt(IFSUM)

     call elapse_time(time,icount0)
     call write_etime(IFLOG,time)
     call write_etime(IFSUM,time)
     call write_title_deliminator(IFLOG)
     call write_title_deliminator(IFSUM)
     ier = 0 ; go to 99
  end if

  call elapse_time(time,icount0)
  call write_etime(IFLOG,time)
  call write_etime(IFSUM,time)
  call write_title_deficit_charge(IFLOG)
  call write_title_deficit_charge(IFSUM)

  call set_rcut_qps_us_kt(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in set_rcut_qps_us_kt' ; go to 99
  end if

  call write_rcut_qps_us_kt(IFLOG)

  call calc_qps_us_kt(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_qps_us_kt' ; go to 99
  end if

  call calc_qps_vlocqps_us_kt(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_qps_vlocqps_us_kt' ; go to 99
  end if

  call write_qps_vlocqps_us_kt(IFLOG)

  call calc_dion_us_kt(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_dion_us_kt' ; go to 99
  end if

  call write_bmat_dmat_dion_us_kt(IFLOG)

  if (is_write_qps /= 0) then
     !+++++++++++++++++++++++++++++++++++++++++++++++++++++++
     allocate(qps_g_us(ng_mesh,num_ltltx_us,0:l3_max_us), &
          q_g_us(ng_mesh,num_ltltx_us))
     qps_g_us = 0.d0 ; q_g_us = 0.d0
     !+++++++++++++++++++++++++++++++++++++++++++++++++++++++
     call calc_qps_fourier(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_qps_fourier' ; go to 99
     end if
  end if

  call write_rcut_qps_us_kt(IFSUM)
  call write_qps_vlocqps_us_kt(IFSUM)

  call write_bmat_dmat_dion_us_kt(IFSUM)

  call elapse_time(time,icount0)
  call write_etime(IFLOG,time)
  call write_etime(IFSUM,time)

  call write_title_deliminator(IFLOG)
  call write_title_deliminator(IFSUM)

99 continue

end subroutine calc_general_pp_srel_kt
! ==================================================================4.0

!=====================================================================
   subroutine sizeof_lt_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: lt, ll, tt, lt_loc, is_debug_here, ishell, ips
   is_debug_here = 1
   if (is_debug /= 0) then
      is_debug_here = is_debug
   end if
   ier = 0
   nref_us(:) = 0
   lt     = 0
   lt_loc = 0
   do ips = 1,nps
      ishell = ishell_ps(ips,1)
      ll = l_qnum(ishell)
      do tt = 1,nref_ps(ips)
         nref_us(ll) = nref_us(ll) + 1
         if (ll /= lloc) then
            lt = lt + 1
         else
            lt_loc = lt_loc + 1
         end if
      end do
   end do
   num_lt_us     = lt
   num_lt_loc_us = lt_loc
   num_ltx_us    = num_lt_us + num_lt_loc_us
   if (is_debug_here /= 0) then
      write(IFLOG,*) 'LT: num_ltx_us .....',num_ltx_us
      write(IFLOG,*) 'LT:    num_lt_us    ',num_lt_us
      write(IFLOG,*) 'LT:    num_lt_loc_us',num_lt_loc_us
   end if
   nref_max_us = 0
   do ll = 0,lmax
      if (nref_max_us < nref_us(ll)) then
         nref_max_us = nref_us(ll)
      end if
   end do
99 continue
   end subroutine sizeof_lt_us
!=====================================================================

! ================================ added by K. T. ========================= 4.0
subroutine sizeof_lt_us_kt(ier)
  use parameters
  implicit none
  
  integer,intent(out) :: ier
  integer :: lt, ll, tt, lt_loc, is_debug_here, ishell, ips
  
  is_debug_here = 1
  if (is_debug /= 0) then
     is_debug_here = is_debug
  end if
  ier = 0
  nref_us(:) = 0
  lt     = 0
  lt_loc = 0
  
  do ips = 1,nps, nspin
     ishell = ishell_ps(ips,1)
     ll = l_qnum(ishell)
     
     do tt = 1,nref_ps(ips)
        nref_us(ll) = nref_us(ll) + 1
        if (ll /= lloc) then
           lt = lt + 1
        else
           lt_loc = lt_loc + 1
        end if
     end do
  end do
  
  num_lt_us     = lt
  num_lt_loc_us = lt_loc
  num_ltx_us    = num_lt_us + num_lt_loc_us
!
  if ( nspin == 2 ) then
     num_lt_us = num_lt_us *nspin
     num_lt_loc_us = num_lt_loc_us *nspin
     num_ltx_us = num_ltx_us *nspin
  endif
  !
  if (is_debug_here /= 0) then
     write(IFLOG,*) 'LT: num_ltx_us .....',num_ltx_us
     write(IFLOG,*) 'LT:    num_lt_us    ',num_lt_us
     write(IFLOG,*) 'LT:    num_lt_loc_us',num_lt_loc_us
  end if
  
  nref_max_us = 0
  do ll = 0,lmax
     if (nref_max_us < nref_us(ll)) then
        nref_max_us = nref_us(ll)
     end if
  end do
  
99 continue

end subroutine sizeof_lt_us_kt
! ===================================================================== 4.0


!=====================================================================
   subroutine set_lt_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: lt, nn, ll, tt, ltx, lt_loc, ips, ishell, &
              is_debug_here
   integer,allocatable :: tn_tmp(:)
   is_debug_here = 1
   if (is_debug /= 0) then
      is_debug_here = is_debug
   end if
   ier = 0
  !++++++++++++++++++++++++++++++++++++++
   allocate(tn_tmp(0:lmax)) ; tn_tmp = 0
  !++++++++++++++++++++++++++++++++++++++
   tn_tmp(:) = 0
   lt       = 0
   lt_loc   = 0
   do ips = 1,nps
      ishell = ishell_ps(ips,1)
      nn = n_qnum(ishell)
      ll = l_qnum(ishell)
      is_val_type_us(ll) = is_val_type_ps(ips)

      do tt = 1,nref_ps(ips)
         if (ll /= lloc) then
            lt  = lt + 1
            ltx = lt
         else
            lt_loc = lt_loc + 1
            ltx    = lt_loc + num_lt_us
         end if
         tn_tmp(ll) = tn_tmp(ll) + 1
         lt_n_us(ll,tn_tmp(ll)) = ltx
         ips_lt_us(ltx) = ips
         n_lt_us  (ltx) = nn
         l_lt_us  (ltx) = ll
         t_lt_us  (ltx) = tt
         ln_lt_us (ltx) = ll
         tn_lt_us (ltx) = tn_tmp(ll)
         if (is_debug_here /= 0) then
            write(IFLOG,*) 'LT: n,l,t,ln,tn,lt,val_type ...', &
               nn,ll,tt,ll,tn_tmp(ll),ltx,is_val_type_ps(ips)
         end if
      end do
   end do
   if (lt /= num_lt_us) then
      write(IFLOG,*) '### ERROR ### lt != num_lt_us'
      ier = 1 ; go to 99
   end if
   if (lt_loc /= num_lt_loc_us) then
      write(IFLOG,*) '### ERROR ### lt_loc != num_lt_loc_us'
      ier = 1 ; go to 99
   end if
  !+++++++++++++++++++
   deallocate(tn_tmp)
  !+++++++++++++++++++
99 continue
   end subroutine set_lt_us

!=============================== added by K. T. =================== 4.0
subroutine set_lt_us_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: lt, nn, ll, tt, ltx, lt_loc, ips, ishell, &
       is_debug_here
  integer :: ispin, itmp
  
  integer,allocatable :: tn_tmp(:,:)
  
  is_debug_here = 1
  if (is_debug /= 0) then
     is_debug_here = is_debug
  end if
  ier = 0
  !++++++++++++++++++++++++++++++++++++++
  allocate(tn_tmp(0:lmax,nspin)) ; tn_tmp = 0
  !++++++++++++++++++++++++++++++++++++++

  lt       = 0
  lt_loc   = 0
  
  do ips = 1,nps
     ishell = ishell_ps(ips,1)
     nn = n_qnum(ishell)
     ll = l_qnum(ishell)
     is_val_type_us(ll) = is_val_type_ps(ips)
     
     ispin = (1-spin(ishell))/2 + 1
     
     do tt = 1,nref_ps(ips)         
        if (ll /= lloc) then
           lt  = lt + 1
           ltx = lt
        else
           lt_loc = lt_loc + 1
           ltx    = lt_loc + num_lt_us
        end if
        
        tn_tmp(ll,ispin) = tn_tmp(ll,ispin) + 1

        itmp = tn_tmp(ll,ispin) + nref_max_us *(ispin-1 )
        lt_n_us( ll, itmp ) = ltx
        
        ips_lt_us(ltx) = ips
        
        n_lt_us  (ltx) = nn
        l_lt_us  (ltx) = ll
        t_lt_us  (ltx) = tt
        spin_index_lt_us  (ltx) = ispin
        
        ln_lt_us (ltx) = ll
        tn_lt_us (ltx) = tn_tmp(ll,ispin)
        
        if (is_debug_here /= 0) then
           write(IFLOG,*) 'LT: n,l,t, s, ln,tn,lt,val_type ...', &
                nn,ll,tt, ispin, ll,tn_tmp(ll,ispin),ltx,is_val_type_ps(ips)
        end if
     end do
  end do
  if (lt /= num_lt_us) then
     write(IFLOG,*) '### ERROR ### lt != num_lt_us'
     ier = 1 ; go to 99
  end if
  if (lt_loc /= num_lt_loc_us) then
     write(IFLOG,*) '### ERROR ### lt_loc != num_lt_loc_us'
     ier = 1 ; go to 99
  end if
  !+++++++++++++++++++
  deallocate(tn_tmp)
  !+++++++++++++++++++

99 continue

end subroutine set_lt_us_kt
! ======================================================================== 4.0


!=====================================================================
   subroutine sizeof_ltt_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ltt, ltt_nc, is_debug_here, &
              n1, l1, t1, n2, l2, t2, ips1, ips2, ll, lt1, lt2
   is_debug_here = 1
   if (is_debug /= 0) then
      is_debug_here = is_debug
   end if
   ier = 0
   ltt    = 0
   ltt_nc = 0

   do lt1 = 1,num_ltx_us
      n1 = n_lt_us(lt1)
      l1 = l_lt_us(lt1)
      t1 = t_lt_us(lt1)
      ips1 = ips_lt_us(lt1)

      do lt2 = 1,num_ltx_us
         n2 = n_lt_us(lt2)
         l2 = l_lt_us(lt2)
         t2 = t_lt_us(lt2)
         ips2 = ips_lt_us(lt2)

         if (l1 == l2) then
            ll = l1
            if (is_val_type_ps(ips1) /= is_val_type_ps(ips2)) then
               write(IFLOG,*) '### ERROR ### val_type are different'
               write(IFLOG,*) '   ips1,(n1,l1,t1)      ...', &
                                  ips1,n1,l1,t1
               write(IFLOG,*) '   ips2,(n2,l2,t2)      ...', &
                                  ips2,n2,l2,t2
               write(IFLOG,*) '   is_val_type_ps(ips1) ...', &
                                  is_val_type_ps(ips1)
               write(IFLOG,*) '   is_val_type_ps(ips2) ...', &
                                  is_val_type_ps(ips2)
               ier = 1 ; go to 99
            end if
            if (is_val_type_ps(ips1) == TM91) then
               ltt_nc = ltt_nc + 1
            else
               ltt = ltt + 1
            end if
         end if
      end do
   end do
   num_ltt_us  = ltt
   num_lttx_us = ltt + ltt_nc
   if (is_debug_here /= 0) then
      write(IFLOG,*) 'LTT: num_lttx_us .....',num_lttx_us
      write(IFLOG,*) 'LTT:    num_ltt_us    ',num_ltt_us
      write(IFLOG,*) 'LTT:    num_ltt_nc_us ',ltt_nc
   end if
99 continue
   end subroutine sizeof_ltt_us

!=====================================================================
   subroutine set_ltt_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ltt, ltt_nc, is_debug_here, &
              n1, l1, t1, n2, l2, t2, ips1, ips2, ll, ips, &
              tn, tm, lt1, lt2, lttx
   is_debug_here = 1
   if (is_debug /= 0) then
      is_debug_here = is_debug
   end if
   ier = 0
   ltt_nm_us(:,:,:) = 0
   l_ltt_us (:) = 0
   t1_ltt_us(:) = 0
   t2_ltt_us(:) = 0
   ltt    = 0
   ltt_nc = 0
   do lt1 = 1,num_ltx_us
      n1 = n_lt_us(lt1)
      l1 = l_lt_us(lt1)
      t1 = t_lt_us(lt1)
      tn = tn_lt_us(lt1)
      ips1 = ips_lt_us(lt1)
      do lt2 = 1,num_ltx_us
         n2 = n_lt_us(lt2)
         l2 = l_lt_us(lt2)
         t2 = t_lt_us(lt2)
         tm = tn_lt_us(lt2)
         ips2 = ips_lt_us(lt2)
         if (l1 == l2) then
            ll = l1
            if (is_val_type_ps(ips1) /= is_val_type_ps(ips2)) then
               write(IFLOG,*) '### ERROR ### val_type are different'
               write(IFLOG,*) '   ips1,(n1,l1,t1)      ...', &
                                  ips1,n1,l1,t1
               write(IFLOG,*) '   ips2,(n2,l2,t2)      ...', &
                                  ips2,n2,l2,t2
               write(IFLOG,*) '   is_val_type_ps(ips1) ...', &
                                  is_val_type_ps(ips1)
               write(IFLOG,*) '   is_val_type_ps(ips2) ...', &
                                  is_val_type_ps(ips2)
               ier = 1 ; go to 99
            end if
            ips = ips1
            if (is_val_type_ps(ips) == TM91) then
               ltt_nc = ltt_nc + 1
               lttx   = ltt_nc + num_ltt_us
            else
               ltt  = ltt + 1
               lttx = ltt
            end if
            ltt_nm_us(ll,tn,tm) = lttx
            l_ltt_us   (lttx) = ll
            ips1_ltt_us(lttx) = ips1 ; ips2_ltt_us(lttx) = ips2
            n1_ltt_us  (lttx) = n1   ; n2_ltt_us  (lttx) = n2
            t1_ltt_us  (lttx) = t1   ; t2_ltt_us  (lttx) = t2
            tn_ltt_us  (lttx) = tn   ; tm_ltt_us  (lttx) = tm
            if (is_debug_here /= 0) then
               write(IFLOG,*) 'LTT: l,t1,t2,tn,tm,ltt ...', &
                                    ll,t1,t2,tn,tm,lttx
            end if
         end if
      end do
   end do
   if (ltt_nc + ltt /= num_lttx_us) then
      write(IFLOG,*) '### ERROR ### ltt_nc + ltt != num_ltt_us'
      ier = 1 ; go to 99
   end if
   if (ltt /= num_ltt_us) then
      write(IFLOG,*) '### ERROR ### ltt != num_ltt_us'
      ier = 1 ; go to 99
   end if
99 continue
   end subroutine set_ltt_us

!================================= added by K. T. ======================== 4.0
subroutine set_ltt_us_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ltt, ltt_nc, is_debug_here, &
       n1, l1, t1, n2, l2, t2, ips1, ips2, ll, ips, &
       tn, tm, lt1, lt2, lttx
  integer :: ispin1, ispin2, itmp1, itmp2

  is_debug_here = 1
  if (is_debug /= 0) then
     is_debug_here = is_debug
  end if

  ier = 0
  ltt_nm_us(:,:,:) = 0
  l_ltt_us (:) = 0
  t1_ltt_us(:) = 0
  t2_ltt_us(:) = 0
  ltt    = 0
  ltt_nc = 0

  do lt1 = 1,num_ltx_us
     n1 = n_lt_us(lt1)
     l1 = l_lt_us(lt1)
     t1 = t_lt_us(lt1)
     tn = tn_lt_us(lt1)
     ips1 = ips_lt_us(lt1)

     ispin1 = spin_index_lt_us(lt1)

     do lt2 = 1,num_ltx_us
        n2 = n_lt_us(lt2)
        l2 = l_lt_us(lt2)
        t2 = t_lt_us(lt2)
        tm = tn_lt_us(lt2)
        ips2 = ips_lt_us(lt2)

        ispin2 = spin_index_lt_us(lt2)

        if (l1 == l2) then
           ll = l1
           if (is_val_type_ps(ips1) /= is_val_type_ps(ips2)) then
              write(IFLOG,*) '### ERROR ### val_type are different'
              write(IFLOG,*) '   ips1,(n1,l1,t1)      ...', &
                   ips1,n1,l1,t1
              write(IFLOG,*) '   ips2,(n2,l2,t2)      ...', &
                   ips2,n2,l2,t2
              write(IFLOG,*) '   is_val_type_ps(ips1) ...', &
                   is_val_type_ps(ips1)
              write(IFLOG,*) '   is_val_type_ps(ips2) ...', &
                   is_val_type_ps(ips2)
              ier = 1 ; go to 99
           end if

           ips = ips1
           if (is_val_type_ps(ips) == TM91) then
              ltt_nc = ltt_nc + 1
              lttx   = ltt_nc + num_ltt_us
           else
              ltt  = ltt + 1
              lttx = ltt
           end if

           itmp1 = tn + nref_max_us *(ispin1 -1)
           itmp2 = tm + nref_max_us *(ispin2 -1)

           ltt_nm_us(ll,itmp1,itmp2) = lttx

           l_ltt_us   (lttx) = ll
           ips1_ltt_us(lttx) = ips1 ; ips2_ltt_us(lttx) = ips2
           n1_ltt_us  (lttx) = n1   ; n2_ltt_us  (lttx) = n2
           t1_ltt_us  (lttx) = t1   ; t2_ltt_us  (lttx) = t2
           tn_ltt_us  (lttx) = tn   ; tm_ltt_us  (lttx) = tm

           spin1_index_ltt_us(lttx) = ispin1
           spin2_index_ltt_us(lttx) = ispin2

           if (is_debug_here /= 0) then
              write(IFLOG,*) 'LTT: l,t1,s1,t2,s2,tn,tm,ltt ...', &
                   ll,t1, ispin1, t2, ispin2, tn,tm,lttx
           end if
        end if
     end do
  end do

  if (ltt_nc + ltt /= num_lttx_us) then
     write(IFLOG,*) '### ERROR ### ltt_nc + ltt != num_ltt_us'
     ier = 1 ; go to 99
  end if
  if (ltt /= num_ltt_us) then
     write(IFLOG,*) '### ERROR ### ltt != num_ltt_us'
     ier = 1 ; go to 99
  end if

99 continue

end subroutine set_ltt_us_kt
! ============================================================================ 4.0

!=====================================================================
   subroutine sizeof_ltlt_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ltlt, ltlt_nc, ltltx, is_debug_here, &
              l1, t1, l2, t2, l3, ips1, ips2, n1, n2, &
              ln, lm, tn, tm, lt1, lt2
   is_debug_here = 1
   if (is_debug /= 0) then
      is_debug_here = is_debug
   end if
   ier = 0
   ltlt = 0
   do lt1 = 1,num_ltx_us
      ips1 = ips_lt_us(lt1)
      n1   = n_lt_us  (lt1)
      l1   = l_lt_us  (lt1)
      t1   = t_lt_us  (lt1)
      ln   = ln_lt_us (lt1)
      tn   = tn_lt_us (lt1)
      if (ln == lloc) then
         cycle
      end if
      do lt2 = 1,num_ltx_us
         ips2 = ips_lt_us(lt2)
         n2   = n_lt_us  (lt2)
         l2   = l_lt_us  (lt2)
         t2   = t_lt_us  (lt2)
         lm   = ln_lt_us (lt2)
         tm   = tn_lt_us (lt2)
         if (lm == lloc) then
            cycle
         end if
         if (ln > lm) then
            cycle
         end if
         if ((ln == lm).and.(tn > tm)) then
            cycle
         end if
         if ((is_val_type_us(ln) == TM91).and. &
             (is_val_type_us(lm) == TM91).and. &
             (tn == 1).and. &
             (tm == 1)) then
            cycle
         end if
         ltlt = ltlt + 1
      end do
   end do
   num_ltlt_us = ltlt
   ltlt_nc = 0
   ltlt    = 0
   l3_max_us = 0
   do lt1 = 1,num_ltx_us
      ips1 = ips_lt_us(lt1)
      n1   = n_lt_us  (lt1)
      l1   = l_lt_us  (lt1)
      t1   = t_lt_us  (lt1)
      ln   = ln_lt_us (lt1)
      tn   = tn_lt_us (lt1)
      if (ln == lloc) then
         cycle
      end if
      do lt2 = 1,num_ltx_us
         ips2 = ips_lt_us(lt2)
         n2   = n_lt_us  (lt2)
         l2   = l_lt_us  (lt2)
         t2   = t_lt_us  (lt2)
         lm   = ln_lt_us (lt2)
         tm   = tn_lt_us (lt2)
         if (lm == lloc) then
            cycle
         end if
         if (ln > lm) then
            cycle
         end if
         if ((ln == lm).and.(tn > tm)) then
            cycle
         end if
         if ((is_val_type_us(ln) == TM91).and. &
             (is_val_type_us(lm) == TM91).and. &
             (tn == 1).and. &
             (tm == 1)) then
            ltlt_nc = ltlt_nc + 1
            ltltx   = ltlt_nc + num_ltlt_us  
         else
            ltlt  = ltlt + 1    
            ltltx = ltlt
         end if
         do l3 = abs(ln-lm),ln+lm,2
            if (l3_max_us < l3) then
               l3_max_us = l3
            end if
         end do
      end do
   end do
   num_ltlt_us  = ltlt
   num_ltltx_us = ltlt + ltlt_nc
   if (is_debug_here /= 0) then
      write(IFLOG,*) 'LTLT: num_ltltx_us ....',num_ltltx_us
      write(IFLOG,*) 'LTLT:    num_ltlt_us   ',num_ltlt_us
      write(IFLOG,*) 'LTLT:    num_ltlt_nc_us',ltlt_nc
      write(IFLOG,*) 'LTLT: l3_max_us .......',l3_max_us
   end if
99 continue
   end subroutine sizeof_ltlt_us

!=====================================================================
   subroutine set_ltlt_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ltlt, ltlt_nc, ltltx, l3_max, is_debug_here, &
              n1, l1, t1, n2, l2, t2, l3, ips1, ips2, &
              ln, lm, tn, tm, lt1, lt2
      
   is_debug_here = 1
   if (is_debug /= 0) then
      is_debug_here = is_debug
   end if
   ier = 0
   ltlt_nm_us(:,:,:,:) = 0
   ips1_ltlt_us(:) = 0 ; ips2_ltlt_us(:) = 0
   n1_ltlt_us(:) = 0   ; n2_ltlt_us(:) = 0
   l1_ltlt_us(:) = 0   ; l2_ltlt_us(:) = 0
   t1_ltlt_us(:) = 0   ; t2_ltlt_us(:) = 0
   ln_ltlt_us(:) = 0   ; lm_ltlt_us(:) = 0
   tn_ltlt_us(:) = 0   ; tm_ltlt_us(:) = 0
   ltlt_nc = 0
   ltlt    = 0
   l3_max  = 0
   do lt1 = 1,num_ltx_us
      ips1 = ips_lt_us(lt1)
      n1   = n_lt_us  (lt1)
      l1   = l_lt_us  (lt1)
      t1   = t_lt_us  (lt1)
      ln   = ln_lt_us (lt1)
      tn   = tn_lt_us (lt1)
      if (ln == lloc) then  
         cycle
      end if
      do lt2 = 1,num_ltx_us
         ips2 = ips_lt_us(lt2)
         n2   = n_lt_us  (lt2)
         l2   = l_lt_us  (lt2)
         t2   = t_lt_us  (lt2)
         lm   = ln_lt_us (lt2)
         tm   = tn_lt_us (lt2)
         if (lm == lloc) then
            cycle
         end if
         if (ln > lm) then
            cycle
         end if
         if ((ln == lm).and.(tn > tm)) then
            cycle
         end if
         if ((is_val_type_us(ln) == TM91).and. &
             (is_val_type_us(lm) == TM91).and. &
             (tn == 1).and. &
             (tm == 1)) then      
            ltlt_nc = ltlt_nc + 1
            ltltx   = ltlt_nc + num_ltlt_us
         else
            ltlt  = ltlt + 1
            ltltx = ltlt
         end if
         ltlt_nm_us(ln,tn,lm,tm) = ltltx
         ltlt_nm_us(lm,tm,ln,tn) = ltltx
         ips1_ltlt_us(ltltx) = ips1 ; ips2_ltlt_us(ltltx) = ips2
         n1_ltlt_us  (ltltx) = n1   ; n2_ltlt_us  (ltltx) = n2
         l1_ltlt_us  (ltltx) = l1   ; l2_ltlt_us  (ltltx) = l2
         t1_ltlt_us  (ltltx) = t1   ; t2_ltlt_us  (ltltx) = t2
         ln_ltlt_us  (ltltx) = ln   ; lm_ltlt_us  (ltltx) = lm
         tn_ltlt_us  (ltltx) = tn   ; tm_ltlt_us  (ltltx) = tm
         do l3 = abs(ln-lm),ln+lm,2
            if (l3_max < l3) then
               l3_max = l3
            end if
         end do
         if (is_debug_here /= 0) then
            write(IFLOG,*) 'LTLT: ln,tn,lm,tm,ltlt ...', &
                                  ln,tn,lm,tm,ltltx
         end if
      end do
   end do
   num_ltltx_us = ltlt + ltlt_nc
   if (is_debug_here /= 0) then
      write(IFLOG,*) 'LTLT: num_ltltx_us',num_ltltx_us
   end if
   if (ltlt /= num_ltlt_us) then
      write(IFLOG,*) '### ERROR ### ltlt != num_ltlt_us'
      ier = 1 ; go to 99
   end if
   if (ltlt + ltlt_nc /= num_ltltx_us) then
      write(IFLOG,*) &
         '### ERROR ### ltlt + ltlt_nc != num_ltltx_us'
      ier = 1 ; go to 99
   end if
   if (l3_max /= l3_max_us) then
      write(IFLOG,*) '### ERROR ### ll3_max_us != l3_max_us'
      ier = 1 ; go to 99
   end if
99 continue
   end subroutine set_ltlt_us

!================================ added by K. T. ======================== 4.0
subroutine set_ltlt_us_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ltlt, ltlt_nc, ltltx, l3_max, is_debug_here, &
       n1, l1, t1, n2, l2, t2, l3, ips1, ips2, &
       ln, lm, tn, tm, lt1, lt2
  integer :: ispin1, ispin2, itmp1, itmp2
  
  is_debug_here = 1
  if (is_debug /= 0) then
     is_debug_here = is_debug
  end if

  ier = 0
  ltlt_nm_us(:,:,:,:) = 0
  ips1_ltlt_us(:) = 0 ; ips2_ltlt_us(:) = 0
  n1_ltlt_us(:) = 0   ; n2_ltlt_us(:) = 0
  l1_ltlt_us(:) = 0   ; l2_ltlt_us(:) = 0
  t1_ltlt_us(:) = 0   ; t2_ltlt_us(:) = 0
  ln_ltlt_us(:) = 0   ; lm_ltlt_us(:) = 0
  tn_ltlt_us(:) = 0   ; tm_ltlt_us(:) = 0
  ltlt_nc = 0
  ltlt    = 0
  l3_max  = 0

  do lt1 = 1,num_ltx_us
     ips1 = ips_lt_us(lt1)
     n1   = n_lt_us  (lt1)
     l1   = l_lt_us  (lt1)
     t1   = t_lt_us  (lt1)
     ln   = ln_lt_us (lt1)
     tn   = tn_lt_us (lt1)

     ispin1 = spin_index_lt_us(lt1)

     if (ln == lloc) then  
        cycle
     end if

     do lt2 = 1,num_ltx_us
        ips2 = ips_lt_us(lt2)
        n2   = n_lt_us  (lt2)
        l2   = l_lt_us  (lt2)
        t2   = t_lt_us  (lt2)
        lm   = ln_lt_us (lt2)
        tm   = tn_lt_us (lt2)

        ispin2 = spin_index_lt_us(lt2)

        if (lm == lloc) then
           cycle
        end if

        if (ln > lm) then
           cycle
        end if

        if ((ln == lm).and.(tn > tm)) then
           cycle
        end if

        if ((is_val_type_us(ln) == TM91).and. &
             (is_val_type_us(lm) == TM91).and. &
             (tn == 1).and. &
             (tm == 1)) then      
           ltlt_nc = ltlt_nc + 1
           ltltx   = ltlt_nc + num_ltlt_us
        else
           ltlt  = ltlt + 1
           ltltx = ltlt
        end if
        
        itmp1 = tn + nref_max_us *(ispin1 -1)
        itmp2 = tm + nref_max_us *(ispin2 -1)

        ltlt_nm_us(ln,itmp1,lm,itmp2) = ltltx
        ltlt_nm_us(lm,itmp2,ln,itmp1) = ltltx

        ips1_ltlt_us(ltltx) = ips1 ; ips2_ltlt_us(ltltx) = ips2
        n1_ltlt_us  (ltltx) = n1   ; n2_ltlt_us  (ltltx) = n2
        l1_ltlt_us  (ltltx) = l1   ; l2_ltlt_us  (ltltx) = l2
        t1_ltlt_us  (ltltx) = t1   ; t2_ltlt_us  (ltltx) = t2
        ln_ltlt_us  (ltltx) = ln   ; lm_ltlt_us  (ltltx) = lm
        tn_ltlt_us  (ltltx) = tn   ; tm_ltlt_us  (ltltx) = tm

        spin1_index_ltlt_us( ltltx ) = ispin1
        spin2_index_ltlt_us( ltltx ) = ispin2

        do l3 = abs(ln-lm),ln+lm,2
           if (l3_max < l3) then
              l3_max = l3
           end if
        end do
        if (is_debug_here /= 0) then
           write(IFLOG,*) 'LTLT: ln,tn,sn,lm,tm,sm,ltlt ...', &
                ln,tn,ispin1,lm,tm,ispin2,ltltx
        end if
     end do
  end do

  num_ltltx_us = ltlt + ltlt_nc
  if (is_debug_here /= 0) then
     write(IFLOG,*) 'LTLT: num_ltltx_us',num_ltltx_us
  end if
  if (ltlt /= num_ltlt_us) then
     write(IFLOG,*) '### ERROR ### ltlt != num_ltlt_us'
     ier = 1 ; go to 99
  end if
  if (ltlt + ltlt_nc /= num_ltltx_us) then
     write(IFLOG,*) &
          '### ERROR ### ltlt + ltlt_nc != num_ltltx_us'
     ier = 1 ; go to 99
  end if
  if (l3_max /= l3_max_us) then
     write(IFLOG,*) '### ERROR ### ll3_max_us != l3_max_us'
     ier = 1 ; go to 99
  end if

99 continue

end subroutine set_ltlt_us_kt
! ======================================================================== 4.0

!=====================================================================
   subroutine set_param_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: nn, ll, tt, ln, tn, ips, ishell, nrc, ir, &
              is_debug_here, lt
   real(8) :: r, ee, sum
   is_debug_here = 1
   if (is_debug /= 0) then
      is_debug_here = is_debug
   end if
   ier = 0
   is_bound_ps(:) = 0
   do lt = 1,num_ltx_us
      ips = ips_lt_us(lt)
      tt = t_lt_us(lt)
      ishell = ishell_ps(ips,1)
      if (is_solve(ishell) /= 0) then
         if (abs(deref_ps(ips,tt)) < 1.d-6) then
            is_bound_us(lt) = 1
         else
            is_bound_us(lt) = 0
         end if
      else
         is_bound_us(lt) = 0
      end if
      is_bound_ps(ips) = max(is_bound_ps(ips),is_bound_us(lt))
   end do
   nrcut_phi_max_us = 0
   norm_psi_ps(:) = 0.d0
   do lt = 1,num_ltx_us
      ips = ips_lt_us(lt)
      nn  = n_lt_us(lt)
      ll  = l_lt_us(lt)
      tt  = t_lt_us(lt)
      ln  = ln_lt_us(lt)
      tn  = tn_lt_us(lt)
      ishell = ishell_ps(ips,1)
      if (abs(engy(ishell)) < 1.d-10) then
         ee = efermi        
      else                  
         ee = engy(ishell)
      end if
      eref_us(lt) = deref_ps(ips,tt) + ee
      if (is_debug_here /= 0) then
         write(IFLOG,*) 'US: l,t,eref_us ......',ll,tt,eref_us(lt)
      end if
      SRCH_RC:do ir = nmesh,10,-1
         r = rpos(ir)
         if (r < rcut_phi_ps(ips,tt)) then
            nrc = ir ; exit SRCH_RC
         end if
         if (ir <= 10) then
            write(IFLOG,*) '### ERROR ### nrc was not found'
            write(IFLOG,*) '   nn ...',nn
            write(IFLOG,*) '   ll ...',ll
            write(IFLOG,*) '   tt ...',tt
            ier = 1 ; go to 99
         end if
      end do SRCH_RC
      nrcut_phi_us(lt) = nrc
      if (nrcut_phi_max_us < nrcut_phi_us(lt)) then
         nrcut_phi_max_us = nrcut_phi_us(lt)
      end if
      if (is_debug_here /= 0) then
         write(IFLOG,*) 'US: l,t,nrcut_phi_us .....', &
                             ll,tt,nrcut_phi_us(lt),l_lt_us(lt),ln_lt_us(lt)
      end if
   end do
   norm_psi_ps(:) = 1.d0
   do lt = 1,num_ltx_us
      ips = ips_lt_us(lt)
      ishell = ishell_ps(ips,1)                       !AAS 2009
      if (is_bound_us(lt) == 1) then
         nrc = nrcut_phi_us(lt)
         call set_weight_exp(ier,1,nrc,rpos,wt)
         sum = 0.d0
         do ir = 1,nrc
            sum = sum + chi_g(ir,ishell)**2 * wt(ir)
         end do
         norm_psi_ps(ips) = sqrt(sum)
      end if
      write(IFLOG,*) 'US: ips,norm_psi_ps(ips) ...', &
                          ips,norm_psi_ps(ips)
   end do
   select case (lloc)
   case (0:3)
      nrcut_loc_us = nrcut_phi_max_us
   case (5)
      nrcut_loc_us = 0
   case (6)
      nrcut_loc_us = 0
   case default
      write(IFLOG,*) '### ERROR ### lloc is out of range'
      write(IFLOG,*) '   lloc ...',lloc
      ier = 1 ; go to 99
   end select
   nrcut_max_us  = max(nrcut_phi_max_us, nrcut_loc_us)
   nrcut_maxx_us = nrcut_max_us + 15
99 continue
   end subroutine set_param_us

!=====================================================================
   subroutine calc_rpsi_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ishell, ll, nn, kk, tt, ispin, id, ln, tn, &
              ll_core, node, node_sum, nrt, nrc, ips, lt
   real(8) :: ee, g_norm, sum, rcut, sign_mod, g1, eref, deref
   ier = 0
  !++++++++++++++++++++++++++++++++++++++++
   allocate( &
      chi_gl(nmesh),chi_gr(nmesh),       &
      chi_fl(nmesh),chi_fr(nmesh),       &
      dxchi_gl(nmesh),dxchi_gr(nmesh),   &
      dxchi_fl(nmesh),dxchi_fr(nmesh))
      chi_gl   = 0.d0 ; chi_gr   = 0.d0
      chi_fl   = 0.d0 ; chi_fr   = 0.d0
      dxchi_gl = 0.d0 ; dxchi_gr = 0.d0
      dxchi_fl = 0.d0 ; dxchi_fr = 0.d0
  !++++++++++++++++++++++++++++++++++++++++
   call calc_vcoeff(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_vcoeff' ; go to 99
   end if
   write(IFLOG,*)
   write(IFLOG,*) 'Calculating unbound states ...'
MAIN1:do lt = 1,num_ltx_us
      ips = ips_lt_us(lt)
      tt = t_lt_us(lt)
      ishell = ishell_ps(ips,1)
      nn = n_qnum(ishell)
      ll = l_qnum(ishell)
      kk = k_qnum(ishell)

      ispin = (1-spin(ishell))/2 + 1

      ln = ln_lt_us(lt)
      tn = tn_lt_us(lt)
      eref  = eref_us(lt)
      deref = deref_ps(ips,tt)
      if (is_bound_us(lt) == 1) then
         rpsi_us(:,lt) = chi_g(:,ishell)
         cycle MAIN1
      else
         rpsi_us(:,lt) = 0.d0
         node = nn - ll - 1
      end if
      write(IFLOG,*)
      write(IFLOG,'(1x,a31,5i5)') &
            '??? ishell,ispin,nn,ll,node ...',ishell,ispin,nn,ll,node
      ee = eref_us(lt)
      if (is_core == PATOM) then
         ll_core = ll
      else
         ll_core = lmax_core
      end if
      nrc  = nrcut_phi_us(lt)
      rcut = rpos(nrc)
      nrt = nrcut_maxx_us 
      id = +1
      call set_initpoints_left(ier,ll,kk,ispin,ee)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in set_initpoints_left'
         go to 99
      end if
      call int_from_left(ier,node_sum,nrt,id,ll,kk,ee,ispin)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in int_from_left' ; go to 99
      end if
      if (node_sum > node) then 
         write(IFLOG,*) '### CAUTION ### node_sum > node'
         write(IFLOG,*) '   node_sum ...',node_sum
         write(IFLOG,*) '   node     ...',node
      end if
      call set_weight_exp(ier,1,nrc,rpos,wt)
      select case (is_calc)
      case (NONREL,SREL)
         sum = 0.d0
         do ir = 1,nrc
            sum = sum + chi_gl(ir)**2 * wt(ir)
         end do
      case (REL)
         sum = 0.d0
         do ir = 1,nrc
            sum = sum + (chi_gl(ir)**2 + chi_fl(ir)**2) * wt(ir)
         end do
      end select
      g1 = chi_gl(nrc)
      if (g1 < 0.d0) then
         write(IFLOG,*) '### CAUTION ### g1 < 0'
         write(IFLOG,*) '   g1 (Hamman) ...',g1
      end if
      g_norm = sqrt(sum)
      if (g1 > 0.d0) then
         sign_mod =  1.d0
      else
         sign_mod = -1.d0
      end if
      select case (is_calc)
      case (NONREL,SREL)
         do ir = 1,nrt
            rpsi_us(ir,lt) = chi_gl(ir)/g_norm * sign_mod &
                              * norm_psi_ps(ips)
         end do
         call set_weight_exp(ier,1,nrc,rpos,wt)
         sum = 0.d0
         do ir = 1,nrc
            sum = sum + rpsi_us(ir,lt)**2 * wt(ir)
         end do
         write(IFLOG,*) &
            '[calc_rpsi_us] norm of rpsi_us     ...', sqrt(sum)
         write(IFLOG,*) &
            '[calc_rpsi_us]    norm_psi_ps      ...',norm_psi_ps(ips)
         write(IFLOG,*) &
            '[calc_rpsi_us]    lt, ips, (n,l,t) ...',lt,ips,nn,ll,tt
        !--- MO-100528 [begin]
         !if (is_val_type_ps(ips) == US90) then
         if (is_bound_us(lt) == 0) then
            call opt_ub_to_bound(ier,IFLOG,IFSUM,nn,ll,tt,eref,deref, &
               nmesh,rpos,nrc,rpsi_us(1,lt),rpsi_us(1,lt))
            if (ier /= 0) then
               write(IFLOG,*) '### ERROR ### in opt_ub_to_bound'
               go to 99
            end if
         end if
        !--- MO-100528 [end]
      case (REL) 
         do ir = 1,nrt
            rpsi_us(ir,lt) = chi_gl(ir)/g_norm * sign_mod &
                              * norm_psi_ps(ips)
         end do
      end select
end do MAIN1
   do lt = 1,num_ltx_us
   do ir = 1,nmesh
      if (abs(rpsi_us(ir,lt)) < 1.d-99) then
         rpsi_us(ir,lt) = 0.d0
      end if
   end do
   end do
99 continue
  !++++++++++++++++++++++++++++++++++++++++++
   deallocate(chi_gl,chi_gr,chi_fl,chi_fr, &
      dxchi_gl,dxchi_gr,dxchi_fl,dxchi_fr)
  !++++++++++++++++++++++++++++++++++++++++++
   end subroutine calc_rpsi_us

!=====================================================================
   subroutine calc_ncpp_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, nn, ll, tt, tn, ips, ishell, nrc, ll_core, &
              is_bound_state, nk_tm, n1, n2, isdiff, icoeff, lt, nodes
   real(8) :: eref, deref, gcut0, gcut1, gcut2, gcut3, gcut4, rcut, &
              sumpsi_exact, sumphi_num
   real(8),allocatable :: drpsi_tmp(:), rphi_tmp(:)
   ier = 0
   nk_tm = 4
   ncoeff_phi_tm = 6
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   allocate(coeff_tm(0:12,nps,2))
   allocate(coeff_phi_tm(0:ncoeff_phi_tm,nps,2))
   allocate(drpsi_tmp(0:nk_tm),rphi_tmp(nmesh))
      coeff_tm  = 0.d0 ; coeff_phi_tm = 0.d0
      drpsi_tmp = 0.d0 ; rphi_tmp     = 0.d0
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   coeff_phi_tm(:,:,:) = 0.d0
LOOP_TM:do lt = 1,num_ltx_us
      ips = ips_lt_us(lt)
      tt = t_lt_us(lt)
      tn = tn_lt_us(lt)
      ishell = ishell_ps(ips,1)
      nn = n_qnum(ishell)
      ll = l_qnum(ishell)
      if (is_val_type_ps(ips) /= TM91) then
         coeff_tm(:,ips,1) = 0.d0
         cycle LOOP_TM
      end if
      write(IFLOG,*)
      write(IFLOG,'(1x,a23,6i5)') &
            '??? lt,ips,nn,ll,tt ...',lt,ips,nn,ll,tt

      if ((ll == lloc).and.(tn /= 1)) then
         write(IFLOG,*) '### ERROR ### tn != 1 for NC-PP local orbital'
         write(IFLOG,*) '   (n,l,t) ...',nn,ll,tt
         write(IFLOG,*) '   tn      ...',tn
         ier = 1 ; go to 99
      end if

      nrc   = nrcut_phi_us(lt)
      rcut  = rpos(nrc)
      eref  = eref_us(lt)
      deref = deref_ps(ips,tt)
      if (is_core == PATOM) then
         ll_core = ll
      else
         ll_core = lmax_core
      end if
      if (is_solve(ishell) /= 0) then
         if (abs(eref-engy(ishell)) < 1.d-6) then
            is_bound_state = 1
!--- MO-110228 [begin]
            is_bound_us(lt) = 1
            is_bound_us(ips) = 1
!--- MO-110228 [end]
         else
            is_bound_state = 0
!--- MO-110228 [begin]
            is_bound_us(lt) = 0
            is_bound_us(ips) = 0
!--- MO-110228 [end]
         end if
      else
         is_bound_state = 0
!--- MO-110228 [begin]
         is_bound_us(lt) = 0
         is_bound_us(ips) = 0
!--- MO-110228 [end]
      end if
      n1 = nrc - 10 ; n2 = nrc + 10
      if (n1 < 1) then
         n1 = 1 ; n2 = 1 + 10*2
      else if (n2 > nmesh) then
         n1 = nmesh - 10*2 ; n2 = nmesh
      end if
      isdiff = 4
      call diff4_exp(ier,isdiff,n1,n2,rpos,rpsi_us(1,lt),rcut, &
                     gcut0,gcut1,gcut2,gcut3,gcut4)
      if (gcut0 < 0.d0) then
         write(IFLOG,*) '### ERROR ### gcut0 < 0'
         write(IFLOG,*) '   gcut0 ...',gcut0
         write(IFLOG,*) '   gcut1 ...',gcut1
         write(IFLOG,*) '   gcut2 ...',gcut2
         write(IFLOG,*) '   gcut3 ...',gcut3
         write(IFLOG,*) '   gcut4 ...',gcut4
         ier = 1 ; go to 99
      end if
      call calc_tmpp_us(ier,IFLOG,is_bound_state, &
           nmesh,rpos,wr,wt, &
           rpsi_us(1,lt),veff(1,1,ll_core), &
           rphi_us(1,lt),veff_us(1,lt), &
           ll,eref,nrc,gcut0,gcut1,gcut2,gcut3,gcut4, &
           coeff_tm(0,ips,1))
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_tmpp_us'
         go to 99
      end if
      chi_ps (:,ips,1) = rphi_us(:,lt)
      veff_ps(:,ips,1) = veff_us(:,lt)
      call calc_nodes_us(nmesh,rphi_us(1,lt),nrc,nodes)
      nodes_phi_us(lt) = nodes
      call set_weight_exp(ier,1,nrc,rpos,wt)
      sumpsi_exact = 0.d0
      sumphi_num   = 0.d0
      do ir = 1,nrc
         sumpsi_exact = sumpsi_exact + rpsi_us(ir,lt)**2 * wt(ir)
         sumphi_num   = sumphi_num   + rphi_us(ir,lt)**2 * wt(ir)
      end do
      norm_psi_us(lt) = sqrt(sumpsi_exact)
      norm_phi_us(lt) = sqrt(sumphi_num)
      drpsi_tmp(0) = gcut0 ; drpsi_tmp(1) = gcut1
      drpsi_tmp(2) = gcut2 ; drpsi_tmp(3) = gcut3
      drpsi_tmp(4) = gcut4
      rphi_tmp(:) = rphi_us(:,lt) 
      do icoeff = 0,ncoeff_phi_tm
         coeff_phi_tm(icoeff,ips,1) = coeff_tm(2*icoeff,ips,1)
      end do
      call check_rphi_tm(ier,ips,nn,ll,tt,eref,deref,nrc,nk_tm, &
                         drpsi_tmp,rphi_tmp, &
                         sumpsi_exact,sumphi_num)
end do LOOP_TM
   do lt = 1,num_ltx_us
   do ir = 1,nmesh
      if (abs(rpsi_us(ir,lt)) < 1.d-99) then
         rpsi_us(ir,lt) = 0.d0
      end if
      if (abs(rphi_us(ir,lt)) < 1.d-99) then
         rphi_us(ir,lt) = 0.d0
      end if
      if (abs(veff_us(ir,lt)) < 1.d-99) then
         veff_us(ir,lt) = 0.d0
      end if
   end do
   end do
99 continue
  !++++++++++++++++++++++++++++++++++++++++
   deallocate(coeff_tm,drpsi_tmp,rphi_tmp)
  !++++++++++++++++++++++++++++++++++++++++
   end subroutine calc_ncpp_us

!============================= added by K. T. =========================== 4.0
subroutine calc_ncpp_us_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ir, nn, ll, tt, tn, ips, ishell, nrc, ll_core, &
       is_bound_state, nk_tm, n1, n2, isdiff, icoeff, lt, nodes

  integer :: ispin

  real(8) :: eref, deref, gcut0, gcut1, gcut2, gcut3, gcut4, rcut, &
       sumpsi_exact, sumphi_num
  real(8),allocatable :: drpsi_tmp(:), rphi_tmp(:)

  ier = 0
  nk_tm = 4
  ncoeff_phi_tm = 6

  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  allocate(coeff_tm(0:12,nps,2))
  allocate(coeff_phi_tm(0:ncoeff_phi_tm,nps,2))
  allocate(drpsi_tmp(0:nk_tm),rphi_tmp(nmesh))
  coeff_tm  = 0.d0 ; coeff_phi_tm = 0.d0
  drpsi_tmp = 0.d0 ; rphi_tmp     = 0.d0

  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  coeff_phi_tm(:,:,:) = 0.d0

  LOOP_TM:do lt = 1,num_ltx_us
     ips = ips_lt_us(lt)
     tt = t_lt_us(lt)
     tn = tn_lt_us(lt)

     ishell = ishell_ps(ips,1)

     nn = n_qnum(ishell)
     ll = l_qnum(ishell)

     ispin = (1-spin(ishell))/2 + 1

     if (is_val_type_ps(ips) /= TM91) then
        coeff_tm(:,ips,1) = 0.d0
        cycle LOOP_TM
     end if
     
     write(IFLOG,*)
     write(IFLOG,'(1x,a23,6i5)') &
          '??? lt,ips,nn,ll,tt ...',lt,ips,nn,ll,tt
     
     if ( nspin == 1 ) then
        if ((ll == lloc).and.(tn /= 1)) then
           write(IFLOG,*) '### ERROR ### tn != 1 for NC-PP local orbital'
           write(IFLOG,*) '   (n,l,t) ...',nn,ll,tt
           write(IFLOG,*) '   tn      ...',tn
           ier = 1 ; go to 99
        end if
     else
        if ((ll == lloc).and.(tn >2 .or. tn <1) ) then
           write(IFLOG,*) '### ERROR ### tn != 1 for NC-PP local orbital'
           write(IFLOG,*) '   (n,l,t) ...',nn,ll,tt
           write(IFLOG,*) '   tn      ...',tn
           ier = 1 ; go to 99
        end if
     endif
      
     nrc   = nrcut_phi_us(lt)
     rcut  = rpos(nrc)
     eref  = eref_us(lt)
     deref = deref_ps(ips,tt)

     if (is_core == PATOM) then
        ll_core = ll
     else
        ll_core = lmax_core
     end if

     if (is_solve(ishell) /= 0) then
        
        if (abs(eref-engy(ishell)) < 1.d-6) then
           is_bound_state = 1
!--- MO-110228 [begin]
           is_bound_us(lt) = 1
           is_bound_us(ips) = 1
!--- MO-110228 [end]
        else
           is_bound_state = 0
!--- MO-110228 [begin]
           is_bound_us(lt) = 0
           is_bound_us(ips) = 0
!--- MO-110228 [end]
        end if
     else
        is_bound_state = 0
!--- MO-110228 [begin]
        is_bound_us(lt) = 0
        is_bound_us(ips) = 0
!--- MO-110228 [end]
     end if

     n1 = nrc - 10 ; n2 = nrc + 10

     if (n1 < 1) then
        n1 = 1 ; n2 = 1 + 10*2
     else if (n2 > nmesh) then
        n1 = nmesh - 10*2 ; n2 = nmesh
     end if

     isdiff = 4
     call diff4_exp(ier,isdiff,n1,n2,rpos,rpsi_us(1,lt),rcut, &
          gcut0,gcut1,gcut2,gcut3,gcut4)

     if (gcut0 < 0.d0) then
        write(IFLOG,*) '### ERROR ### gcut0 < 0'
        write(IFLOG,*) '   gcut0 ...',gcut0
        write(IFLOG,*) '   gcut1 ...',gcut1
        write(IFLOG,*) '   gcut2 ...',gcut2
        write(IFLOG,*) '   gcut3 ...',gcut3
        write(IFLOG,*) '   gcut4 ...',gcut4
        ier = 1 ; go to 99
     end if

     call calc_tmpp_us(ier,IFLOG,is_bound_state, &
          nmesh,rpos,wr,wt, &
          rpsi_us(1,lt),veff(1,ispin,ll_core), &
          rphi_us(1,lt),veff_us(1,lt), &
          ll,eref,nrc,gcut0,gcut1,gcut2,gcut3,gcut4, &
          coeff_tm(0,ips,1))

     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_tmpp_us'
        go to 99
     end if

     chi_ps (:,ips,1) = rphi_us(:,lt)
     veff_ps(:,ips,1) = veff_us(:,lt)

     call calc_nodes_us(nmesh,rphi_us(1,lt),nrc,nodes)
     nodes_phi_us(lt) = nodes

     call set_weight_exp(ier,1,nrc,rpos,wt)
     sumpsi_exact = 0.d0
     sumphi_num   = 0.d0

     do ir = 1,nrc
        sumpsi_exact = sumpsi_exact + rpsi_us(ir,lt)**2 * wt(ir)
        sumphi_num   = sumphi_num   + rphi_us(ir,lt)**2 * wt(ir)
     end do

     norm_psi_us(lt) = sqrt(sumpsi_exact)
     norm_phi_us(lt) = sqrt(sumphi_num)
     drpsi_tmp(0) = gcut0 ; drpsi_tmp(1) = gcut1
     drpsi_tmp(2) = gcut2 ; drpsi_tmp(3) = gcut3
     drpsi_tmp(4) = gcut4
     rphi_tmp(:) = rphi_us(:,lt) 

     do icoeff = 0,ncoeff_phi_tm
        coeff_phi_tm(icoeff,ips,1) = coeff_tm(2*icoeff,ips,1)
     end do
     call check_rphi_tm(ier,ips,nn,ll,tt,eref,deref,nrc,nk_tm, &
          drpsi_tmp,rphi_tmp, &
          sumpsi_exact,sumphi_num)
  end do LOOP_TM

  do lt = 1,num_ltx_us
     do ir = 1,nmesh
        if (abs(rpsi_us(ir,lt)) < 1.d-99) then
           rpsi_us(ir,lt) = 0.d0
        end if
        if (abs(rphi_us(ir,lt)) < 1.d-99) then
           rphi_us(ir,lt) = 0.d0
        end if
        if (abs(veff_us(ir,lt)) < 1.d-99) then
           veff_us(ir,lt) = 0.d0
        end if
     end do
  end do

99 continue
  !++++++++++++++++++++++++++++++++++++++++
  deallocate(coeff_tm,drpsi_tmp,rphi_tmp)
  !++++++++++++++++++++++++++++++++++++++++

end subroutine calc_ncpp_us_kt

!=====================================================================
   subroutine calc_nodes_us(nmesh,func,nrc,nodes)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: nmesh, nrc
   real(8),intent(in)  :: func(nmesh)
   integer,intent(out) :: nodes
   integer :: ir
   nodes = 0
   do ir = 2,nrc
      if (func(ir-1)*func(ir) < 0.d0) then
         nodes = nodes + 1
      end if
   end do
   end subroutine calc_nodes_us

!=====================================================================
   subroutine set_vloc_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ll, ips, ishell, is_found, ir, ll_core
   real(8) :: eps
   ier = 0
   select case (lloc)
   case (0:3)
      write(IFLOG,*) 'VLOC: Orbital ... lloc =',lloc
      if (is_core == PATOM) then
         ll_core = lloc
      else
         ll_core = lmax_core
      end if
      is_found = 0
      do ips = 1,nps
         ishell = ishell_ps(ips,1)
         ll = l_qnum(ishell)
         if (ll == lloc) then
! ======================================== modified by K. T. ============ 4.0
!            vloc_scr_us(:) = veff_ps(:,ips,1)
            vloc_scr_us(:,1) = veff_ps(:,ips,1)
! ======================================================================= 4.0
            is_found = 1
            exit
         end if
      end do
      if (is_found == 0) then
         write(IFLOG,*) '### ERROR ### lloc was not found'
         write(IFLOG,*) '   lloc ...',lloc
         ier = 1 ; go to 99
      end if
      nrcut_loc_us = nrcut_phi_max_us
   case (5)
      write(IFLOG,*) 'VLOC: BHS'
      if (is_core == PATOM) then
         write(IFLOG,*) '### ERROR ### Vloc cannot be constructed'
         write(IFLOG,*) '              for a pseudo-atom. (lloc=5)'
         ier = 1 ; go to 99
      else
         ll_core = lmax_core
      end if
      do ir = 1,nmesh
         eps = exp(-(rpos(ir)/rcut_loc_bhs)**lambda_loc_bhs)

! ================================= modified by K. T. =============== 4.0
!         vloc_scr_us(ir) = eps*vcut_loc_bhs + (1.d0-eps)*veff(ir,1,ll_core) 
         vloc_scr_us(ir,1) = eps*vcut_loc_bhs + (1.d0-eps)*veff(ir,1,ll_core) 
! ===================================================================== 4.0

      end do
      write(IFLOG,*) 'VLOC: lambda ...',lambda_loc_bhs
      write(IFLOG,*) 'VLOC: rcut   ...',rcut_loc_bhs
      write(IFLOG,*) 'VLOC: vcut   ...',vcut_loc_bhs
   case (6)
      write(IFLOG,*) 'VLOC: Polynomial'
      if (is_core == PATOM) then
         write(IFLOG,*) '### ERROR ### Vloc cannot be constructed'
         write(IFLOG,*) '              for a pseudo-atom. (lloc=6)'
         ier = 1 ; go to 99
      else
         ll_core = lmax_core
      end if
      call set_vloc_poly10(nmesh,rpos,veff(1,1,ll_core), &
                         rcut_loc_poly,vcut_loc_poly,vloc_scr_us)
      write(IFLOG,*) 'VLOC: rcut ...',rcut_loc_poly
      write(IFLOG,*) 'VLOC: vcut ...',vcut_loc_poly
   case default
      write(IFLOG,*) '### ERROR ### lloc is out of range'
      write(IFLOG,*) '   lloc ...',lloc
      ier = 2 ; go to 99
   end select
   write(IFLOG,*) '      ir, rpos, vloc_scr'
   do ir = 1,nmesh,100
      write(IFLOG,'(i5,8(1pe15.5))') &
! ========================================== modiifed by K. T. ========== 4.0
!         ir,rpos(ir),vloc_scr_us(ir),veff(ir,1,ll_core)
         ir,rpos(ir),vloc_scr_us(ir,1),veff(ir,1,ll_core)
! ======================================================================== 4.0
   end do
99 continue
   end subroutine set_vloc_us

!============================ added by K. T. =============================== 4.0
subroutine set_vloc_us_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ll, ips, ishell, is_found, ir, ll_core
  real(8) :: eps
  ier = 0

  select case (lloc)

  case (0:3)
     write(IFLOG,*) 'VLOC: Orbital ... lloc =',lloc
     if (is_core == PATOM) then
        ll_core = lloc
     else
        ll_core = lmax_core
     end if
     is_found = 0
     
     do ips = 1,nps, nspin
        ishell = ishell_ps(ips,1)
        ll = l_qnum(ishell)

        if (ll == lloc) then
           if ( nspin == 1 ) then
              vloc_scr_us(:,1) = veff_ps(:,ips,1)
              is_found = 1
              exit
           else if ( nspin == 2 ) then
              vloc_scr_us(1:nmesh,1) = veff_ps(1:nmesh,ips,  1)
              vloc_scr_us(1:nmesh,2) = veff_ps(1:nmesh,ips+1,1)
              is_found = 1
              exit
           endif
        endif

     end do
     
     if (is_found == 0) then
        write(IFLOG,*) '### ERROR ### lloc was not found'
        write(IFLOG,*) '   lloc ...',lloc
        ier = 1 ; go to 99
     end if
     nrcut_loc_us = nrcut_phi_max_us
     
  case (5)
     write(IFLOG,*) 'VLOC: BHS'
     if (is_core == PATOM) then
        write(IFLOG,*) '### ERROR ### Vloc cannot be constructed'
        write(IFLOG,*) '              for a pseudo-atom. (lloc=5)'
        ier = 1 ; go to 99
     else
        ll_core = lmax_core
     end if

     do ir = 1,nmesh
        eps = exp(-(rpos(ir)/rcut_loc_bhs)**lambda_loc_bhs)
        vloc_scr_us(ir,1) = eps*vcut_loc_bhs + (1.d0-eps)*veff(ir,1,ll_core) 
     end do

     if ( nspin == 2 ) then
        do ir = 1,nmesh
           eps = exp(-(rpos(ir)/rcut_loc_bhs)**lambda_loc_bhs)
           vloc_scr_us(ir,2) = eps*vcut_loc_bhs + (1.d0-eps)*veff(ir,nspin,ll_core) 
        end do
     endif

     write(IFLOG,*) 'VLOC: lambda ...',lambda_loc_bhs
     write(IFLOG,*) 'VLOC: rcut   ...',rcut_loc_bhs
     write(IFLOG,*) 'VLOC: vcut   ...',vcut_loc_bhs
     
  case (6)
     write(IFLOG,*) 'VLOC: Polynomial'
     if (is_core == PATOM) then
        write(IFLOG,*) '### ERROR ### Vloc cannot be constructed'
        write(IFLOG,*) '              for a pseudo-atom. (lloc=6)'
        ier = 1 ; go to 99
     else
        ll_core = lmax_core
     end if

     
     call set_vloc_poly10(nmesh,rpos,veff(1,1,ll_core), &
          rcut_loc_poly,vcut_loc_poly,vloc_scr_us(1:nmesh,1) )

     if ( nspin == 2 ) then
        call set_vloc_poly10( nmesh, rpos, veff(1,nspin,ll_core), &
             rcut_loc_poly,vcut_loc_poly,vloc_scr_us(1:nmesh,2) )
     endif

     write(IFLOG,*) 'VLOC: rcut ...',rcut_loc_poly
     write(IFLOG,*) 'VLOC: vcut ...',vcut_loc_poly

  case default
     write(IFLOG,*) '### ERROR ### lloc is out of range'
     write(IFLOG,*) '   lloc ...',lloc
     ier = 2 ; go to 99

  end select

  write(IFLOG,*) '      ir, rpos, vloc_scr ( ispin == 1 )'
  do ir = 1,nmesh,100
     write(IFLOG,'(i5,8(1pe15.5))') &
          ir,rpos(ir),vloc_scr_us(ir,1),veff(ir,1,ll_core)
  end do

  if ( nspin==2 ) then
     write(IFLOG,*) '      ir, rpos, vloc_scr ( ispin == 2 )'
     do ir = 1,nmesh,100
        write(IFLOG,'(i5,8(1pe15.5))') &
             ir,rpos(ir),vloc_scr_us(ir,2),veff(ir,nspin,ll_core)
     end do
  endif

99 continue

end subroutine set_vloc_us_kt
! ========================================================================== 4.0

!=====================================================================
   subroutine calc_rphi_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ishell, ll, nn, kk, tt, ispin, ln, tn, &
              nrc, ips, n1, n2, nk_us, isdiff, lt, nodes, ir
   real(8) :: rcut, eref, deref
   real(8),allocatable :: dpsi_tmp(:), psi_tmp(:), phi_tmp(:)
   ier = 0
   nk_us = 4
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   allocate(dpsi_tmp(0:nk_us),psi_tmp(nmesh),phi_tmp(nmesh))
      dpsi_tmp = 0.d0 ; psi_tmp = 0.d0 ; phi_tmp = 0.d0
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
MAIN1:do lt = 1,num_ltx_us
      ips = ips_lt_us(lt)
      tt = t_lt_us(lt)
      ishell = ishell_ps(ips,1)
      nn = n_qnum(ishell)
      ll = l_qnum(ishell)
      kk = k_qnum(ishell)
      ispin = (1-spin(ishell))/2 + 1
      ln = ln_lt_us(lt)
      tn = tn_lt_us(lt)
      if (is_val_type_ps(ips) /= US90) then
         cycle MAIN1
      end if
      write(IFLOG,*)
      write(IFLOG,'(1x,a29,7i5)') &
            '??? lt,ips,ispin,nn,ll,tt ...', &
                 lt,ips,ispin,nn,ll,tt
      psi_tmp(:) = rpsi_us(:,lt) / rpos(:)
      nrc   = nrcut_phi_us(lt)
      rcut  = rpos(nrc)
      eref  = eref_us(lt)
      deref = deref_ps(ips,tt)
      n1 = nrc - 10 ; n2 = nrc + 10
      if (n1 < 1) then
         n1 = 1 ; n2 = 1 + 10*2
      else if (n2 > nmesh) then
         n1 = nmesh - 10*2 ; n2 = nmesh
      end if
      isdiff = nk_us
      select case (nk_us)
      case (2)
         call diff_exp(ier,isdiff,n1,n2,rpos,psi_tmp,rcut, &
                       dpsi_tmp(0),dpsi_tmp(1),dpsi_tmp(2))
      case (3)
         call diff3_exp(ier,isdiff,n1,n2,rpos,psi_tmp,rcut, &
                 dpsi_tmp(0),dpsi_tmp(1),dpsi_tmp(2),dpsi_tmp(3))
      case (4)
         call diff4_exp(ier,isdiff,n1,n2,rpos,psi_tmp,rcut, &
                 dpsi_tmp(0),dpsi_tmp(1),dpsi_tmp(2),dpsi_tmp(3), &
                 dpsi_tmp(4))
      end select
      call opt_poly_fn(ier,IFLOG,ll,2, &
              nmesh,rpos,psi_tmp,nk_us,nrc,dpsi_tmp(0), &
              ng_phi_us,gmin_phi_us,gmax_phi_us,ncoeff_phi_us, &
              coeff_phi_us(0,lt))
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in opt_poly_fn'
         go to 99
      end if
      phi_tmp(:) = psi_tmp(:)
      call calc_poly_fn(1,nrc,rpos,ll,ncoeff_phi_us, &
              coeff_phi_us(0,lt),phi_tmp)
      rphi_us(:,lt) = phi_tmp(:) * rpos(:)
      call calc_nodes_us(nmesh,rphi_us(1,lt),nmesh,nodes)
      nodes_phi_us(lt) = nodes
      call check_phi_us(ier,lt,nn,ll,tt,ln,tn,eref,deref,nrc,nk_us, &
                        dpsi_tmp,phi_tmp)
end do MAIN1
   do lt = 1,num_ltx_us
   do ir = 1,nmesh
      if (abs(rphi_us(ir,lt)) < 1.d-99) then
         rphi_us(ir,lt) = 0.d0
      end if
   end do
   end do
99 continue
  !+++++++++++++++++++++++++++++++++++++
   deallocate(dpsi_tmp,psi_tmp,phi_tmp)
  !+++++++++++++++++++++++++++++++++++++
   end subroutine calc_rphi_us

!=====================================================================
   subroutine check_phi_us(ier,lt,nn,ll,tt,ln,tn,eref,deref,nrc, &
                           nk_us,dpsi_tmp,phi_tmp)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir1, ir2, lt, nn, ll, tt, ln, tn, n1, n2, &
              isdiff, nrc, ik, nk_us, ncoeff
   real(8) :: dpsi_tmp(0:nk_us), phi_tmp(nmesh), rcut, eref, deref
   real(8),allocatable :: &
      f_tmp(:), f0_exact(:), f0_anal(:), f0_num(:)
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   allocate(f_tmp(nmesh), &
      f0_exact(0:nk_us), f0_anal(0:nk_us), f0_num(0:nk_us))
      f_tmp    = 0.d0
      f0_exact = 0.d0 ; f0_anal = 0.d0 ; f0_num = 0.d0
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ier = 0
   do ik = 0,nk_us
      f0_exact(ik) = dpsi_tmp(ik)
   end do
   f0_anal(:) = 0.d0
   nrc = nrcut_phi_us(lt)
   ncoeff = ncoeff_phi_us
   ir1 = nrc ; ir2 = nrc
   call calc_poly_fn( &
      ir1,ir2,rpos,ll,ncoeff_phi_us,coeff_phi_us(0,lt),f_tmp)
   f0_anal(0) = f_tmp(nrc)
   call calc_dpoly_fn( &
      ir1,ir2,rpos,ll,ncoeff_phi_us,coeff_phi_us(0,lt),f_tmp)
   f0_anal(1) = f_tmp(nrc)
   if (nk_us >= 2) then
      call calc_ddpoly_fn( &
         ir1,ir2,rpos,ll,ncoeff_phi_us,coeff_phi_us(0,lt),f_tmp)
      f0_anal(2) = f_tmp(nrc)
   end if
   if (nk_us >= 3) then
      call calc_dddpoly_fn( &
         ir1,ir2,rpos,ll,ncoeff_phi_us,coeff_phi_us(0,lt),f_tmp)
      f0_anal(3) = f_tmp(nrc)
   end if
   if (nk_us >= 4) then
      call calc_ddddpoly_fn( &
         ir1,ir2,rpos,ll,ncoeff_phi_us,coeff_phi_us(0,lt),f_tmp)
      f0_anal(4) = f_tmp(nrc)
   end if
   f0_num(:) = 0.d0
   isdiff = nk_us
   n1 = nrc - 10 ; n2 = nrc + 10
   rcut = rpos(nrc)
   select case (nk_us)
   case (2)
      call diff_exp(ier,isdiff,n1,n2,rpos,phi_tmp,rcut, &
              f0_num(0),f0_num(1),f0_num(2))
   case (3)
      call diff3_exp(ier,isdiff,n1,n2,rpos,phi_tmp,rcut, &
              f0_num(0),f0_num(1),f0_num(2),f0_num(3))
   case (4)
      call diff4_exp(ier,isdiff,n1,n2,rpos,phi_tmp,rcut, &
              f0_num(0),f0_num(1),f0_num(2),f0_num(3),f0_num(4))
   end select
   f0_num(0) = phi_tmp(nrc)
   call write_checked_phi_us(IFLOG,nn,ll,tt,ln,tn, &
           nrc,rcut,eref,deref,ncoeff_phi_us,coeff_phi_us(0,lt), &
           nk_us,f0_exact,f0_anal,f0_num)
   call write_checked_phi_us(IFSUM,nn,ll,tt,ln,tn, &
           nrc,rcut,eref,deref,ncoeff_phi_us,coeff_phi_us(0,lt), &
           nk_us,f0_exact,f0_anal,f0_num)
99 continue
  !++++++++++++++++++++++++++++++++++++++++++
   deallocate(f_tmp,f0_exact,f0_anal,f0_num)
  !++++++++++++++++++++++++++++++++++++++++++
   end subroutine check_phi_us

!=====================================================================
   subroutine write_checked_phi_us(ifile,nn,ll,tt,ln,tn, &
      nrc,rcut,eref,deref,ncoeff,coeff,nk,f0_exact,f0_anal,f0_num)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in) :: ifile, nn, ll, tt, ln, tn, nrc, ncoeff, nk
   real(8),intent(in) :: &
      rcut, eref, deref, coeff(0:ncoeff), &
      f0_exact(0:nk), f0_anal(0:nk), f0_num(0:nk)
   integer :: icoeff, ik
   write(ifile,*)
   write(ifile,*)  &
      'Vanderbilt ultrasoft phi[n](r) (polynomial) was optimized.'
   write(ifile,15) ' (n,l,t) :', nn,ll,tt,'US'
   write(ifile,16) ' (ln,tn) :', ln,tn
   write(ifile,10) ' rc, nrc :', rcut, nrc
   write(ifile,14) 'eref, de :', eref, deref
   write(ifile,11) 'ncoeff,nk:', ncoeff, nk
   do icoeff=0,ncoeff
   write(ifile,12) 'coeff(',2*icoeff,'):', coeff(icoeff)
   end do
   write(ifile,13) 'phi(rc)','phi''(rc)','phi"(rc)'
   write(ifile,14) 'Exact    :',(f0_exact(ik),ik=0,2)
   write(ifile,14) 'Analytic :',(f0_anal (ik),ik=0,2)
   write(ifile,14) 'Numerical:',(f0_num  (ik),ik=0,2)
   if (nk >= 3) then
   select case (nk)
   case (3)
      write(ifile,17) 'phi"''(rc)'
   case (4)
      write(ifile,17) 'phi"''(rc)','phi""(rc)'
   case (5)
      write(ifile,17) 'phi"''(rc)','phi""(rc)','phi""''(rc)'
   end select
   write(ifile,14) 'Exact    :',(f0_exact(ik),ik=3,nk)
   write(ifile,14) 'Analytic :',(f0_anal (ik),ik=3,nk)
   write(ifile,14) 'Numerical:',(f0_num  (ik),ik=3,nk)
   end if
10 format(1x,a10,f20.10,i20)
11 format(1x,a10,2(i20))
12 format(1x,(a6,i2,a2),f20.10)
13 format(1x,10x,(8x,a7,5x),(8x,a8,4x),(8x,a8,4x))
14 format(1x,a10,5(f20.10))
15 format(1x,a10,(10x,(i2,2x,i2,2x,i2)),(18x,a2))
16 format(1x,a10,(10x,(2x,2x,i2,2x,i2)))
17 format(1x,10x,(8x,a9,3x),(8x,a9,3x),(8x,a10,2x))
   end subroutine write_checked_phi_us

!=====================================================================
   subroutine calc_norm_rcl_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: lt, nrc, ir
   real(8) :: sum
   ier = 0
MAIN1:do lt = 1,num_ltx_us
      nrc = nrcut_phi_us(lt)
      call set_weight_exp(ier,1,nrc,rpos,wt)
      sum = 0.d0
      do ir = 1,nrc
         sum = sum + rpsi_us(ir,lt)**2 * wt(ir)
      end do
      norm_psi_us(lt) = sqrt(sum)
      sum = 0.d0
      do ir = 1,nrc
         sum = sum + rphi_us(ir,lt)**2 * wt(ir)
      end do
      norm_phi_us(lt) = sqrt(sum)
end do MAIN1
99 continue
   end subroutine calc_norm_rcl_us

!=====================================================================
   subroutine write_norm_rcl_us(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer :: lt, nn, ll, tt, ln, tn
   character(1) :: fn_label_orbital
   write(ifile,*)
   write(ifile,*) &
      'Norms of psi[n] & phi[n] (0 < r < rcl) : n = (n,l,t) = (ln,tn)'
   write(ifile,10) &
      'n','l','t','ln','tn','<psi|psi>rcl','<phi|phi>rcl','nrcl'
MAIN1:do lt = 1,num_ltx_us
      nn = n_lt_us(lt)
      ll = l_lt_us(lt)
      tt = t_lt_us(lt)
      ln = ln_lt_us(lt)
      tn = tn_lt_us(lt)
   write(ifile,11) nn,ll,tt,ln,tn,fn_label_orbital(ln),tn, &
      norm_psi_us(lt),norm_phi_us(lt),nrcut_phi_us(lt)
end do MAIN1
10 format(1x,3(1x,a1,2x),(a2,2x,a2),(4x),2(8x,a12),(11x,a4))
11 format(1x,3(i2,2x),(i2,2x,i2),(3x,a1,i1),f19.10,f20.10,i15)
   end subroutine write_norm_rcl_us

!====================== added by K. T. =============================== 4.0
subroutine write_norm_rcl_us_kt(ifile)
  use parameters
  implicit none

  integer,intent(in) :: ifile
  integer :: lt, nn, ll, tt, ln,  tn, ispin
  character(1) :: fn_label_orbital

  write(ifile,*)
  write(ifile,*) &
       'Norms of psi[n] & phi[n] (0 < r < rcl) : n = (n,l,t,s) = (ln,tn,s)'

  write(ifile,10) &
       'n','l','t', 's', 'ln','tn','<psi|psi>rcl','<phi|phi>rcl','nrcl'

  MAIN1:do lt = 1,num_ltx_us
     nn = n_lt_us(lt)
     ll = l_lt_us(lt)
     tt = t_lt_us(lt)
     ln = ln_lt_us(lt)
     tn = tn_lt_us(lt)

     ispin = spin_index_lt_us(lt)

     write(ifile,11) nn,ll,tt, ispin, ln,tn,fn_label_orbital(ln),tn, &
          norm_psi_us(lt),norm_phi_us(lt),nrcut_phi_us(lt)
  end do MAIN1

10 format(1x,4(1x,a1,2x),(a2,2x,a2),(4x),2(8x,a12),(11x,a4))
11 format(1x,4(i2,2x),(i2,2x,i2),(3x,a1,i1),f19.10,f20.10,i15)

end subroutine write_norm_rcl_us_kt
! ============================================================================ 4.0

!=====================================================================
   subroutine calc_norm_rc_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: lt, nrc, ir
   real(8) :: sum
   ier = 0
MAIN1:do lt = 1,num_ltx_us
      nrc = nrcut_max_us
      call set_weight_exp(ier,1,nrc,rpos,wt)
      sum = 0.d0
      do ir = 1,nrc
         sum = sum + rpsi_us(ir,lt)**2 * wt(ir)
      end do
      norm_psi_us(lt) = sqrt(sum)
      sum = 0.d0
      do ir = 1,nrc
         sum = sum + rphi_us(ir,lt)**2 * wt(ir)
      end do
      norm_phi_us(lt) = sqrt(sum)
end do MAIN1
99 continue
   end subroutine calc_norm_rc_us

!=====================================================================
   subroutine write_norm_rc_us(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer :: lt, nn, ll, tt, ln, tn
   character(1) :: fn_label_orbital
   write(ifile,*)
   write(ifile,*) &
      'Norms of psi[n] & phi[n] (0 < r < R) : n = (n,l,t) = (ln,tn)'
   write(ifile,10) &
      'n','l','t','ln','tn','<psi|psi>R','<phi|phi>R','nR'
MAIN1:do lt = 1,num_ltx_us
      nn = n_lt_us(lt)
      ll = l_lt_us(lt)
      tt = t_lt_us(lt)
      ln = ln_lt_us(lt)
      tn = tn_lt_us(lt)
   write(ifile,11) nn,ll,tt,ln,tn,fn_label_orbital(ln),tn, &
      norm_psi_us(lt),norm_phi_us(lt),nrcut_max_us
end do MAIN1
10 format(1x,3(1x,a1,2x),(a2,2x,a2),(4x),2(8x,a10,2x),(13x,a2))
11 format(1x,3(i2,2x),(i2,2x,i2),(3x,a1,i1),f19.10,f20.10,i15)
   end subroutine write_norm_rc_us

!========================== added by K. T. =============================== 4.0
subroutine write_norm_rc_us_kt(ifile)
  use parameters
  implicit none

  integer,intent(in) :: ifile
  integer :: lt, nn, ll, tt, ln, tn, ispin
  character(1) :: fn_label_orbital

  write(ifile,*)
  write(ifile,*) &
       'Norms of psi[n] & phi[n] (0 < r < R) : n = (n,l,t,s) = (ln,tn)'
  write(ifile,10) &
       'n','l','t','s', 'ln','tn','<psi|psi>R','<phi|phi>R','nR'

  MAIN1:do lt = 1,num_ltx_us
     nn = n_lt_us(lt)
     ll = l_lt_us(lt)
     tt = t_lt_us(lt)
     ln = ln_lt_us(lt)
     tn = tn_lt_us(lt)

     ispin = spin_index_lt_us(lt)

     write(ifile,11) nn,ll,tt, ispin, ln,tn,fn_label_orbital(ln),tn, &
          norm_psi_us(lt),norm_phi_us(lt),nrcut_max_us

  end do MAIN1

10 format(1x,4(1x,a1,2x),(a2,2x,a2),(4x),2(8x,a10,2x),(13x,a2))
11 format(1x,4(i2,2x),(i2,2x,i2),(3x,a1,i1),f19.10,f20.10,i15)

end subroutine write_norm_rc_us_kt
! ====================================================================== 4.0

!=====================================================================
   subroutine write_eref_rcl_phi_us(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer :: ips, nn, ll, tt, ln, tn, lt, nrc
   real(8) :: rcut, eref
   character(2) :: pp_type_tmp
   write(ifile,*)
   write(ifile,*) &
   'Reference energies E[n] & cutoff radii rcl[n] : n = (n,l,t) = (ln,tn)'
   write(ifile,10) 'n','l','t','ln','tn','E[n]','rcl[n]','nrcl[n]'
   do lt = 1,num_ltx_us
      ips = ips_lt_us(lt)
      nn  = n_lt_us(lt)
      ll  = l_lt_us(lt)
      tt  = t_lt_us(lt)
      ln  = ln_lt_us(lt)
      tn  = tn_lt_us(lt)
      nrc = nrcut_phi_us(lt)
      rcut = rpos(nrc)
      eref = eref_us(lt)
      select case (is_val_type_ps(ips))
      case (TM91)
         pp_type_tmp = 'NC'
      case (US90)
         pp_type_tmp = 'US'
      end select
      write(ifile,11) nn,ll,tt,ln,tn,pp_type_tmp,eref,rcut,nrc
   end do
10 format(1x,3(1x,a1,2x),2(a2,2x),2x, &
             (8x,a4,8x),(8x,a6,6x),(8x,a7))
11 format(1x,3(i2,2x),2(i2,2x),(1x,a2),f19.10,f20.10,i15)
   end subroutine write_eref_rcl_phi_us

!=========================== added by K. T. =============================== 4.0
subroutine write_eref_rcl_phi_us_kt(ifile)
  use parameters
  implicit none

  integer,intent(in) :: ifile
  integer :: ips, nn, ll, tt, ln, tn, lt, nrc, ispin
  real(8) :: rcut, eref
  character(2) :: pp_type_tmp

  write(ifile,*)
  write(ifile,*) &
       'Reference energies E[n] & cutoff radii rcl[n] : n = (n,l,t,s) = (ln,tn)'
  write(ifile,10) 'n','l','t','s', 'ln','tn','E[n]','rcl[n]','nrcl[n]'

  do lt = 1,num_ltx_us
     ips = ips_lt_us(lt)
     nn  = n_lt_us(lt)
     ll  = l_lt_us(lt)
     tt  = t_lt_us(lt)
     ln  = ln_lt_us(lt)
     tn  = tn_lt_us(lt)

     ispin = spin_index_lt_us(lt)

     nrc = nrcut_phi_us(lt)
     rcut = rpos(nrc)
     eref = eref_us(lt)

     select case (is_val_type_ps(ips))
     case (TM91)
        pp_type_tmp = 'NC'
     case (US90)
        pp_type_tmp = 'US'
     end select

     write(ifile,11) nn,ll,tt, ispin, ln,tn,pp_type_tmp,eref,rcut,nrc

  end do

10 format(1x,4(1x,a1,2x),2(a2,2x),2x, &
        (8x,a4,8x),(8x,a6,6x),(8x,a7))
11 format(1x,4(i2,2x),2(i2,2x),(1x,a2),f19.10,f20.10,i15)

end subroutine write_eref_rcl_phi_us_kt
! ============================================================================= 4.0

!=====================================================================
   subroutine calc_rchi_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: lt, ln, tn, ir, is_direct_diff, ispin, icoeff, &
              is_debug_here, nrc, nrc2, iord_diff_tmp, ll_core, ips, tt
   is_debug_here = 1
   if (is_debug /= 0) then
      is_debug_here = is_debug
   end if
   ier = 0
   is_direct_diff = 0
   select case (is_direct_diff)
   case (0) 
      rchi_us(:,:) = 0.d0
      do lt = 1,num_ltx_us
         ips = ips_lt_us(lt)
         tt  = t_lt_us(lt)
         ln  = ln_lt_us(lt)
         tn  = tn_lt_us(lt)
         select case (is_val_type_ps(ips))
         case (TM91) 
            do ir = 1,nmesh
               rchi_us(ir,lt) = &
! ============================================= modiifed by K. T. ======= 4.0
!                  (veff_ps(ir,ips,1) - vloc_scr_us(ir)) &
                  (veff_ps(ir,ips,1) - vloc_scr_us(ir,1)) &
! ======================================================================== 4.0
                     * rphi_us(ir,lt)
            end do
         case (US90) 
            nrc = nrcut_phi_us(lt)
            call calc_poly_rchi(1,nrc,rpos,ln, &
               ncoeff_phi_us,coeff_phi_us(0,lt), &
               eref_us(lt),rphi_us(1,lt),vloc_scr_us, &
               rchi_us(1,lt))
            do ir = nrc+1,nmesh
               ispin = 1
               if (is_core == PATOM) then
                  ll_core = ln
               else
                  ll_core = lmax_core
               end if
               rchi_us(ir,lt) = &
! ================================================ modified by K. T. ======== 4.0
!                  (veff(ir,ispin,ll_core) - vloc_scr_us(ir)) &
                  (veff(ir,ispin,ll_core) - vloc_scr_us(ir,ispin)) &
! =========================================================================== 4.0
                     * rphi_us(ir,lt)
            end do
            if (is_debug_here /= 0) then
               write(IFLOG,*) 'RCHI: ln,tn,ncoeff ...',&
                                     ln,tn,ncoeff_phi_us
               write(IFLOG,'(8(1pe15.5))') &
                  (coeff_phi_us(icoeff,lt),icoeff=0,ncoeff_phi_us)
            end if
         end select
      end do
   case (1)
      drphi_us(:,:)  = 0.d0
      ddrphi_us(:,:) = 0.d0
      iord_diff_tmp = 10
      do lt = 1,num_ltx_us
         call calc_ddiff_exp(ier,iord_diff_tmp, &
               nrcut_phi_max_us,rpos(1), &
               rphi_us(1,lt),drphi_us(1,lt), &
               ddrphi_us(1,lt))
      end do
      rchi_us(:,:) = 0.d0
      do lt = 1,num_ltx_us
         ln = l_lt_us(lt)
         do ir = 1,nrcut_phi_max_us
            rchi_us(ir,lt) = &
                + 0.5d0 * ddrphi_us(ir,lt) &
                + ( + eref_us(lt) &
                    - 0.5d0*dble(ln*(ln+1))/rpos(ir)**2 &
! ============================================== modified by K. T. ======== 4.0
!                    - vloc_scr_us(ir) ) * rphi_us(ir,lt)
                    - vloc_scr_us(ir,1) ) * rphi_us(ir,lt)
! ========================================================================== 4.0
         end do
      end do
   case (2) 
      rchi_us(:,:) = 0.d0
      do lt = 1,num_ltx_us
         ips = ips_lt_us(lt)
         tt  = t_lt_us(lt)
         ln  = ln_lt_us(lt)
         tn  = tn_lt_us(lt)
         select case (is_val_type_ps(ips))
         case (TM91) 
            do ir = 1,nmesh
               rchi_us(ir,lt) = &
! ============================================= modified by K. T. ============ 4.0
!                  (veff_ps(ir,ips,1) - vloc_scr_us(ir)) &
                  (veff_ps(ir,ips,1) - vloc_scr_us(ir,1)) &
! ============================================================================ 4.0
                     * rphi_us(ir,lt)
            end do
         case (US90)
            nrc = nrcut_phi_us(lt)
            nrc2 = nrcut_max_us
            call calc_poly_rchi(1,nrc,rpos,ln, &
               ncoeff_phi_us,coeff_phi_us(0,lt), &
               eref_us(lt),rphi_us(1,lt),vloc_scr_us, &
               rchi_us(1,lt))
            if (nrc2 > nrc) then
               drphi_us(:,:)  = 0.d0
               ddrphi_us(:,:) = 0.d0
               iord_diff_tmp = 10
               call calc_ddiff_exp(ier,iord_diff_tmp, &
                     nrcut_phi_max_us,rpos(1), &
                     rphi_us(1,lt),drphi_us(1,lt), &
                     ddrphi_us(1,lt))
               do ir = nrc+1,nrc2
                  ispin = 1
                  if (is_core == PATOM) then
                     ll_core = ln
                  else
                     ll_core = lmax_core
                  end if
                  rchi_us(ir,lt) = &
                      + 0.5d0 * ddrphi_us(ir,lt) &
! ======================================================== modified by K. T. ====== 4.0
!                      + ( + eref_us(lt) - vloc_scr_us(ir) &
                      + ( + eref_us(lt) - vloc_scr_us(ir,1) &
! ================================================================================ 4.0
                          - 0.5d0*dble(ln*(ln+1))/rpos(ir)**2 &
                        ) * rphi_us(ir,lt)
               end do
            end if
            if (is_debug_here /= 0) then
               write(IFLOG,*) 'RCHI: ln,tn,ncoeff ...',&
                                     ln,tn,ncoeff_phi_us
               write(IFLOG,'(8(1pe15.5))') &
                  (coeff_phi_us(icoeff,lt),icoeff=0,ncoeff_phi_us)
            end if
         end select
      end do
   end select
   write(IFLOG,*) 'RCHI: nref_ps       ',(nref_ps(ips),ips=1,nps)
   write(IFLOG,*) 'RCHI: is_val_type_ps',(is_val_type_ps(ips),ips=1,nps)
   write(IFLOG,*) '      ir, rpos, rchi'
   do ir = 1,nmesh,100
      write(IFLOG,'(i5,8(1pe15.5))') &
         ir,rpos(ir), &
         (rchi_us(ir,lt),lt=1,num_ltx_us)
   end do
   do lt = 1,num_ltx_us
   do ir = 1,nmesh
      if (abs(rchi_us(ir,lt)) < 1.d-99) then
         rchi_us(ir,lt) = 0.d0
      end if
   end do
   end do
99 continue
   end subroutine calc_rchi_us
!=====================================================================

! ================================== addd by K. T. ===================== 4.0
subroutine calc_rchi_us_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ishell
  
  integer :: lt, ln, tn, ir, is_direct_diff, ispin, icoeff, &
       is_debug_here, nrc, nrc2, iord_diff_tmp, ll_core, ips, tt

  real(8) :: vloc_tmp(nmesh)

  is_debug_here = 1
  if (is_debug /= 0) then
     is_debug_here = is_debug
  end if
  ier = 0
  is_direct_diff = 0

  select case (is_direct_diff)

  case (0) 
     rchi_us(:,:) = 0.d0
     do lt = 1,num_ltx_us
        ips = ips_lt_us(lt)
        tt  = t_lt_us(lt)
        ln  = ln_lt_us(lt)
        tn  = tn_lt_us(lt)

        ishell = ishell_ps(ips,1)
        ispin = (1-spin(ishell))/2 + 1

        select case (is_val_type_ps(ips))

        case (TM91) 
           if ( ispin == 1 ) then
              do ir = 1,nmesh
                 rchi_us(ir,lt) = &
                      (veff_ps(ir,ips,1) - vloc_scr_us(ir,1)) &
                      * rphi_us(ir,lt)
              end do
           else if ( ispin ==2 ) then
              do ir = 1,nmesh
                 rchi_us(ir,lt) = &
                      (veff_ps(ir,ips,1) - vloc_scr_us(ir,2)) &
                      * rphi_us(ir,lt)
              end do
           endif

        case (US90) 
           nrc = nrcut_phi_us(lt)

           if ( ispin == 1 ) then
              vloc_tmp(1:nmesh) = vloc_scr_us(1:nmesh,1)
           else if ( ispin == 2 ) then
              vloc_tmp(1:nmesh) = vloc_scr_us(1:nmesh,2)
           endif

           call calc_poly_rchi(1,nrc,rpos,ln, &
                ncoeff_phi_us,coeff_phi_us(0,lt), &
                eref_us(lt),rphi_us(1,lt),vloc_tmp, &
                rchi_us(1,lt))

           do ir = nrc+1,nmesh
              if (is_core == PATOM) then
                 ll_core = ln
              else
                 ll_core = lmax_core
              end if
              rchi_us(ir,lt) = &
                   (veff(ir,ispin,ll_core) - vloc_tmp(ir)) &
                   * rphi_us(ir,lt)
           end do

           if (is_debug_here /= 0) then
              write(IFLOG,*) 'RCHI: ln,tn, sn, ncoeff ...',&
                   ln,tn,ispin, ncoeff_phi_us
              write(IFLOG,'(8(1pe15.5))') &
                   (coeff_phi_us(icoeff,lt),icoeff=0,ncoeff_phi_us)
           end if
        end select
     end do

  case (1)
     drphi_us(:,:)  = 0.d0
     ddrphi_us(:,:) = 0.d0
     iord_diff_tmp = 10
     do lt = 1,num_ltx_us
        call calc_ddiff_exp(ier,iord_diff_tmp, &
             nrcut_phi_max_us,rpos(1), &
             rphi_us(1,lt),drphi_us(1,lt), &
             ddrphi_us(1,lt))
     end do
     rchi_us(:,:) = 0.d0
     do lt = 1,num_ltx_us
        ln = l_lt_us(lt)

        ishell = ishell_ps(ips,1)
        ispin = (1-spin(ishell))/2 + 1

        if ( ispin == 1 ) then
           do ir = 1,nrcut_phi_max_us
              rchi_us(ir,lt) = &
                   + 0.5d0 * ddrphi_us(ir,lt) &
                   + ( + eref_us(lt) &
                   - 0.5d0*dble(ln*(ln+1))/rpos(ir)**2 &
                   - vloc_scr_us(ir,ispin) ) * rphi_us(ir,lt)
           end do
        else if ( ispin == 2 ) then
           do ir = 1,nrcut_phi_max_us
              rchi_us(ir,lt) = &
                   + 0.5d0 * ddrphi_us(ir,lt) &
                   + ( + eref_us(lt) &
                   - 0.5d0*dble(ln*(ln+1))/rpos(ir)**2 &
                   - vloc_scr_us(ir,ispin) ) * rphi_us(ir,lt)
           end do
        endif

     end do

  case (2) 
     rchi_us(:,:) = 0.d0
     do lt = 1,num_ltx_us
        ips = ips_lt_us(lt)
        tt  = t_lt_us(lt)
        ln  = ln_lt_us(lt)
        tn  = tn_lt_us(lt)

        ishell = ishell_ps(ips,1)
        ispin = (1-spin(ishell))/2 + 1

        select case (is_val_type_ps(ips))

        case (TM91) 
           if ( ispin == 1 ) then
              do ir = 1,nmesh
                 rchi_us(ir,lt) = &
                      (veff_ps(ir,ips,1) - vloc_scr_us(ir,1)) &
                      * rphi_us(ir,lt)
              end do
           else if ( ispin==2 ) then
              do ir = 1,nmesh
                 rchi_us(ir,lt) = &
                      (veff_ps(ir,ips,1) - vloc_scr_us(ir,2)) &
                      * rphi_us(ir,lt)
              end do
           endif

        case (US90)
           nrc = nrcut_phi_us(lt)
           nrc2 = nrcut_max_us

           if ( ispin == 1 ) then
              vloc_tmp(1:nmesh) = vloc_scr_us(1:nmesh,1)
           else if ( ispin == 2 ) then
              vloc_tmp(1:nmesh) = vloc_scr_us(1:nmesh,2)
           endif

           call calc_poly_rchi(1,nrc,rpos,ln, &
                ncoeff_phi_us,coeff_phi_us(0,lt), &
                eref_us(lt),rphi_us(1,lt),vloc_tmp, &
                rchi_us(1,lt))

           if (nrc2 > nrc) then
              drphi_us(:,:)  = 0.d0
              ddrphi_us(:,:) = 0.d0
              iord_diff_tmp = 10
              call calc_ddiff_exp(ier,iord_diff_tmp, &
                   nrcut_phi_max_us,rpos(1), &
                   rphi_us(1,lt),drphi_us(1,lt), &
                   ddrphi_us(1,lt))

              do ir = nrc+1,nrc2
                 if (is_core == PATOM) then
                    ll_core = ln
                 else
                    ll_core = lmax_core
                 end if
                 rchi_us(ir,lt) = &
                      + 0.5d0 * ddrphi_us(ir,lt) &
                      + ( + eref_us(lt) - vloc_tmp(ir) &
                      - 0.5d0*dble(ln*(ln+1))/rpos(ir)**2 &
                      ) * rphi_us(ir,lt)
              end do
           end if

           if (is_debug_here /= 0) then
              write(IFLOG,*) 'RCHI: ln,tn, sn,ncoeff ...',&
                   ln,tn, ispin, ncoeff_phi_us
              write(IFLOG,'(8(1pe15.5))') &
                   (coeff_phi_us(icoeff,lt),icoeff=0,ncoeff_phi_us)
           end if

        end select
     end do
  end select

  write(IFLOG,*) 'RCHI: nref_ps       ',(nref_ps(ips),ips=1,nps)
  write(IFLOG,*) 'RCHI: is_val_type_ps',(is_val_type_ps(ips),ips=1,nps)
  write(IFLOG,*) '      ir, rpos, rchi'

  do ir = 1,nmesh,100
     write(IFLOG,'(i5,8(1pe15.5))') &
          ir,rpos(ir), &
          (rchi_us(ir,lt),lt=1,num_ltx_us)
  end do

  do lt = 1,num_ltx_us
     do ir = 1,nmesh
        if (abs(rchi_us(ir,lt)) < 1.d-99) then
           rchi_us(ir,lt) = 0.d0
        end if
     end do
  end do

99 continue

end subroutine calc_rchi_us_kt
! ============================================================================ 4.0

!=====================================================================
   subroutine calc_bmat_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ll, tn, tm, lt1, lt2, ltt, ir, is_debug_here
   real(8) :: sum
   is_debug_here = 1
   if (is_debug /= 0) then
      is_debug_here = is_debug
   end if
   ier = 0
   bmat_us(:) = 0.d0
   do ltt = 1,num_lttx_us
      ll  = l_ltt_us(ltt)
      tn  = tn_ltt_us(ltt)
      tm  = tm_ltt_us(ltt)
      lt1 = lt_n_us(ll,tn)
      lt2 = lt_n_us(ll,tm)
      sum = 0.d0
      do ir = 1,nmesh
         sum = sum &
            + wr(ir) * rphi_us(ir,lt1) * rchi_us(ir,lt2)
      end do
      bmat_us(ltt) = sum
      if (is_debug_here /= 0) then
         write(IFLOG,*) 'BMAT: l,tn,tm,bmat_us ...',&
                               ll,tn,tm,sum
      end if
   end do
99 continue
   end subroutine calc_bmat_us
!=====================================================================

! ==================================== added by K. T. ================== 4.0
subroutine calc_bmat_us_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ll, tn, tm, lt1, lt2, ltt, ir, is_debug_here
  integer :: ispin1, ispin2, itmp1, itmp2
  real(8) :: sum

  is_debug_here = 1
  if (is_debug /= 0) then
     is_debug_here = is_debug
  end if

  ier = 0
  bmat_us(:) = 0.d0

  do ltt = 1,num_lttx_us
     ll  = l_ltt_us(ltt)
     tn  = tn_ltt_us(ltt)
     tm  = tm_ltt_us(ltt)
!
     ispin1 = spin1_index_ltt_us(ltt)
     ispin2 = spin2_index_ltt_us(ltt)
!
     itmp1 = tn + nref_max_us *(ispin1 -1)
     itmp2 = tm + nref_max_us *(ispin2 -1)
!
     lt1 = lt_n_us(ll,itmp1)
     lt2 = lt_n_us(ll,itmp2)
!
     if ( ispin1 /= ispin2 ) cycle

     sum = 0.d0
     do ir = 1,nmesh
        sum = sum &
             + wr(ir) * rphi_us(ir,lt1) * rchi_us(ir,lt2)
     end do
     bmat_us(ltt) = sum
     if (is_debug_here /= 0) then
        write(IFLOG,*) 'BMAT: l,tn,sn,tm,sm,bmat_us ...',&
             ll,tn, ispin1, tm, ispin2, sum
     end if
  end do

99 continue

end subroutine calc_bmat_us_kt
! =========================================================================== 4.0

!=====================================================================
   subroutine calc_rbeta_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ll, tn, tm, lt1, lt2, ir, is_debug_here, &
              nref, ltt, lt, ips
   real(8) :: sum, det, arg, fac
   real(8),allocatable :: bmat(:,:), binv(:,:), bchk(:,:)
   is_debug_here = 1
   if (is_debug /= 0) then
      is_debug_here = is_debug
   end if
   ier = 0
   rbeta_us(:,:) = 0.d0
   do ll = 0,lmax
      nref = nref_us(ll)
      if (ll /= lloc) then
         if (nref == 0) then
            cycle
         end if
        !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         allocate(bmat(nref,nref),binv(nref,nref),bchk(nref,nref))
            bmat = 0.d0 ; binv = 0.d0 ; bchk = 0.d0
        !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         bmat(:,:) = 0.d0
         do tn = 1,nref
            do tm = 1,nref
               ltt = ltt_nm_us(ll,tn,tm)
               bmat(tn,tm) = bmat_us(ltt)
               write(IFLOG,*) '[calc_rbeta_us] l,tn,tm,bmat ...', &
                    ll,tn,tm,bmat(tn,tm)
            end do
         end do

         call det_real_matrix(ier,nref,bmat,det)
         call inv_real_matrix(ier,nref,bmat,binv)
         write(IFLOG,*) '### CHECK ### det(Bnm) ...',det

         do ir = 1,nmesh
            do tn = 1,nref
               do tm = 1,nref
                  lt1 = lt_n_us(ll,tn)
                  lt2 = lt_n_us(ll,tm)
                  rbeta_us(ir,lt1) = rbeta_us(ir,lt1) &
                       + binv(tm,tn) * rchi_us(ir,lt2)
               end do
            end do
         end do

         do tn = 1,nref
            lt1 = lt_n_us(ll,tn)
            sum = 0.d0
            do ir = 1,nmesh
               sum = sum + wr(ir) * rbeta_us(ir,lt1)**2
            end do
            if (is_debug_here /= 0) then
               write(IFLOG,*) 'BETA: ln,tn,<beta|beta>',ll,tn,sum
            end if
         end do
         bchk = matmul(bmat,binv)
         write(IFLOG,*) 'BCHK: ll, nref ...',ll,nref
         write(IFLOG,*) 'bmat:'
         do tn = 1,nref
            write(IFLOG,10) (bmat(tn,tm),tm=1,nref)
         end do
         write(IFLOG,*) 'binv:'
         do tn = 1,nref
            write(IFLOG,10) (binv(tn,tm),tm=1,nref)
         end do
         write(IFLOG,*) 'bchk:'
         do tn = 1,nref
            write(IFLOG,10) (bchk(tn,tm),tm=1,nref)
         end do
      10 format(5(1pe15.5))
         do tn = 1,nref
         do tm = 1,nref
            if (tn == tm) then
               if (abs(bchk(tn,tm) - 1.d0) > 1.d-6) then
                  write(IFLOG,*) &
                     '### ERROR ### bmat * binv (diag) != 1'
                  write(IFLOG,*) '   ll ...',ll
                  ier = 1 ; go to 99
               end if
            else
               if (abs(bchk(tn,tm)) > 1.d-6) then
                  write(IFLOG,*) &
                     '### ERROR ### bmat * binv (off-diag) != 1'
                  write(IFLOG,*) '   ll ...',ll
                  ier = 2 ; go to 99
               end if
            end if
         end do
         end do
        !+++++++++++++++++++++++++++
         deallocate(bmat,binv,bchk)
        !+++++++++++++++++++++++++++
      else if (ll == lloc) then
         if (nref /= 1) then
            write(IFLOG,*) '### ERROR ### nref != 1 for local orbital'
            write(IFLOG,*) '   ll   ...',ll
            write(IFLOG,*) '   nref ...',nref
            ier = 1 ; go to 99
         end if
         lt = lt_n_us(ll,1)
         select case (is_projector_type)
         case (MANUAL)
            do ir = nmesh,1,-1
               if (rpos(ir) < rcut_beta) then
                  nrcut_beta = ir ; exit
               end if
               if (ir < 10) then
                  write(IFLOG,*) '### ERROR ### nrcut_beta was not found.'
                  ier = 1 ; go to 99
               end if
            end do
            call set_weight_exp(ier,1,nrcut_beta,rpos,wt)
            rbeta_us(:,lt) = 0.d0
            do ir=1,nrcut_beta
               arg = min(kappa_beta*(rpos(ir)-rcut_beta)**2,ARGMAX)
               fac = 1.d0 - exp(-arg)
               rbeta_us(ir,lt) = fac*rphi_us(ir,lt)
            end do
            sum = 0.d0
            do ir = 1,nmesh
               sum = sum + wr(ir) * rbeta_us(ir,lt) * rphi_us(ir,lt)
            end do
            rbeta_us(:,lt) = rbeta_us(:,lt)/sum
         case default
            rbeta_us(:,lt) = 0.d0
         end select            
      end if
   end do
   write(IFLOG,*) 'DUAL: l, tn, tm, <phi[l,tn] | beta[l,tm]>'
   do ll = 0,lmax
      nref = nref_us(ll)
      if ((ll /= lloc).or.(is_projector_type /= NONE)) then
         do tn = 1,nref
         do tm = 1,nref
            lt1 = lt_n_us(ll,tn)
            lt2 = lt_n_us(ll,tm)
            sum = 0.d0
            do ir = 1,nmesh
               sum = sum + wr(ir) &
                   * rphi_us(ir,lt1) * rbeta_us(ir,lt2)
            end do
            write(IFLOG,*) ll,tn,tm,sum
            if (((tn == tm).and.(abs(1.d0-sum) > 1.d-6)).or. &
                ((tn /= tm).and.(abs(sum) > 1.d-6))) then
               write(IFLOG,*) &
                  '### ERROR ### <phi[n] | beta[m]> != delta[nm]'
               write(IFLOG,*) '   tn,tm ...',tn,tm
               write(IFLOG,*) '   sum   ...',sum
               ier = 1 ; go to 99
            end if
         end do
         end do
      end if
   end do
   write(IFLOG,*) 'RBETA: nref_us       ',(nref_us(ll),ll=0,lmax)
   write(IFLOG,*) 'RBETA: nref_ps       ',(nref_ps(ips),ips=1,nps)
   write(IFLOG,*) 'RBETA: is_val_type_ps',(is_val_type_ps(ips),ips=1,nps)
   write(IFLOG,*) '       ir, rpos, rbeta'
   do ir = 1,nmesh,100
      write(IFLOG,'(i5,8(1pe15.5))') &
         ir,rpos(ir), &
         (rbeta_us(ir,lt),lt=1,num_ltx_us)
   end do
   do lt = 1,num_ltx_us
   do ir = 1,nmesh
      if (abs(rbeta_us(ir,lt)) < 1.d-99) then
         rbeta_us(ir,lt) = 0.d0
      end if
   end do
   end do
99 continue
   end subroutine calc_rbeta_us

!=========================== added by K. T. ========================== 4.0
subroutine calc_rbeta_us_kt(ier)
  use parameters
  implicit none
  
  integer,intent(out) :: ier
  integer :: ll, tn, tm, lt1, lt2, ir, is_debug_here, &
       nref, ltt, lt, ips
  integer :: ispin, nref_s
  integer :: ispin1, ispin2, itmp1, itmp2

  real(8) :: sum, det, arg, fac
  real(8),allocatable :: bmat(:,:), binv(:,:), bchk(:,:)

  is_debug_here = 1
  if (is_debug /= 0) then
     is_debug_here = is_debug
  end if

  ier = 0
  rbeta_us(:,:) = 0.d0

  do ll = 0,lmax
     nref = nref_us(ll)
     nref_s = nref *nspin

     if (ll /= lloc) then
        if (nref == 0) then
           cycle
        end if

        !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        allocate(bmat(nref_s,nref_s), &
             &   binv(nref_s,nref_s), &
             &   bchk(nref_s,nref_s))
        bmat = 0.d0 ; binv = 0.d0 ; bchk = 0.d0
        !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

        do tn = 1,nref_s
           do tm = 1,nref_s

              if ( tn <= nref ) then
                 itmp1 = tn
              else
                 itmp1 = nref_max_us +( tn -nref )
              endif
              if ( tm <= nref ) then
                 itmp2 = tm
              else
                 itmp2 = nref_max_us +( tm -nref )
              endif

              ltt = ltt_nm_us(ll,itmp1,itmp2)

              bmat(tn,tm) = bmat_us(ltt)
              write(IFLOG,*) '[calc_rbeta_us_kt] l,tns,tms,bmat ...', &
                   ll,tn,tm,bmat(tn,tm)
           end do
        end do
        
        call det_real_matrix(ier,nref_s,bmat,det)
        call inv_real_matrix(ier,nref_s,bmat,binv)
        write(IFLOG,*) '### CHECK ### det(Bnm) ...',det
        
        do ir = 1,nmesh
           do tn = 1,nref_s
              do tm = 1,nref_s

                 if ( tn <= nref ) then
                    itmp1 = tn
                 else
                    itmp1 = nref_max_us +( tn -nref )
                 endif
                 if ( tm <= nref ) then
                    itmp2 = tm
                 else
                    itmp2 = nref_max_us +( tm -nref )
                 endif

                 lt1 = lt_n_us(ll,itmp1)
                 lt2 = lt_n_us(ll,itmp2)

                 ispin1 =  spin_index_lt_us(lt1)
                 ispin2 =  spin_index_lt_us(lt2)

                 if ( ispin1 == ispin2 ) then
                    rbeta_us(ir,lt1) = rbeta_us(ir,lt1) &
                         + binv(tm,tn) * rchi_us(ir,lt2)
                 endif

              end do
           end do
        end do
        
        do tn = 1,nref_s

           if ( tn <= nref ) then
              itmp1 = tn
           else
              itmp1 = nref_max_us +( tn -nref )
           endif

           lt1 = lt_n_us(ll,itmp1)

           sum = 0.d0
           do ir = 1,nmesh
              sum = sum + wr(ir) * rbeta_us(ir,lt1)**2
           end do
           if (is_debug_here /= 0) then
              write(IFLOG,*) 'BETA: ln,tns,<beta|beta>',ll,tn,sum
           end if
        end do

        bchk = matmul(bmat,binv)
        write(IFLOG,*) 'BCHK: ll, nref, nspin  ...',ll,nref, nspin
        
        write(IFLOG,*) 'bmat:'
        do tn = 1,nref_s
           write(IFLOG,10) (bmat(tn,tm),tm=1,nref_s)
        end do
        
        write(IFLOG,*) 'binv:'
        do tn = 1,nref_s
           write(IFLOG,10) (binv(tn,tm),tm=1,nref_s)
        end do
        
        write(IFLOG,*) 'bchk:'
        do tn = 1,nref_s
           write(IFLOG,10) (bchk(tn,tm),tm=1,nref_s)
        end do

      10 format(5(1pe15.5))

        do tn = 1,nref_s
           do tm = 1,nref_s
              if (tn == tm) then
                 if (abs(bchk(tn,tm) - 1.d0) > 1.d-6) then
                    write(IFLOG,*) &
                         '### ERROR ### bmat * binv (diag) != 1'
                    write(IFLOG,*) '   ll ...',ll
                    ier = 1 ; go to 99
                 end if
              else
                 if (abs(bchk(tn,tm)) > 1.d-6) then
                    write(IFLOG,*) &
                         '### ERROR ### bmat * binv (off-diag) != 1'
                    write(IFLOG,*) '   ll ...',ll
                    ier = 2 ; go to 99
                 end if
              end if
           end do
        end do
        !+++++++++++++++++++++++++++
        deallocate(bmat,binv,bchk)
        !+++++++++++++++++++++++++++

     else if (ll == lloc) then

        if (nref /= 1) then
           write(IFLOG,*) '### ERROR ### nref != 1 for local orbital'
           write(IFLOG,*) '   ll   ...',ll
           write(IFLOG,*) '   nref ...',nref
           ier = 1 ; go to 99
        end if

        Do ispin=1, nspin
           if ( ispin == 1 ) then
              itmp1 = ispin
           else
              itmp1 = nref_max_us + 1
           endif

           lt = lt_n_us(ll,itmp1)

           select case (is_projector_type)

           case (MANUAL)
              do ir = nmesh,1,-1
                 if (rpos(ir) < rcut_beta) then
                    nrcut_beta = ir ; exit
                 end if
                 if (ir < 10) then
                    write(IFLOG,*) '### ERROR ### nrcut_beta was not found.'
                    ier = 1 ; go to 99
                 end if
              end do
           
              call set_weight_exp(ier,1,nrcut_beta,rpos,wt)
              rbeta_us(:,lt) = 0.d0

              do ir=1,nrcut_beta
                 arg = min(kappa_beta*(rpos(ir)-rcut_beta)**2,ARGMAX)
                 fac = 1.d0 - exp(-arg)
                 rbeta_us(ir,lt) = fac*rphi_us(ir,lt)
              end do
              
              sum = 0.d0
              do ir = 1,nmesh
                 sum = sum + wr(ir) * rbeta_us(ir,lt) * rphi_us(ir,lt)
              end do
              rbeta_us(:,lt) = rbeta_us(:,lt)/sum

           case default
              rbeta_us(:,lt) = 0.d0
           end select

        End Do

     end if
  end do

  write(IFLOG,*) 'DUAL: l, tns, tms, <phi[l,tns] | beta[l,tms]>'

  do ll = 0,lmax
     nref = nref_us(ll)

     nref_s = nref *nspin

     if ((ll /= lloc).or.(is_projector_type /= NONE)) then
        do tn = 1,nref_s
           do tm = 1,nref_s

              if ( tn <= nref ) then
                 itmp1 = tn
              else
                 itmp1 = nref_max_us +( tn -nref )
              endif
              if ( tm <= nref ) then
                 itmp2 = tm
              else
                 itmp2 = nref_max_us +( tm -nref )
              endif

              lt1 = lt_n_us(ll,itmp1)
              lt2 = lt_n_us(ll,itmp2)

              ispin1 =  spin_index_lt_us(lt1)
              ispin2 =  spin_index_lt_us(lt2)

              sum = 0.d0

              if ( ispin1 == ispin2 ) then
                 do ir = 1,nmesh
                    sum = sum + wr(ir) &
                         * rphi_us(ir,lt1) * rbeta_us(ir,lt2)
                 end do
              endif

              write(IFLOG,*) ll,tn,tm,sum

              if (((tn == tm).and.(abs(1.d0-sum) > 1.d-6)).or. &
                   ((tn /= tm).and.(abs(sum) > 1.d-6))) then
                 write(IFLOG,*) &
                      '### ERROR ### <phi[n] | beta[m]> != delta[nm]'
                 write(IFLOG,*) '   tns,tms ...',tn,tm
                 write(IFLOG,*) '   sum   ...',sum
                 ier = 1 ; go to 99
              end if
           end do
        end do
     end if
  end do

  write(IFLOG,*) 'RBETA: nref_us       ',(nref_us(ll),ll=0,lmax)
  write(IFLOG,*) 'RBETA: nref_ps       ',(nref_ps(ips),ips=1,nps)
  write(IFLOG,*) 'RBETA: is_val_type_ps',(is_val_type_ps(ips),ips=1,nps)
  write(IFLOG,*) '       ir, rpos, rbeta'

  do ir = 1,nmesh,100
     write(IFLOG,'(i5,8(1pe15.5))') &
          ir,rpos(ir), &
          (rbeta_us(ir,lt),lt=1,num_ltx_us)
  end do

  do lt = 1,num_ltx_us
     do ir = 1,nmesh
        if (abs(rbeta_us(ir,lt)) < 1.d-99) then
           rbeta_us(ir,lt) = 0.d0
        end if
     end do
  end do

99 continue
  
end subroutine calc_rbeta_us_kt
! ============================================================================== 4.0

!=====================================================================
   subroutine calc_qnm_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ltlt, ln, tn, lm, tm, ir, is_debug_here, lt1, lt2
   is_debug_here = 1
   if (is_debug /= 0) then
      is_debug_here = is_debug
   end if
   ier = 0
   q_us(:,:) = 0.d0
   do ltlt = 1,num_ltltx_us
      ln = ln_ltlt_us(ltlt)
      tn = tn_ltlt_us(ltlt)
      lm = lm_ltlt_us(ltlt)
      tm = tm_ltlt_us(ltlt)
      lt1 = lt_n_us(ln,tn)
      lt2 = lt_n_us(lm,tm)
      do ir = 1,nrcut_maxx_us
         q_us(ir,ltlt) = &
             ( rpsi_us(ir,lt1)*rpsi_us(ir,lt2) &
              -rphi_us(ir,lt1)*rphi_us(ir,lt2)) &
              / (rpos(ir)**2)
      end do
   end do
99 continue
   end subroutine calc_qnm_us

!============================ added by K. T. ============================== 4.0
subroutine calc_qnm_us_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ltlt, ln, tn, lm, tm, ir, is_debug_here, lt1, lt2
  integer :: ispin1, ispin2, itmp1, itmp2

  is_debug_here = 1
  if (is_debug /= 0) then
     is_debug_here = is_debug
  end if

  ier = 0
  q_us(:,:) = 0.d0

  do ltlt = 1,num_ltltx_us
     ln = ln_ltlt_us(ltlt)
     tn = tn_ltlt_us(ltlt)
     lm = lm_ltlt_us(ltlt)
     tm = tm_ltlt_us(ltlt)
!
     ispin1 = spin1_index_ltlt_us(ltlt)
     ispin2 = spin2_index_ltlt_us(ltlt)
!
     itmp1 = tn + nref_max_us *(ispin1 -1)
     itmp2 = tm + nref_max_us *(ispin2 -1)
!
     lt1 = lt_n_us(ln,itmp1)
     lt2 = lt_n_us(lm,itmp2)
!
     if ( ispin1 /= ispin2 ) cycle
!
     do ir = 1,nrcut_maxx_us
        q_us(ir,ltlt) = &
             ( rpsi_us(ir,lt1)*rpsi_us(ir,lt2) &
             -rphi_us(ir,lt1)*rphi_us(ir,lt2)) &
             / (rpos(ir)**2)
     end do
  end do

99 continue

end subroutine calc_qnm_us_kt
! ======================================================================== 4.0

!=====================================================================
   subroutine calc_qnm_sum_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ltlt, ltt, ll, tn, tm, is_debug_here
   real(8) :: r
   is_debug_here = 1
   if (is_debug /= 0) then
      is_debug_here = is_debug
   end if
   ier = 0
   q_sum_us(:) = 0.d0
   do ltt = 1,num_lttx_us
      ll   = l_ltt_us(ltt)
      tn   = tn_ltt_us(ltt)
      tm   = tm_ltt_us(ltt)
      ltlt = ltlt_nm_us(ll,tn,ll,tm)
      if (ltlt /= 0) then
         do ir = 1,nmesh
            r = rpos(ir)
            q_sum_us(ltt) = q_sum_us(ltt) &
               + r*r*wr(ir) * q_us(ir,ltlt)
         end do
      else
         q_sum_us(ltt) = 0.d0
      end if
   end do
   write(IFLOG,*) 'q[nm]: l, tn, tm, q[nm]'
   do ltt = 1,num_lttx_us
      ll = l_ltt_us(ltt)
      tn = tn_ltt_us(ltt)
      tm = tm_ltt_us(ltt)
      write(IFLOG,'(3i5,2(1pe20.10))') &
         ll,tn,tm,q_sum_us(ltt)
   end do
99 continue
   end subroutine calc_qnm_sum_us

!============================ added by K. T. ===================== 4.0
subroutine calc_qnm_sum_us_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ir, ltlt, ltt, ll, tn, tm, is_debug_here
  integer :: ispin1, ispin2, itmp1, itmp2

  real(8) :: r

  is_debug_here = 1
  if (is_debug /= 0) then
     is_debug_here = is_debug
  end if

  ier = 0
  q_sum_us(:) = 0.d0

  do ltt = 1,num_lttx_us
     ll   = l_ltt_us(ltt)
     tn   = tn_ltt_us(ltt)
     tm   = tm_ltt_us(ltt)

     ispin1 = spin1_index_ltt_us(ltt)
     ispin2 = spin2_index_ltt_us(ltt)
!
     itmp1 = tn + nref_max_us *(ispin1 -1)
     itmp2 = tm + nref_max_us *(ispin2 -1)

     ltlt = ltlt_nm_us(ll,itmp1,ll,itmp2)

     if (ltlt /= 0) then
        do ir = 1,nmesh
           r = rpos(ir)
           q_sum_us(ltt) = q_sum_us(ltt) &
                + r*r*wr(ir) * q_us(ir,ltlt)
        end do
     else
        q_sum_us(ltt) = 0.d0
     end if
  end do

  write(IFLOG,*) 'q[nm]:'
  write(IFLOG,*) '   l,  tn,  sn,  tm,  sm, q[nm]'
  do ltt = 1,num_lttx_us
     ll = l_ltt_us(ltt)
     tn = tn_ltt_us(ltt)
     tm = tm_ltt_us(ltt)

     ispin1 = spin1_index_ltt_us(ltt)
     ispin2 = spin2_index_ltt_us(ltt)

     write(IFLOG,'(5i5,2(1pe20.10))') &
          ll,tn, ispin1, tm, ispin2, q_sum_us(ltt)
  end do

99 continue

end subroutine calc_qnm_sum_us_kt
! =========================================================================== 4.0

!=====================================================================
   subroutine write_qnm_sum_us(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer :: ltt, ll, tn, tm
   write(ifile,*)
   write(ifile,*) &
    'Integrals of deficit charges : nm = (l,tn,tm)'
   write(ifile,10) 'l','tn','tm','q[nm]'
   do ltt = 1,num_lttx_us
      ll = l_ltt_us (ltt)
      tn = tn_ltt_us(ltt)
      tm = tm_ltt_us(ltt)
      write(ifile,11) ll,tn,tm,q_sum_us(ltt)
   end do
10 format(1x,((1x,a1),2x,(a2),2x,(a2)), &
             (8x,a5,7x))
11 format(1x,(i2,2x,i2,2x,i2),3f20.10)
   end subroutine write_qnm_sum_us


!======================= added by K. T. ================================= 4.0
subroutine write_qnm_sum_us_kt(ifile)
  use parameters
  implicit none

  integer,intent(in) :: ifile
  integer :: ltt, ll, tn, tm
  integer :: ispin1, ispin2

  write(ifile,*)
  write(ifile,*) &
       'Integrals of deficit charges : nm = (l,tn,sn,tm,sm)'
  write(ifile,10) 'l','tn','sn','tm', 'sm', 'q[nm]'

  do ltt = 1,num_lttx_us
     ll = l_ltt_us (ltt)
     tn = tn_ltt_us(ltt)
     tm = tm_ltt_us(ltt)
!
     ispin1 = spin1_index_ltt_us(ltt)
     ispin2 = spin2_index_ltt_us(ltt)

     write(ifile,11) ll,tn, ispin1, tm, ispin2, q_sum_us(ltt)
  end do

10 format(1x,((1x,a1),2x,(a2),2x,(a2),2x,a2,2x,a2), &
        (8x,a5,7x))
11 format(1x,(i2,2x,i2,2x,i2,2x,i2,2x,i2),f20.10)

end subroutine write_qnm_sum_us_kt
! ========================================================================= 4.0

!=====================================================================
   subroutine calc_dmat_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ltt, ll, tn, tm, is_debug_here
   is_debug_here = 1
   if (is_debug /= 0) then
      is_debug_here = is_debug
   end if
   ier = 0
   do ltt = 1,num_lttx_us
      ll = l_ltt_us(ltt)
      tn = tn_ltt_us(ltt)
      tm = tm_ltt_us(ltt)
      dmat_us(ltt) = bmat_us(ltt) &
                     + eref_us(lt_n_us(ll,tm)) * q_sum_us(ltt)
      if (is_debug_here /= 0) then
         write(IFLOG,*) 'D[nm]: l,tn,tm,dmat_us', &
                             ll,tn,tm,dmat_us(ltt)
      end if
   end do
99 continue
   end subroutine calc_dmat_us

!========================== added by K. T. ==================================== 4.0
subroutine calc_dmat_us_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ltt, ll, tn, tm, is_debug_here
  integer :: ispin1, ispin2, itmp1, itmp2

  is_debug_here = 1
  if (is_debug /= 0) then
     is_debug_here = is_debug
  end if

  ier = 0
  do ltt = 1,num_lttx_us
     ll = l_ltt_us(ltt)
     tn = tn_ltt_us(ltt)
     tm = tm_ltt_us(ltt)

     ispin1 = spin1_index_ltt_us(ltt)
     ispin2 = spin2_index_ltt_us(ltt)
!
     itmp1 = tn + nref_max_us *(ispin1 -1)
     itmp2 = tm + nref_max_us *(ispin2 -1)
!
     dmat_us(ltt) = bmat_us(ltt) &
          + eref_us(lt_n_us(ll,itmp2)) * q_sum_us(ltt)

     if (is_debug_here /= 0) then
        write(IFLOG,*) 'D[nm]: l,tn,sn,tm,sm, dmat_us', &
             ll,tn, ispin1, tm, ispin2, dmat_us(ltt)
     end if

  end do

99 continue

end subroutine calc_dmat_us_kt
! =============================================================================== 4.0

!=====================================================================
   subroutine write_qnm_bmat_dmat_us(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer :: ll, tn, tm, ltt
   write(ifile,*)
   write(ifile,*)  'Matrices q[nm], B[nm] & D[nm] : nm = (l,tn,tm)'
   write(ifile,10) 'l','tn','tm','q[nm]','B[nm]','D[nm]'
   do ltt = 1,num_lttx_us
      ll = l_ltt_us(ltt)
      tn = tn_ltt_us(ltt)
      tm = tm_ltt_us(ltt)
         write(ifile,11) ll,tn,tm,q_sum_us(ltt), &
                      bmat_us(ltt),dmat_us(ltt)
   end do
10 format(1x,((1x,a1),2x,(a2),2x,(a2)),3(8x,a5,7x))
11 format(1x,(i2,2x,i2,2x,i2),3f20.10)
   end subroutine write_qnm_bmat_dmat_us

!=====================================================================
   subroutine set_rcut_qps_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ltlt, ln, tn, lm, tm, t1, t2, ips1, ips2, l3, &
              nrc, ir, is_debug_here
   real(8) :: rcut1, rcut2, rcut, r
   is_debug_here = 1
   if (is_debug /= 0) then
      is_debug_here = is_debug
   end if
   ier = 0
   do ltlt = 1,num_ltltx_us
      ln = ln_ltlt_us(ltlt)
      tn = tn_ltlt_us(ltlt)
      lm = lm_ltlt_us(ltlt)
      tm = tm_ltlt_us(ltlt)
      t1 = t1_ltlt_us(ltlt)
      t2 = t2_ltlt_us(ltlt)
      ips1 = ips1_ltlt_us(ltlt)
      ips2 = ips2_ltlt_us(ltlt)
      rcut1 = rin_qps_ps(ips1,t1)
      rcut2 = rin_qps_ps(ips2,t2)
      rcut  = min(rcut1,rcut2)
      SRCH_RC:do ir = nmesh,10,-1
         r = rpos(ir)
         if (r < rcut) then
            nrc = ir ; exit SRCH_RC
         end if
         if (ir <= 10) then
            write(IFLOG,*) '### ERROR ### nrc was not found'
            write(IFLOG,*) '   ln,tn,lm,tm ...',ln,tn,lm,tm
            ier = 1 ; go to 99
         end if
      end do SRCH_RC
      nrcut_qps_us(ltlt,:) = nrc        
      rcut_qps_us (ltlt,:) = rpos(nrc)  
      if (is_debug_here /= 0) then
         write(IFLOG,*) 'QPS: ln,tn,lm,tm,nrcut_qps_us .....', &
                              ln,tn,lm,tm,nrcut_qps_us(ltlt,l3_max_us)
      end if
   end do
   if (allocated(rcl_qps)) then
      do l3 = 0,min(lmax_qps,l3_max_us)
         rcut  = rcl_qps(l3)
         SRCH_RC2:do ir = nmesh,10,-1
            r = rpos(ir)
            if (r < rcut) then
               nrc = ir ; exit SRCH_RC2
            end if
            if (ir <= 10) then
               write(IFLOG,*) '### ERROR ### nrc was not found'
               write(IFLOG,*) '   l3 ...',l3
               ier = 1 ; go to 99
            end if
         end do SRCH_RC2
         nrcut_qps_us(:,l3) = nrc
         rcut_qps_us (:,l3) = rpos(nrc)
         if (is_debug_here /= 0) then
            write(IFLOG,*) 'QPS: l3,nrcut_qps_us .....',l3,nrc
         end if
      end do
     !++++++++++++++++++++
      deallocate(rcl_qps)
     !++++++++++++++++++++
   end if
99 continue
   end subroutine set_rcut_qps_us

! ====================================== added by K. T. ================= 4.0
subroutine set_rcut_qps_us_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ltlt, ln, tn, lm, tm, t1, t2, ips1, ips2, l3, &
              nrc, ir, is_debug_here
  integer :: ispin1, ispin2

  real(8) :: rcut1, rcut2, rcut, r

  is_debug_here = 1
  if (is_debug /= 0) then
     is_debug_here = is_debug
  end if

  ier = 0
  do ltlt = 1,num_ltltx_us
     ln = ln_ltlt_us(ltlt)
     tn = tn_ltlt_us(ltlt)
     lm = lm_ltlt_us(ltlt)
     tm = tm_ltlt_us(ltlt)
     t1 = t1_ltlt_us(ltlt)
     t2 = t2_ltlt_us(ltlt)
!
     ispin1 = spin1_index_ltlt_us(ltlt)
     ispin2 = spin2_index_ltlt_us(ltlt)
!
     ips1 = ips1_ltlt_us(ltlt)
     ips2 = ips2_ltlt_us(ltlt)

     rcut1 = rin_qps_ps(ips1,t1)
     rcut2 = rin_qps_ps(ips2,t2)
     rcut  = min(rcut1,rcut2)

     SRCH_RC:do ir = nmesh,10,-1
        r = rpos(ir)
        if (r < rcut) then
           nrc = ir ; exit SRCH_RC
        end if
        if (ir <= 10) then
           write(IFLOG,*) '### ERROR ### nrc was not found'
           write(IFLOG,*) '   ln,tn,sn, lm,tm, sm...',ln,tn,ispin1, lm,tm, ispin2
           ier = 1 ; go to 99
        end if
     end do SRCH_RC

     nrcut_qps_us(ltlt,:) = nrc        
     rcut_qps_us (ltlt,:) = rpos(nrc)  
     
     if (is_debug_here /= 0) then
        write(IFLOG,*) 'QPS: ln,tn,sn, lm,tm, sm, nrcut_qps_us .....', &
             ln,tn,ispin1, lm,tm, ispin2, nrcut_qps_us(ltlt,l3_max_us)
     end if

  end do

  if (allocated(rcl_qps)) then

     do l3 = 0,min(lmax_qps,l3_max_us)
        rcut  = rcl_qps(l3)

        SRCH_RC2:do ir = nmesh,10,-1
           r = rpos(ir)
           if (r < rcut) then
              nrc = ir ; exit SRCH_RC2
           end if
           if (ir <= 10) then
              write(IFLOG,*) '### ERROR ### nrc was not found'
              write(IFLOG,*) '   l3 ...',l3
              ier = 1 ; go to 99
           end if
        end do SRCH_RC2

        nrcut_qps_us(:,l3) = nrc
        rcut_qps_us (:,l3) = rpos(nrc)

        if (is_debug_here /= 0) then
           write(IFLOG,*) 'QPS: l3,nrcut_qps_us .....',l3,nrc
        end if

     end do

     !++++++++++++++++++++
     deallocate(rcl_qps)
     !++++++++++++++++++++

  end if

99 continue

end subroutine set_rcut_qps_us_kt
! ============================================================================== 4.0


!=====================================================================
   subroutine write_rcut_qps_us(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer :: ltlt, ln, tn, lm, tm, l3
   character(1) :: fn_label_orbital, fn_label_orbital_capital
   write(ifile,*)
   write(ifile,*) &
      'Cutoff radii rin[nmL] : nmL = (ln,tn,lm,tm,L)'
   write(ifile,10) 'ln','tn','lm','tm','L','rin[nmL]','nrin[nmL]'
   !do ltlt = 1,num_ltltx_us
   do ltlt = 1,num_ltlt_us
      ln = ln_ltlt_us(ltlt)
      tn = tn_ltlt_us(ltlt)
      lm = lm_ltlt_us(ltlt)
      tm = tm_ltlt_us(ltlt)
      do l3 = abs(ln-lm),ln+lm,2
         write(ifile,11) ln,tn,lm,tm,l3, &
                         fn_label_orbital(ln),tn, &
                         fn_label_orbital(lm),tm, &
                         fn_label_orbital_capital(l3), &
                         rcut_qps_us(ltlt,l3), &
                         nrcut_qps_us(ltlt,l3)
      end do
   end do
10 format(1x,((a2),2x,(a2),2x,(a2),2x,(a2),2x,(1x,a1)),12x, &
             (8x,a8,4x),(6x,a9))
11 format(1x,(i2,2x,i2,2x,i2,2x,i2,2x,i2), &
             (5x,a1,i1,'-',a1,i1,'-',a1), &
              f20.10,i15)
   end subroutine write_rcut_qps_us

!================================== added by K. T. ======================= 4.0
subroutine write_rcut_qps_us_kt(ifile)
  use parameters
  implicit none

  integer,intent(in) :: ifile
  integer :: ltlt, ln, tn, lm, tm, l3
  integer :: ispin1, ispin2

  character(1) :: fn_label_orbital, fn_label_orbital_capital

  write(ifile,*)
  write(ifile,*) &
       'Cutoff radii rin[nmL] : nmL = (ln,tn,sn,lm,tm,sn,L)'
  write(ifile,10) 'ln','tn','sn', 'lm','tm', 'sn','L','rin[nmL]','nrin[nmL]'

  !do ltlt = 1,num_ltltx_us
  do ltlt = 1,num_ltlt_us
     ln = ln_ltlt_us(ltlt)
     tn = tn_ltlt_us(ltlt)
     lm = lm_ltlt_us(ltlt)
     tm = tm_ltlt_us(ltlt)
!
     ispin1 = spin1_index_ltlt_us(ltlt)
     ispin2 = spin2_index_ltlt_us(ltlt)

     do l3 = abs(ln-lm),ln+lm,2
        write(ifile,11) ln,tn, ispin1, lm,tm, ispin2, l3, &
             fn_label_orbital(ln),tn, &
             fn_label_orbital(lm),tm, &
             fn_label_orbital_capital(l3), &
             rcut_qps_us(ltlt,l3), &
             nrcut_qps_us(ltlt,l3)
     end do
  end do

10 format(1x,((a2),2x,(a2),2x,a5,2x,(a2),2x,(a2),2x,a5,2x,(1x,a1)),12x, &
        (8x,a8,4x),(6x,a9))
11 format(1x,(i2,2x,i2,2x,i4,3x,i2,2x,i2,2x,i4,3x,i2), &
        (5x,a1,i1,'-',a1,i1,'-',a1), &
        f20.10,i15)

end subroutine write_rcut_qps_us_kt
! ============================================================================== 4.0

!=====================================================================
   subroutine calc_qps_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ltlt, ln, tn, lm, tm, l3, nrc, ir, &
              is_debug_here, nk_us, isdiff, n1, n2
   real(8) :: rcut, qint
   real(8),allocatable :: dq_us(:)
   is_debug_here = 1
   if (is_debug /= 0) then
      is_debug_here = is_debug
   end if
   ier = 0
   nk_us = 2
  !++++++++++++++++++++++++++++++++++++++++
   allocate(dq_us(0:nk_us)) ; dq_us = 0.d0
  !++++++++++++++++++++++++++++++++++++++++
   qps_us(:,:,:) = 0.d0
   !do ltlt = 1,num_ltltx_us
   do ltlt = 1,num_ltlt_us
      ln = ln_ltlt_us(ltlt)
      tn = tn_ltlt_us(ltlt)
      lm = lm_ltlt_us(ltlt)
      tm = tm_ltlt_us(ltlt)
      do l3 = abs(ln-lm),ln+lm,2
         write(IFLOG,*)
         write(IFLOG,*)  &
            'Optimizing Qps[nmL](r) (polynomial) ...'
         write(IFLOG,15) 'ltlt,  L :', ln, tn, lm, tm, l3
         nrc = nrcut_qps_us(ltlt,l3)
         rcut = rpos(nrc)
         n1 = nrc - 10 ; n2 = nrc + 10
         if (n1 < 1) then
            n1 = 1 ; n2 = 1 + 10*2
         else if (n2 > nmesh) then
            n1 = nmesh - 10*2 ; n2 = nmesh
         end if
         isdiff = 2
         call diff_exp(ier,isdiff,n1,n2,rpos,q_us(1,ltlt),rcut, &
                       dq_us(0),dq_us(1),dq_us(2))
         call set_weight_exp(ier,1,nrc,rpos,wt)
         qint = 0.d0
         do ir = 1,nrc
            qint = qint + q_us(ir,ltlt) * rpos(ir)**(l3+2) * wt(ir)
         end do
         if (is_qps_type /= NOOPT) then
            call opt_poly_qps(ier,IFLOG,l3,0, &
               nmesh,rpos,q_us(1,ltlt),nk_us,nrc,dq_us(0),qint, &
               ng_qps_us,gmin_qps_us,gmax_qps_us,ncoeff_qps_us, &
               coeff_qps_us(0,ltlt,l3))
            if (ier /= 0) then
               write(IFLOG,*) '### ERROR ### in opt_poly_qps'
               go to 99
            end if
         end if
         qps_us(:,ltlt,l3) = q_us(:,ltlt)
         if (is_qps_type /= NOOPT) then
            call calc_poly_fn(1,nrc,rpos,l3,ncoeff_qps_us, &
                    coeff_qps_us(0,ltlt,l3),qps_us(1,ltlt,l3))
            call check_qps_us(ier,ltlt,l3,nk_us,dq_us,qint)
         end if
      end do
   end do
15 format(1x,a10,6x,(i2,2x,i2,2x,i2,2x,i2),i20)
   do ltlt = 1,num_ltlt_us
      ln = ln_ltlt_us(ltlt)
      tn = tn_ltlt_us(ltlt)
      lm = lm_ltlt_us(ltlt)
      tm = tm_ltlt_us(ltlt)
      do l3 = abs(ln-lm),ln+lm,2
         do ir = 1,nmesh
         if (abs(qps_us(ir,ltlt,l3)) < 1.d-99) then
            qps_us(ir,ltlt,l3) = 0.d0
         end if
         end do
      end do
   end do
99 continue
  !++++++++++++++++++
   deallocate(dq_us)
  !++++++++++++++++++
   end subroutine calc_qps_us


!================================== added by K. T. ==================== 4.0
subroutine calc_qps_us_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ltlt, ln, tn, lm, tm, l3, nrc, ir, &
       is_debug_here, nk_us, isdiff, n1, n2
  integer :: ispin1, ispin2

  real(8) :: rcut, qint
  real(8),allocatable :: dq_us(:)

  is_debug_here = 1
  if (is_debug /= 0) then
     is_debug_here = is_debug
  end if

  ier = 0
  nk_us = 2

  !++++++++++++++++++++++++++++++++++++++++
  allocate(dq_us(0:nk_us)) ; dq_us = 0.d0
  !++++++++++++++++++++++++++++++++++++++++

  qps_us(:,:,:) = 0.d0
  !do ltlt = 1,num_ltltx_us
  do ltlt = 1,num_ltlt_us
     ln = ln_ltlt_us(ltlt)
     tn = tn_ltlt_us(ltlt)
     lm = lm_ltlt_us(ltlt)
     tm = tm_ltlt_us(ltlt)

     ispin1 = spin1_index_ltlt_us(ltlt)
     ispin2 = spin2_index_ltlt_us(ltlt)

     do l3 = abs(ln-lm),ln+lm,2
        write(IFLOG,*)
        write(IFLOG,*)  &
             'Optimizing Qps[nmL](r) (polynomial) ...'
        write(IFLOG,15) 'ltlt,  L :', ln, tn, ispin1, lm, tm, ispin2, l3


        nrc = nrcut_qps_us(ltlt,l3)
        rcut = rpos(nrc)
        n1 = nrc - 10 ; n2 = nrc + 10

        if (n1 < 1) then
           n1 = 1 ; n2 = 1 + 10*2
        else if (n2 > nmesh) then
           n1 = nmesh - 10*2 ; n2 = nmesh
        end if

        isdiff = 2
        call diff_exp(ier,isdiff,n1,n2,rpos,q_us(1,ltlt),rcut, &
             dq_us(0),dq_us(1),dq_us(2))
        call set_weight_exp(ier,1,nrc,rpos,wt)

        qint = 0.d0
        do ir = 1,nrc
           qint = qint + q_us(ir,ltlt) * rpos(ir)**(l3+2) * wt(ir)
        end do

        if (is_qps_type /= NOOPT) then
           call opt_poly_qps(ier,IFLOG,l3,0, &
                nmesh,rpos,q_us(1,ltlt),nk_us,nrc,dq_us(0),qint, &
                ng_qps_us,gmin_qps_us,gmax_qps_us,ncoeff_qps_us, &
                coeff_qps_us(0,ltlt,l3))
           if (ier /= 0) then
              write(IFLOG,*) '### ERROR ### in opt_poly_qps'
              go to 99
           end if
        end if
        qps_us(:,ltlt,l3) = q_us(:,ltlt)
        if (is_qps_type /= NOOPT) then
           call calc_poly_fn(1,nrc,rpos,l3,ncoeff_qps_us, &
                coeff_qps_us(0,ltlt,l3),qps_us(1,ltlt,l3))
           call check_qps_us_kt(ier,ltlt,l3,nk_us,dq_us,qint)
        end if
     end do
  end do

15 format(1x,a10,6x,(i2,2x,i2,2x,i2,2x,i2,2x,i2,2x,i2,2x,i2),i20)

  do ltlt = 1,num_ltlt_us
     ln = ln_ltlt_us(ltlt)
     tn = tn_ltlt_us(ltlt)
     lm = lm_ltlt_us(ltlt)
     tm = tm_ltlt_us(ltlt)

     do l3 = abs(ln-lm),ln+lm,2
        do ir = 1,nmesh
           if (abs(qps_us(ir,ltlt,l3)) < 1.d-99) then
              qps_us(ir,ltlt,l3) = 0.d0
           end if
        end do
     end do
  end do

99 continue

  !++++++++++++++++++
  deallocate(dq_us)
  !++++++++++++++++++

end subroutine calc_qps_us_kt
! ============================================================================= 4.0

!=====================================================================
   subroutine check_qps_us(ier,ltlt,l3,nk_us,dq_us,qint)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer,intent(in)  :: ltlt, l3, nk_us
   real(8),intent(in)  :: dq_us(0:nk_us), qint
   integer :: nrc, ir1, ir2, ir, n1, n2, isdiff, &
              ln, tn, lm, tm, ncoeff, itmp, icoeff
   real(8) :: f0_anal(0:2), f0_num(0:2), &
              fint_anal, fint_num, f_tmp(nmesh), rcut
   ier = 0
   ln = ln_ltlt_us(ltlt)
   tn = tn_ltlt_us(ltlt)
   lm = lm_ltlt_us(ltlt)
   tm = tm_ltlt_us(ltlt)
   f0_anal(:) = 0.d0
   nrc = nrcut_qps_us(ltlt,l3)
   ncoeff = ncoeff_qps_us
   ir1 = nrc
   ir2 = nrc
   call calc_poly_fn( &
      ir1,ir2,rpos,l3,ncoeff_qps_us,coeff_qps_us(0,ltlt,l3),f_tmp)
   f0_anal(0) = f_tmp(nrc)
   call calc_dpoly_fn( &
      ir1,ir2,rpos,l3,ncoeff_qps_us,coeff_qps_us(0,ltlt,l3),f_tmp)
   f0_anal(1) = f_tmp(nrc)
   call calc_ddpoly_fn( &
      ir1,ir2,rpos,l3,ncoeff_qps_us,coeff_qps_us(0,ltlt,l3),f_tmp)
   f0_anal(2) = f_tmp(nrc)
   f0_num(:) = 0.d0
   isdiff = nk_us
   n1 = nrc - 10
   n2 = nrc + 10
   rcut = rpos(nrc)
   call diff_exp(ier,isdiff,n1,n2,rpos,qps_us(1,ltlt,l3),rcut, &
           f0_num(0),f0_num(1),f0_num(2))
   f0_num(0) = qps_us(nrc,ltlt,l3)
   fint_anal = 0.d0
   nrc = nrcut_qps_us(ltlt,l3)
   rcut = rpos(nrc)
   ncoeff = ncoeff_qps_us
   do icoeff = 0,ncoeff_qps_us
      itmp = 2*l3 + 2*icoeff + 3
      fint_anal = fint_anal &
         + coeff_qps_us(icoeff,ltlt,l3) / dble(itmp) &
            * rcut**(itmp)
   end do
   nrc = nrcut_qps_us(ltlt,l3)
   call set_weight_exp(ier,1,nrc,rpos,wt)
   fint_num = 0.d0
   do ir = 1,nrc
      fint_num = fint_num &
         + qps_us(ir,ltlt,l3) * rpos(ir)**(l3+2) * wt(ir)
   end do
   call write_checked_qps_us(IFLOG,ln,tn,lm,tm,l3, &
           nrc,rcut,ncoeff_qps_us,coeff_qps_us(0,ltlt,l3), &
           nk_us,dq_us,f0_anal,f0_num,qint,fint_anal,fint_num)
   call write_checked_qps_us(IFSUM,ln,tn,lm,tm,l3, &
           nrc,rcut,ncoeff_qps_us,coeff_qps_us(0,ltlt,l3), &
           nk_us,dq_us,f0_anal,f0_num,qint,fint_anal,fint_num)
99 continue
   end subroutine check_qps_us

!============================== added by K. T. ===================== 4.0
subroutine check_qps_us_kt(ier,ltlt,l3,nk_us,dq_us,qint)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer,intent(in)  :: ltlt, l3, nk_us
  real(8),intent(in)  :: dq_us(0:nk_us), qint
  integer :: nrc, ir1, ir2, ir, n1, n2, isdiff, &
       ln, tn, lm, tm, ncoeff, itmp, icoeff
  real(8) :: f0_anal(0:2), f0_num(0:2), &
       fint_anal, fint_num, f_tmp(nmesh), rcut
  integer :: ispin1, ispin2

  ier = 0
  ln = ln_ltlt_us(ltlt)
  tn = tn_ltlt_us(ltlt)
  lm = lm_ltlt_us(ltlt)
  tm = tm_ltlt_us(ltlt)

  ispin1 = spin1_index_ltlt_us(ltlt)
  ispin2 = spin2_index_ltlt_us(ltlt)
  
  f0_anal(:) = 0.d0

  nrc = nrcut_qps_us(ltlt,l3)
  ncoeff = ncoeff_qps_us

  ir1 = nrc
  ir2 = nrc

  call calc_poly_fn( &
       ir1,ir2,rpos,l3,ncoeff_qps_us,coeff_qps_us(0,ltlt,l3),f_tmp)
  f0_anal(0) = f_tmp(nrc)

  call calc_dpoly_fn( &
       ir1,ir2,rpos,l3,ncoeff_qps_us,coeff_qps_us(0,ltlt,l3),f_tmp)
  f0_anal(1) = f_tmp(nrc)

  call calc_ddpoly_fn( &
       ir1,ir2,rpos,l3,ncoeff_qps_us,coeff_qps_us(0,ltlt,l3),f_tmp)
  f0_anal(2) = f_tmp(nrc)

  f0_num(:) = 0.d0
  isdiff = nk_us

  n1 = nrc - 10
  n2 = nrc + 10
  rcut = rpos(nrc)

  call diff_exp(ier,isdiff,n1,n2,rpos,qps_us(1,ltlt,l3),rcut, &
       f0_num(0),f0_num(1),f0_num(2))
  f0_num(0) = qps_us(nrc,ltlt,l3)

  fint_anal = 0.d0
  nrc = nrcut_qps_us(ltlt,l3)
  rcut = rpos(nrc)

  ncoeff = ncoeff_qps_us

  do icoeff = 0,ncoeff_qps_us
     itmp = 2*l3 + 2*icoeff + 3
     fint_anal = fint_anal &
          + coeff_qps_us(icoeff,ltlt,l3) / dble(itmp) &
          * rcut**(itmp)
  end do

  nrc = nrcut_qps_us(ltlt,l3)
  call set_weight_exp(ier,1,nrc,rpos,wt)

  fint_num = 0.d0
  do ir = 1,nrc
     fint_num = fint_num &
          + qps_us(ir,ltlt,l3) * rpos(ir)**(l3+2) * wt(ir)
  end do

  call write_checked_qps_us_kt(IFLOG,ln,tn,ispin1,lm,tm,ispin2,l3, &
       nrc,rcut,ncoeff_qps_us,coeff_qps_us(0,ltlt,l3), &
       nk_us,dq_us,f0_anal,f0_num,qint,fint_anal,fint_num)

  call write_checked_qps_us_kt(IFSUM,ln,tn,ispin1,lm,tm,ispin2,l3, &
       nrc,rcut,ncoeff_qps_us,coeff_qps_us(0,ltlt,l3), &
       nk_us,dq_us,f0_anal,f0_num,qint,fint_anal,fint_num)

99 continue

end subroutine check_qps_us_kt
! ======================================================================== 4.0

!=====================================================================
   subroutine write_checked_qps_us(ifile,ln,tn,lm,tm,l3, &
      nrc,rcut,ncoeff,coeff,nk,f0_exact,f0_anal,f0_num, &
      fint_exact,fint_anal,fint_num)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in) :: ifile, ln, tn, lm, tm, l3, nrc, ncoeff, nk
   real(8),intent(in) :: &
      rcut,coeff(0:ncoeff), f0_exact(0:nk), f0_anal(0:nk), &
      f0_num(0:nk), fint_exact, fint_anal, fint_num
   integer :: icoeff, ik               
   write(ifile,*)
   write(ifile,*)  &
      'Vanderbilt ultrasoft Qps[nmL](r) (polynomial) was optimized.'
   write(ifile,15) 'ltlt,  L :', ln, tn, lm, tm, l3
   write(ifile,10) ' rc,  nrc:', rcut, nrc
   write(ifile,11) 'ncoeff,nk:', ncoeff, nk
   do icoeff=0,ncoeff
   write(ifile,12) 'coeff(',2*icoeff,'):', coeff(icoeff)
   end do
   write(ifile,13) 'Qps(rc)','Qps''(rc)','Qps"(rc)'
   write(ifile,14) 'Exact    :',(f0_exact(ik),ik=0,nk)
   write(ifile,14) 'Analytic :',(f0_anal (ik),ik=0,nk)
   write(ifile,14) 'Numerical:',(f0_num  (ik),ik=0,nk)
   write(ifile,16) '<r^L*Qps>'
   write(ifile,14) 'Exact    :',fint_exact
   write(ifile,14) 'Analytic :',fint_anal
   write(ifile,14) 'Numerical:',fint_num
10 format(1x,a10,f20.10,i20)
11 format(1x,a10,2(i20))
12 format(1x,(a6,i2,a2),f20.10)
13 format(1x,10x,(8x,a7,5x),(8x,a8,4x),(8x,a8,4x))
14 format(1x,a10,5(f20.10))
15 format(1x,a10,6x,(i2,2x,i2,2x,i2,2x,i2),i20)
16 format(1x,10x,(8x,a9,3x))
   end subroutine write_checked_qps_us

!================================== added by K. T. ====================== 4.0
subroutine write_checked_qps_us_kt(ifile,ln,tn,ispin1, lm,tm,ispin2, l3, &
     nrc,rcut,ncoeff,coeff,nk,f0_exact,f0_anal,f0_num, &
     fint_exact,fint_anal,fint_num)
  implicit none

  integer,intent(in) :: ifile, ln, tn, lm, tm, l3, nrc, ncoeff, nk
  integer, intent(in) :: ispin1, ispin2

  real(8),intent(in) :: &
       rcut,coeff(0:ncoeff), f0_exact(0:nk), f0_anal(0:nk), &
       f0_num(0:nk), fint_exact, fint_anal, fint_num

  integer :: icoeff, ik               

  write(ifile,*)
  write(ifile,*)  &
       'Vanderbilt ultrasoft Qps[nmL](r) (polynomial) was optimized.'
  write(ifile,15) 'ltlt,  L :', ln, tn, ispin1, lm, tm, ispin2, l3
  write(ifile,10) ' rc,  nrc:', rcut, nrc
  write(ifile,11) 'ncoeff,nk:', ncoeff, nk

  do icoeff=0,ncoeff
     write(ifile,12) 'coeff(',2*icoeff,'):', coeff(icoeff)
  end do

  write(ifile,13) 'Qps(rc)','Qps''(rc)','Qps"(rc)'
  write(ifile,14) 'Exact    :',(f0_exact(ik),ik=0,nk)
  write(ifile,14) 'Analytic :',(f0_anal (ik),ik=0,nk)
  write(ifile,14) 'Numerical:',(f0_num  (ik),ik=0,nk)
  write(ifile,16) '<r^L*Qps>'
  write(ifile,14) 'Exact    :',fint_exact
  write(ifile,14) 'Analytic :',fint_anal
  write(ifile,14) 'Numerical:',fint_num

10 format(1x,a10,f20.10,i20)
11 format(1x,a10,2(i20))
12 format(1x,(a6,i2,a2),f20.10)
13 format(1x,10x,(8x,a7,5x),(8x,a8,4x),(8x,a8,4x))
14 format(1x,a10,5(f20.10))
15 format(1x,a10,6x,(i2,2x,i2,2x,i2,2x,i2,2x,i2,2x,i2,2x,i2),i20)
16 format(1x,10x,(8x,a9,3x))
  
end subroutine write_checked_qps_us_kt
! =========================================================================== 4.0

!=====================================================================
   subroutine calc_qps_vlocqps_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ltlt, ltt, ll, tn, tm, is_debug_here
   real(8) :: r
   is_debug_here = 1
   if (is_debug /= 0) then
      is_debug_here = is_debug
   end if
   ier = 0
   qps_sum_us(:) = 0.d0
   vlocqps_us(:) = 0.d0
   do ltt = 1,num_lttx_us
      ll   = l_ltt_us(ltt)
      tn   = tn_ltt_us(ltt)
      tm   = tm_ltt_us(ltt)
      ltlt = ltlt_nm_us(ll,tn,ll,tm)
      if (ltlt /= 0) then
         do ir = 1,nmesh
            r = rpos(ir)
            qps_sum_us(ltt) = qps_sum_us(ltt) &
               + r*r*wr(ir) * qps_us(ir,ltlt,0)
            vlocqps_us(ltt) = vlocqps_us(ltt) &
! =============================================== modified by K. T. ====== 4.0
!               + r*r*wr(ir) * qps_us(ir,ltlt,0) * vloc_scr_us(ir)
               + r*r*wr(ir) * qps_us(ir,ltlt,0) * vloc_scr_us(ir,1)
! ========================================================================= 4.0
         end do
      else
         qps_sum_us(ltt) = 0.d0
         vlocqps_us(ltt) = 0.d0
      end if
      if (is_debug_here /= 0) then
         write(IFLOG,*) 'q[nm]: l,tn,tm,qps_sum,vlocqps', &
                         ll,tn,tm,qps_sum_us(ltt),vlocqps_us(ltt)
      end if
   end do
   call symmetrize_ltt(num_lttx_us,num_lttx_us, &
      l_ltt_us,tn_ltt_us,tm_ltt_us,qps_sum_us)
   call symmetrize_ltt(num_lttx_us,num_lttx_us, &
      l_ltt_us,tn_ltt_us,tm_ltt_us,vlocqps_us)
   write(IFLOG,*) 'q[nm]: l, tn, tm, q[nm], qps[nm]'
   do ltt = 1,num_lttx_us
      ll = l_ltt_us(ltt)
      tn = tn_ltt_us(ltt)
      tm = tm_ltt_us(ltt)
      write(IFLOG,'(3i5,2(1pe20.10))') &
         ll,tn,tm,q_sum_us(ltt),qps_sum_us(ltt)
   end do
99 continue
   end subroutine calc_qps_vlocqps_us

!==================================== added by K. T. ======================== 4.0
subroutine calc_qps_vlocqps_us_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ir, ltlt, ltt, ll, tn, tm, is_debug_here
  integer :: ispin1, ispin2, itmp1, itmp2
  real(8) :: r

  is_debug_here = 1
  if (is_debug /= 0) then
     is_debug_here = is_debug
  end if

  ier = 0
  qps_sum_us(:) = 0.d0
  vlocqps_us(:) = 0.d0

  do ltt = 1,num_lttx_us
     ll   = l_ltt_us(ltt)
     tn   = tn_ltt_us(ltt)
     tm   = tm_ltt_us(ltt)

     ispin1 = spin1_index_ltt_us(ltt)
     ispin2 = spin2_index_ltt_us(ltt)
!
     itmp1 = tn + nref_max_us *(ispin1 -1)
     itmp2 = tm + nref_max_us *(ispin2 -1)

     ltlt = ltlt_nm_us(ll,itmp1,ll,itmp2)

     if ( ispin1 == ispin2 ) then

        if (ltlt /= 0) then
           do ir = 1,nmesh
              r = rpos(ir)
              qps_sum_us(ltt) = qps_sum_us(ltt) &
                   + r*r*wr(ir) * qps_us(ir,ltlt,0)
              vlocqps_us(ltt) = vlocqps_us(ltt) &
                   + r*r*wr(ir) * qps_us(ir,ltlt,0) * vloc_scr_us(ir,ispin2)
           end do
        else
           qps_sum_us(ltt) = 0.d0
           vlocqps_us(ltt) = 0.d0
        end if
     endif

     if (is_debug_here /= 0) then
        write(IFLOG,*) 'q[nm]: l,tn,sn,tm,sm,qps_sum,vlocqps', &
             ll,tn, ispin1, tm, ispin2, qps_sum_us(ltt),vlocqps_us(ltt)
     end if

  end do

  call symmetrize_ltt_kt( num_lttx_us, num_lttx_us, &
       &                 l_ltt_us, tn_ltt_us, spin1_index_ltt_us, &
       &                           tm_ltt_us, spin2_index_ltt_us, qps_sum_us )

  call symmetrize_ltt_kt( num_lttx_us, num_lttx_us, &
       &                 l_ltt_us, tn_ltt_us, spin1_index_ltt_us, &
       &                           tm_ltt_us, spin2_index_ltt_us, vlocqps_us)

  write(IFLOG,*) 'q[nm]: l, tn, tm, q[nm], qps[nm]'

  do ltt = 1,num_lttx_us
     ll = l_ltt_us(ltt)
     tn = tn_ltt_us(ltt)
     tm = tm_ltt_us(ltt)

     ispin1 = spin1_index_ltt_us(ltt)
     ispin2 = spin2_index_ltt_us(ltt)

     write(IFLOG,'(5i5,2(1pe20.10))') &
          ll,tn, ispin1, tm, ispin2, q_sum_us(ltt),qps_sum_us(ltt)
  end do

99 continue

end subroutine calc_qps_vlocqps_us_kt
! ============================================================================= 4.0

!=====================================================================
   subroutine write_qps_vlocqps_us(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer :: ltt, ll, tn, tm
   write(ifile,*)
   write(ifile,*) &
    'Integrals of deficit charges & <Vloc*Qps[nm]> : nm = (l,tn,tm)'
   write(ifile,10) 'l','tn','tm','q[nm]','qps[nm]','<Vloc*Qps[nm]>'
   do ltt = 1,num_lttx_us
      ll = l_ltt_us (ltt)
      tn = tn_ltt_us(ltt)
      tm = tm_ltt_us(ltt)
      write(ifile,11) ll,tn,tm,q_sum_us(ltt), &
                      qps_sum_us(ltt),vlocqps_us(ltt)
   end do
10 format(1x,((1x,a1),2x,(a2),2x,(a2)), &
             (8x,a5,7x),(8x,a7,5x),(6x,a14))
11 format(1x,(i2,2x,i2,2x,i2),3f20.10)
   end subroutine write_qps_vlocqps_us


!==================================== added by K. T. ============== 4.0
subroutine write_qps_vlocqps_us_kt(ifile)
  use parameters
  implicit none

  integer,intent(in) :: ifile
  integer :: ltt, ll, tn, tm
  integer :: ispin1, ispin2

  write(ifile,*)
  write(ifile,*) &
       'Integrals of deficit charges & <Vloc*Qps[nm]> : nm = (l,tn,sn,tm,sm)'
  write(ifile,10) 'l','tn','sn', 'tm','sm', 'q[nm]','qps[nm]','<Vloc*Qps[nm]>'

  do ltt = 1,num_lttx_us
     ll = l_ltt_us (ltt)
     tn = tn_ltt_us(ltt)
     tm = tm_ltt_us(ltt)

     ispin1 = spin1_index_ltt_us(ltt)
     ispin2 = spin2_index_ltt_us(ltt)

     write(ifile,11) ll,tn, ispin1, tm, ispin2, q_sum_us(ltt), &
          qps_sum_us(ltt),vlocqps_us(ltt)
  end do

10 format(1x,((1x,a1),2x,(a2),2x,(a2),2x,a2,2x,a2), &
        (8x,a5,7x),(8x,a7,5x),(6x,a14))
11 format(1x,(i2,2x,i2,2x,i2,2x,i2,2x,i2),3f20.10)

end subroutine write_qps_vlocqps_us_kt
!============================================================================ 4.0

   subroutine calc_dion_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ltt, ll, tn, tm, is_debug_here
   is_debug_here = 1
   if (is_debug /= 0) then
      is_debug_here = is_debug
   end if
   ier = 0
   do ltt = 1,num_lttx_us
      ll = l_ltt_us(ltt)
      tn = tn_ltt_us(ltt)
      tm = tm_ltt_us(ltt)
      dion_us(ltt) = dmat_us(ltt) - vlocqps_us(ltt)
   end do
   call symmetrize_ltt(num_lttx_us,num_lttx_us, &
      l_ltt_us,tn_ltt_us,tm_ltt_us,dion_us)
   if (is_debug_here /= 0) then
      do ltt = 1,num_lttx_us
         ll = l_ltt_us(ltt)
         tn = tn_ltt_us(ltt)
         tm = tm_ltt_us(ltt)
            write(IFLOG,*) 'Dion[nm]: l,tn,tm,dion_us', &
                                   ll,tn,tm,dion_us(ltt)
      end do
   end if
99 continue
   end subroutine calc_dion_us

! ===================================== added by K. T. ====================== 4.0
subroutine calc_dion_us_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ltt, ll, tn, tm, is_debug_here
  integer :: ispin1, ispin2

  is_debug_here = 1
  if (is_debug /= 0) then
     is_debug_here = is_debug
  end if

  ier = 0
  do ltt = 1,num_lttx_us
     ll = l_ltt_us(ltt)
     tn = tn_ltt_us(ltt)
     tm = tm_ltt_us(ltt)
     dion_us(ltt) = dmat_us(ltt) - vlocqps_us(ltt)
  end do

  call symmetrize_ltt_kt( num_lttx_us, num_lttx_us, &
       &                  l_ltt_us, tn_ltt_us, spin1_index_ltt_us, &
       &                            tm_ltt_us, spin2_index_ltt_us, dion_us )

  if (is_debug_here /= 0) then
     do ltt = 1,num_lttx_us
        ll = l_ltt_us(ltt)
        tn = tn_ltt_us(ltt)
        tm = tm_ltt_us(ltt)

        ispin1 = spin1_index_ltt_us(ltt)
        ispin2 = spin2_index_ltt_us(ltt)

        write(IFLOG,*) 'Dion[nm]: l,tn,sn,tm,sm,dion_us', &
             ll,tn, ispin1, tm, ispin2, dion_us(ltt)

     end do
  end if

99 continue

end subroutine calc_dion_us_kt
! ========================================================================== 4.0

!=====================================================================
   subroutine symmetrize_ltt(na,n,ln,tn,tm,val_ltt)
!=====================================================================
!
!  Symmetrize val_ltt(1:n)
!
!  2007.10.25  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)    :: na, n, ln(na), tn(na), tm(na)
   real(8),intent(inout) :: val_ltt(na)
   real(8),allocatable :: varray(:,:,:)
   integer :: lmin, lmax, tmax, i
   lmax = maxval(ln(1:n))
   lmin = minval(ln(1:n))
   tmax = max(maxval(tn(1:n)),maxval(tm(1:n)))
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++
   allocate(varray(lmin:lmax,tmax,tmax)) ; varray = 0.d0
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++
   do i = 1,n
      varray(ln(i),tn(i),tm(i)) = val_ltt(i)
   end do
   do i = 1,n
      val_ltt(i) = 0.5d0 * ( &
         varray(ln(i),tn(i),tm(i)) + varray(ln(i),tm(i),tn(i)) )
   end do
  !+++++++++++++++++++
   deallocate(varray)
  !+++++++++++++++++++
   end subroutine symmetrize_ltt

!====================================== added by K. T. ====================== 4.0
subroutine symmetrize_ltt_kt(na,n,ln,tn,sn,tm,sm,val_ltt)
  implicit none

  integer,intent(in)    :: na, n, ln(na), tn(na), tm(na)
  integer, intent(in) :: sn(na), sm(na)

  real(8),intent(inout) :: val_ltt(na)
  real(8),allocatable :: varray(:,:,:,:,:)
  integer :: lmin, lmax, tmax, smax, i

  lmax = maxval(ln(1:n))
  lmin = minval(ln(1:n))
  tmax = max(maxval(tn(1:n)),maxval(tm(1:n)))

  smax = max(maxval(sn(1:n)),maxval(sm(1:n)))

  !++++++++++++++++++++++++++++++++++++++++++++++++++++++
  allocate(varray(lmin:lmax,tmax,smax,tmax,smax)) ; varray = 0.d0
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++

  do i = 1,n
     varray(ln(i),tn(i),sn(i),tm(i),sm(i)) = val_ltt(i)
  end do
  do i = 1,n
     val_ltt(i) = 0.5d0 * ( &
          &       varray(ln(i),tn(i),sn(i),tm(i),sm(i)) &
          &     + varray(ln(i),tm(i),sm(i),tn(i),sn(i)) )
  end do
  !+++++++++++++++++++
  deallocate(varray)
  !+++++++++++++++++++
end subroutine symmetrize_ltt_kt
! ============================================================================ 4.0

!=====================================================================
   subroutine write_bmat_dmat_dion_us(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer :: ll, tn, tm, ltt
   write(ifile,*)
   write(ifile,*)  'Matrices B[nm], D[nm] & Dion[nm] : nm = (l,tn,tm)'
   write(ifile,10) 'l','tn','tm','B[nm]','D[nm]','Dion[nm]'
   do ltt = 1,num_lttx_us
      ll = l_ltt_us(ltt)
      tn = tn_ltt_us(ltt)
      tm = tm_ltt_us(ltt)
         write(ifile,11) ll,tn,tm,bmat_us(ltt), &
                      dmat_us(ltt),dion_us(ltt)
   end do
10 format(1x,((1x,a1),2x,(a2),2x,(a2)),2(8x,a5,7x),(8x,a8,4x))
11 format(1x,(i2,2x,i2,2x,i2),3f20.10)
   end subroutine write_bmat_dmat_dion_us

!============================= added by K. T. =========================== 4.0
subroutine write_bmat_dmat_dion_us_kt(ifile)
  use parameters
  implicit none

  integer,intent(in) :: ifile
  integer :: ll, tn, tm, ltt
  integer :: ispin1, ispin2

  write(ifile,*)
  write(ifile,*)  'Matrices B[nm], D[nm] & Dion[nm] : nm = (l,tn,sn,tm,sm)'
  write(ifile,10) 'l','tn','sn', 'tm','sm', 'B[nm]','D[nm]','Dion[nm]'

  do ltt = 1,num_lttx_us
     ll = l_ltt_us(ltt)
     tn = tn_ltt_us(ltt)
     tm = tm_ltt_us(ltt)

     ispin1 = spin1_index_ltt_us(ltt)
     ispin2 = spin2_index_ltt_us(ltt)

     write(ifile,11) ll,tn, ispin1, tm, ispin2, bmat_us(ltt), &
          dmat_us(ltt),dion_us(ltt)
  end do

10 format(1x,((1x,a1),2x,(a2),2x,(a2),2x,a2,2x,a2),2(8x,a5,7x),(8x,a8,4x))
11 format(1x,(i2,2x,i2,2x,i2,2x,i2,2x,i2),3f20.10)

end subroutine write_bmat_dmat_dion_us_kt
! ========================================================================== 4.0
   
!=====================================================================
   subroutine calc_us_fourier(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ig, ll, lt, nrc
   real(8) :: r
   ier = 0
   psi_g_us(:,:) = 0.d0
   phi_g_us(:,:) = 0.d0
   chi_g_us(:,:) = 0.d0
   beta_g_us(:,:) = 0.d0
   do lt = 1,num_ltx_us
      ll = l_lt_us(lt)
     !--- MO-100528 [begin]
      !if (is_bound_us(lt) == 0) then
      !   nrc = nrcut_phi_us(lt)
      !   rphi_us(nrc:nmesh,lt) = rpsi_us(nrc:nmesh,lt)
      !end if
     !--- MO-100528 [end]
      do ir = 1,nmesh
         r = rpos(ir)
         psi_g_us(1,lt) = psi_g_us(1,lt)  & 
            + r*wr(ir) * rpsi_us(ir,lt)
         phi_g_us(1,lt) = phi_g_us(1,lt)  &
            + r*wr(ir) * rphi_us(ir,lt)
         chi_g_us(1,lt) = chi_g_us(1,lt)  &
            + r*wr(ir) * rchi_us(ir,lt)
         beta_g_us(1,lt) = beta_g_us(1,lt)  &
            + r*wr(ir) * rbeta_us(ir,lt)
      end do
      do ig = 2,ng_mesh
         gr_wk(:) = gpos(ig) * rpos(:)
         call bessel_js(ll,nmesh,gr_wk,js_wk)
         do ir = 1,nmesh
            r = rpos(ir)
            psi_g_us(ig,lt) = psi_g_us(ig,lt) &
               + r*wr(ir) * rpsi_us(ir,lt)  * js_wk(ir)
            phi_g_us(ig,lt) = phi_g_us(ig,lt) &
               + r*wr(ir) * rphi_us(ir,lt)  * js_wk(ir)
            chi_g_us(ig,lt) = chi_g_us(ig,lt) &
               + r*wr(ir) * rchi_us(ir,lt)  * js_wk(ir)
            beta_g_us(ig,lt) = beta_g_us(ig,lt) &
               + r*wr(ir) * rbeta_us(ir,lt) * js_wk(ir)
         end do
      end do
   end do
99 continue
   end subroutine calc_us_fourier

!=====================================================================
   subroutine write_us(ier)
!=====================================================================
!
!  M. Okamoto
!     
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ig, nn, ll, tt, ln, tn, lt, ips
   real(8) :: g
   character(1) :: ch_ln, ch_tn, fn_label_orbital
   character(2) :: ch_del, pp_type_tmp
   character(3) :: ch3
   ier = 0
   ch_del = ','//' '
   open(IFUS,file=trim(usfile),status='unknown')
   write(IFUS,*) 'US wave functions and their fourier transforms'
   call write_file_header(IFUS)
   do lt = 1,num_ltx_us
      ips = ips_lt_us(lt)
      nn  = n_lt_us(lt)
      ll  = l_lt_us(lt)
      tt  = t_lt_us(lt)
      ln  = ln_lt_us(lt)
      tn  = tn_lt_us(lt)
      select case (is_val_type_ps(ips))
      case (TM91)
         pp_type_tmp = 'NC'
      case (US90)
         pp_type_tmp = 'US'
      end select
      ch_ln = fn_label_orbital(ll)
      write(ch_tn,'(i1)') tn
      ch3(1:3) = '_'//ch_ln(1:1)//ch_tn(1:1)
      write(IFUS,*)
      write(IFUS,*)  '(n,l,t) --->',nn,ll,tt
      write(IFUS,*)  '(ln,tn) --->',ln,tn
      write(IFUS,*)  'pp_type --->  ',pp_type_tmp
      write(IFUS,20) 'eref    --->',eref_us(lt)
      write(IFUS,20) 'rcut    --->',rpos(nrcut_phi_us(lt))
      write(IFUS,*) &
         'rpos'//ch3//ch_del//'rpsi'//ch3//ch_del//'rphi'//ch3 &
         //ch_del//'rchi'//ch3//ch_del//'rbeta'//ch3
      do ir = 1,nmesh
         write(IFUS,10) rpos(ir), &
            rpsi_us(ir,lt),rphi_us(ir,lt), &
            rchi_us(ir,lt),rbeta_us(ir,lt)
      end do
      write(IFUS,*)
      write(IFUS,*) '(n,l,t) --->',nn,ll,tt
      write(IFUS,*) '(ln,tn) --->',ln,tn
      write(IFUS,*) 'pp_type --->  ',pp_type_tmp
      write(IFUS,*) &
         'gpos'//ch3//ch_del//'gpsi'//ch3//ch_del//'gphi'//ch3 &
         //ch_del//'gchi'//ch3//ch_del//'gbeta'//ch3
      do ig = 1,ng_mesh
         g = gpos(ig)
         write(IFUS,10) g, &
            g*psi_g_us(ig,lt),g*phi_g_us(ig,lt), &
            g*chi_g_us(ig,lt),g*beta_g_us(ig,lt)
      end do
   end do
10 format(10(1pe20.10))
20 format(1x,a12,f20.10)
   close(IFUS)
   end subroutine write_us

! ======================================== added by K. T. ============== 4.0
subroutine write_us_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier

  integer :: ir, ig, nn, ll, tt, ln, tn, lt, ips
  real(8) :: g
  character(1) :: ch_ln, ch_tn, fn_label_orbital
  character(2) :: ch_del, pp_type_tmp
  character(3) :: ch3

  integer :: ispin

  ier = 0
  ch_del = ','//' '

  open(IFUS,file=trim(usfile),status='unknown')
  write(IFUS,*) 'US wave functions and their fourier transforms'

  call write_file_header(IFUS)

  do lt = 1,num_ltx_us
     ips = ips_lt_us(lt)
     nn  = n_lt_us(lt)
     ll  = l_lt_us(lt)
     tt  = t_lt_us(lt)
     ln  = ln_lt_us(lt)
     tn  = tn_lt_us(lt)

     ispin = spin_index_lt_us(lt)

     select case (is_val_type_ps(ips))
     case (TM91)
        pp_type_tmp = 'NC'
     case (US90)
        pp_type_tmp = 'US'
     end select

     ch_ln = fn_label_orbital(ll)
     write(ch_tn,'(i1)') tn

     ch3(1:3) = '_'//ch_ln(1:1)//ch_tn(1:1)
     write(IFUS,*)
     write(IFUS,*)  '(n,l,t,s) --->',nn,ll,tt, ispin
     write(IFUS,*)  '(ln,tn) --->',ln,tn
     write(IFUS,*)  'pp_type --->  ',pp_type_tmp
     write(IFUS,20) 'eref    --->',eref_us(lt)
     write(IFUS,20) 'rcut    --->',rpos(nrcut_phi_us(lt))

     write(IFUS,*) &
          'rpos'//ch3//ch_del//'rpsi'//ch3//ch_del//'rphi'//ch3 &
          //ch_del//'rchi'//ch3//ch_del//'rbeta'//ch3

     do ir = 1,nmesh
        write(IFUS,10) rpos(ir), &
             rpsi_us(ir,lt),rphi_us(ir,lt), &
             rchi_us(ir,lt),rbeta_us(ir,lt)
     end do

     write(IFUS,*)
     write(IFUS,*) '(n,l,t,s) --->',nn,ll,tt, ispin
     write(IFUS,*) '(ln,tn) --->',ln,tn
     write(IFUS,*) 'pp_type --->  ',pp_type_tmp
     write(IFUS,*) &
          'gpos'//ch3//ch_del//'gpsi'//ch3//ch_del//'gphi'//ch3 &
          //ch_del//'gchi'//ch3//ch_del//'gbeta'//ch3

     do ig = 1,ng_mesh
        g = gpos(ig)
        write(IFUS,10) g, &
             g*psi_g_us(ig,lt),g*phi_g_us(ig,lt), &
             g*chi_g_us(ig,lt),g*beta_g_us(ig,lt)
     end do
  end do
10 format(10(1pe20.10))
20 format(1x,a12,f20.10)

  close(IFUS)

end subroutine write_us_kt
! ============================================================================= 4.0

!=====================================================================
   subroutine calc_qps_fourier(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ig, ln, tn, lm, tm, l3, ltlt
   real(8) :: r
   ier = 0
   qps_g_us(:,:,:) = 0.d0
   q_g_us(:,:) = 0.d0
   !do ltlt = 1,num_ltltx_us
   do ltlt = 1,num_ltlt_us
      ln = ln_ltlt_us(ltlt)
      tn = tn_ltlt_us(ltlt)
      lm = lm_ltlt_us(ltlt)
      tm = tm_ltlt_us(ltlt)
      do l3 = abs(ln-lm),ln+lm,2
         do ir = 1,nmesh
            r = rpos(ir)
            qps_g_us(1,ltlt,l3) = qps_g_us(1,ltlt,l3)  &
               + r*r*wr(ir) * qps_us(ir,ltlt,l3)
         end do
         do ig = 2,ng_mesh
            gr_wk(:) = gpos(ig) * rpos(:)
            call bessel_js(l3,nmesh,gr_wk,js_wk)
            do ir = 1,nmesh
               r = rpos(ir)
               qps_g_us(ig,ltlt,l3) = qps_g_us(ig,ltlt,l3) &
                  + r*r*wr(ir) * qps_us(ir,ltlt,l3) * js_wk(ir)
            end do
         end do
      end do
      do ir = 1,nmesh
         r = rpos(ir)
         q_g_us(1,ltlt) = q_g_us(1,ltlt)  &
            + r*r*wr(ir) * q_us(ir,ltlt)
      end do
      do ig = 2,ng_mesh
         gr_wk(:) = gpos(ig) * rpos(:)
         call bessel_js(0,nmesh,gr_wk,js_wk)
         do ir = 1,nmesh
            r = rpos(ir)
            q_g_us(ig,ltlt) = q_g_us(ig,ltlt) &
               + r*r*wr(ir) * q_us(ir,ltlt) * js_wk(ir) 
         end do
      end do
   end do
99 continue
   end subroutine calc_qps_fourier

!=====================================================================

   subroutine write_qps(ier)
!=====================================================================
!
!  M. Okamoto
!     
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ig, ln, tn, lm, tm, l3, ltlt
   real(8) :: r, g
   character(1) :: ch_ln, ch_tn, ch_lm, ch_tm, ch_l3, &
                   fn_label_orbital, fn_label_orbital_capital
   character(2) :: ch_del
   character(5) :: ch5
   character(6) :: ch6
   ier = 0
   ch_del = ','//' '
   open(IFQPS,file=trim(qpsfile),status='unknown')
   write(IFQPS,*) 'Qps[nmL](r) and their fourier transforms'
   call write_file_header(IFQPS)
   !do ltlt = 1,num_ltltx_us
   do ltlt = 1,num_ltlt_us
      ln = ln_ltlt_us(ltlt)
      tn = tn_ltlt_us(ltlt)
      lm = lm_ltlt_us(ltlt)
      tm = tm_ltlt_us(ltlt)
      ch_ln = fn_label_orbital(ln)
      ch_lm = fn_label_orbital(lm)
      write(ch_tn,'(i1)') tn
      write(ch_tm,'(i1)') tm
      ch5(1:5) = '_'//ch_ln(1:1)//ch_tn(1:1) &
                    //ch_lm(1:1)//ch_tm(1:1)
      write(IFQPS,*)
      write(IFQPS,*) 'r*r*Q[nm](r): (ln,tn,lm,tm) --->',ln,tn,lm,tm
      write(IFQPS,*) 'rpos'//ch5//ch_del//'rr_qnm'//ch5
      do ir = 1,nmesh
         r = rpos(ir)
         write(IFQPS,10) r,r*r*q_us(ir,ltlt)
      end do
      write(IFQPS,*)
      write(IFQPS,*) 'G*G*Q[nm](G): (ln,tn,lm,tm) --->',ln,tn,lm,tm
      write(IFQPS,*) 'gpos'//ch5//ch_del//'gg_qnm'//ch5
      do ig = 1,ng_mesh
         g = gpos(ig)
         write(IFQPS,10) g,g*g*q_g_us(ig,ltlt)
      end do
      do l3 = abs(ln-lm),ln+lm,2
         ch_l3 = fn_label_orbital_capital(l3)
         ch6(1:6) = ch5(1:5)//ch_l3(1:1)
         write(IFQPS,*)
         write(IFQPS,*) 'r*r*Qps[nmL](r): (ln,tn,lm,tm,L) --->', &
                                       ln,tn,lm,tm,l3
         write(IFQPS,*) 'rpos'//ch6//ch_del//'rr_qps'//ch6
         do ir = 1,nmesh
            r = rpos(ir)
            write(IFQPS,10) r,r*r*qps_us(ir,ltlt,l3)
         end do
         write(IFQPS,*)
         write(IFQPS,*) 'G*G*Qps[nmL](G): (ln,tn,lm,tm,L) --->', &
                                       ln,tn,lm,tm,l3
         write(IFQPS,*) 'gpos'//ch6//ch_del//'gg_qps'//ch6
         do ig = 1,ng_mesh
            g = gpos(ig)
            write(IFQPS,10) g,g*g*qps_g_us(ig,ltlt,l3)
         end do
      end do
   end do
10 format(10(1pe20.10))
   close(IFQPS)
   end subroutine write_qps

! ==================================== added by K. T. ========================= 4.0
subroutine write_qps_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier

  integer :: ir, ig, ln, tn, lm, tm, l3, ltlt
  integer :: ispin1, ispin2

  real(8) :: r, g
  character(1) :: ch_ln, ch_tn, ch_lm, ch_tm, ch_l3, &
       fn_label_orbital, fn_label_orbital_capital
  character(2) :: ch_del
  character(5) :: ch5
  character(6) :: ch6

  ier = 0
  ch_del = ','//' '

  open(IFQPS,file=trim(qpsfile),status='unknown')
  write(IFQPS,*) 'Qps[nmL](r) and their fourier transforms'

  call write_file_header(IFQPS)
   !do ltlt = 1,num_ltltx_us
  do ltlt = 1,num_ltlt_us
     ln = ln_ltlt_us(ltlt)
     tn = tn_ltlt_us(ltlt)
     lm = lm_ltlt_us(ltlt)
     tm = tm_ltlt_us(ltlt)

     ispin1 = spin1_index_ltlt_us(ltlt)
     ispin2 = spin2_index_ltlt_us(ltlt)

     ch_ln = fn_label_orbital(ln)
     ch_lm = fn_label_orbital(lm)

     write(ch_tn,'(i1)') tn
     write(ch_tm,'(i1)') tm

     ch5(1:5) = '_'//ch_ln(1:1)//ch_tn(1:1) &
          //ch_lm(1:1)//ch_tm(1:1)

     write(IFQPS,*)
     write(IFQPS,*) 'r*r*Q[nm](r): (ln,tn,sn,lm,tm,sm) --->',ln,tn,ispin1, lm,tm, ispin2
     write(IFQPS,*) 'rpos'//ch5//ch_del//'rr_qnm'//ch5

     do ir = 1,nmesh
        r = rpos(ir)
        write(IFQPS,10) r,r*r*q_us(ir,ltlt)
     end do

     write(IFQPS,*)
     write(IFQPS,*) 'G*G*Q[nm](G): (ln,tn,sn,lm,tm,sm) --->',ln,tn,ispin1,lm,tm, ispin2
     write(IFQPS,*) 'gpos'//ch5//ch_del//'gg_qnm'//ch5

     do ig = 1,ng_mesh
        g = gpos(ig)
        write(IFQPS,10) g,g*g*q_g_us(ig,ltlt)
     end do

     do l3 = abs(ln-lm),ln+lm,2
        ch_l3 = fn_label_orbital_capital(l3)
        ch6(1:6) = ch5(1:5)//ch_l3(1:1)

        write(IFQPS,*)
        write(IFQPS,*) 'r*r*Qps[nmL](r): (ln,tn,sn,lm,tm,sm,L) --->', &
             ln,tn,ispin1, lm,tm, ispin2, l3
        write(IFQPS,*) 'rpos'//ch6//ch_del//'rr_qps'//ch6

        do ir = 1,nmesh
           r = rpos(ir)
           write(IFQPS,10) r,r*r*qps_us(ir,ltlt,l3)
        end do

        write(IFQPS,*)
        write(IFQPS,*) 'G*G*Qps[nmL](G): (ln,tn,sn,lm,tm,sm,L) --->', &
             ln,tn, ispin1, lm,tm, ispin2, l3
        write(IFQPS,*) 'gpos'//ch6//ch_del//'gg_qps'//ch6

        do ig = 1,ng_mesh
           g = gpos(ig)
           write(IFQPS,10) g,g*g*qps_g_us(ig,ltlt,l3)
        end do
     end do
  end do

10 format(10(1pe20.10))

  close(IFQPS)

end subroutine write_qps_kt
! ============================================================================ 4.0

!=====================================================================
   subroutine calc_dekin_tkc(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ig, lt, nn, ll, tt, ips, ln, tn, it, ifound
   character(1) :: ch_ln, ch_tn, fn_label_orbital
   character(3) :: ch3
   real(8) :: arg, dekin_tmp, dekin_inf
   integer,allocatable :: igc(:)
   real(8),allocatable :: wgt(:)
   ier = 0
  !++++++++++++++++++++++++++++++++++++
   allocate(igc(ntkc))    ; igc = 0
   allocate(wgt(ng_mesh)) ; wgt = 0.d0
  !++++++++++++++++++++++++++++++++++++
   igc(:) = 0
   do it = 1,ntkc
      GLOOP: do ig = 1,ng_mesh
         if (gpos(ig) > tkc(it)) then
            igc(it) = ig - 1
            exit GLOOP
         end if
      end do GLOOP
   end do
   dekin_tkc(:,:) = 0.d0
   do lt = 1,num_ltx_us
      nn  = n_lt_us(lt)
      ll  = l_lt_us(lt)
      tt  = t_lt_us(lt)
      ln  = ln_lt_us(lt)
      tn  = tn_lt_us(lt)
      ips = ips_lt_us(lt)
      ch_ln = fn_label_orbital(ll)
      write(ch_tn,'(i1)') tn
      ch3(1:3) = '_'//ch_ln(1:1)//ch_tn(1:1)
      write(IFLOG,'(1x,a,5i3,2x,a,a)') &
         'dEkin: n = (n,l,t,ln,tn) -->',nn,ll,tt,ln,tn,'dEkin',ch3
      dekin_tmp = 0.d0
      do ig = 1,ng_mesh
         arg = gpos(ig)*gpos(ig)*phi_g_us(ig,lt)
         dekin_tmp = dekin_tmp + arg*arg*wg(ig)
      end do
      dekin_inf = dekin_tmp / PI
      do it = 1,ntkc
         call set_weight_unif(ier,1,ng_mesh-igc(it)+1,gpos,wgt)
         dekin_tmp = 0.d0
         do ig = igc(it),ng_mesh
            arg = gpos(ig)*gpos(ig)*phi_g_us(ig,lt)
            dekin_tmp = dekin_tmp + arg*arg*wgt(ig-igc(it)+1)
         end do
         dekin_tkc(lt,it) = dekin_tmp / PI
      end do
   end do
99 continue
  !++++++++++++++++++++
   deallocate(igc,wgt)
  !++++++++++++++++++++
   end subroutine calc_dekin_tkc

!================================= added by K. T. =========================== 4.0
subroutine calc_dekin_tkc_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier

  integer :: ig, lt, nn, ll, tt, ips, ln, tn, it, ifound
  character(1) :: ch_ln, ch_tn, fn_label_orbital
  character(3) :: ch3
  real(8) :: arg, dekin_tmp, dekin_inf

  integer :: ispin

  integer,allocatable :: igc(:)
  real(8),allocatable :: wgt(:)

  ier = 0

  !++++++++++++++++++++++++++++++++++++
  allocate(igc(ntkc))    ; igc = 0
  allocate(wgt(ng_mesh)) ; wgt = 0.d0
  !++++++++++++++++++++++++++++++++++++
  igc(:) = 0

  do it = 1,ntkc
     GLOOP: do ig = 1,ng_mesh
        if (gpos(ig) > tkc(it)) then
           igc(it) = ig - 1
           exit GLOOP
        end if
     end do GLOOP
  end do

  dekin_tkc(:,:) = 0.d0

  do lt = 1,num_ltx_us
     nn  = n_lt_us(lt)
     ll  = l_lt_us(lt)
     tt  = t_lt_us(lt)
     ln  = ln_lt_us(lt)
     tn  = tn_lt_us(lt)
     ips = ips_lt_us(lt)

     ispin = spin_index_lt_us(lt)

     ch_ln = fn_label_orbital(ll)

     write(ch_tn,'(i1)') tn
     ch3(1:3) = '_'//ch_ln(1:1)//ch_tn(1:1)

     write(IFLOG,'(1x,a,6i3,2x,a,a)') &
          'dEkin: n = (n,l,t,s,ln,tn) -->',nn,ll,tt, ispin, ln,tn,'dEkin',ch3

     dekin_tmp = 0.d0
     do ig = 1,ng_mesh
        arg = gpos(ig)*gpos(ig)*phi_g_us(ig,lt)
        dekin_tmp = dekin_tmp + arg*arg*wg(ig)
     end do

     dekin_inf = dekin_tmp / PI

     do it = 1,ntkc
        call set_weight_unif(ier,1,ng_mesh-igc(it)+1,gpos,wgt)

        dekin_tmp = 0.d0
        do ig = igc(it),ng_mesh
           arg = gpos(ig)*gpos(ig)*phi_g_us(ig,lt)
           dekin_tmp = dekin_tmp + arg*arg*wgt(ig-igc(it)+1)
        end do

        dekin_tkc(lt,it) = dekin_tmp / PI
     end do
  end do
99 continue

  !++++++++++++++++++++
  deallocate(igc,wgt)
  !++++++++++++++++++++

end subroutine calc_dekin_tkc_kt
! ============================================================================= 4.0

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   Version history: 
!
!     4.0:  2013/03/01
!           codes for spin-polarized pseudopotential generation are added
!     4.1:  2013/11/22 - 
!           Info of core wfns and energy contributions can be added to gncpp2
!     4.2:  2014/07/23 - 
!           gncpp2 can be geregated even when nmesh /= 1501
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Function(s)   : fn_factorial
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   function fn_factorial(n)
!=====================================================================
!
!  Calculates factorial of n
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer(8) :: fn_factorial
   integer,intent(in) :: n
   integer :: i
   select case (n)
   case (:-1)
      fn_factorial = 0
   case (0)
      fn_factorial = 1
   case (1:)
      fn_factorial = 1
      do i = 1,n
         fn_factorial = fn_factorial * i
      end do
   case default
   end select
   end function fn_factorial

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   Version history: 
!
!     4.0:  2013/03/01
!           codes for spin-polarized pseudopotential generation are added
!     4.1:  2013/11/22 - 
!           Info of core wfns and energy contributions can be added to gncpp2
!     4.2:  2014/07/23 - 
!           gncpp2 can be geregated even when nmesh /= 1501
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : calc_unbound_state
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine calc_unbound_state(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ishell, ll, nn, ispin, kk, id, ll_core, &
              node, node_sum, nrt, nrc, ir0, ir2, isdiff, n1, n2
   real(8) :: r, dr, ee, g_norm, sum, &
              rcut, r0, r1, r2, g0, g1, g2, f0, f1, f2, sign_mod, &
              dummy, dummy2
   ier    =  0
   call calc_vcoeff(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_vcoeff' ; go to 99
   end if
   write(IFLOG,*)
   write(IFLOG,*) 'Calculating unbound states ...'
MAIN:do ishell = 1,nshell
      if ((is_solve(ishell) /= 0).or.(is_valence(ishell) == 0)) then
         cycle MAIN
      end if
      engy(ishell) = 0.d0      
      ee = efermi              
      ispin = (1-spin(ishell))/2 + 1
      ll = l_qnum(ishell)
      if (is_core == PATOM) then
         ll_core = ll
      else
         ll_core = lmax_core
      end if
      nn = n_qnum(ishell)
      kk = k_qnum(ishell)
      rcut = rcut_tm(ll)
      node = 0
         write(IFLOG,'(1x,a31,5i5)') &
            '??? ishell,ispin,nn,ll,node ...',ishell,ispin,nn,ll,node
SRCH_RC:do ir = nmesh,10,-1
         r = rpos(ir)
         if (r < rcut) then
            nrc = ir ; exit SRCH_RC
         end if
      end do SRCH_RC
      nrt = nrc + 20
      id = +1
      call set_initpoints_left(ier,ll,kk,ispin,ee)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in set_initpoints_left'
         go to 99
      end if
      call int_from_left(ier,node_sum,nrt,id,ll,kk,ee,ispin)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in int_from_left' ; go to 99
      end if
      if (node_sum > node) then
         write(IFLOG,*) '### CAUTION ### node_sum > node'
         write(IFLOG,*) '   node_sum ...',node_sum
         write(IFLOG,*) '   node     ...',node
      end if
      ir0 = nrc ; ir2 = nrc+1
      select case (is_calc)
      case (NONREL,SREL)
      call set_weight_exp(ier,1,ir0,rpos,wt)
      sum = 0.d0
      do ir = 1,ir0
         sum = sum + chi_gl(ir)**2 * wt(ir)
      end do
      r0 = rpos(ir0) ; r2 = rpos(ir2) ; r1 = (r0+r2)*0.5d0
      dr = r1 - r0
      g0 = chi_gl(ir0) ; g2 = chi_gl(ir2)
      isdiff = 0
      n1 = ir0 - iord_diff ; n2 = ir0 + iord_diff
      if (n1 < 1) then
         n1 = 1 ; n2 = 1 + iord_diff*2
      else if (n2 > nmesh) then
         n1 = nmesh - iord_diff*2 ; n2 = nmesh
      end if
      call diff_exp(ier,isdiff,n1,n2,rpos,chi_gl,r1,g1,dummy,dummy2)
      sum  = sum + (g0*g0 + 4.d0*g1*g1 + g2*g2) / 3.d0 * dr
      case (REL)
      call set_weight_exp(ier,1,ir0,rpos,wt)
      sum = 0.d0
      do ir = 1,ir0
         sum = sum + (chi_gl(ir)**2 + chi_fl(ir)**2) * wt(ir)
      end do
      r0 = rpos(ir0) ; r2 = rpos(ir2) ; r1 = (r0+r2)*0.5d0
      dr = r1 - r0
      g0 = chi_gl(ir0) ; g2 = chi_gl(ir2)
      f0 = chi_fl(ir0) ; f2 = chi_fl(ir2)
      isdiff = 0
      n1 = ir0 - iord_diff ; n2 = ir0 + iord_diff
      if (n1 < 1) then
         n1 = 1 ; n2 = 1 + iord_diff*2
      else if (n2 > nmesh) then
         n1 = nmesh - iord_diff*2 ; n2 = nmesh
      end if
      call diff_exp(ier,isdiff,n1,n2,rpos,chi_gl,r1,g1,dummy,dummy2)
      call diff_exp(ier,isdiff,n1,n2,rpos,chi_fl,r1,f1,dummy,dummy2)
      sum  = sum + (g0*g0 + 4.d0*g1*g1 + g2*g2) / 3.d0 * dr
      sum  = sum + (f0*f0 + 4.d0*f1*f1 + f2*f2) / 3.d0 * dr
      end select
      if (g1 < 0.d0) then
         write(IFLOG,*) '### CAUTION ### g1 < 0'
         write(IFLOG,*) '   g1 (Hamman) ...',g1
      end if
      g_norm = sqrt(sum)
      if (g1 > 0.d0) then
         sign_mod =  1.d0
      else
         sign_mod = -1.d0
      end if
      select case (is_calc)
      case (NONREL,SREL)
         do ir = 1,nrt
              chi_g(ir,ishell) =   chi_gl(ir)/g_norm * sign_mod
            dxchi_g(ir,ishell) = dxchi_gl(ir)/g_norm * sign_mod
         end do
         do ir = nrt+1,nmesh
              chi_g(ir,ishell) = 0.d0
            dxchi_g(ir,ishell) = 0.d0
         end do
      case (REL)
         do ir = 1,nrt
              chi_g(ir,ishell) =   chi_gl(ir)/g_norm * sign_mod
            dxchi_g(ir,ishell) = dxchi_gl(ir)/g_norm * sign_mod
              chi_f(ir,ishell) =   chi_fl(ir)/g_norm * sign_mod
            dxchi_f(ir,ishell) = dxchi_fl(ir)/g_norm * sign_mod
         end do
         do ir = nrt+1,nmesh
              chi_g(ir,ishell) = 0.d0
            dxchi_g(ir,ishell) = 0.d0
              chi_f(ir,ishell) = 0.d0
            dxchi_f(ir,ishell) = 0.d0
         end do
      end select
end do MAIN
99 continue
   end subroutine calc_unbound_state
